# PyPestUtils

Suite of Python tools based on PEST utilities to support parameterization with pilot points, drawing stochastic realizations, and MODFLOW post-processing for structured and unstructured grids. This package consists of a (pre-)compiled shared fortran library, and a corresponding low-level python wrapper around the library functions.  There are also higher-level "helper" functions to further abstract the granular low-level function calls for common workflow elements.  

The low-level functions are relatively strict in their argument types - this is required to effectively pass the array-type data container references to the fortran library.  As such, the low-level python functions perform considerable type checking.  The higher-level helpers attempt to support a variety of argument types and will attempt coerce to the required type.  

This package is currently in pre-alpha development, and is not suitable for use, but early adopters are welcome to have a go.

## Examples

There are several jupyter notebook examples of using pypestutils for a structured and quadtree Freyberg model.  These notebooks rely on both [flopy](https://github.com/modflowpy/flopy) and [pyEMU](https://github.com/pypest/pyemu) to help with visualization and processing.

The use the low-level python interface to the shared fortran library, you create a `PESTUTILSLIB` instance and then can directly call the shared library routines:

```
from pypestutils.pestutilslib import PestUtilsLib
lib = PestUtilsLib() #the constructor searches for the shared lib
grid_info = lib.install_mf6_grid_from_file("grid","freyberg6.disv.grb")
easting,northing,elev = lib.get_cell_centres_mf6("grid",grid_info["ncells"])
```

The higher-level helper functions obsecure the calls the fortran library and string together multiple low-level function calls:

```
import pypestutils.helpers as helpers
grid_info = helpers.get_grid_info_from_file("freyberg6.disv.grb")
```

## Documentation

The documentation for pypestutils can be found [here](https://pypest.github.io/pypestutils/)

The documentation for the shared FORTRAN library can be found [here](docs/pestutilslib/fortran_library_documentation.md)

## Installation

### Dependencies

pypestutils requires `numpy` and `pandas`

### Easy way

Use `pip` to install a built distribution for Windows, Linux or macOS:

    pip install pypestutils

to also include optional requirements use:

    pip install pypestutils[optional]

### From source

Installation from source requires a Fortran compiler and build tools. See [BUILD.md](BUILD.md) for details.

## Disclaimer


This software is preliminary or provisional and is subject to revision. It is
being provided to meet the need for timely best science. This software is
provided "as is" and "as-available", and makes no representations or warranties
of any kind concerning the software, whether express, implied, statutory, or
other. This includes, without limitation, warranties of title,
merchantability, fitness for a particular purpose, non-infringement, absence
of latent or other defects, accuracy, or the presence or absence of errors,
whether or not known or discoverable.

module dimvar_c
  use iso_c_binding, only: c_int
  use dimvar, only: LENFILENAME, LENMESSAGE, LENGRIDNAME
  implicit none

  integer(c_int), bind(C, name="LENFILENAME") :: LENFILENAME_C = LENFILENAME

  integer(c_int), bind(C, name="LENMESSAGE") :: LENMESSAGE_C = LENMESSAGE

  integer(c_int), bind(C, name="LENGRIDNAME") :: LENGRIDNAME_C = LENGRIDNAME

end module dimvar_c

module utilities

       use dimvar
       implicit none

public

! -- General reuseable variables

        integer                        :: lw(100),rw(100)
        double precision               :: pi=3.14159265358979
        character (len=LENFUNCNAME)    :: function_name
        character (len=LENFILENAME)    :: afile1,afile2
        character (len=LENCLINE)       :: cline
        character (len=LENMESSAGE)     :: amessage

        integer, allocatable           :: seed(:)
        integer, allocatable           :: ivector1(:)
        integer, allocatable           :: ivector2(:)
        real, allocatable              :: rvector1(:)
        real, allocatable              :: rvector2(:)
        real, allocatable              :: rvector3(:)
        double precision, allocatable  :: dvector1(:)
        double precision, allocatable  :: dvector2(:)
        double precision, allocatable  :: dvector3(:)

! -- Geometry utilities

public   utl_locpt,          &
         utl_distance_to_segment

! -- File utilities

public  utl_addquote,        &
        utl_MfBinOpSpecs,    &
        utl_nextunit

! -- Text utilities

public  utl_casetrans,       &
        utl_char2string,     &
        utl_num2char,        &
        utl_int2char,        &
        utl_real2char,       &
        utl_dbl2char,        &
        utl_char2num,        &
        utl_char2int,        &
        utl_char2real,       &
        utl_char2dbl,        &
        utl_string2char,     &
        utl_textcheck,       &
        utl_wordsplit

! -- Array utilities

public  utl_allocate_vector, &
        utl_whichone,        &
        utl_sort,            &
        utl_uniform_dvector

! -- Number utilities

public utl_equals
public utl_random_normal

! -- Interfaces for generic functions.

interface utl_num2char
        module procedure utl_int2char
        module procedure utl_real2char
        module procedure utl_dbl2char
end interface

interface utl_char2num
        module procedure utl_char2int
        module procedure utl_char2real
        module procedure utl_char2dbl
end interface

interface utl_whichone
        module procedure utl_whichone_int
        module procedure utl_whichone_char
end interface

interface utl_sort
        module procedure utl_sort_int
        module procedure utl_sort_real
        module procedure utl_sort_dbl
end interface

interface utl_equals
        module procedure utl_equals_int
        module procedure utl_equals_real
        module procedure utl_equals_dbl
end interface

contains


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!                               ARRAY UTILITES                                     !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

integer function utl_allocate_vector(atype,inum,ndim)

! -- Function UTL_ALLOCATE_VECTOR allocates one of the utility vectors used by the
!    UTILITIES module.

        implicit none
        character (len=*), intent(in)   :: atype
        integer, intent(in)             :: inum
        integer, intent(in)             :: ndim

        integer                         :: ierr
        character (len=10)              :: atemp

        utl_allocate_vector=0
        if(inum.le.0) go to 9890
        if(ndim.le.0) go to 9890
        atemp=atype
        call utl_casetrans(atemp,'lo')

        if(atemp.eq.'i')then
          if(inum.eq.1)then
            if(allocated(ivector1))then
              if(size(ivector1).ge.ndim)go to 9900
              deallocate(ivector1,stat=ierr)
              if(ierr.ne.0) go to 9890
            end if
            allocate(ivector1(ndim),stat=ierr)
            if(ierr.ne.0) go to 9890
          else if(inum.eq.2)then
            if(allocated(ivector2))then
              if(size(ivector2).ge.ndim)go to 9900
              deallocate(ivector2,stat=ierr)
              if(ierr.ne.0) go to 9890
            end if
            allocate(ivector2(ndim),stat=ierr)
            if(ierr.ne.0) go to 9890
          else
            go to 9890
          end if
        else if(atemp.eq.'r')then
          if(inum.eq.1)then
            if(allocated(rvector1))then
              if(size(rvector1).ge.ndim)go to 9900
              deallocate(rvector1,stat=ierr)
              if(ierr.ne.0) go to 9890
            end if
            allocate(rvector1(ndim),stat=ierr)
            if(ierr.ne.0) go to 9890
          else if(inum.eq.3)then
            if(allocated(rvector3))then
              if(size(rvector3).ge.ndim)go to 9900
              deallocate(rvector3,stat=ierr)
              if(ierr.ne.0) go to 9890
            end if
            allocate(rvector3(ndim),stat=ierr)
            if(ierr.ne.0) go to 9890
          else if(inum.eq.2)then
            if(allocated(rvector2))then
              if(size(rvector2).ge.ndim)go to 9900
              deallocate(rvector2,stat=ierr)
              if(ierr.ne.0) go to 9890
            end if
            allocate(rvector2(ndim),stat=ierr)
            if(ierr.ne.0) go to 9890
          else
            go to 9890
          end if
        else if(atemp.eq.'d')then
          if(inum.eq.1)then
            if(allocated(dvector1))then
              if(size(dvector1).ge.ndim)go to 9900
              deallocate(dvector1,stat=ierr)
              if(ierr.ne.0) go to 9890
            end if
            allocate(dvector1(ndim),stat=ierr)
            if(ierr.ne.0) go to 9890
          else if(inum.eq.2)then
            if(allocated(dvector2))then
              if(size(dvector2).ge.ndim)go to 9900
              deallocate(dvector2,stat=ierr)
              if(ierr.ne.0) go to 9890
            end if
            allocate(dvector2(ndim),stat=ierr)
            if(ierr.ne.0) go to 9890
          else if(inum.eq.3)then
            if(allocated(dvector3))then
              if(size(dvector3).ge.ndim)go to 9900
              deallocate(dvector3,stat=ierr)
              if(ierr.ne.0) go to 9890
            end if
            allocate(dvector3(ndim),stat=ierr)
            if(ierr.ne.0) go to 9890
          else
            go to 9890
          end if
        else
          go to 9890
        end if
        go to 9900

9890    continue
        utl_allocate_vector=1

9900    continue
        return

end function utl_allocate_vector

subroutine utl_sort_int(n,iarray)            ! Check this when a really low item occurs late in the array.

        integer, intent(in)     :: n
        integer, intent(inout)  :: iarray(n)

        integer                 :: iw,i,j

        if(n.eq.1) then
          return
        else if(n.eq.2)then
          if(iarray(2).lt.iarray(1))then
            iw=iarray(2)
            iarray(2)=iarray(1)
            iarray(1)=iw
          end if
        else
          do i = 2, n
            iw = iarray(i)
            do j =i,2,-1
              if(iw.ge.iarray(j-1)) go to 100
              iarray(j) = iarray(j-1)
            end do
            j=1
100         continue
            iarray(j) = iw
          end do
        end if

        return

end subroutine utl_sort_int



subroutine utl_sort_real(n,rarray)            ! Check this when a really low item occurs late in the array.

        integer, intent(in)     :: n
        real, intent(inout)     :: rarray(n)

        integer                 :: i,j
        real                    :: rw

        if(n.eq.1) then
          return
        else if(n.eq.2)then
          if(rarray(2).lt.rarray(1))then
            rw=rarray(2)
            rarray(2)=rarray(1)
            rarray(1)=rw
          end if
        else
          do i = 2, n
            rw = rarray(i)
            do j =i,2,-1
              if(rw.ge.rarray(j-1)) go to 100
              rarray(j) = rarray(j-1)
            end do
            j=1
100         continue
            rarray(j) = rw
          end do
        end if

        return

end subroutine utl_sort_real



subroutine utl_sort_dbl(n,rarray)            ! Check this when a really low item occurs late in the array.

        integer, intent(in)                 :: n
        double precision, intent(inout)     :: rarray(n)

        integer                             :: i,j
        double precision                    :: rw

        if(n.eq.1) then
          return
        else if(n.eq.2)then
          if(rarray(2).lt.rarray(1))then
            rw=rarray(2)
            rarray(2)=rarray(1)
            rarray(1)=rw
          end if
        else
          do i = 2, n
            rw = rarray(i)
            do j =i,2,-1
              if(rw.ge.rarray(j-1)) go to 100
              rarray(j) = rarray(j-1)
            end do
            j=1
100         continue
            rarray(j) = rw
          end do
        end if

        return

end subroutine utl_sort_dbl


integer function utl_whichone_char(npar,ipar,apar,tpar)

! -- Function UTL_WHICHONE_CHAR locates a string in an array of strings.

        implicit none
        integer, intent(in)               :: npar
        integer, intent(inout)            :: ipar
        character (len=*), intent(in)     :: apar(npar)
        character (len=*), intent(inout)  :: tpar

        integer i

        utl_whichone_char=0
        if((ipar.lt.1).or.(ipar.gt.npar)) ipar=1
        call utl_casetrans(tpar,'lo')
        if(tpar.eq.apar(ipar)) return
        if(ipar.ne.npar)then
          do i=ipar+1,npar
            if(tpar.eq.apar(i))then
              ipar=i
              return
            end if
          end do
        end if
        if(ipar.ne.1)then
          do i=ipar-1,1,-1
            if(tpar.eq.apar(i)) then
              ipar=i
              return
            end if
          end do
        end if
        utl_whichone_char=1
        return

end function utl_whichone_char



integer function utl_whichone_int(npar,ipar,apar,tpar)

! -- Function UTL_WHICHONE_INT locates an integer in an array of integers.

        implicit none
        integer, intent(in)           :: npar
        integer, intent(inout)        :: ipar
        integer, intent(in)           :: apar(npar)
        integer, intent(in)           :: tpar

        integer i

        utl_whichone_int=0
        if((ipar.lt.1).or.(ipar.gt.npar)) ipar=1
        if(tpar.eq.apar(ipar)) return
        if(ipar.ne.npar)then
          do i=ipar+1,npar
            if(tpar.eq.apar(i))then
              ipar=i
              return
            end if
          end do
        end if
        if(ipar.ne.1)then
          do i=ipar-1,1,-1
            if(tpar.eq.apar(i)) then
              ipar=i
              return
            end if
          end do
        end if
        utl_whichone_int=1
        return

end function utl_whichone_int



logical function utl_uniform_dvector(num,dvector,zone,izone)

! -- This function tests whether all elements in a vector are equal for a particular zone.

       integer, intent(in)          :: num
       double precision, intent(in) :: dvector(num)
       integer, intent(in)          :: zone(num)
       integer, intent(in)          :: izone

       integer                      :: i,j
       double precision             :: dtemp

       utl_uniform_dvector=.TRUE.
       do i=1,num
         if(zone(i).eq.izone) go to 10
       end do
       return

10     continue
       if(i.eq.num) return
       dtemp=dvector(i)
       do j=i+1,num
         if(zone(j).eq.izone)then
           if(.not.utl_equals(dvector(j),dtemp)) then
             utl_uniform_dvector=.FALSE.
             return
           end if
         end if
       end do
       return

end function utl_uniform_dvector



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!                             GEOMETRY UTILITES                                    !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


SUBROUTINE UTL_LOCPT (X0, Y0, X, Y, N, L, M)

!-----------------------------------------------------------------------
!     GIVEN A POLYGONAL LINE CONNECTING THE VERTICES (X(I),Y(I))
!     (I = 1,...,N) TAKEN IN THIS ORDER. IT IS ASSUMED THAT THE
!     POLYGONAL PATH IS A LOOP, WHERE (X(N),Y(N)) = (X(1),Y(1))
!     OR THERE IS AN ARC FROM (X(N),Y(N)) TO (X(1),Y(1)).
!
!     (X0,Y0) IS AN ARBITRARY POINT AND L AND M ARE VARIABLES.
!     L AND M ARE ASSIGNED THE FOLLOWING VALUES ...
!
!        L = -1   IF (X0,Y0) IS OUTSIDE THE POLYGONAL PATH
!        L =  0   IF (X0,Y0) LIES ON THE POLYGONAL PATH
!        L =  1   IF (X0,Y0) IS INSIDE THE POLYGONAL PATH
!
!     M = 0 IF (X0,Y0) IS ON OR OUTSIDE THE PATH. IF (X0,Y0)
!     IS INSIDE THE PATH THEN M IS THE WINDING NUMBER OF THE
!     PATH AROUND THE POINT (X0,Y0).
!
!-----------------------
!
!     ****** EPS IS A MACHINE DEPENDENT CONSTANT. EPS IS THE
!            SMALLEST NUMBER SUCH THAT 1.0 + EPS .GT. 1.0
!
!jed      EXTERNAL   DPMPAR

      INTEGER            N,L,M,N0,I
      DOUBLE PRECISION, intent(in) :: X(N), Y(N)
      DOUBLE PRECISION   ANGLE  ,DPMPAR ,EPS    ,PI     ,PI2    ,SUM
      DOUBLE PRECISION   THETA  ,THETAI ,THETA1 ,TOL    ,U      ,V
      DOUBLE PRECISION   X0     ,Y0
!jed                     EPS = DPMPAR(1)
                      eps=1.0d-10   ! a rough guess, sufficient for double prec
!
!-----------------------------------------------------------------------
      N0 = N
      IF (X(1) .EQ. X(N) .AND. Y(1) .EQ. Y(N)) N0 = N - 1
      PI = ATAN2(0.0D0, -1.0D0)
      PI2 = 2.0D0*PI
      TOL = 4.0D0*EPS*PI
      L = -1
      M = 0

      U = X(1) - X0
      V = Y(1) - Y0
      IF (U .EQ. 0.0D0 .AND. V .EQ. 0.0D0) GO TO 20
      IF (N0 .LT. 2) RETURN
      THETA1 = ATAN2(V, U)

      SUM = 0.0D0
      THETA = THETA1
      DO 10 I = 2,N0
         U = X(I) - X0
         V = Y(I) - Y0
         IF (U .EQ. 0.0D0 .AND. V .EQ. 0.0D0) GO TO 20
         THETAI = ATAN2(V, U)

         ANGLE = ABS(THETAI - THETA)
         IF (ABS(ANGLE - PI) .LT. TOL) GO TO 20
         IF (ANGLE .GT. PI) ANGLE = ANGLE - PI2
         IF (THETA .GT. THETAI) ANGLE = -ANGLE
         SUM = SUM + ANGLE
         THETA = THETAI
   10 CONTINUE

      ANGLE = ABS(THETA1 - THETA)
      IF (ABS(ANGLE - PI) .LT. TOL) GO TO 20
      IF (ANGLE .GT. PI) ANGLE = ANGLE - PI2
      IF (THETA .GT. THETA1) ANGLE = -ANGLE
      SUM = SUM + ANGLE

!     SUM = 2*PI*M WHERE M IS THE WINDING NUMBER

      M = ABS(SUM)/PI2 + 0.2D0
      IF (M .EQ. 0) RETURN
      L = 1
      IF (SUM .LT. 0.0D0) M = -M
      RETURN

!     (X0, Y0) IS ON THE BOUNDARY OF THE PATH

   20 L = 0
      RETURN
END SUBROUTINE UTL_LOCPT



double precision function utl_distance_to_segment(x1,y1,x2,y2,x3,y3,u)

! -- This function finds the distance between point (x3,y3) and the segment
!    that joins points (x1,y1) and (x2,y2).

      implicit none
      double precision, intent(in)  :: x1,y1,x2,y2,x3,y3
      double precision, intent(out) :: u

      double precision             :: x,y
      double precision             :: dx21,dx31,dy21,dy31,den

! -- First we find the distance along the line to the intersection point.

      dx21=x2-x1
      dx31=x3-x1
      dy21=y2-y1
      dy31=y3-y1
      den=dx21*dx21+dy21*dy21
      if(den.gt.1.0d-200)then
        u=(dx31*dx21+dy31*dy21)/den
        if(u.le.0.0d0)then
          x=x1
          y=y1
        else if(u.ge.1.0d0)then
          x=x2
          y=y2
        else
          x=x1+u*dx21
          y=y1+u*dy21
        end if
      else
        x=x1
        y=y1
        u=0.0d0
      end if
      utl_distance_to_segment=sqrt((x3-x)*(x3-x)+(y3-y)*(y3-y))

end function utl_distance_to_segment



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!                               FILE UTILITES                                      !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine utl_addquote(afile,aqfile)

! -- Subroutine UTL_ADDQUOTE adds quotes to a filename if it has a space in it.

        implicit none

        character (len=*), intent(in)   :: afile
        character (len=*), intent(out)  :: aqfile
        integer nbb

        if(index(trim(afile),' ').eq.0)then
          aqfile=afile
        else
          aqfile(1:1)='"'
          aqfile(2:)=trim(afile)
          nbb=len_trim(aqfile)+1
          aqfile(nbb:nbb)='"'
        end if

        return

end subroutine utl_addquote



integer function utl_MfBinOpSpecs(inunit,itype,infile,iprec)

! -- This function tries to establish the precision of a MODFLOW binary output file
!    by reading the first lineor two of this file.
! -- It probably works well in identifying the precision of a system state file. It may not
!    work so well in identifying the precision of a budget file. The calling program should
!    be aware of this.

       implicit none

       integer, intent(in)             :: inunit  ! The file is already open
       integer, intent(in)             :: itype   ! 1 = system states;  2 = cell-by-cell flow
       character (len=*), intent(in)   :: infile
       integer, intent(out)            :: iprec   ! 1 = single precision; 2 = double precision

       integer                         :: kstp,kper,ilay,int1,int2,int3
       integer                         :: ibig,imeth
       real                            :: rbig
       real                            :: pertim,totim,delt
       double precision                :: dbig
       double precision                :: dpertim,dtotim,ddelt
       character (len=16)              :: text

! -- Initialisation

       utl_mfbinopspecs=0
       call utl_addquote(infile,afile1)
       ibig=huge(ibig)/2                   ! arbitrary
       rbig=huge(rbig)*0.5                 ! arbitrary
       dbig=huge(dbig)*0.5d0               ! arbitrary
       iprec=0

! -- Try to establish file details by reading its first line. (The file is assumed to
!    be already open.)

       if(itype.eq.1)then
         read(inunit,err=9000,end=9000) kstp,kper,pertim,totim,text,int1,int2,ilay
         if((kstp.lt.0).or.(kper.lt.0).or.(pertim.lt.0.0).or.(totim.lt.0.0).or.         &
           (int1.lt.0).or.(int2.lt.0).or.(ilay.lt.0).or.                                &
           (kstp.gt.ibig).or.(kper.gt.ibig).or.(int1.gt.ibig).or.(int2.gt.ibig).or.     &
           (ilay.gt.ibig).or.(pertim.gt.rbig).or.(totim.gt.rbig).or.                  &
           (utl_textcheck(text).ne.0)) go to 100
         iprec=1
         go to 200
100      continue
         rewind(unit=inunit)
         read(inunit,err=9000,end=9000) kstp,kper,dpertim,dtotim,text,int1,int2,ilay
         if((kstp.lt.0).or.(kper.lt.0).or.(dpertim.lt.0.0d0).or.(dtotim.lt.0.0d0).or.      &
           (int1.lt.0).or.(int2.lt.0).or.(ilay.lt.0).or.                                   &
           (kstp.gt.ibig).or.(kper.gt.ibig).or.(int1.gt.ibig).or.(int2.gt.ibig).or.        &
           (ilay.gt.ibig).or.(dpertim.gt.dbig).or.(dtotim.gt.dbig).or.                     &
           (utl_textcheck(text).ne.0)) go to 9000
         iprec=2
         go to 200
       else if(itype.eq.2)then
         read(inunit,err=9000,end=9000) kstp,kper,text,int1,int2,int3
         if((int1.lt.0).or.(int2.lt.0).or.(int1.gt.ibig).or.(int2.gt.ibig).or.     &
         (abs(int3).gt.ibig).or.(utl_textcheck(text).ne.0)) go to 130
         if(int3.lt.0)then
           read(inunit,err=9000,end=9000) imeth,delt,pertim,totim
           if((imeth.lt.0).or.(imeth.gt.ibig)) go to 130
           if((delt.lt.0.0).or.(pertim.lt.0.0).or.(totim.lt.0.0)) go to 130
           if((delt.gt.rbig).or.(pertim.gt.rbig).or.(totim.gt.rbig)) go to 130
           if(totim.lt.pertim) go to 130
         end if
         iprec=1          ! we cannot be 100% sure
         go to 200
130      continue
         rewind(unit=inunit)
         read(inunit,err=9000,end=9000) kstp,kper,text,int1,int2,int3
         read(inunit,err=9000,end=9000) imeth,ddelt,dpertim,dtotim
         if((ddelt.lt.0.0d0).or.(dpertim.lt.0.0d0).or.(dtotim.lt.0.0d0)) go to 9000
         if((ddelt.gt.dbig).or.(dpertim.gt.dbig).or.(dtotim.gt.dbig)) go to 9000
         if(dtotim.lt.dpertim) go to 9000
         iprec=2          ! we cannot be 100% sure
         go to 200
       end if
200    continue
       go to 9900

9000   write(amessage,9010) trim(afile1)
9010   format('Unable to obtain specifications of file ',a,'.')
       go to 9890

9890   continue
       utl_mfbinopspecs=1

9900   continue
       return

end function utl_MfBinOpSpecs




integer function utl_nextunit()

! -- Function UTL_NEXTUNIT determines the lowest unit number available for
! -- opening.

        implicit none
        logical::lopen

        do utl_nextunit=10,200
          inquire(unit=utl_nextunit,opened=lopen)
          if(.not.lopen) return
        end do

        utl_nextunit=0

end function utl_nextunit


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!                               TEXT UTILITES                                      !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


subroutine utl_casetrans(string,hi_or_lo)

! -- Subroutine UTL_CASETRANS converts a string to upper or lower case.

! -- Arguments are as follows:-
!      string:    contains the string whose case must be changed
!      hi_or_lo:  must be either 'lo' or 'hi' to indicate
!                 change of case direction.

        implicit none

        character (len=*), intent(inout)        :: string
        character (len=*), intent(in)           :: hi_or_lo
        character                               :: alo, ahi
        integer                                 :: inc,i

        if(hi_or_lo.eq.'lo') then
          alo='A'; ahi='Z'; inc=iachar('a')-iachar('A')
        else if(hi_or_lo.eq.'hi') then
          alo='a'; ahi='z'; inc=iachar('A')-iachar('a')
        else
          return
        endif

        do i=1,len_trim(string)
          if((string(i:i).ge.alo).and.(string(i:i).le.ahi)) &
          string(i:i)=achar(iachar(string(i:i))+inc)
        end do

        return

end subroutine utl_casetrans



subroutine utl_int2char(inum,anum)

! -- Subroutine UTL_INT2CHAR converts an integer to a string.

        implicit none
        integer, intent(in)             :: inum
        character (len=*), intent(out)  :: anum

        character (len=12)              :: afmt
        integer                         :: llen

        afmt='(i    )'
        llen=min(40,len(anum))
        write(afmt(3:6),'(i4)') llen
        write(anum(1:llen),afmt,err=100) inum
        anum=adjustl(anum)
        if(index(anum,'*').ne.0) go to 100
        return

100     continue
        anum=' '
        return

end subroutine utl_int2char


subroutine utl_real2char(rnum,anum)

! -- Subroutine UTL_REAL2CHAR converts a real number to a string.

        implicit none
        real, intent(in)                :: rnum
        character (len=*), intent(out)  :: anum

        integer                         :: llen,n1,n2,i
        character (len=15)              :: afmt

        llen=len(anum)
        n1=min(13,llen)
        if(rnum.lt.0)then
          i=7
        else
          i=6
        end if
        n2=n1-i
        if(n2.lt.0) go to 100
        afmt='(1pg  .  )'
        write(afmt(5:6),'(i2)') n1
        write(afmt(8:9),'(i2)') n2
        write(anum,afmt,err=100) rnum
        anum=adjustl(anum)
        return

100     continue
        anum=' '
        return

end subroutine utl_real2char



subroutine utl_dbl2char(dnum,anum)

! -- Subroutine UTL_DBL2CHAR converts a double precision number to a string.

        implicit none
        double precision, intent(in)    :: dnum
        character (len=*), intent(out)  :: anum

        integer                         :: llen,n1,n2,i
        character (len=15)              :: afmt

        llen=len(anum)
        n1=min(13,llen)
        if(dnum.lt.0)then
          i=7
        else
          i=6
        end if
        n2=n1-i
        if(n2.lt.0) go to 100
        afmt='(1pg  .  )'
        write(afmt(5:6),'(i2)') n1
        write(afmt(8:9),'(i2)') n2
        write(anum,afmt,err=100) dnum
        anum=adjustl(anum)
        return

100     continue
        anum=' '
	      return

end subroutine utl_dbl2char



integer function utl_char2int(astring,inum)

! -- Function UTL_CHAR2INT reads an integer from a string.

        implicit none
        character (len=*), intent(in)   :: astring
        integer, intent(out)            :: inum

        integer                         :: i
        character (len=6)               :: afmt

        if(astring.eq.' ') go to 100
        utl_char2int=0
        afmt='(i   )'
        write(afmt(3:5),'(i3)') len(astring)
        read(astring,afmt,err=100) inum
        return

100     utl_char2int=1
        return

end function utl_char2int



integer function utl_char2real(astring,rnum)

! -- Function UTL_CHAR2REAL reads a real number from a string.

        implicit none
        character (len=*), intent(in)    :: astring
        real, intent(out)                :: rnum

        character (len=8)                :: afmt

        if(astring.eq.' ') go to 100
        utl_char2real=0
        afmt='(f   .0)'
        write(afmt(3:5),'(i3)') len(astring)
        read(astring,afmt,err=100) rnum
        return

100     utl_char2real=1
        return

end function utl_char2real



integer function utl_char2dbl(astring,dnum)

! -- Function UTL_CHAR2DBL reads a double precision number from a string.

        implicit none
        character (len=*), intent(in)    :: astring
        double precision, intent(out)    :: dnum

        character (len=8)                :: afmt

        if(astring.eq.' ') go to 100
        utl_char2dbl=0
        afmt='(f   .0)'
        write(afmt(3:5),'(i3)') len(astring)
        read(astring,afmt,err=100) dnum
        return

100     utl_char2dbl=1
        return

end function utl_char2dbl



subroutine utl_char2string(ndim,textchar,textstring)

! -- Converts a FORTRAN character variable to a C type string.

       implicit none
       integer, intent(in)            :: ndim
       character (len=*), intent(in)  :: textchar
       character (len=1), intent(out) :: textstring(ndim)

       integer    :: ns,is

       ns=min(len_trim(textchar),ndim-1)
       do is=1,ns
         textstring(is)=textchar(is:is)
       end do
       textstring(ns+1)=achar(0)
       return

end subroutine utl_char2string



subroutine utl_string2char(ndim,textstring,textchar)

! -- Converts a C type character string to a FORTRAN character variable.

       implicit none
       integer, intent(in)            :: ndim
       character (len=1), intent(in)  :: textstring(ndim)
       character (len=*), intent(out) :: textchar

       integer       :: ns,is

       ns=len(textchar)
       textchar=' '
       do is=1,min(ns,ndim)
         if(textstring(is).eq.achar(0))exit
         textchar(is:is)=textstring(is)
       end do
       return

end subroutine utl_string2char



integer function utl_textcheck(astring)

! -- This function tests for ASCII reasonable values in a text string.

       implicit none
       character (len=*), intent(in) :: astring
       integer i,ii

! -- Initialisation

       utl_textcheck=0

       do i=1,len_trim(astring)
         ii=ichar(astring(i:i))
         if((ii.le.31).or.(ii.ge.127)) go to 9890
       end do
       return

9890   continue
       utl_textcheck=1
       return

end function utl_textcheck



integer function utl_wordsplit(nword,ls,rs,aline)

! -- Function UTL_WORDSPLIT splits a character string into words.

        implicit none

        integer, intent(in)            :: nword
        integer, intent(out)           :: ls(nword),rs(nword)
        character (len=*),intent(in)   :: aline

        integer                        :: istart,ifin,iword
        integer                        :: i,j
        character (len=1)              :: atab,aa

        utl_wordsplit=0
        atab=char(9)

        if(nword.eq.0) return
        if(aline.eq.' ')then
          utl_wordsplit=-1
          return
        end if

        istart=0
        ifin=len_trim(aline)
        if(ifin.eq.0)then
          utl_wordsplit=-1
          return
        end if

        do iword=1,nword
          if(istart.eq.ifin) go to 9890
          do i=istart+1,ifin
            if((aline(i:i).ne.' ').and.(aline(i:i).ne.atab))exit
          end do
          aa=aline(i:i)
          if((aa.ne.'''').and.(aa.ne.'"'))aa=' '
          if(aa.eq.' ')then
            ls(iword)=i
            do j=i,ifin
              if((aline(j:j).eq.' ').or.(aline(j:j).eq.atab)) exit
            end do
          else
            ls(iword)=i+1
            do j=i+1,ifin
              if(aline(j:j).eq.aa) go to 20
            end do
            go to 9891
20          continue
          end if
          if(aa.eq.' ')then
            if(j.eq.ifin)then
              rs(iword)=ifin
            else
              rs(iword)=j-1
            end if
            istart=rs(iword)
          else
            istart=j
            if(i+1.eq.j)go to 9890
            rs(iword)=j-1
          end if
        end do

        return
9890    utl_wordsplit=1
        go to 9999
9891    utl_wordsplit=2
        go to 9999

9999    continue
        return

end function utl_wordsplit


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!                             NUMBER UTILITES                                      !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

logical function utl_equals_int(r1,r2)

        integer, intent(in)   :: r1
        integer, intent(in)   :: r2

        utl_equals_int=(r1.eq.r2)

end function utl_equals_int



logical function utl_equals_real(r1,r2,nspace)

          real, intent(in)              :: r1
          real, intent(in)              :: r2
          integer, intent(in), optional :: nspace

          integer                       :: ispace
          real                          :: rtemp

          ispace=5
          if(present(nspace))then
            ispace=max(ispace,nspace)
          end if

          rtemp=abs(ispace*spacing(r1))
          if(abs(r1-r2).lt.rtemp)then
            utl_equals_real=.true.
          else
            utl_equals_real=.false.
          end if

end function utl_equals_real


logical function utl_equals_dbl(r1,r2,nspace)

          real (kind (1.0d0)), intent(in)      :: r1
          real (kind (1.0d0)), intent(in)      :: r2
          integer, intent(in), optional        :: nspace

          integer                              :: ispace
          real (kind (1.0d0))                  :: rtemp

          ispace=5
          if(present(nspace))then
            ispace=max(ispace,nspace)
          end if
          rtemp=abs(ispace*spacing(r1))
          if(abs(r1-r2).lt.rtemp)then
            utl_equals_dbl=.true.
          else
            utl_equals_dbl=.false.
          end if

end function utl_equals_dbl


double precision function utl_random_normal()

! -- Generate a sample from a normal distribution.

       implicit none

       double precision :: pi
       double precision :: d1,d2

       pi=3.14159265358979323846264338
       call random_number(d1)
       call random_number(d2)
       utl_random_normal = sqrt ( - 2.0D+00 * log ( d1 ) ) * cos ( 2.0D+00 * pi * d2 )

       return
end function utl_random_normal

end module utilities

       program driver5

! -- DRIVER5 tests the reading of a cell-by-cell flow term file.

       use function_interfaces
       use iso_c_binding, only : c_int,c_char,c_double
       implicit none

       integer(kind=c_int)             :: ifail
       integer(kind=c_int)             :: ncell,nzone,isim
       integer(kind=c_int)             :: itype,iprec,narray,ntime
       integer(kind=c_int)             :: numzone,nproctime,numobsdat
       real(kind=c_double)             :: time_extrap,nointerpval,interpthresh
       character(kind=c_char,len=1)    :: how_extrap
       character(kind=c_char,len=1)    :: flowtype(17)
       character(kind=c_char,len=1)    :: cbcfile(256),recfile(256)
       character(kind=c_char,len=1)    :: messagestring(1500)

       integer(kind=c_int),allocatable :: izone(:)
       integer(kind=c_int),allocatable :: zonenumber(:)
       integer(kind=c_int),allocatable :: timestep(:),stressperiod(:)
       integer(kind=c_int),allocatable :: obszonenum(:)
       real(kind=c_double),allocatable :: simtime(:),simflow(:,:)
       real(kind=c_double),allocatable :: obstime(:),obsval(:)

       integer           :: ierr,itemp
       integer           :: icell,iz,itime,iobs
       character (len=1)    :: aa
       character (len=17)   :: atext
       character (len=20)   :: atemp20
       character (len=30)   :: atype,aprec
       character (len=256)  :: infile,afile1,afile2,outfile,cline
       character (len=1500) :: amessage

       character (len=20), allocatable   :: obspoint(:)

! -- Initialization
       cbcfile=' '  ! an array

       write(6,*)
100    write(6,110,advance='no')
110    format(' Enter number of cells in model: ')
       read(5,*,err=100) ncell
       if(ncell.le.0) go to 100
50     write(6,60)
60     format(' A simulator code is required.')
       write(6,70)
70     format(' (1=mf; 21=mfusg_s; 22=mfusg_us; 31=mf6_dis; 32=mfusg_disv; 33=mfusg_disu)')
79     write(6,80,advance='no')
80     format(' Enter simulation code: ')
       read(5,*,err=79) isim

! -- Allocate some memory

       allocate(izone(ncell),stat=ierr)
       if(ierr.ne.0) go to 9200
       izone=0        ! an array

! -- Read the zonation file.

       write(6,*)
150    write(6,160,advance='no')
160    format(' Enter file containing model cell zone numbers: ')
       read(5,*) infile
       open(unit=10,file=infile,status='old',err=150)
       do
         read(10,*,end=200) icell, itemp
         if((icell.le.0).or.(icell.gt.ncell)) then
           call writint(atemp20,icell)
           write(amessage,171) trim(atemp20),trim(infile)
171        format('Cell number ',a,' out of range in file ',a,'.')
           go to 9890
         end if
         izone(icell)=itemp
       end do
200    close(unit=10)
       write(6,210) trim(infile)
210    format(' - file ',a,' read ok.')
211    write(6,212,advance='no')
212    format(' Enter a number that equals or exceeds number of separate zones: ')
       read(5,*,err=211) nzone
       if(nzone.le.0) go to 211

! -- Obtain the name of the cbc flow term file to read.

       write(6,*)
230    write(6,240,advance='no')
240    format(' Enter name of model-generated cbc flow term file to read: ')
       read(5,*,err=230) afile1
250    write(6,260,advance='no')
260    format(' Enter name of file to record contents of this file: ')
       read(5,*,err=250) afile2
       call char2string(256,afile1,cbcfile)
       call char2string(256,afile2,recfile)

! -- Call function inquire_modflow_binary_file_specs() to pre-read file.

       write(6,*)
       write(6,270)
270    format(' - calling function inquire_modflow_binary_file_specs()...')
       itype=2
       ifail=inquire_modflow_binary_file_specs(cbcfile,recfile,     &
       isim,itype,iprec,narray,ntime)
       if(ifail.eq.0)then
         write(6,280)
280      format(' - function call successful')
         atype='cell-by-cell flow term'
         if(iprec.eq.1)then
           aprec='single'
         else if(iprec.eq.2)then
           aprec='double'
         endif
         write(6,170) trim(atype)
170      format(' FILE TYPE                      = ',a)
         write(6,180) trim(aprec)
180      format(' PRECISION                      = ',a)
         write(6,190) narray
190      format(' Number of arrays in file       =',i5)
         write(6,195) ntime
195      format(' Number of output times in file =',i5)
       else
         write(6,290,advance='no')
290      format(/,' - function call unsuccessful; error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       end if
       write(6,*)

! -- Obtain other information that is needed by function extract_flows_from_cbc_file().

350    write(6,360,advance='no')
360    format(' Enter text that denotes flow type of interest: ')
       read(5,*,err=350) atext
       call lowcase(atext)
       atext=adjustl(atext)
       call char2string(17,atext,flowtype)

! -- Allocate more memory

       allocate(zonenumber(nzone),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(timestep(ntime),stressperiod(ntime),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(simtime(ntime),simflow(ntime,nzone),stat=ierr)
       if(ierr.ne.0) go to 9200

! -- Call the function.

       write(6,370)
370    format(' - calling function extract_flows_from_cbc_file()...')
       ifail=extract_flows_from_cbc_file(                 &
                 cbcfile,flowtype,isim,iprec,             &
                 ncell,izone,nzone,                       &
                 numzone,zonenumber,                      &
                 ntime,nproctime,                         &
                 timestep,stressperiod,simtime,simflow)
       if(ifail.eq.0)then
         write(6,280)
         write(6,402) nproctime
402      format('   NPROCTIME = ',i5)
         write(6,390) numzone
390      format('   NUMZONE   = ',i5)
         write(6,401)
401      format('   Zone numbers:-')
         write(6,403) (zonenumber(iz),iz=1,numzone)
403      format(5i8)
       else
         write(6,291,advance='no')
291      format(/,' - function call unsuccessful; error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       end if

! -- Record extracted results in a file.

       write(6,*)
400    write(6,410,advance='no')
410    format(' Enter name of flow-in-zone file to write: ')
       read(5,*) outfile
       open(unit=20,file=outfile,action='write')
       write(20,411)
411    format(' ZONENUMBER',t20,'KSTP',t30,'KPER',t40,'SIMTIME',t55,'SIMFLOW')
       do iz=1,numzone
         do itime=1,ntime
           write(20,420) zonenumber(iz),timestep(itime),stressperiod(itime),   &
           simtime(itime),simflow(itime,iz)
420        format(1x,i5,t20,i5,t30,i5,t40,1pg16.9,t55,1pg16.9)
         end do
       end do
       close(unit=20)
       write(6,430) trim(outfile)
430    format(' - file ',a,' written ok.')

! -- If the simulation times are all -1.0 (because of an old MF budget file type),
!    we give them artificial times.

       do itime=1,ntime
         if(simtime(itime).lt.-0.5) simtime(itime)=itime
       end do

! -- Time-interpolation will now be undertaken.

       write(6,*)
431    write(6,432,advance='no')
432    format(' Undertake time interpolation? (y/n): ')
       read(5,*,err=431) aa
       if((aa.eq.'n').or.(aa.eq.'N')) go to 1000
       if((aa.ne.'y').and.(aa.ne.'Y')) go to 431
440    write(6,450,advance='no')
450    format(' Enter name of observation time file: ')
       read(5,*,err=440) infile
       open(unit=10,file=infile,status='old',err=440)
       numobsdat=0
       do
         read(10,'(a)',end=460) cline
         if(cline.ne.' ') numobsdat=numobsdat+1
       end do
460    continue
       if(numobsdat.eq.0)then
         write(6,470)
470      format('No observation data in this file. Try again.')
         close(unit=10)
         go to 440
       else
         rewind(unit=10)
       end if
       allocate(obspoint(numobsdat),obstime(numobsdat),obsval(numobsdat),    &
       obszonenum(numobsdat),stat=ierr)
       if(ierr.ne.0) go to 9200
       do iobs=1,numobsdat
         read(10,*,err=9050,end=9050) obspoint(iobs),obstime(iobs)
         call lowcase(obspoint(iobs))
       end do
       close(unit=10)
       write(6,210) trim(infile)

! -- Extract zone numbers from from observation point names.

       do iobs=1,numobsdat
         obszonenum(iobs)=-1
         atemp20=obspoint(iobs)
         call lowcase(atemp20)
         atemp20=adjustl(atemp20)
         if(atemp20(1:4).eq.'zone')then
           atemp20=atemp20(5:)
           call intread(ifail,atemp20,itemp)
           if(ifail.eq.0)then
             do iz=1,numzone
               if(itemp.eq.zonenumber(iz))then
                 obszonenum(iobs)=iz-1             ! Don't forget requires indexing beginning at 0
                 go to 510
               end if
             end do
           end if
         end if
510      continue
       end do

! -- Now undertake temporal interpolation.

       write(6,*)
860    write(6,870,advance='no')
870    format(' Enter time-extrapolation option (L/C): ')
       read(5,*,err=860) how_extrap
       if((how_extrap.ne.'L').and.(how_extrap.ne.'l').and.   &
        (how_extrap.ne.'C').and.(how_extrap.ne.'c')) go to 860
880    write(6,890,advance='no')
890    format(' Enter extrapolation time limit: ')
       read(5,*,err=880) time_extrap
       if(time_extrap.lt.0.0d0) go to 880
895    write(6,896,advance='no')
896    format(' Enter value indicating no time interpolation: ')
       read(5,*,err=895) nointerpval
       interpthresh=1.0d300
       write(6,520)
520    format(' - calling function interp_to_obstime()....')
       ifail=interp_to_obstime(                                   &
             ntime,nproctime,nzone,simtime,simflow,interpthresh,  &
             how_extrap,time_extrap,nointerpval,                  &
             numobsdat,obszonenum,obstime,obsval)
       if(ifail.ne.0)then
         write(6,290,advance='no')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       else
         write(6,920)
920      format(' - temporal interpolation successful.')
! -- Write the output file.
940      write(6,950,advance='no')
950      format(' Enter name for post-time-interpolation output file: ')
         read(5,*,err=940) outfile
         open(unit=21,file=outfile,action='write',err=940)
         do iobs=1,numobsdat
           write(21,960) trim(obspoint(iobs)),obstime(iobs),obsval(iobs)
960        format(1x,a,t25,1pg16.9,t50,1pg16.9)
         end do
         close(unit=21)
         write(6,970) trim(outfile)
970      format(' - file ',a,' written ok.')
       end if

1000   continue
       go to 9900

9050   write(amessage,9060) trim(infile)
9060   format('Error encountered in reading file ',a,'.')
       go to 9890

9200   write(amessage,9210)
9210   format('DRIVER5 memory allocation error.')
       go to 9890

9890   continue
       amessage=' '//trim(amessage)
       call writmess(6,amessage)

! -- Tidy up

9900   continue
       write(6,*)
       write(6,9910)
9910   format(' Tidying up...')
       write(6,9915)
9915   format(' - calling function free_all_memory()...')
       ifail=free_all_memory()
       if(ifail.eq.0)then
         write(6,280)
         write(6,*)
       else
         write(6,9921)
9921     format(' Function call unsuccessful; error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         amessage=' '//trim(amessage)
         call writmess(6,amessage)
       end if
       deallocate(izone,zonenumber,stat=ierr)
       deallocate(timestep,stressperiod,stat=ierr)
       deallocate(obszonenum,stat=ierr)
       deallocate(simtime,simflow,stat=ierr)
       deallocate(obstime,obsval,stat=ierr)
       deallocate(obspoint,stat=ierr)

       end

module used_by_kb2d_1
  integer                       :: maxsam=0
  real, allocatable             :: xa(:),ya(:),dist(:)
  double precision, allocatable :: r(:),rr(:),s(:),a(:)
  integer, allocatable          :: nums(:)
end module used_by_kb2d_1


module geostat_3d

      integer             :: MAXDAT
      integer,allocatable :: nisb(:),ixsbtosr(:),iysbtosr(:),izsbtosr(:)
      real,allocatable    :: x(:),y(:),z(:),vr(:),ve(:),dh(:),tmp(:),                   &
               close(:),xa(:),ya(:),za(:),vra(:),vea(:),xdb(:),ydb(:),                  &
               zdb(:),cut(:),cdf(:)
      real*8,allocatable  :: r(:),rr(:),s(:),a(:)

      real, allocatable    :: sec3(:)                               !jd

end module geostat_3d


!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 2-D KRIGGING FOLLOWS!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


subroutine kb2d_1(n_ndmin,n_ndmax,r_radius,k_ktype,s_skmean,    &
      n_nst,c_c0,i_it,c_cc,a_ang,a_aa,a_anis,                   &
      unestimated,n_npts,n_ndat,inumdat,icellno,epoint,npoint,  &
      aoutfile,outunit,pmx,x,y,af1,af2)

      use used_by_kb2d_1

      implicit integer(i-n), real(a-h, o-z)                    !jd

!-----------------------------------------------------------------------
!
!           Ordinary/Simple Kriging of a 2-D Rectangular Grid
!           *************************************************
!
! This subroutine estimates point or block values of one variable by
! ordinary kriging.  All of the samples are rescanned for each block
! estimate; this makes the program simple but inefficient.  The data
! should NOT contain any missing values.  Unestimated points are
! returned as -1.0e21
!
!
!
! Original:  A.G. Journel                                           1978
! Revisions: B.E. Buxton                                       Apr. 1983
!-----------------------------------------------------------------------
!      include  'kb2d.inc'

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!Here is kb2d.inc!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! The following Parameters control static dimensioning within okb2d:
!
!   MAXSAM    maximum number of data points to use in one kriging system
!   MAXDIS    maximum number of discretization points per block
!   MAXNST    maximum number of nested structures
!
!-----------------------------------------------------------------------
!
! User Adjustable:
!
!      parameter(MAXSAM =  3600,  &
!                MAXDIS =   64,  &
!                MAXNST =    5)
      parameter(MAXDIS =   64,MAXNST =    5)

!
! Fixed
!
!      parameter(MAXKD=MAXSAM+1,MAXKRG=MAXKD*MAXKD,UNEST=-999.,  &
!                EPSLON=0.0000001,VERSION=2.000)
      parameter(UNEST=-999.,EPSLON=0.0000001,VERSION=2.000)
!
! Variable Declaration:
!
      real      aa(MAXNST),cc(MAXNST),ang(MAXNST),anis(MAXNST)
      integer   it(MAXNST)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!      real      xdb(MAXDIS),ydb(MAXDIS),xa(MAXSAM),ya(MAXSAM), &
!                vra(MAXSAM),dist(MAXSAM)
!!                dist(MAXSAM)
      real      xdb(MAXDIS),ydb(MAXDIS)
!!      real*8    r(MAXSAM+1),rr(MAXSAM+1),s(MAXSAM+1),a(MAXKRG)
!!      integer   nums(MAXSAM)
      logical   first

! -- The following dimension statement was added by myself for the
!    subroutine arguments.



     integer n_npts,n_ndat,outunit                                  !jd
     integer icellno(n_npts),inumdat(n_ndat)                        !jd
     real pmx                                                       !jd
     real epoint(n_npts),npoint(n_npts)                             !jd
     character*(*) aoutfile                                         !jd
     character*(*)  af1,af2                                         !jd
     character*150 aformat                                          !jd
     real x(n_ndat),y(n_ndat)                                       !jd

     integer unestimated

!!!!!!!! OLD READPARM !!!!!!!!!!
! -- The following used to be in subroutine READPARM. This allows us to
!    get rid of the common block.

      integer n_nst
      integer i_it(n_nst)
      real c_c0
      real c_cc(n_nst),a_ang(n_nst),a_aa(n_nst),a_anis(n_nst)
      lout = 2
      ldbg = 3
      idbg=0                    !debugging level
      nxdis=1
      nydis=1

! -- Here are the dummy grid specifications.

      nx=1
      xmn=0.0
      xsiz=1.0
      ny=1
      ymn=0.0
      ysiz=1.0

! -- The following variables were supplied through the subroutine argument.

      ndmin=n_ndmin
      ndmax=n_ndmax
      radius=r_radius
      ktype=k_ktype
      skmean=s_skmean
      nst=n_nst
      c0=c_c0

            do i=1,nst
                  it(i)=i_it(i)
                  cc(i)=c_cc(i)
                  ang(i)=a_ang(i)
                  aa(i)=a_aa(i)
                  anis(i)=a_anis(i)
                  if(it(i).eq.4) then
                        if(aa(i).lt.0.0) stop ' INVALID power variogram'
                        if(aa(i).gt.2.0) stop ' INVALID power variogram'
                  end if
            end do

! -- The following code was added for Damian so that we can dynamically allocate some arrays

      if(ndmax.gt.maxsam)then
        if(maxsam.gt.0)then
          deallocate(xa,ya,dist,stat=ierr)
          if(ierr.ne.0)then
            write(6,12)
12          format(' Deallocation error in subroutine kb2d_1.')
            stop
          end if
          deallocate(r,rr,s,a,nums,stat=ierr)
          if(ierr.ne.0) then
            write(6,12)
            stop
          end if
          maxsam=0
        end if
      end if
      if(maxsam.eq.0)then
!        maxsam=max(ndmax,3600)
        maxsam=max(ndmax,7000)
!        maxsam=max(ndmax,15000)
        maxkd=maxsam+1
        maxkrg=maxkd*maxkd
        allocate(xa(maxsam),ya(maxsam),dist(maxsam),stat=ierr)
        if(ierr.ne.0)then
          write(6,11)
11        format(' Allocation error in subroutine kb2d_1.')
          stop
        end if
        allocate(r(maxsam+1),rr(maxsam+1),s(maxsam+1),a(maxkrg),nums(maxsam),stat=ierr)
        if(ierr.ne.0)then
          write(6,11)
          stop
        end if
      end if

! -- Testing

      if(nst.gt.MAXNST)   stop ' nst is too big - contact programmer'
      if(ndmax.gt.MAXSAM) stop ' ndmax is too big - contact programmer'

!!!!!!!! OLD READPARM !!!!!!!!!!

! -- We work out the formatting so that we get good compression if
!    writing an ascii file.

     nd=n_ndat
     aformat='('//trim(af2)//','//trim(af1)//',1x,1pg14.7,1000('//trim(af1)//',1x,1pg14.7))' !jd

      first=.true.                                    !jd
      unestimated=0
!
! Echo the input parameters if debugging flag is >2:
!
      if(idbg.gt.2) then
            write(ldbg,*) 'KB2D Parameters'
            write(ldbg,*)
            write(ldbg,*) 'Variogram Parameters for ',nst,' structures:'
            write(ldbg,*) '  Nugget effect:         ',c0
            write(ldbg,*) '  Types of variograms:   ',(it(i),i=1,nst)
            write(ldbg,*) '  Contribution cc        ',(cc(i),i=1,nst)
            write(ldbg,*) '  Ranges:                ',(aa(i),i=1,nst)
            write(ldbg,*) '  Angle for Continuity:  ',(ang(i),i=1,nst)
            write(ldbg,*) '  Anisotropy Factors:    ',(anis(i),i=1,nst)
            write(ldbg,*) ' '
            write(ldbg,*) 'Grid for Kriging:'
            write(ldbg,*) '  Number of X and Y Blocks:',nx,ny
            write(ldbg,*) '  Origin of X and Y Blocks:',xmn,ymn
            write(ldbg,*) '  Size   of X and Y Blocks:',xsiz,ysiz
            write(ldbg,*) ' '
            write(ldbg,*) 'Discretization of blocks:  ',nxdis,nydis
            write(ldbg,*) 'Search Radius:             ',radius
            write(ldbg,*) 'Minimum number of samples: ',ndmin
            write(ldbg,*) 'Maximum number of samples: ',ndmax
            write(ldbg,*) ' '
      endif
!
! Echo the input data if debugging flag >1:
!
!      if(idbg.ge.4) then
!            do id=1,nd
!                  write(ldbg,99) id,x(id),y(id),vr(id)
! 99               format('Data: ',i5,' at ',2f12.3,' value: ',f12.5)
!            end do
!      endif
!
! Set up the discretization points per block.  Figure out how many
! are needed, the spacing, and fill the xdb and ydb arrays with the
! offsets relative to the block center (this only gets done once):
!
      ndb  = nxdis * nydis
      if(ndb.gt.MAXDIS) then
            write(*,*) ' ERROR KB2D: Too many discretization points '
            write(*,*) '             Increase MAXDIS or lower n[xy]dis'
            stop
      endif
      xdis = xsiz  / max(real(nxdis),1.0)
      ydis = ysiz  / max(real(nydis),1.0)
      xloc = -0.5*(xsiz+xdis)
      i    = 0
      do ix =1,nxdis
            xloc = xloc + xdis
            yloc = -0.5*(ysiz+ydis)
            do iy=1,nydis
                  yloc = yloc + ydis
                  i = i+1
                  xdb(i) = xloc
                  ydb(i) = yloc
            end do
      end do
!
! Initialize accumulators:
!
      cbb  = 0.0
      rad2 = radius*radius
!
! Calculate Block Covariance. Check for point kriging.
!
      cov   = cova2(xdb(1),ydb(1),xdb(1),ydb(1),nst,c0,PMX,cc, &
                    aa,it,ang,anis,first,passmaxcov)
!
! Keep this value to use for the unbiasedness constraint:
!
      unbias = cov
      first  = .false.
      if (ndb.le.1) then
            cbb = cov
      else
            do i=1,ndb
                  do j=1,ndb
                        cov = cova2(xdb(i),ydb(i),xdb(j),ydb(j),nst,c0, &
                                    PMX,cc,aa,it,ang,anis,first,passmaxcov)
                        if(i.eq.j) cov = cov - c0
                        cbb = cbb + cov
                  end do
            end do
            cbb = cbb/real(ndb*ndb)
      endif
      if(idbg.gt.1) then
            write(ldbg,*) ' '
            write(ldbg,*) 'Block Covariance: ',cbb
            write(ldbg,*) ' '
      endif
!
! MAIN LOOP OVER ALL THE BLOCKS IN THE GRID:
!
      nk = 0
      ak = 0.0
      vk = 0.0
!jd      do 4 iy=1,ny                                               !jd
!jd      yloc = ymn + (iy-1)*ysiz                                   !jd
!jd      do 4 ix=1,nx                                               !jd
!jd            xloc = xmn + (ix-1)*xsiz                             !jd

         do 4 i_ipts=1,n_npts                                       !jd
            xloc=epoint(i_ipts)                                     !jd
            yloc=npoint(i_ipts)                                     !jd
            icell=icellno(i_ipts)                                   !jd
!
! Find the nearest samples within each octant: First initialize
! the counter arrays:
!
            na = 0
            do isam=1,ndmax
                  dist(isam) = 1.0e+20
                  nums(isam) = 0
            end do
!
! Scan all the samples (this is inefficient and the user with lots of
! data should move to ktb3d):
!
            do 6 id=1,nd
                  dx = x(id) - xloc
                  dy = y(id) - yloc
                  h2 = dx*dx + dy*dy
                  if(h2.gt.rad2) go to 6
!
! Do not consider this sample if there are enough close ones:
!
                  if(na.ne.0)then                          !jd
                  if(na.eq.ndmax.and.h2.gt.dist(na)) go to 6
                  end if                                  !jd
!
! Consider this sample (it will be added in the correct location):
!
                  if(na.lt.ndmax) na = na + 1
                  nums(na)           = id
                  dist(na)           = h2
                  if(na.eq.1) go to 6
!
! Sort samples found thus far in increasing order of distance:
!
                  n1 = na-1
                  do ii=1,n1
                        k=ii
                        if(h2.lt.dist(ii)) then
                              jk = 0
                              do jj=k,n1
                                    j  = n1-jk
                                    jk = jk+1
                                    j1 = j+1
                                    dist(j1) = dist(j)
                                    nums(j1) = nums(j)
                              end do
                              dist(k) = h2
                              nums(k) = id
                              go to 6
                        endif
                  end do
 6          continue
!
! Is there enough samples?
!
            if(na.lt.ndmin) then
                  if(idbg.ge.2) &
                  write(ldbg,*) 'Block ',ix,iy, 'not estimated'
                  est  = UNEST
                  estv = UNEST
                  go to 8888
!                  go to 1
            endif
!
! Put coordinates and values of neighborhood samples into xa,ya,vra:
!
            do ia=1,na
                  jj      = nums(ia)
                  xa(ia)  = x(jj)
                  ya(ia)  = y(jj)
!                  vra(ia) = vr(jj)
            end do
!
! Handle the situation of only one sample:
!
            if(na.eq.1) then
                  cb1 = cova2(xa(1),ya(1),xa(1),ya(1),nst,c0,   &
                              PMX,cc,aa,it,ang,anis,first,passmaxcov)
                  xx  = xa(1) - xloc
                  yy  = ya(1) - yloc
!
! Establish Right Hand Side Covariance:
!
                  if(ndb.le.1) then
                        cb = cova2(xx,yy,xdb(1),ydb(1),nst,c0,  &
                                   PMX,cc,aa,it,ang,anis,first,passmaxcov)
                  else
                        cb  = 0.0
                        do i=1,ndb
                              cb = cb + cova2(xx,yy,xdb(i),ydb(i),nst, &
                                        c0,PMX,cc,aa,it,ang,anis,first,passmaxcov)
                              dx = xx - xdb(i)
                              dy = yy - ydb(i)
                              if((dx*dx+dy*dy).lt.EPSLON) &
                              cb = cb - c0
                        end do
                        cb = cb / real(ndb)
                  end if
                  if(ktype.eq.0) then
                        s(1) = cb/cbb
!                        est  = s(1)*vra(1) + (1.0-s(1))*skmean
!                        estv = cbb - s(1) * cb
                  else
                        s(1) = 1.0                                      !jd
!                        est  = vra(1)
!                        estv = cbb - 2.0*cb + cb1
                  end if

                  if(ktype.eq.0)then                                    !jd
!!                    rrtemp=(1.0-s(1))*skmean                            !jd
                    rrtemp=(1.0-s(1))                                  !jd
                  else                                                  !jd
                    rrtemp=0.0                                          !jd
                  end if                                                !jd
                  if(aoutfile.eq.'f')then                               !jd
                    write(outunit,aformat) icell,1,rrtemp, &            !jd
                    inumdat(nums(1)),s(1)                                 !jd
                  else                                                    !jd
                    i_one=1                                               !jd
                    write(outunit)   icell,i_one,rrtemp, &                    !jd
                    inumdat(nums(1)),real(s(1))                              !jd
                  end if                                                  !jd

            else
!
! Solve the Kriging System with more than one sample:
!
                  neq = na + ktype
                  nn  = (neq + 1)*neq/2
!
! Set up kriging matrices:
!
                  in=0
                  do j=1,na
!
! Establish Left Hand Side Covariance Matrix:
!
                        do i=1,j
                              in = in + 1
                              a(in) = dble( cova2(xa(i),ya(i),xa(j),  &
                                            ya(j),nst,c0,PMX,cc,aa,it, &
                                            ang,anis,first,passmaxcov) )
                        end do
                        xx = xa(j) - xloc
                        yy = ya(j) - yloc
!
! Establish Right Hand Side Covariance:
!
                        if(ndb.le.1) then
                              cb = cova2(xx,yy,xdb(1),ydb(1),nst,c0,  &
                                         PMX,cc,aa,it,ang,anis,first,passmaxcov)
                        else
                              cb  = 0.0
                              do j1=1,ndb
                                    cb = cb + cova2(xx,yy,xdb(j1),  &
                                         ydb(j1),nst,c0,PMX,cc,aa,  &
                                         it,ang,anis,first,passmaxcov)
                                    dx = xx - xdb(j1)
                                    dy = yy - ydb(j1)
                                    if((dx*dx+dy*dy).lt.EPSLON)  &
                                          cb = cb - c0
                              end do
                              cb = cb / real(ndb)
                        end if
                        r(j)  = dble(cb)
                        rr(j) = r(j)
                  end do
!
! Set the unbiasedness constraint:
!
                  if(ktype.eq.1) then
                        do i=1,na
                              in    = in + 1
                              a(in) = dble(unbias)
                        end do
                        in      = in + 1
                        a(in)   = 0.0
                        r(neq)  = dble(unbias)
                        rr(neq) = r(neq)
                  end if
!
! Write out the kriging Matrix if Seriously Debugging:
!
                  if(idbg.ge.3) then
                        write(ldbg,101) ix,iy
                        is = 1
                        do i=1,neq
                              ie = is + i - 1
                              write(ldbg,102) i,r(i),(a(j),j=is,ie)
                              is = is + i
                        end do
 101                    format(/,'Kriging Matrices for Node: ',2i4,  &
                                 ' RHS first')
 102                    format('    r(',i2,') =',f7.4,'  a= ',9(10f7.4))
                  endif
!
! Solve the Kriging System:
!
                  call ksol(1,neq,1,a,r,s,ising)
!
! Write a warning if the matrix is singular:
!
                  if(ising.ne.0) then
        write(6,450) icell                                            !jd
450     format(' WARNING: singular kriging matrix for cell',i5)      !jd
                        est  = UNEST
                        estv = UNEST
                        go to 8888
!                        go to 1
                  endif
!
! Write the kriging weights and data if requested:
!
!                  if(idbg.ge.2) then
!                        write(ldbg,*) '       '
!                        write(ldbg,*) 'BLOCK: ',ix,iy
!                        write(ldbg,*) '       '
!                        if(ktype.eq.1) write(ldbg,*)    &
!                        '  Lagrange multiplier: ',s(neq)*unbias
!                        write(ldbg,*) '  BLOCK EST: x,y,vr,wt '
!                        do i=1,na
!                        write(ldbg,'(4f12.3)') xa(i),ya(i),vra(i),s(i)
!                        end do
!                  endif
!
! Compute the estimate and the kriging variance:
!
                  est  = 0.0
                  estv = cbb
                  sumw = 0.0
                  if(ktype.eq.1) estv = estv - real(s(na+1))
                  do i=1,na
                        sumw = sumw + real(s(i))
!                        est  = est  + real(s(i))*vra(i)
!                        estv = estv - real(s(i)*rr(i))
                  end do
!                  if(ktype.eq.0) est = est + (1.0-sumw)*skmean

                  if(ktype.eq.0)then                                    !jd
!!                    rrtemp=(1.0-sumw)*skmean                            !jd
                    rrtemp=(1.0-sumw)                                   !jd
                  else                                                  !jd
                    rrtemp=0.0                                          !jd
                  end if                                                !jd
                  if(aoutfile.eq.'f')then                               !jd
                    write(outunit,aformat) icell,na,rrtemp, &           !jd
                    (inumdat(nums(i)),real(s(i)),i=1,na)              !jd
                  else                                                  !jd
                    write(outunit)   icell,na,rrtemp, &                 !jd
                    (inumdat(nums(i)),real(s(i)),i=1,na)              !jd
                  end if                                                !jd
            endif
!            if(idbg.ge.2) then
!                  write(ldbg,*) '  est  ',est
!                  write(ldbg,*) '  estv ',estv
!                  write(ldbg,*) ' '
!            endif
!
! Write the result to the output file:
!
! 1          write(lout,'(f8.3,1x,f8.3)') est,estv

1           continue

!            if(est.gt.UNEST)then
!              iirow=(icell-1)/n_ncol+1
!              iicol=icell-((iirow-1)*n_ncol)
!              rrtemp=estv
!              if(rrtemp.lt.0.0)rrtemp=0.0
!              var_arr(iicol,iirow)=sqrt(rrtemp)
!            end if

!            if(est.gt.UNEST) then
!                  nk = nk + 1
!                  ak = ak + est
!                  vk = vk + est*est
!            end if
!
! END OF MAIN LOOP OVER ALL THE BLOCKS:
!
 4    continue
!      if(nk.ge.1) then
!            ak = ak / real(nk)
!            vk = vk/real(nk) - ak*ak
!             write(6,105) nk
105          format('   No. of grid points for which factors were calculated = ',i5)
!             write(6,106) ak
!106          format('   Average interpolated value at these points           = ',1pg12.5)
!             if(vk.lt.0.0)vk=0.0
!             write(6,107) sqrt(vk)
!107          format('   Standard deviation of interpolated grid point values = ',1pg12.5)

!            write(ldbg,105) nk,ak,vk
!            write(*,   105) nk,ak,vk
! 105        format(/,'Estimated   ',i8,' blocks ',/,  &
!                     '  average   ',f9.4,/,'  variance  ',f9.4,/)
!      else
!        write(6,105) nk
!      end if
      return

! Error condition arising from an unestimable point.

8888  unestimated=icell
      return


end subroutine kb2d_1



      real function cova2(x1,y1,x2,y2,nst,c0,PMX,cc,aa,it,  &
                          ang,anis,first,passmaxcov)              !jd

      implicit integer(i-n), real(a-h, o-z)                    !jd

!-----------------------------------------------------------------------
!
!              Covariance Between Two Points (2-D Version)
!              *******************************************
!
! This function returns the covariance associated with a variogram model
! that is specified by a nugget effect and possibly four different
! nested varigoram structures.  The anisotropy definition can be
! different for each of the nested structures (spherical, exponential,
! gaussian, or power).
!
!
!
! INPUT VARIABLES:
!
!   x1,y1            Coordinates of first point
!   x2,y2            Coordinates of second point
!   nst              Number of nested structures (max. 4).
!   c0               Nugget constant (isotropic).
!   PMX              Maximum variogram value needed for kriging when
!                      using power model.  A unique value of PMX is
!                      used for all nested structures which use the
!                      power model.  therefore, PMX should be chosen
!                      large enough to account for the largest single
!                      structure which uses the power model.
!   cc(nst)          Multiplicative factor of each nested structure.
!   aa(nst)          Parameter "a" of each nested structure.
!   it(nst)          Type of each nested structure:
!                      1. spherical model of range a;
!                      2. exponential model of parameter a;
!                           i.e. practical range is 3a
!                      3. gaussian model of parameter a;
!                           i.e. practical range is a*sqrt(3)
!                      4. power model of power a (a must be gt. 0  and
!                           lt. 2).  if linear model, a=1,c=slope.
!   ang(nst)         Azimuth angle for the principal direction of
!                      continuity (measured clockwise in degrees from Y)
!   anis(nst)        Anisotropy (radius in minor direction at 90 degrees
!                      from "ang" divided by the principal radius in
!                      direction "ang")
!   first            A logical variable which is set to true if the
!                      direction specifications have changed - causes
!                      the rotation matrices to be recomputed.
!
!
!
! OUTPUT VARIABLES: returns "cova2" the covariance obtained from the
!                   variogram model.
!
!
!
!-----------------------------------------------------------------------
      parameter(DTOR=3.14159265/180.0,EPSLON=0.0000001)
      real      aa(*),cc(*),ang(*),anis(*),rotmat(4,4),maxcov
      integer   it(*)
      logical   first
      save      rotmat,maxcov
!
! The first time around, re-initialize the cosine matrix for the
! variogram structures:
!
      if(first) then
            maxcov = c0
            do is=1,nst
                  azmuth       = (90.0-ang(is))*DTOR
                  rotmat(1,is) =  cos(azmuth)
                  rotmat(2,is) =  sin(azmuth)
                  rotmat(3,is) = -sin(azmuth)
                  rotmat(4,is) =  cos(azmuth)
                  if(it(is).eq.4) then
                        maxcov = maxcov + PMX
                  else
                        maxcov = maxcov + cc(is)
                  endif
            end do
      endif
      passmaxcov=maxcov                                            !jd
!
! Check for very small distance:
!
      dx = x2-x1
      dy = y2-y1
      if((dx*dx+dy*dy).lt.EPSLON) then
            cova2 = maxcov
            return
      endif
!
! Non-zero distance, loop over all the structures:
!
      cova2 = 0.0
      do is=1,nst
!
! Compute the appropriate structural distance:
!
            dx1 = (dx*rotmat(1,is) + dy*rotmat(2,is))
            dy1 = (dx*rotmat(3,is) + dy*rotmat(4,is))/anis(is)
            h   = sqrt(max((dx1*dx1+dy1*dy1),0.0))
            if(it(is).eq.1) then
!
! Spherical model:
!
                  hr = h/aa(is)
                  if(hr.lt.1.0) cova2 = cova2    &
                                      + cc(is)*(1.-hr*(1.5-.5*hr*hr))
            else if(it(is).eq.2) then
!
! Exponential model:
!
                  cova2 = cova2 +cc(is)*exp(-h/aa(is))
            else if(it(is).eq. 3) then
!
! Gaussian model:
!
                  hh=-(h*h)/(aa(is)*aa(is))
                  cova2 = cova2 +cc(is)*exp(hh)
            else
!
! Power model:
!
                  cov1  = PMX - cc(is)*(h**aa(is))
                  cova2 = cova2 + cov1
            endif
      end do
      return
      end





      subroutine ksol(nright,neq,nsb,a,r,s,ising)

!-----------------------------------------------------------------------
!
!                Solution of a System of Linear Equations
!                ****************************************
!
!
!
! INPUT VARIABLES:
!
!   nright,nsb       number of columns in right hand side matrix.
!                      for KB2D: nright=1, nsb=1
!   neq              number of equations
!   a()              upper triangular left hand side matrix (stored
!                      columnwise)
!   r()              right hand side matrix (stored columnwise)
!                      for kb2d, one column per variable
!
!
!
! OUTPUT VARIABLES:
!
!   s()              solution array, same dimension as  r  above.
!   ising            singularity indicator
!                      0,  no singularity problem
!                     -1,  neq .le. 1
!                      k,  a null pivot appeared at the kth iteration
!
!
!
! PROGRAM NOTES:
!
!   1. Requires the upper triangular left hand side matrix.
!   2. Pivots are on the diagonal.
!   3. Does not search for max. element for pivot.
!   4. Several right hand side matrices possible.
!   5. USE for ok and sk only, NOT for UK.
!
!
!-----------------------------------------------------------------------
      implicit integer (i-n)
      implicit real*8 (a-h,o-z)
      real*8   a(*),r(*),s(*)
!
! If there is only one equation then set ising and return:
!
      if(neq.le.1) then
            ising = -1
            return
      endif
!
! Initialize:
!
      tol   = 0.1e-06
      ising = 0
      nn    = neq*(neq+1)/2
      nm    = nsb*neq
      m1    = neq-1
      kk    = 0
!
! Start triangulation:
!
      do k=1,m1
            kk=kk+k
            ak=a(kk)
            if(abs(ak).lt.tol) then
                  ising=k
                  return
            endif
            km1=k-1
            do iv=1,nright
                  nm1=nm*(iv-1)
                  ii=kk+nn*(iv-1)
                  piv=1./a(ii)
                  lp=0
                  do i=k,m1
                        ll=ii
                        ii=ii+i
                        ap=a(ii)*piv
                        lp=lp+1
                        ij=ii-km1
                        do j=i,m1
                              ij=ij+j
                              ll=ll+j
                              a(ij)=a(ij)-ap*a(ll)
                        end do
                        do llb=k,nm,neq
                              in=llb+lp+nm1
                              ll1=llb+nm1
                              r(in)=r(in)-ap*r(ll1)
                        end do
                  end do
            end do
      end do
!
! Error checking - singular matrix:
!
      ijm=ij-nn*(nright-1)
      if(abs(a(ijm)).lt.tol) then
            ising=neq
            return
      endif
!
! Finished triangulation, start solving back:
!
      do iv=1,nright
            nm1=nm*(iv-1)
            ij=ijm+nn*(iv-1)
            piv=1./a(ij)
            do llb=neq,nm,neq
                  ll1=llb+nm1
                  s(ll1)=r(ll1)*piv
            end do
            i=neq
            kk=ij
            do ii=1,m1
                  kk=kk-i
                  piv=1./a(kk)
                  i=i-1
                  do llb=i,nm,neq
                        ll1=llb+nm1
                        in=ll1
                        ap=r(in)
                        ij=kk
                        do j=i,m1
                              ij=ij+j
                              in=in+1
                              ap=ap-a(ij)*s(in)
                        end do
                        s(ll1)=ap*piv
                  end do
            end do
      end do
!
! Finished solving back, return:
!
      return
      end

!Notes:-
! standard deviations computed for gaussian case seem to be in error when a is large.



!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 3-D KRIGGING FOLLOWS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


      subroutine readparm_1(MAXDIS,MAXSBX,MAXSBY,MAXSBZ,MAXEQ,n_ndmin,n_ndmax,     &
      r_radius1,r_radius2,r_radius3,k_ktype,s_skmean,n_nst,c_c0,           &
      i_it,c_cc,a_ang1,a_ang2,a_ang3,a_hmax,a_hmin,a_vert,                 &
      n_nd,ncol_range,nrow_range,icall)

!      use       msflib
      use       geostat_3d

      implicit integer(i-n), real(a-h, o-z)                    !jd

!!!!!!!!!!!!!!!!!!kt3d.inc!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      parameter(MAXDT  =   9, MAXNST =   4)
      parameter(UNEST = -999.0, EPSLON = 0.000001, MAXROT = MAXNST + 1,VERSION = 3.000)
      integer   idrif(MAXDT),nst(1),it(MAXNST),iktype,ncut,test
      real      bv(9),c0(1),cc(MAXNST),aa(MAXNST),ang1(MAXNST),	         &
                ang2(MAXNST),ang3(MAXNST),anis1(MAXNST),anis2(MAXNST)
      real*8    rotmat(MAXROT,3,3)
      common /datcom/ nd,tmin,tmax,nx,ny,nz,xmn,ymn,zmn,test,            &
                      xsiz,ysiz,zsiz,ndmax,ndmin,radius,noct,nxdis,      &
                      nydis,nzdis,idrif,itrend,ktype,skmean,koption,     &
                      idbg,ldbg,iout,lout,iext,lext,iextve,ljack,        &
                      idhlj,ixlj,iylj,izlj,ivrlj,iextvj,nvarij
      common /vargdt/ nst,it,c0,cc,aa,ang1,ang2,ang3,anis1,anis2,rotmat
      common /srccom/ sang1,sang2,sang3,sanis1,sanis2,isrot,na,ndb,bv,unbias,iktype,ncut

!!!!!!!!!!!!!!!!!!kt3d.inc!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      parameter(MV=100)
      real      var(MV)
      character datafl*512,jackfl*512,extfl*512,outfl*512,dbgfl*512,str*512,title*80
      logical   testfl

! -- Dimension statements added by myself for subroutine arguments.

      integer ncol_range,nrow_range
      integer i_it(n_nst)
      integer icall
      real c_c0
      real c_cc(n_nst),a_ang1(n_nst),a_ang2(n_nst),a_ang3(n_nst)
      real a_hmax(n_nst),a_hmin(n_nst),a_vert(n_nst)

!
! FORTRAN Units:
!
      lin   = 81                       !jd
      ldbg  = 83                       !jd
      lout  = 84                       !jd
      lext  = 87                       !jd
      ljack = 88                       !jd

!
! Read Input Parameters:
!
!jd      read(lin,'(a512)',err=98) datafl
!jd      call chknam(datafl,512)
!jd      write(*,*) ' data file = ',datafl(1:40)

!jd      read(lin,*,err=98) idhl,ixl,iyl,izl,ivrl,iextv
!jd      write(*,*) ' columns = ',idhl,ixl,iyl,izl,ivrl,iextv

!jd      read(lin,*,err=98) tmin,tmax
!jd      write(*,*) ' trimming limits = ',tmin,tmax

!jd      read(lin,*,err=98) koption
!jd      write(*,*) ' kriging option = ',koption

      datafl=' '                 !jd
      idhl=-9999                 !jd
      ixl=-9999                  !jd
      iyl=-9999                  !jd
      izl=-9999                  !jd
      ivrl=-9999                 !jd
      iextv=-9999                !jd
      tmax=0.0                   !jd
      tmin=0.0                   !jd
      koption=0                  !jd
!
! This is an undocumented feature to have kt3d construct an IK-type
! distribution:
!
      iktype = 0
!jd      if(koption.lt.0) then
!jd            iktype  = 1
!jd            koption = -koption
!jd      end if
!jd      if(iktype.eq.1) then

!jd            read(lin,*,err=98) ncut
!jd            write(*,*) ' number of cutoffs = ',ncut
!
! Find the needed parameter:
!
!jd            MAXCUT = ncut
!
! Allocate the needed memory:
!21
!jd            allocate(cut(MAXCUT),stat = test)
!jd                  if(test.ne.0)then
!jd                        write(*,*)'ERROR: Allocation failed due to',
!jd     +                        ' insufficient memory.'
!jd                        stop
!jd                  end if
!22
!jd            allocate(cdf(MAXCUT),stat = test)
!jd                  if(test.ne.0)then
!jd                        write(*,*)'ERROR: Allocation failed due to',
!jd     +                        ' insufficient memory.'
!jd                        stop
!jd                  end if
!
!jd            read(lin,*,err=98) (cut(i),i=1,ncut)
!jd            write(*,*) ' cutoffs = ',(cut(i),i=1,ncut)

!jd      end if

!jd      read(lin,'(a512)',err=98) jackfl
!jd      call chknam(jackfl,512)
!jd      write(*,*) ' jackknife data file = ',jackfl(1:40)

         jackfl=' '                     !jd

!jd      read(lin,*,err=98) ixlj,iylj,izlj,ivrlj,iextvj
!jd      write(*,*) ' columns = ',ixlj,iylj,izlj,ivrlj,iextvj

       ixlj=0           !jd
       iylj=0           !jd
       izlj=0           !jd
       ivrlj=0          !jd
       iextvj=0         !jd

!jd      read(lin,*,err=98) idbg
!jd      write(*,*) ' debugging level = ',idbg

      idbg=0                                            !jd

!jd      read(lin,'(a512)',err=98) dbgfl
!jd      call chknam(dbgfl,512)
!jd      write(*,*) ' debugging file = ',dbgfl(1:40)

      dbgfl='debug_kt3d.dat'                            !jd

!jd      read(lin,'(a512)',err=98) outfl
!jd      call chknam(outfl,512)
!jd      write(*,*) ' output file = ',outfl(1:40)


      outfl='output_kt3d.dat'                           !jd

!jd      read(lin,*,err=98) nx,xmn,xsiz
!jd      write(*,*) ' nx, xmn, xsiz = ',nx,xmn,xsiz

      nx=1                                             !jd
      xmn=0.0                                          !jd
      xsiz=1.0                                         !jd

!jd      read(lin,*,err=98) ny,ymn,ysiz
!jd      write(*,*) ' ny, ymn, ysiz = ',ny,ymn,ysiz

      ny=1                                             !jd
      ymn=0.0                                          !jd
      ysiz=1.0                                         !jd

!jd      read(lin,*,err=98) nz,zmn,zsiz
!jd      write(*,*) ' nz, zmn, zsiz = ',nz,zmn,zsiz

      nz=1                                             !jd
      zmn=0.0                                          !jd
      zsiz=1.0                                         !jd

!jd      read(lin,*,err=98) nxdis,nydis,nzdis
!jd      write(*,*) ' block discretization:',nxdis,nydis,nzdis

      nxdis=1                                          !jd
      nydis=1                                          !jd
      nzdis=1                                          !jd

!jd      read(lin,*,err=98) ndmin,ndmax
!jd      write(*,*) ' ndmin,ndmax = ',ndmin,ndmax

      ndmin=n_ndmin                                    !jd
      ndmax=n_ndmax                                    !jd

!jd      read(lin,*,err=98) noct
!jd      write(*,*) ' max per octant = ',noct

      noct=0                                           !jd

!jd      read(lin,*,err=98) radius,radius1,radius2
!jd      write(*,*) ' search radii = ',radius,radius1,radius2
!jd      if(radius.lt.EPSLON) stop 'radius must be greater than zero'

      radius=r_radius1                                !jd
      radius1=r_radius2                                !jd
      radius2=r_radius3                                !jd

      radsqd = radius  * radius
      sanis1 = radius1 / radius
      sanis2 = radius2 / radius

!jd      read(lin,*,err=98) sang1,sang2,sang3
!jd      write(*,*) ' search anisotropy angles = ',sang1,sang2,sang3

!jd      read(lin,*,err=98) ktype,skmean
!jd      write(*,*) ' ktype, skmean =',ktype,skmean

      ktype=k_ktype                                    !jd
      skmean=s_skmean                                  !jd

!jd      read(lin,*,err=98) (idrif(i),i=1,9)
!jd      write(*,*) ' drift terms = ',(idrif(i),i=1,9)

      do i=1,9                                         !jd
        idrif(i)=0                                     !jd
      end do                                           !jd

!jd      read(lin,*,err=98) itrend
!jd      write(*,*) ' itrend = ',itrend

      itrend=0                                         !jd

!jd      read(lin,'(a512)',err=98) extfl
!jd      call chknam(extfl,40)
!jd      write(*,*) ' external drift file = ',extfl(1:40)

      extfl=' '                                        !jd

!jd      read(lin,*,err=98) iextve
!jd      write(*,*) ' variable in external drift file = ',iextve

      iextve=0                                         !jd

!jd      read(lin,*,err=98) nst(1),c0(1)
!jd      write(*,*) ' nst, c0 = ',nst(1),c0(1)

      nst(1)=n_nst                                     !jd
      c0(1)=c_c0                                       !jd

!jd      if(nst(1).le.0) then
!jd            write(*,9997) nst(1)
!jd 9997       format(' nst must be at least 1, it has been set to ',i4,/,
!jd     +             ' The c or a values can be set to zero')
!jd            stop
!jd      endif

      do i=1,nst(1)
!jd            read(lin,*,err=98) it(i),cc(i),ang1(i),ang2(i),ang3(i)

            it(i)=i_it(i)                               !jd
            cc(i)=c_cc(i)                               !jd
            ang1(i)=a_ang1(i)                           !jd
            ang2(i)=a_ang2(i)                           !jd
            ang3(i)=a_ang3(i)                           !jd

!jd            read(lin,*,err=98) aa(i),aa1,aa2

            aa(i)=a_hmax(i)                             !jd
            aa1  =a_hmin(i)                             !jd
            aa2  =a_vert(i)                             !jd

            anis1(i) = aa1 / max(aa(i),EPSLON)
            anis2(i) = aa2 / max(aa(i),EPSLON)
!jd            write(*,*) ' it,cc,ang[1,2,3]; ',it(i),cc(i),
!jd     +                   ang1(i),ang2(i),ang3(i)
!jd            write(*,*) ' a1 a2 a3: ',aa(i),aa1,aa2
            if(it(i).eq.4) then
                  if(aa(i).lt.0.0) stop ' INVALID power variogram'
                  if(aa(i).gt.2.0) stop ' INVALID power variogram'
            end if
      end do

      if(nst(1).eq.1)then                            !jd
        itemp=1                                      !jd
      else                                           !jd
        rtemp=-1.035                                 !jd
        do i=1,nst(1)                                !jd
          if(cc(i).gt.rtemp)then                     !jd
            rtemp=cc(i)                              !jd
            itemp=i                                  !jd
          end if                                     !jd
        end do                                       !jd
      end if                                         !jd
      sang1=ang1(itemp)                              !jd
      sang2=ang2(itemp)                              !jd
      sang3=ang3(itemp)                              !jd

!jd      close(lin)
!
! Find the needed parameters:
!
      MAXDIS = nxdis*nydis*nzdis
      MAXSAM = ndmax + 1
      MAXEQ = MAXSAM + MAXDT + 2
      MAXSBX = 1
!jd      if(nx.gt.1)then
!jd            MAXSBX = int(nx/2.00)
!jd            if(MAXSBX.gt.50)MAXSBX=50
!jd      end if

!!      if(ncol_range.gt.1)then                         !jd
!!            MAXSBX = int(ncol_range/2.00)             !jd
!!            if(MAXSBX.gt.50)MAXSBX=50                 !jd
!!      end if                                          !jd
!
      MAXSBY = 1
!jd      if(ny.gt.1)then
!jd            MAXSBY = int(ny/2.00)
!jd            if(MAXSBY.gt.50)MAXSBY=50
!jd      end if

!!      if(nrow_range.gt.1)then                         !jd
!!            MAXSBY = int(nrow_range/2.00)             !jd
!!            if(MAXSBY.gt.50)MAXSBY=50                 !jd
!!      end if                                          !jd
!
      MAXSBZ = 1
!jd      if(nz.gt.1)then
!jd            MAXSBZ = int(nz/2.00)
!jd            if(MAXSBZ.gt.50)MAXSBZ=50
!jd      end if
!
      MAXSB = MAXSBX*MAXSBY*MAXSBZ
      MXSXY = 4 * MAXSBX * MAXSBY
      MXSX  = 2 * MAXSBX
!
! Allocate the needed memory:
!1
      if(icall.eq.1)then
      allocate(nisb(MAXSB),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!2
      if(icall.eq.1)then
      allocate(ixsbtosr(8 * MAXSB),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!3
      if(icall.eq.1)then
      allocate(iysbtosr(8 * MAXSB),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!4
      if(icall.eq.1)then
      allocate(izsbtosr(8 * MAXSB),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!13
      if(icall.eq.1)then
      allocate(xa(MAXSAM),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!14
      if(icall.eq.1)then
      allocate(ya(MAXSAM),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!15
      if(icall.eq.1)then
      allocate(za(MAXSAM),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!16
      if(icall.eq.1)then
      allocate(vra(MAXSAM),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!17
      if(icall.eq.1)then
      allocate(vea(MAXSAM),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!18
      if(icall.eq.1)then
      allocate(xdb(MAXDIS),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!19
      if(icall.eq.1)then
      allocate(ydb(MAXDIS),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!20
      if(icall.eq.1)then
      allocate(zdb(MAXDIS),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!23
      if(icall.eq.1)then
      allocate(r(MAXEQ),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!24
      if(icall.eq.1)then
      allocate(rr(MAXEQ),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!25

      if(icall.eq.1)then
      allocate(s(MAXEQ),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!26
      if(icall.eq.1)then
      allocate(a(MAXEQ * MAXEQ),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!
! Perform some quick error checking:
!
      if(ndmax.gt.MAXSAM) stop 'ndmax is too big - modify .inc file'
      if(ktype.eq.3.and.iextv.le.0) stop 'must have external variable'
      if(ixl.le.0.and.nx.gt.1) write(*,*) ' WARNING: ixl=0 and nx>1 ! '
      if(iyl.le.0.and.ny.gt.1) write(*,*) ' WARNING: iyl=0 and ny>1 ! '
      if(izl.le.0.and.nz.gt.1) write(*,*) ' WARNING: izl=0 and nz>1 ! '
!
! Check to make sure the data file exists, then either read in the
! data or write an error message and stop:
!

!jd      inquire(file=datafl,exist=testfl)
!jd      if(.not.testfl) then
!jd            write(*,*) 'ERROR data file ',datafl,' does not exist!'
!jd            stop
!jd      endif
!
! The data file exists so open the file and read in the header
! information. Initialize the storage that will be used to summarize
! the data found in the file:
!
      title(1:22) = 'KT3D ESTIMATES WITH: '
!jd      open(lin,file=datafl,status='OLD')
!jd      read(lin,*)
!jd      read(lin,*,err=99)       nvari
!jd      do i=1,nvari
!jd            read(lin,*)
!jd      end do
!jd      MAXDAT = 0
!jd 22   read(lin,*,end=33,err=99) (var(j),j=1,nvari)
!jd      if(var(ivrl).lt.tmin.or.var(ivrl).ge.tmax) go to 22
!jd      MAXDAT = MAXDAT + 1
!jd      go to 22
!jd 33   continue
!
! Allocate the needed memory:
!5

!jd      MAXDAT=n_nd+1                                !jd

!jd      if(icall.eq.1)then
!jd      allocate(x(MAXDAT),stat = test)
!jd            if(test.ne.0)then
!jd                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
!jd                  stop
!jd            end if
!jd      end if
!6
!jd      if(icall.eq.1)then
!jd      allocate(y(MAXDAT),stat = test)
!jd            if(test.ne.0)then
!jd                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
!jd                  stop
!jd            end if
!jd      end if
!7
!jd      if(icall.eq.1)then
!jd      allocate(z(MAXDAT),stat = test)
!jd            if(test.ne.0)then
!jd                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
!jd                  stop
!jd            end if
!jd      end if

      if(icall.eq.1)then
      allocate(sec3(MAXDAT),stat=ierr)                                                    !jd
            if(test.ne.0)then                                                             !jd
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'        !jd
                  stop                                                                    !jd
            end if                                                                        !jd
      end if
!8
!jd      if(icall.eq.1)then
!jd      allocate(vr(MAXDAT),stat = test)
!jd            if(test.ne.0)then
!jd                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
!jd                  stop
!jd            end if
!jd      end if
!9

      if(icall.eq.1)then
      allocate(ve(MAXDAT),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!10
      if(icall.eq.1)then
      allocate(dh(MAXDAT),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!11
      if(icall.eq.1)then
      allocate(tmp(MAXDAT),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!12
      if(icall.eq.1)then
      allocate(close(MAXDAT),stat = test)
            if(test.ne.0)then
                  write(*,*)'ERROR: Allocation failed due to insufficient memory.'
                  stop
            end if
      end if
!
!jd      rewind(lin)
!jd      read(lin,'(a58)') title(23:80)
!jd      read(lin,*,err=99)       nvari
      nd = 0
      av = 0.0
      ss = 0.0
!jd      do i=1,nvari
!jd            read(lin,'(a40)',err=99) str
!jd      end do
!
! Some tests on column numbers:
!
!jd      if(ixl.gt.nvari.or.iyl.gt.nvari.or.izl.gt.nvari.or.ivrl.gt.nvari)
!jd     +      then
!jd            write(*,*) 'There are only ',nvari,' columns in input data'
!jd            write(*,*) '  your specification is out of range'
!jd            stop
!jd      end if
!
! Read all the data until the end of the file:
!
!jd 2    read(lin,*,end=3,err=99) (var(j),j=1,nvari)
2     continue
!jd      vrt = var(ivrl)
!jd      if(vrt.lt.tmin.or.vrt.ge.tmax) go to 2
      nd = nd + 1
      if(nd.gt.n_nd) go to 3                         !jd
!jd      if(nd.gt.MAXDAT) then
!jd            write(*,*) ' ERROR: Exceeded available memory for data'
!jd            stop
!jd      end if
!
! Establish the location of this datum:
!
!jd      if(idhl.le.0) then
!jd            dh(nd) = -99
!jd      else
!jd            dh(nd) = var(idhl)
!jd      endif
!jd      if(ixl.le.0) then
!jd            x(nd) = xmn
!jd      else
!jd            x(nd) = var(ixl)
!jd      endif
!jd      if(iyl.le.0) then
!jd            y(nd) = ymn
!jd      else
!jd            y(nd) = var(iyl)
!jd      endif
!jd      if(izl.le.0) then
!jd            z(nd) = zmn
!jd      else
!jd            z(nd) = var(izl)
!jd      endif

!jd         vrt=valdat(nd)                                 !jd
         vrt=vr(nd)                                     !jd
         dh(nd)=-99                                     !jd
         sec3(nd)=real(nd)                              !jd
!
! Establish the external drift variable (if needed):
!
      ve(nd) = 1.0
!jd      if(ktype.eq.3.or.ktype.eq.2) then
!jd            ve(nd) = var(iextv)
!jd            if(ve(nd).lt.tmin.or.ve(nd).ge.tmax) then
!jd                  write(*,*) ' External drift variable must be present at all data locations!'
!jd                  write(*,*) ' Encountered at data number ',nd
!jd                  stop
!jd            end if
!jd      end if
!jd      vr(nd) = vrt
      av     = av + vrt
      ss     = ss + vrt*vrt
      go to 2
!jd 3    close(lin)
3     continue                     !jd
      nd=n_nd
!
! Compute the averages and variances as an error check for the user:
!
      av = av / max(real(nd),1.0)
      ss =(ss / max(real(nd),1.0)) - av * av
!jd      write(*,*) 'Data for KT3D: Variable number ',ivrl
!jd      write(*,*) '  Number   = ',nd
!jd      write(*,*) '  Average  = ',av
!jd      write(*,*) '  Variance = ',ss

!       write(6,*)
!       write(6,900) nd
!900    format('   Number of pilot points for this zone     = ',i6)
!       write(6,901) av
!901    format('   Mean data value for these pilot points   = ',1pg12.5)
!       write(6,902) sqrt(max(ss,0.0))
!902    format('   Data standard deviation for these points = ',1pg12.5)
!       write(6,903)
!903    format('   Working....')

      if(nd.lt.1) then
            write(*,*) ' ERROR: there are no data'
            stop
      end if
!
! Open the debugging and output files:
!
!jd      open(ldbg,file=dbgfl,status='UNKNOWN')
!jd      open(lout,file=outfl,status='UNKNOWN')
!jd      write(lout,'(a80)') title

!jd      if(iktype.eq.0.and.koption.eq.0) then
!jd           write(lout,201) 2,nx,ny,nz
!jd           write(lout,102)
!jd 102       format('Estimate',/,'EstimationVariance')
!jd      end if
!jd      if(iktype.eq.0.and.koption.ge.1) then
!jd           write(lout,201) 7
!jd           write(lout,103)
!jd 103       format('X',/,'Y',/,'Z',/,'True',/,'Estimate',/,'EstimationVariance',/,'Error: est-true')
!jd      end if
!jd 201  format(4(1x,i4))

!jd      if(iktype.eq.1) then
!jd            if(koption.eq.0) then
!jd                  write(lout,201) ncut,nx,ny,nz
!jd            else
!jd                  write(lout,201) ncut+1
!jd            end if
!jd            do i=1,ncut
!jd                  write(lout,104) i,cut(i)
!jd 104              format('Threshold: ',i2,' = ',f12.5)
!jd            end do
!jd            if(koption.eq.1) write(lout,105)
!jd 105        format('true value')
!jd      end if
!
! Open the external drift file if needed and position it at the
! first grid node in the file:
!
!jd      if((ktype.eq.2.or.ktype.eq.3).and.koption.eq.0) then
!jd            inquire(file=extfl,exist=testfl)
!jd            if(.not.testfl) then
!jd                  write(*,*) 'ERROR file ',extfl,' does not exist!'
!jd                  stop
!jd            endif
!jd            open(lext,file=extfl,status='UNKNOWN')
!jd            read(lext,'(a40)',err=97) str
!jd            read(lext,*,err=97)       nvari
!jd            do i=1,nvari
!jd                  read(lext,'(a40)',err=97) str
!jd            end do
!jd            if(idbg.ge.3) write(ldbg,100) iextve
!jd 100        format('A secondary variable is being used.  The gridded '     &
!jd                   'file',/,'must have the same grid specifications '      &
!jd                   'as the grid you are kriging.',/,'The external '        &
!jd                   'drift variable was taken from column ',i2)
!jd      endif
!
! Set up for cross validation:
!
!jd      if(koption.eq.1) then
!jd            jackfl = datafl
!jd            idhlj  = idhl
!jd            ixlj   = ixl
!jd            iylj   = iyl
!jd            izlj   = izl
!jd            ivrlj  = ivrl
!jd            iextvj = iextv
!jd      end if
!
! Open the file with the jackknife data?
!
!jd      if(koption.gt.0) then
!jd            inquire(file=jackfl,exist=testfl)
!jd            if(.not.testfl) then
!jd                  write(*,*) 'ERROR file ',jackfl,' does not exist!'
!jd                  stop
!jd            endif
!jd            open(ljack,file=jackfl,status='OLD')
!jd            read(ljack,*,err=96)
!jd            read(ljack,*,err=96) nvarij
!jd            do i=1,nvarij
!jd                  read(ljack,*,err=96)
!jd            end do
!jd      end if
!
! Finished here:
!
      return
!
! Error in an Input File Somewhere:
!
 96   stop 'ERROR in jackknife file!'
 97   stop 'ERROR in external drift file!'
 98   stop 'ERROR in parameter file!'
 99   stop 'ERROR in data file!'
      end



      subroutine kt3d_1(MAXDIS,MAXSBX,MAXSBY,MAXSBZ,MAXEQ,unestimated,                   &
                      n_npts,n_ndat,inumdat,icellno,epoint,npoint,zpoint,                &
                      outfile,aoutfile,outunit,pmx,                                      &
                      ncol_range,nrow_range,e_min,e_max,n_min,n_max,elev_min,elev_max,   &
                      af1,af2)
!-----------------------------------------------------------------------
!
!                Krige a 3-D Grid of Rectangular Blocks
!                **************************************
!
! This subroutine estimates point or block values of one variable by
! simple, ordinary, or kriging with a trend model.  It is also possible
! to estimate the trend directly.
!
!
!
! PROGRAM NOTES:
!
!   1. The data and parameters are passed in common blocks defined
!      in kt3d.inc.  Local storage is allocated in the subroutine
!      for kriging matrices, i.e.,
!         - xa,ya,za,vra   arrays for data within search neighborhood
!         - a,r,rr,s       kriging arrays
!         - xdb,ydb,zdb    relative position of discretization points
!         - cbb            block covariance
!   2. The kriged value and the kriging variance is written to Fortran
!      unit number "lout".
!
!
!
!
! Original:  A.G. Journel and C. Lemmer                             1981
! Revisions: A.G. Journel and C. Kostov                             1984
!-----------------------------------------------------------------------

      use geostat_3d

      implicit integer(i-n), real(a-h, o-z)                          !jd


!!!!!!!!!!!!!!!!!!kt3d.inc!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      parameter(MAXDT  =   9, MAXNST =   4)
      parameter(UNEST = -999.0, EPSLON = 0.000001, MAXROT = MAXNST + 1,VERSION = 3.000)
      integer   idrif(MAXDT),nst(1),it(MAXNST),iktype,ncut,test
      real      bv(9),c0(1),cc(MAXNST),aa(MAXNST),ang1(MAXNST),	         &
                ang2(MAXNST),ang3(MAXNST),anis1(MAXNST),anis2(MAXNST)
      real*8    rotmat(MAXROT,3,3)
      common /datcom/ nd,tmin,tmax,nx,ny,nz,xmn,ymn,zmn,test,            &
                      xsiz,ysiz,zsiz,ndmax,ndmin,radius,noct,nxdis,      &
                      nydis,nzdis,idrif,itrend,ktype,skmean,koption,     &
                      idbg,ldbg,iout,lout,iext,lext,iextve,ljack,        &
                      idhlj,ixlj,iylj,izlj,ivrlj,iextvj,nvarij
      common /vargdt/ nst,it,c0,cc,aa,ang1,ang2,ang3,anis1,anis2,rotmat
      common /srccom/ sang1,sang2,sang3,sanis1,sanis2,isrot,na,ndb,bv,unbias,iktype,ncut

!!!!!!!!!!!!!!!!!!kt3d.inc!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      real*8     cbb
      real       var(20)
      logical    first,fircon,accept

      integer    n_npts,n_ndat,outunit                               !jd
      integer    inumdat(n_ndat),icellno(n_npts)                     !jd
      integer    ncol_range,nrow_range                               !jd
      real       epoint(n_npts),npoint(n_npts),zpoint(n_npts)        !jd
      real       e_min,e_max,n_min,n_max,elev_min,elev_max           !jd
      real       pmx                                                 !jd
      character*(*) outfile,aoutfile                                 !jd
      integer    unestimated                                         !jd

      character*(*)  af1,af2                                         !jd
      character*150 aformat                                          !jd

      data       fircon/.true./

! -- We work out the formatting so that we get good compression if
!    writing an ascii file.

     nd=n_ndat

     aformat='('//trim(af2)//','//trim(af1)//',1x,1pg14.7,1000('//trim(af1)//',1x,1pg14.7))' !jd

!
! Set up the rotation/anisotropy matrices that are needed for the
! variogram and search.  Also compute the maximum covariance for
! the rescaling factor:
!
!jd      write(*,*) 'Setting up rotation matrices for variogram and search'
      radsqd = radius * radius
!jd      PMX    = 999.0
      covmax = c0(1)
      do is=1,nst(1)
            call setrot_new(ang1(is),ang2(is),ang3(is),anis1(is),anis2(is),is,MAXROT,rotmat)
            if(it(is).eq.4) then
                  covmax = covmax + PMX
            else
                  covmax = covmax + cc(is)
            endif
      end do
      isrot = MAXNST + 1
      call setrot_new(sang1,sang2,sang3,sanis1,sanis2,isrot,MAXROT,rotmat)
!
! Finish computing the rescaling factor and stop if unacceptable:
!
      if(radsqd.lt.1.0) then
            resc = 2.0 * radius / max(covmax,0.0001)
      else
            resc =(4.0 * radsqd)/ max(covmax,0.0001)
      endif
      if(resc.le.0.0) then
            write(*,*) 'ERROR KT3D: The rescaling value is wrong ',resc
            write(*,*) '            Maximum covariance: ',covmax
            write(*,*) '            search radius:      ',radius
            stop
      endif
      resc = 1.0 / resc

!
! Set up for super block searching:
!
!jd      write(*,*) 'Setting up super block search strategy'
!jd      nsec = 2
         nsec = 3                                                               !jd
!jd      call setsupr(nx,xmn,xsiz,ny,ymn,ysiz,nz,zmn,zsiz,nd,x,y,z,
!jd     +             vr,tmp,nsec,ve,dh,sec3,MAXSBX,MAXSBY,MAXSBZ,nisb,
!jd     +             nxsup,xmnsup,xsizsup,nysup,ymnsup,ysizsup,nzsup,
!jd     +             zmnsup,zsizsup)

      call setsupr_jd(nx,xmn,xsiz,ny,ymn,ysiz,nz,zmn,zsiz,nd,x,y,z,  &          !jd
                   vr,tmp,nsec,ve,dh,sec3,MAXSBX,MAXSBY,MAXSBZ,nisb, &          !jd
                   nxsup,xmnsup,xsizsup,nysup,ymnsup,ysizsup,nzsup,  &          !jd
                   zmnsup,zsizsup,                                   &          !jd
                   ncol_range,nrow_range,e_min,e_max,n_min,n_max,    &          !jd
                   elev_min,elev_max)                                           !jd
      call picksup_new(nxsup,xsizsup,nysup,ysizsup,nzsup,zsizsup,        &
                   isrot,MAXROT,rotmat,radsqd,nsbtosr,ixsbtosr,      &
                   iysbtosr,izsbtosr)
!
! Compute the number of drift terms, if an external drift is being
! considered then it is one more drift term, if SK is being considered
! then we will set all the drift terms off and mdt to 0):
!
      mdt = 1
      do i=1,9
            if(ktype.eq.0.or.ktype.eq.2) idrif(i) = 0
            if(idrif(i).lt.0.or.idrif(i).gt.1) then
                  write(*,*) 'ERROR KT3D: invalid drift term',idrif(i)
                  stop
            endif
            mdt = mdt + idrif(i)
      end do
      if(ktype.eq.3) mdt = mdt + 1
      if(ktype.eq.0) mdt = 0
      if(ktype.eq.2) mdt = 0
!
! Set up the discretization points per block.  Figure out how many
! are needed, the spacing, and fill the xdb,ydb, and zdb arrays with
! the offsets relative to the block center (this only gets done once):
!
! In all cases the offsets are relative to the lower left corner.
! This is done for rescaling the drift terms in the kriging matrix.
!
      if(nxdis.lt.1) nxdis = 1
      if(nydis.lt.1) nydis = 1
      if(nzdis.lt.1) nzdis = 1
      ndb = nxdis * nydis * nzdis
      if(ndb.gt.MAXDIS) then
            write(*,*) 'ERROR KT3D: Too many discretization points',ndb
            write(*,*) '            Increase MAXDIS or lower n[xyz]dis'
            stop
      endif
      xdis = xsiz  / max(real(nxdis),1.0)
      ydis = ysiz  / max(real(nydis),1.0)
      zdis = zsiz  / max(real(nzdis),1.0)
      i    = 0
      xloc = -0.5*(xsiz+xdis)
      do ix =1,nxdis
            xloc = xloc + xdis
            yloc = -0.5*(ysiz+ydis)
            do iy=1,nydis
                  yloc = yloc + ydis
                  zloc = -0.5*(zsiz+zdis)
                  do iz=1,nzdis
                        zloc = zloc + zdis
                        i = i+1
                        xdb(i) = xloc + 0.5*xsiz
                        ydb(i) = yloc + 0.5*ysiz
                        zdb(i) = zloc + 0.5*zsiz
                  end do
            end do
      end do
!
! Initialize accumulators:
!
      nk    = 0
      xk    = 0.0
      vk    = 0.0
      xkmae = 0.0
      xkmse = 0.0
!
! Calculate Block Covariance. Check for point kriging.
!
      call cova3_jd(xdb(1),ydb(1),zdb(1),xdb(1),ydb(1),zdb(1),1,nst,MAXNST,c0,it,cc,aa,1,MAXROT,rotmat,cmax,cov,PMX)
!
! Set the ``unbias'' variable so that the matrix solution is more stable
!

      unbias = cov
      cbb    = dble(cov)
      if(ndb.gt.1) then
            cbb = 0.0
            do i=1,ndb
               do j=1,ndb
                  call cova3_jd(xdb(i),ydb(i),zdb(i),xdb(j),ydb(j),zdb(j),                  &
                     1,nst,MAXNST,c0,it,cc,aa,1,MAXROT,rotmat,cmax,cov,PMX)
                  if(i.eq.j) cov = cov - c0(1)
                  cbb = cbb + dble(cov)
               end do
            end do
            cbb = cbb/dble(real(ndb*ndb))
      end if
      if(idbg.gt.1) then
            write(ldbg,*) ' '
            write(ldbg,*) 'Block Covariance: ',cbb
            write(ldbg,*) ' '
      end if
!
! Mean values of the drift functions:
!
      do i=1,9
            bv(i) = 0.0
      end do
      do i=1,ndb
            bv(1) = bv(1) + xdb(i)
            bv(2) = bv(2) + ydb(i)
            bv(3) = bv(3) + zdb(i)
            bv(4) = bv(4) + xdb(i)*xdb(i)
            bv(5) = bv(5) + ydb(i)*ydb(i)
            bv(6) = bv(6) + zdb(i)*zdb(i)
            bv(7) = bv(7) + xdb(i)*ydb(i)
            bv(8) = bv(8) + xdb(i)*zdb(i)
            bv(9) = bv(9) + ydb(i)*zdb(i)
      end do
      do i=1,9
            bv(i) = (bv(i) / real(ndb)) * resc
      end do
!
! Report on progress from time to time:
!
      if(koption.eq.0) then
            nxy   = nx*ny
            nxyz  = nx*ny*nz
            nloop = nxyz
            irepo = max(1,min((nxyz/10),10000))
      else
            nloop = 10000000
            irepo = max(1,min((nd/10),10000))
      end if
      ddh = 0.0
!jd      write(*,*)
!jd      write(*,*) 'Working on the kriging '

      nloop=n_npts                 !jd
!
! MAIN LOOP OVER ALL THE BLOCKS IN THE GRID:
!
!jd      do index=1,nloop
      do i_ipts=1,n_npts
!jd      if((int(index/irepo)*irepo).eq.index) write(*,103) index
!jd103   format('   currently on estimate ',i9)
!
! Where are we making an estimate?
!
      if(koption.eq.0) then
!jd            iz   = int((index-1)/nxy) + 1
!jd            iy   = int((index-(iz-1)*nxy-1)/nx) + 1
!jd            ix   = index - (iz-1)*nxy - (iy-1)*nx
!jd            xloc = xmn + real(ix-1)*xsiz
!jd            yloc = ymn + real(iy-1)*ysiz
!jd            zloc = zmn + real(iz-1)*zsiz

          xloc=epoint(i_ipts)                     !jd
          yloc=npoint(i_ipts)                     !jd
          zloc=zpoint(i_ipts)                     !jd
          icell=icellno(i_ipts)                   !jd
      else
            read(ljack,*,err=96,end=2) (var(i),i=1,nvarij)
            ddh  = 0.0
            xloc = xmn
            yloc = ymn
            zloc = zmn
            true = UNEST
            secj = UNEST
            if(idhlj.gt.0)  ddh    = var(idhlj)
            if(ixlj.gt.0)   xloc   = var(ixlj)
            if(iylj.gt.0)   yloc   = var(iylj)
            if(izlj.gt.0)   zloc   = var(izlj)
            if(ivrlj.gt.0)  true   = var(ivrlj)
            if(iextvj.gt.0) extest = var(iextvj)
            if(true.lt.tmin.or.true.ge.tmax) true = UNEST
      end if

!
! Read in the external drift variable for this grid node if needed:
!
      if(ktype.eq.2.or.ktype.eq.3) then
            if(koption.eq.0) then
                  read(lext,*) (var(i),i=1,iextve)
                  extest = var(iextve)
            end if
            if(extest.lt.tmin.or.extest.ge.tmax) then
                  est  = UNEST
                  estv = UNEST
                  go to 8888
!jd                  go to 1
            end if
            resce  = covmax / max(extest,0.0001)
      endif
!
! Find the nearest samples:
!
      call srchsupr_new(xloc,yloc,zloc,radsqd,isrot,MAXROT,rotmat,nsbtosr,            &
                    ixsbtosr,iysbtosr,izsbtosr,noct,nd,x,y,z,tmp,                 &
                    nisb,nxsup,xmnsup,xsizsup,nysup,ymnsup,ysizsup,               &
                    nzsup,zmnsup,zsizsup,nclose,close,infoct)

!       write(6,*) ' nclose = ',nclose     !debug
!
! Load the nearest data in xa,ya,za,vra,vea:
!
      na = 0
      do i=1,nclose
            ind    = int(close(i)+0.5)
            accept = .true.
            if(koption.ne.0.and.(abs(x(ind)-xloc)+abs(y(ind)-yloc)+ abs(z(ind)-zloc))  &
                                 .lt.EPSLON) accept = .false.
            if(koption.ne.0.and.(abs(dh(ind)-ddh)).lt.EPSLON) accept = .false.
            if(accept) then
                  if(na.lt.ndmax) then
                        na = na + 1
!jd                        xa(na)  = x(ind) - xloc + 0.5*xsiz
!jd                        ya(na)  = y(ind) - yloc + 0.5*ysiz
!jd                        za(na)  = z(ind) - zloc + 0.5*zsiz
                        xa(na)  = x(ind) - xloc
                        ya(na)  = y(ind) - yloc
                        za(na)  = z(ind) - zloc
                        vra(na) = vr(ind)
                        vea(na) = ve(ind)
                  end if
            end if
      end do
!
! Test number of samples found:
!
      if(na.lt.ndmin) then
            est  = UNEST
            estv = UNEST
            go to 8888
!jd            go to 1
      end if
!
! Test if there are enough samples to estimate all drift terms:
!
!jd      if(na.ge.1.and.na.le.mdt) then
!jd            if(fircon) then
!jd                  write(ldbg,999)
!jd                  write(6,999)
!jd                  fircon = .false.
!jd            end if
!jd            est  = UNEST
!jd            estv = UNEST
!jd            go to 1
!jd      end if
 999  format(' Encountered a location where there were too few data ',/,     &
             ' to estimate all of the drift terms but there would be',/,     &
             ' enough data for OK or SK.   KT3D currently leaves ',/,        &
             ' these locations unestimated.',/,                              &
             ' This message is only written once - the first time.',/)
!
! There are enough samples - proceed with estimation.
!
      if(na.le.1) then
!
! Handle the situation of only one sample:
!
            call cova3_jd(xa(1),ya(1),za(1),xa(1),ya(1),za(1),1,nst,MAXNST,     &
                       c0,it,cc,aa,1,MAXROT,rotmat,cmax,cb1,PMX)
!
! Establish Right Hand Side Covariance:
!
            if(ndb.le.1) then
                  zero=0.0                                              !jd
!jd                  call cova3_jd(xa(1),ya(1),za(1),xdb(1),ydb(1),zdb(1),1,       &
!jd                       nst,MAXNST,c0,it,cc,aa,1,MAXROT,rotmat,cmax,cb,PMX)
                  call cova3_jd(xa(1),ya(1),za(1),zero,zero,zero,1,       &          !jd
                       nst,MAXNST,c0,it,cc,aa,1,MAXROT,rotmat,cmax,cb,PMX)          !jd

            else
                  cb  = 0.0
                  do i=1,ndb
                        call cova3_jd(xa(1),ya(1),za(1),xdb(i),ydb(i),          &
                                   zdb(i),1,nst,MAXNST,c0,it,cc,aa,1,        &
                                   MAXROT,rotmat,cmax,cov,PMX)
                        cb = cb + cov
                        dx = xa(1) - xdb(i)
                        dy = ya(1) - ydb(i)
                        dz = za(1) - zdb(i)
                        if((dx*dx+dy*dy+dz*dz).lt.EPSLON) cb=cb-c0(1)
                  end do
                  cb = cb / real(ndb)
            end if
!vd
!
! Early bug - always did OK in presence of one data.
!
!vd
            if(ktype.eq.2) skmean = extest
            if(ktype.eq.0.or.ktype.eq.2) then
                  wt   = cb / cb1
                  est  = wt * vra(1) + (1.0-wt) * skmean
                  estv = real(cbb) - wt*cb
            else
                  est  = vra(1)
                  estv = real(cbb) - 2.0*cb + cb1
                  wt=1.0                                         !jd
            end if

            if(ktype.eq.0)then                                    !jd
!!              rrtemp=(1.0-wt)*skmean                              !jd
              rrtemp=(1.0-wt)                                     !jd
            else                                                  !jd
              rrtemp=0.0                                          !jd
            end if                                                !jd
            if(aoutfile.eq.'f')then                               !jd
              write(outunit,aformat) icell,1,rrtemp, &            !jd
              inumdat(nint(sec3(nint(close(1))))),wt              !jd
            else                                                  !jd
              write(outunit)   icell,1,rrtemp, &                  !jd
              inumdat(nint(sec3(nint(close(1))))),wt              !jd
            end if                                                !jd

            nk   = nk + 1
            xk   = xk + est
            vk   = vk + est*est
            go to 1
      end if
!
! Go ahead and set up the OK portion of the kriging matrix:
!
      neq = mdt+na
!
! Initialize the main kriging matrix:
!
      first = .false.
      do i=1,neq*neq
            a(i) = 0.0
      end do
!
! Fill in the kriging matrix:
!
      do i=1,na
      do j=i,na
            call cova3_jd(xa(i),ya(i),za(i),xa(j),ya(j),za(j),1,nst,MAXNST,   &
                       c0,it,cc,aa,1,MAXROT,rotmat,cmax,cov,PMX)
            a(neq*(i-1)+j) = dble(cov)
            a(neq*(j-1)+i) = dble(cov)
      end do
      end do
!
! Fill in the OK unbiasedness portion of the matrix (if not doing SK):
!
      if(neq.gt.na) then
            do i=1,na
                  a(neq*(i-1)+na+1) = dble(unbias)
                  a(neq*na+i)       = dble(unbias)
            end do
      endif
!
! Set up the right hand side:
!
      do i=1,na
            if(ndb.le.1) then
                  zero=0.0
!jd                  call cova3_jd(xa(i),ya(i),za(i),xdb(1),ydb(1),zdb(1),1,     &
!jd                       nst,MAXNST,c0,it,cc,aa,1,MAXROT,rotmat,cmax,cb,PMX)
                  call cova3_jd(xa(i),ya(i),za(i),zero,zero,zero,1,     &
                       nst,MAXNST,c0,it,cc,aa,1,MAXROT,rotmat,cmax,cb,PMX)
            else
                  cb  = 0.0
                  do j=1,ndb
                        call cova3_jd(xa(i),ya(i),za(i),xdb(j),ydb(j),        &
                                   zdb(j),1,nst,MAXNST,c0,it,cc,aa,1,        &
                                   MAXROT,rotmat,cmax,cov,PMX)
                        cb = cb + cov
                        dx = xa(i) - xdb(j)
                        dy = ya(i) - ydb(j)
                        dz = za(i) - zdb(j)
                        if((dx*dx+dy*dy+dz*dz).lt.EPSLON) cb=cb-c0(1)
                  end do
                  cb = cb / real(ndb)
            end if
            r(i) = dble(cb)
      end do
      if(neq.gt.na) r(na+1) = dble(unbias)
!
! Add the additional unbiasedness constraints:
!
      im = na + 1
!
! First drift term (linear in "x"):
!
      if(idrif(1).eq.1) then
            im=im+1
            do k=1,na
                  a(neq*(im-1)+k) = dble(xa(k)*resc)
                  a(neq*(k-1)+im) = dble(xa(k)*resc)
            end do
            r(im) = dble(bv(1))
      endif
!
! Second drift term (linear in "y"):
!
      if(idrif(2).eq.1) then
            im=im+1
            do k=1,na
                  a(neq*(im-1)+k) = dble(ya(k)*resc)
                  a(neq*(k-1)+im) = dble(ya(k)*resc)
            end do
            r(im) = dble(bv(2))
      endif
!
! Third drift term (linear in "z"):
!
      if(idrif(3).eq.1) then
            im=im+1
            do k=1,na
                  a(neq*(im-1)+k) = dble(za(k)*resc)
                  a(neq*(k-1)+im) = dble(za(k)*resc)
            end do
            r(im) = dble(bv(3))
      endif
!
! Fourth drift term (quadratic in "x"):
!
      if(idrif(4).eq.1) then
            im=im+1
            do k=1,na
                  a(neq*(im-1)+k) = dble(xa(k)*xa(k)*resc)
                  a(neq*(k-1)+im) = dble(xa(k)*xa(k)*resc)
            end do
            r(im) = dble(bv(4))
      endif
!
! Fifth drift term (quadratic in "y"):
!
      if(idrif(5).eq.1) then
            im=im+1
            do k=1,na
                  a(neq*(im-1)+k) = dble(ya(k)*ya(k)*resc)
                  a(neq*(k-1)+im) = dble(ya(k)*ya(k)*resc)
            end do
            r(im) = dble(bv(5))
      endif
!
! Sixth drift term (quadratic in "z"):
!
      if(idrif(6).eq.1) then
            im=im+1
            do k=1,na
                  a(neq*(im-1)+k) = dble(za(k)*za(k)*resc)
                  a(neq*(k-1)+im) = dble(za(k)*za(k)*resc)
            end do
            r(im) = dble(bv(6))
      endif
!
! Seventh drift term (quadratic in "xy"):
!
      if(idrif(7).eq.1) then
            im=im+1
            do k=1,na
                  a(neq*(im-1)+k) = dble(xa(k)*ya(k)*resc)
                  a(neq*(k-1)+im) = dble(xa(k)*ya(k)*resc)
            end do
            r(im) = dble(bv(7))
      endif
!
! Eighth drift term (quadratic in "xz"):
!
      if(idrif(8).eq.1) then
            im=im+1
            do k=1,na
                  a(neq*(im-1)+k) = dble(xa(k)*za(k)*resc)
                  a(neq*(k-1)+im) = dble(xa(k)*za(k)*resc)
            end do
            r(im) = dble(bv(8))
      endif
!
! Ninth drift term (quadratic in "yz"):
!
      if(idrif(9).eq.1) then
            im=im+1
            do k=1,na
                  a(neq*(im-1)+k) = dble(ya(k)*za(k)*resc)
                  a(neq*(k-1)+im) = dble(ya(k)*za(k)*resc)
            end do
            r(im) = dble(bv(9))
      endif
!
! External drift term (specified by external variable):
!
      if(ktype.eq.3) then
            im=im+1
            do k=1,na
                  a(neq*(im-1)+k) = dble(vea(k)*resce)
                  a(neq*(k-1)+im) = dble(vea(k)*resce)
            end do
            r(im) = dble(extest*resce)
      endif
!
! Copy the right hand side to compute the kriging variance later:
!
      do k=1,neq
            rr(k) = r(k)
      end do
      kadim = neq * neq
      ksdim = neq
      nrhs  = 1
      nv    = 1
!
! If estimating the trend then reset all the right hand side terms=0.0:
!
      if(itrend.ge.1) then
            do i=1,na
                  r(i)  = 0.0
                  rr(i) = 0.0
            end do
      endif
!
! Write out the kriging Matrix if Seriously Debugging:
!
      if(idbg.eq.3) then
            write(ldbg,*) 'Estimating node index : ',ix,iy,iz
            is = 1 - neq
            do i=1,neq
                  is = 1 + (i-1)*neq
                  ie = is + neq - 1
                  write(ldbg,100) i,r(i),(a(j),j=is,ie)
 100              format('    r(',i2,') =',f7.4,'  a= ',9(10f7.4))
            end do
      endif
!
! Solve the kriging system:
!
      call ktsol_new(neq,nrhs,nv,a,r,s,ising,maxeq)
!
! Compute the solution:
!
      if(ising.ne.0) then
            write(6,*)                                                             !jd
            write(6,450) icell                                                     !jd
450         format(' *** ERROR: singular kriging matrix for cell',i5,' ***')       !jd
            write(6,451)                                                           !jd
451         format(' *** Check for coincidence of points in source CLIST ***')     !jd
            if(idbg.ge.3) write(ldbg,*) ' Singular Matrix ',ix,iy,iz
            est  = UNEST
            estv = UNEST
            go to 8888
      else
            est  = 0.0
            estv = real(cbb)
            sumw=0.0                                                 !jd
            if(ktype.eq.2) skmean = extest
            do j=1,neq
                  estv = estv - real(s(j))*rr(j)
                  if(j.le.na) then
                        if(ktype.eq.0) then
                              est = est + real(s(j))*(vra(j)-skmean)
                              sumw=sumw+real(s(j))                   !jd
                        else if(ktype.eq.2) then
                              est = est + real(s(j))*(vra(j)-vea(j))
                        else
                              est = est + real(s(j))*vra(j)
                        endif
                  endif
            end do
            if(ktype.eq.0.or.ktype.eq.2) est = est + skmean
            nk   = nk + 1
            xk   = xk + est
            vk   = vk + est*est
            if(ktype.eq.0)then                                       !jd
!!              rrtemp=(1.0-sumw)*skmean                               !jd
              rrtemp=(1.0-sumw)                                      !jd
            else                                                     !jd
              rrtemp=0.0                                             !jd
            end if                                                   !jd
            if(aoutfile.eq.'f')then                                  !jd
              write(outunit,aformat) icell,na,rrtemp, &              !jd
              (inumdat(nint(sec3(nint(close(i))))),real(s(i)),i=1,na)         !jd
            else                                                     !jd
              write(outunit)   icell,na,rrtemp, &                    !jd
              (inumdat(nint(sec3(nint(close(i))))),real(s(i)),i=1,na)         !jd
            end if                                                   !jd

!
! Write the kriging weights and data if debugging level is above 2:
!
            if(idbg.ge.2) then
                  write(ldbg,*) '       '
                  write(ldbg,*) 'BLOCK: ',ix,iy,iz,' at ',xloc,yloc,zloc
                  write(ldbg,*) '       '
                  if(ktype.ne.0)write(ldbg,*) '  Lagrange : ',s(na+1)*unbias
                  write(ldbg,*) '  BLOCK EST: x,y,z,vr,wt '
                  do i=1,na
                        xa(i) = xa(i) + xloc - 0.5*xsiz
                        ya(i) = ya(i) + yloc - 0.5*ysiz
                        za(i) = za(i) + zloc - 0.5*zsiz
                        write(ldbg,'(5f12.3)') xa(i),ya(i),za(i),vra(i),s(i)
                  end do
                  write(ldbg,*) '  estimate, variance  ',est,estv
            endif
      endif
!
! END OF MAIN KRIGING LOOP:
!
 1          continue
            if(iktype.eq.0) then
                  if(koption.eq.0) then
!jd                        write(lout,'(g14.8,1x,g14.8)') est,estv
                  else
                        err = UNEST
                        if(true.ne.UNEST.and.est.ne.UNEST) then
                              err=est-true
                              xkmae = xkmae + abs(err)
                              xkmse = xkmse + err*err
                        end if
!jd                        write(lout,'(7(g14.8,1x))') xloc,yloc,zloc,true,est,estv,err
                  end if
            else
!
! Work out the IK-type distribution implicit to this data configuration
! and kriging weights:
!
                  do icut=1,ncut
                        cdf(icut) = -1.0
                  end do
                  wtmin = 1.0
                  do i=1,na
                        if(s(i).lt.wtmin) wtmin = s(i)
                  end do
                  sumwt = 0.0
                  do i=1,na
                        s(i)  = s(i) - wtmin
                        sumwt = sumwt + s(i)
                  end do
                  do i=1,na
                        s(i) = s(i) / max(0.00001,sumwt)
                  end do
                  if(na.gt.1.and.sumwt.gt.0.00001) then
                        do icut=1,ncut
                              cdf(icut) = 0.0
                              do i=1,na
                                    if(vra(i).le.cut(icut))cdf(icut)=cdf(icut)+s(i)
                              end do
                        end do
                  end if
                  if(koption.eq.0) then
!jd                        write(lout,'(30(f8.4))') (cdf(i),i=1,ncut)
                  else
!jd                        write(lout,'(30(f8.4))') (cdf(i),i=1,ncut),true
                  end if
            end if
      end do
 2    continue
      if(koption.gt.0) close(ljack)
!
! Write statistics of kriged values:
!

!jd      if(nk.gt.0.and.idbg.gt.0) then
!jd            xk    = xk/real(nk)
!jd            vk    = vk/real(nk) - xk*xk
!jd            xkmae = xkmae/real(nk)
!jd            xkmse = xkmse/real(nk)
!jd            write(ldbg,105) nk,xk,vk
!jd            write(*,   105) nk,xk,vk
!jd 105        format(/,'Estimated   ',i8,' blocks ',/,
!jd     +               '  average   ',g14.8,/,'  variance  ',g14.8,/)
!jd            if(koption.ne.0) then
!jd                  write(*,106) xkmae,xkmse
!jd 106              format(/,'  mean error',g14.8,/,'  mean sqd e',g14.8)
!jd            end if
!jd      endif
!
! All finished the kriging:
!
      return
 96   stop 'ERROR in jackknife file!'

8888  unestimated=icell
      return

      end




      subroutine setsupr_jd(nx,xmn,xsiz,ny,ymn,ysiz,nz,zmn,zsiz,nd,x,y,z,     &
                         vr,tmp,nsec,sec1,sec2,sec3,MAXSBX,MAXSBY,            &
                         MAXSBZ,nisb,nxsup,xmnsup,xsizsup,nysup,ymnsup,       &
                         ysizsup,nzsup,zmnsup,zsizsup,                        &
                         ncol_range,nrow_range,e_min,e_max,n_min,n_max,       &
                         elev_min,elev_max)
!-----------------------------------------------------------------------
!
!           Establish Super Block Search Limits and Sort Data
!           *************************************************
!
! This subroutine sets up a 3-D "super block" model and orders the data
! by super block number.  The limits of the super block is set to the
! minimum and maximum limits of the grid; data outside are assigned to
! the nearest edge block.
!
! The idea is to establish a 3-D block network that contains all the
! relevant data.  The data are then sorted by their index location in
! the search network, i.e., the index location is given after knowing
! the block index in each coordinate direction (ix,iy,iz):
!          ii = (iz-1)*nxsup*nysup + (iy-1)*nxsup + ix
! An array, the same size as the number of super blocks, is constructed
! that contains the cumulative number of data in the model.  With this
! array it is easy to quickly check what data are located near any given
! location.
!
!
!
! INPUT VARIABLES:
!
!   nx,xmn,xsiz      Definition of the X grid being considered
!   ny,ymn,ysiz      Definition of the Y grid being considered
!   nz,zmn,zsiz      Definition of the Z grid being considered
!   nd               Number of data
!   x(nd)            X coordinates of the data
!   y(nd)            Y coordinates of the data
!   z(nd)            Z coordinates of the data
!   vr(nd)           Variable at each location.
!   tmp(nd)          Temporary storage to keep track of the super block
!                      index associated to each data (uses the same
!                      storage already allocated for the simulation)
!   nsec             Number of secondary variables to carry with vr
!   sec1(nd)         First secondary variable (if nsec >= 1)
!   sec2(nd)         Second secondary variable (if nsec >= 2)
!   sec3(nd)         Third secondary variable (if nsec = 3)
!   MAXSB[X,Y,Z]     Maximum size of super block network
!
!
!
! OUTPUT VARIABLES:
!
!   nisb()                Array with cumulative number of data in each
!                           super block.
!   nxsup,xmnsup,xsizsup  Definition of the X super block grid
!   nysup,ymnsup,ysizsup  Definition of the Y super block grid
!   nzsup,zmnsup,zsizsup  Definition of the Z super block grid
!
!
!
! EXTERNAL REFERENCES:
!
!   sortem           Sorting routine to sort the data
!
!
!
!-----------------------------------------------------------------------

      implicit integer(i-n), real(a-h, o-z)                    !jd

      real    x(*),y(*),z(*),vr(*),tmp(*),sec1(*),sec2(*),sec3(*)
      integer nisb(*)
      logical inflag

      integer ncol_range,nrow_range                            !jd
      real e_min,e_max,n_min,n_max,elev_min,elev_max           !jd
!
! Establish the number and size of the super blocks:
!
!jd      nxsup   = min(nx,MAXSBX)
!jd      nysup   = min(ny,MAXSBY)
      nxsup=min(ncol_range,MAXSBX)                             !jd
      nysup=min(nrow_range,MAXSBY)                             !jd
      nzsup   = min(nz,MAXSBZ)
!jd      xsizsup = real(nx)*xsiz/real(nxsup)
!jd      ysizsup = real(ny)*ysiz/real(nysup)
!jd      zsizsup = real(nz)*zsiz/real(nzsup)

      xsizsup = (e_max-e_min)*1.1/real(nxsup)                      !jd
      ysizsup = (n_max-n_min)*1.1/real(nysup)                      !jd
      zsizsup = (elev_max-elev_min)*1.1                            !jd
      if(xsizsup.le.0.0d0)xsizsup=1.0              !jd  arbitrary
      if(ysizsup.le.0.0d0)ysizsup=1.0              !jd  arbitrary
      if(zsizsup.le.0.0d0)zsizsup=1.0              !jd  arbitrary

!jd      xmnsup  = (xmn-0.5*xsiz)+0.5*xsizsup
!jd      ymnsup  = (ymn-0.5*ysiz)+0.5*ysizsup
!jd      zmnsup  = (zmn-0.5*zsiz)+0.5*zsizsup

      xmnsup  = e_min-0.05*(e_max-e_min)                           !jd
      ymnsup  = n_min-0.05*(n_max-n_min)                           !jd
      zmnsup  = elev_min-0.05*(elev_max-elev_min)                  !jd

!
! Initialize the extra super block array to zeros:
!
      do i=1,nxsup*nysup*nzsup
            nisb(i) = 0
      end do
!
! Loop over all the data assigning the data to a super block and
! accumulating how many data are in each super block:
!
      do i=1,nd
            call getindx_new(nxsup,xmnsup,xsizsup,x(i),ix,inflag)
            call getindx_new(nysup,ymnsup,ysizsup,y(i),iy,inflag)
            call getindx_new(nzsup,zmnsup,zsizsup,z(i),iz,inflag)
            ii = ix + (iy-1)*nxsup + (iz-1)*nxsup*nysup
            tmp(i)   = ii
            nisb(ii) = nisb(ii) + 1
      end do
!
! Sort the data by ascending super block number:
!
      nsort = 4 + nsec
      call sortem_new(1,nd,tmp,nsort,x,y,z,vr,sec1,sec2,sec3)
!
! Set up array nisb with the starting address of the block data:
!
      do i=1,(nxsup*nysup*nzsup-1)
            nisb(i+1) = nisb(i) + nisb(i+1)
      end do
!
! Finished:
!
      return
      end



      subroutine cova3_jd(x1,y1,z1,x2,y2,z2,ivarg,nst,MAXNST,c0,it,cc,aa,   &
                       irot,MAXROT,rotmat,cmax,cova,PMX)
!-----------------------------------------------------------------------
!
!                    Covariance Between Two Points
!                    *****************************
!
! This subroutine calculated the covariance associated with a variogram
! model specified by a nugget effect and nested varigoram structures.
! The anisotropy definition can be different for each nested structure.
!
!
!
! INPUT VARIABLES:
!
!   x1,y1,z1         coordinates of first point
!   x2,y2,z2         coordinates of second point
!   nst(ivarg)       number of nested structures (maximum of 4)
!   ivarg            variogram number (set to 1 unless doing cokriging
!                       or indicator kriging)
!   MAXNST           size of variogram parameter arrays
!   c0(ivarg)        isotropic nugget constant
!   it(i)            type of each nested structure:
!                      1. spherical model of range a;
!                      2. exponential model of parameter a;
!                           i.e. practical range is 3a
!                      3. gaussian model of parameter a;
!                           i.e. practical range is a*sqrt(3)
!                      4. power model of power a (a must be gt. 0  and
!                           lt. 2).  if linear model, a=1,c=slope.
!                      5. hole effect model
!   cc(i)            multiplicative factor of each nested structure.
!                      (sill-c0) for spherical, exponential,and gaussian
!                      slope for linear model.
!   aa(i)            parameter "a" of each nested structure.
!   irot             index of the rotation matrix for the first nested
!                    structure (the second nested structure will use
!                    irot+1, the third irot+2, and so on)
!   MAXROT           size of rotation matrix arrays
!   rotmat           rotation matrices
!
!
! OUTPUT VARIABLES:
!
!   cmax             maximum covariance
!   cova             covariance between (x1,y1,z1) and (x2,y2,z2)
!
!
!
! EXTERNAL REFERENCES: sqdist    computes anisotropic squared distance
!                      rotmat    computes rotation matrix for distance
!-----------------------------------------------------------------------

      implicit integer(i-n), real(a-h, o-z)                    !jd

!jd      parameter(PI=3.14159265,PMX=999.,EPSLON=1.e-5)
      parameter(PI=3.14159265,EPSLON=1.e-5)

      integer   nst(*),it(*)
      real      c0(*),cc(*),aa(*)
      real*8    rotmat(MAXROT,3,3),hsqd,sqdist_new

      real      PMX                                         !jd
!
! Calculate the maximum covariance value (used for zero distances and
! for power model covariance):
!
      istart = 1 + (ivarg-1)*MAXNST
      cmax   = c0(ivarg)
      do is=1,nst(ivarg)
            ist = istart + is - 1
            if(it(ist).eq.4) then
                  cmax = cmax + PMX
            else
                  cmax = cmax + cc(ist)
            endif
      end do
!
! Check for "zero" distance, return with cmax if so:
!
      hsqd = sqdist_new(x1,y1,z1,x2,y2,z2,irot,MAXROT,rotmat)
      if(real(hsqd).lt.EPSLON) then
            cova = cmax
            return
      endif
!
! Loop over all the structures:
!
      cova = 0.0
      do is=1,nst(ivarg)
            ist = istart + is - 1
!
! Compute the appropriate distance:
!
            if(ist.ne.1) then
                  ir = min((irot+is-1),MAXROT)
                  hsqd=sqdist_new(x1,y1,z1,x2,y2,z2,ir,MAXROT,rotmat)
            end if
            h = real(dsqrt(hsqd))
!
! Spherical Variogram Model?
!
            if(it(ist).eq.1) then
                  hr = h/aa(ist)
                  if(hr.lt.1.) cova=cova+cc(ist)*(1.-hr*(1.5-.5*hr*hr))
!
! Exponential Variogram Model?
!
            else if(it(ist).eq.2) then
!jd                  cova = cova + cc(ist)*exp(-3.0*h/aa(ist))
                  cova = cova + cc(ist)*exp(-1.0*h/aa(ist))                   !jd
!
! Gaussian Variogram Model?
!
            else if(it(ist).eq.3) then
!jd                  cova = cova + cc(ist)*exp(-3.*(h/aa(ist))*(h/aa(ist)))
                  cova = cova + cc(ist)*exp(-1.*(h/aa(ist))*(h/aa(ist)))      !jd
!
! Power Variogram Model?
!
            else if(it(ist).eq.4) then
                  cova = cova + cmax - cc(ist)*(h**aa(ist))
!
! Hole Effect Model?
!
            else if(it(ist).eq.5) then
!                 d = 10.0 * aa(ist)
!                 cova = cova + cc(ist)*exp(-3.0*h/d)*cos(h/aa(ist)*PI)
                  cova = cova + cc(ist)*cos(h/aa(ist)*PI)
            endif
      end do
!
! Finished:
!
      return
      end


      subroutine ktsol_new(n,ns,nv,a,b,x,ktilt,maxeq)
!-----------------------------------------------------------------------
!
! Solution of a system of linear equations by gaussian elimination with
! partial pivoting.  Several right hand side matrices and several
! variables are allowed.
!
!
!         NOTE: All input matrices must be in double precision
!
!
! INPUT/OUTPUT VARIABLES:
!
!   n                Number of equations
!   ns               Number of right hand side matrices
!   nv               Number of variables.
!   a(n*n*nv)        left hand side matrices versus columnwise.
!   b(n*ns*nv)       input right hand side matrices.
!   x(n*ns*nv)       solution matrices.
!   ktilt            indicator of singularity
!                      =  0  everything is ok.
!                      = -1 n.le.1
!                      =  k  a null pivot appeared at the kth iteration.
!   tol              used in test for null pivot. depends on machine
!                      precision and can also be set for the tolerance
!                      of an ill-defined kriging system.
!
!
!-----------------------------------------------------------------------


!jd      implicit real*8 (a-h,o-z)

      implicit integer(i-n), real*8(a-h, o-z)                    !jd

      real*8 x(maxeq),a(maxeq*maxeq),b(maxeq)
!
! Make sure there are equations to solve:
!
      if(n.le.1) then
            ktilt = -1
            return
      endif
!
! Initialization:
!
      tol   = 0.1e-10
      ktilt = 0
      ntn   = n*n
      nm1   = n-1
!
! Triangulation is done variable by variable:
!
      do iv=1,nv
!
! Indices of location in vectors a and b:
!
            nva = ntn*(iv-1)
            nvb = n*ns*(iv-1)
!
! Gaussian elimination with partial pivoting:
!
            do k=1,nm1
                  kp1 = k+1
!
! Indice of the diagonal element in the kth row:
!
                  kdiag = nva+(k-1)*n+k
!
! Find the pivot - interchange diagonal element/pivot:
!
                  npiv = kdiag
                  ipiv = k
                  i1   = kdiag
                  do i=kp1,n
                        i1 = i1+1
                        if(abs(a(i1)).gt.abs(a(npiv))) then
                              npiv = i1
                              ipiv = i
                        endif
                  end do
                  t        = a(npiv)
                  a(npiv)  = a(kdiag)
                  a(kdiag) = t
!
! Test for singularity:
!
                  if(abs(a(kdiag)).lt.tol) then
                        ktilt=k
                        return
                  endif
!
! Compute multipliers:
!
                  i1 = kdiag
                  do i=kp1,n
                        i1    = i1+1
                        a(i1) = -a(i1)/a(kdiag)
                  end do
!
! Interchange and eliminate column per column:
!
                  j1 = kdiag
                  j2 = npiv
                  do j=kp1,n
                        j1    = j1+n
                        j2    = j2+n
                        t     = a(j2)
                        a(j2) = a(j1)
                        a(j1) = t
                        i1    = j1
                        i2    = kdiag
                        do i=kp1,n
                              i1    = i1+1
                              i2    = i2+1
                              a(i1) = a(i1)+a(i2)*a(j1)
                        end do
                  end do
!
! Interchange and modify the ns right hand matrices:
!
                  i1 = nvb+ipiv
                  i2 = nvb+k
                  do i=1,ns
                        t     = b(i1)
                        b(i1) = b(i2)
                        b(i2) = t
                        j1    = i2
                        j2    = kdiag
                        do j=kp1,n
                              j1    = j1+1
                              j2    = j2+1
                              b(j1) = b(j1)+b(i2)*a(j2)
                        end do
                        i1 = i1+n
                        i2 = i2+n
                  end do
            end do
!
! Test for singularity for the last pivot:
!
            kdiag = ntn*iv
            if(abs(a(kdiag)).lt.tol) then
                  ktilt = n
                  return
            endif
      end do
!
! End of triangulation. Now, solve back variable per variable:
!
      do iv=1,nv
!
! Indices of location in vectors a and b:
!
            nva  = ntn*iv
            nvb1 = n*ns*(iv-1)+1
            nvb2 = n*ns*iv
!
! Back substitution with the ns right hand matrices:
!
            do il=1,ns
                  do k=1,nm1
                        nmk = n-k
!
! Indice of the diagonal element of the (n-k+1)th row and of
! the (n-k+1)th element of the left hand side.
!
                        kdiag = nva-(n+1)*(k-1)
                        kb    = nvb2-(il-1)*n-k+1
                        b(kb) = b(kb)/a(kdiag)
                        t     = -b(kb)
                        i1    = kb
                        i2    = kdiag
                        do i=1,nmk
                              i1    = i1-1
                              i2    = i2-1
                              b(i1) = b(i1)+a(i2)*t
                        end do
                  end do
                  kdiag = kdiag-n-1
                  kb    = kb-1
                  b(kb) = b(kb)/a(kdiag)
            end do
!
! End of back substitution:
!
      end do
!
! Restitution of the solution:
!
      itot = n*ns*nv
      do i=1,itot
            x(i) = b(i)
      end do
!
! Finished:
!
      return
      end



      subroutine srchsupr_new(xloc,yloc,zloc,radsqd,irot,MAXROT,rotmat,    &
                          nsbtosr,ixsbtosr,iysbtosr,izsbtosr,noct,nd,      &
                          x,y,z,tmp,nisb,nxsup,xmnsup,xsizsup,             &
                          nysup,ymnsup,ysizsup,nzsup,zmnsup,zsizsup,       &
                          nclose,close,infoct)
!-----------------------------------------------------------------------
!
!              Search Within Super Block Search Limits
!              ***************************************
!
!
! This subroutine searches through all the data that have been tagged in
! the super block subroutine.  The close data are passed back in the
! index array "close".  An octant search is allowed.
!
!
!
! INPUT VARIABLES:
!
!   xloc,yloc,zloc   location of point being estimated/simulated
!   radsqd           squared search radius
!   irot             index of the rotation matrix for searching
!   MAXROT           size of rotation matrix arrays
!   rotmat           rotation matrices
!   nsbtosr          Number of super blocks to search
!   ixsbtosr         X offsets for super blocks to search
!   iysbtosr         Y offsets for super blocks to search
!   izsbtosr         Z offsets for super blocks to search
!   noct             If >0 then data will be partitioned into octants
!   nd               Number of data
!   x(nd)            X coordinates of the data
!   y(nd)            Y coordinates of the data
!   z(nd)            Z coordinates of the data
!   tmp(nd)          Temporary storage to keep track of the squared
!                      distance associated with each data
!   nisb()                Array with cumulative number of data in each
!                           super block.
!   nxsup,xmnsup,xsizsup  Definition of the X super block grid
!   nysup,ymnsup,ysizsup  Definition of the X super block grid
!   nzsup,zmnsup,zsizsup  Definition of the X super block grid
!
!
!
! OUTPUT VARIABLES:
!
!   nclose           Number of close data
!   close()          Index of close data
!   infoct           Number of informed octants (only computes if
!                      performing an octant search)
!
!
!
! EXTERNAL REFERENCES:
!
!   sqdist           Computes anisotropic squared distance
!   sortem           Sorts multiple arrays in ascending order
!
!
!
!-----------------------------------------------------------------------

      implicit integer(i-n), real(a-h, o-z)                    !jd

      real    x(*),y(*),z(*),tmp(*),close(*)
      real*8  rotmat(MAXROT,3,3),hsqd,sqdist_new
      integer nisb(*),inoct(8)
      integer ixsbtosr(*),iysbtosr(*),izsbtosr(*)
      logical inflag
!
! Determine the super block location of point being estimated:
!
      call getindx_new(nxsup,xmnsup,xsizsup,xloc,ix,inflag)
      call getindx_new(nysup,ymnsup,ysizsup,yloc,iy,inflag)
      call getindx_new(nzsup,zmnsup,zsizsup,zloc,iz,inflag)
!
! Loop over all the possible Super Blocks:
!
      nclose = 0
      do 1 isup=1,nsbtosr
!
! Is this super block within the grid system:
!
            ixsup = ix + ixsbtosr(isup)
            iysup = iy + iysbtosr(isup)
            izsup = iz + izsbtosr(isup)
            if(ixsup.le.0.or.ixsup.gt.nxsup.or.                      &
               iysup.le.0.or.iysup.gt.nysup.or.			     &
               izsup.le.0.or.izsup.gt.nzsup) go to 1
!
! Figure out how many samples in this super block:
!
            ii = ixsup + (iysup-1)*nxsup + (izsup-1)*nxsup*nysup
            if(ii.eq.1) then
                  nums = nisb(ii)
                  i    = 0
            else
                  nums = nisb(ii) - nisb(ii-1)
                  i    = nisb(ii-1)
            endif
!
! Loop over all the data in this super block:
!
            do 2 ii=1,nums
                  i = i + 1
!
! Check squared distance:
!
                  hsqd = sqdist_new(xloc,yloc,zloc,x(i),y(i),z(i),irot,    &
                                MAXROT,rotmat)
                  if(real(hsqd).gt.radsqd) go to 2
!
! Accept this sample:
!
                  nclose = nclose + 1
                  close(nclose) = real(i)
                  tmp(nclose)  = real(hsqd)
 2          continue
 1    continue
!
! Sort the nearby samples by distance to point being estimated:
!
      call sortem_new(1,nclose,tmp,1,close,c,d,e,f,g,h)
!
! If we aren't doing an octant search then just return:
!
      if(noct.le.0) return
!
! PARTITION THE DATA INTO OCTANTS:
!
      do i=1,8
            inoct(i) = 0
      end do
!
! Now pick up the closest samples in each octant:
!
      nt = 8*noct
      na = 0
      do j=1,nclose
            i  = int(close(j))
            h  = tmp(j)
            dx = x(i) - xloc
            dy = y(i) - yloc
            dz = z(i) - zloc
            if(dz.lt.0.) go to 5
            iq=4
            if(dx.le.0.0 .and. dy.gt.0.0) iq=1
            if(dx.gt.0.0 .and. dy.ge.0.0) iq=2
            if(dx.lt.0.0 .and. dy.le.0.0) iq=3
            go to 6
 5          iq=8
            if(dx.le.0.0 .and. dy.gt.0.0) iq=5
            if(dx.gt.0.0 .and. dy.ge.0.0) iq=6
            if(dx.lt.0.0 .and. dy.le.0.0) iq=7
 6          continue
            inoct(iq) = inoct(iq) + 1
!
! Keep this sample if the maximum has not been exceeded:
!
            if(inoct(iq).le.noct) then
                  na = na + 1
                  close(na) = i
                  tmp(na)   = h
                  if(na.eq.nt) go to 7
            endif
      end do
!
! End of data selection. Compute number of informed octants and return:
!
 7    nclose = na
      infoct = 0
      do i=1,8
            if(inoct(i).gt.0) infoct = infoct + 1
      end do
!
! Finished:
!
      return
      end



      subroutine getindx_new(n,min,siz,loc,index,inflag)
!-----------------------------------------------------------------------
!
!     Gets the coordinate index location of a point within a grid
!     ***********************************************************
!
!
! n       number of "nodes" or "cells" in this coordinate direction
! min     origin at the center of the first cell
! siz     size of the cells
! loc     location of the point being considered
! index   output index within [1,n]
! inflag  true if the location is actually in the grid (false otherwise
!         e.g., if the location is outside then index will be set to
!         nearest boundary
!
!
!
!-----------------------------------------------------------------------
      integer   n,index
      real      min,siz,loc
      logical   inflag
!
! Compute the index of "loc":
!
      index = int( (loc-min)/siz + 1.5 )
!
! Check to see if in or out:
!
      if(index.lt.1) then
            index  = 1
            inflag = .false.
      else if(index.gt.n) then
            index  = n
            inflag = .false.
      else
            inflag = .true.
      end if
!
! Return to calling program:
!
      return
      end


      subroutine setrot_new(ang1,ang2,ang3,anis1,anis2,ind,MAXROT,rotmat)
!-----------------------------------------------------------------------
!
!              Sets up an Anisotropic Rotation Matrix
!              **************************************
!
! Sets up the matrix to transform cartesian coordinates to coordinates
! accounting for angles and anisotropy (see manual for a detailed
! definition):
!
!
! INPUT PARAMETERS:
!
!   ang1             Azimuth angle for principal direction
!   ang2             Dip angle for principal direction
!   ang3             Third rotation angle
!   anis1            First anisotropy ratio
!   anis2            Second anisotropy ratio
!   ind              matrix indicator to initialize
!   MAXROT           maximum number of rotation matrices dimensioned
!   rotmat           rotation matrices
!
!
! NO EXTERNAL REFERENCES
!
!
!-----------------------------------------------------------------------
      implicit integer(i-n), real(a-h, o-z)                    !jd

      parameter(DEG2RAD=3.141592654/180.0,EPSLON=1.e-20)
      real*8    rotmat(MAXROT,3,3),afac1,afac2,sina,sinb,sint,cosa,cosb,cost
!
! Converts the input angles to three angles which make more
!  mathematical sense:
!
!         alpha   angle between the major axis of anisotropy and the
!                 E-W axis. Note: Counter clockwise is positive.
!         beta    angle between major axis and the horizontal plane.
!                 (The dip of the ellipsoid measured positive down)
!         theta   Angle of rotation of minor axis about the major axis
!                 of the ellipsoid.
!
      if(ang1.ge.0.0.and.ang1.lt.270.0) then
            alpha = (90.0   - ang1) * DEG2RAD
      else
            alpha = (450.0  - ang1) * DEG2RAD
      endif
      beta  = -1.0 * ang2 * DEG2RAD
      theta =        ang3 * DEG2RAD
!
! Get the required sines and cosines:
!
      sina  = dble(sin(alpha))
      sinb  = dble(sin(beta))
      sint  = dble(sin(theta))
      cosa  = dble(cos(alpha))
      cosb  = dble(cos(beta))
      cost  = dble(cos(theta))
!
! Construct the rotation matrix in the required memory:
!
      afac1 = 1.0 / dble(max(anis1,EPSLON))
      afac2 = 1.0 / dble(max(anis2,EPSLON))
      rotmat(ind,1,1) =       (cosb * cosa)
      rotmat(ind,1,2) =       (cosb * sina)
      rotmat(ind,1,3) =       (-sinb)
      rotmat(ind,2,1) = afac1*(-cost*sina + sint*sinb*cosa)
      rotmat(ind,2,2) = afac1*(cost*cosa + sint*sinb*sina)
      rotmat(ind,2,3) = afac1*( sint * cosb)
      rotmat(ind,3,1) = afac2*(sint*sina + cost*sinb*cosa)
      rotmat(ind,3,2) = afac2*(-sint*cosa + cost*sinb*sina)
      rotmat(ind,3,3) = afac2*(cost * cosb)
!
! Return to calling program:
!
      return
      end




      subroutine picksup_new(nxsup,xsizsup,nysup,ysizsup,nzsup,zsizsup,    &
                         irot,MAXROT,rotmat,radsqd,nsbtosr,ixsbtosr,	   &
                         iysbtosr,izsbtosr)
!-----------------------------------------------------------------------
!
!             Establish Which Super Blocks to Search
!             **************************************
!
! This subroutine establishes which super blocks must be searched given
! that a point being estimated/simulated falls within a super block
! centered at 0,0,0.
!
!
!
! INPUT VARIABLES:
!
!   nxsup,xsizsup    Definition of the X super block grid
!   nysup,ysizsup    Definition of the Y super block grid
!   nzsup,zsizsup    Definition of the Z super block grid
!   irot             index of the rotation matrix for searching
!   MAXROT           size of rotation matrix arrays
!   rotmat           rotation matrices
!   radsqd           squared search radius
!
!
!
! OUTPUT VARIABLES:
!
!   nsbtosr          Number of super blocks to search
!   ixsbtosr         X offsets for super blocks to search
!   iysbtosr         Y offsets for super blocks to search
!   izsbtosr         Z offsets for super blocks to search
!
!
!
! EXTERNAL REFERENCES:
!
!   sqdist           Computes anisotropic squared distance
!
!
!
!-----------------------------------------------------------------------
      implicit integer(i-n), real(a-h, o-z)                    !jd

      real*8  rotmat(MAXROT,3,3),hsqd,sqdist_new,shortest
      integer ixsbtosr(*),iysbtosr(*),izsbtosr(*)
!
! MAIN Loop over all possible super blocks:
!
      nsbtosr = 0
      do i=-(nxsup-1),(nxsup-1)
      do j=-(nysup-1),(nysup-1)
      do k=-(nzsup-1),(nzsup-1)
            xo = real(i)*xsizsup
            yo = real(j)*ysizsup
            zo = real(k)*zsizsup
!
! Find the closest distance between the corners of the super blocks:
!
            shortest = 1.0e21
            do i1=-1,1
            do j1=-1,1
            do k1=-1,1
                  do i2=-1,1
                  do j2=-1,1
                  do k2=-1,1
                        if(i1.ne.0.and.j1.ne.0.and.k1.ne.0.and.          &
                           i2.ne.0.and.j2.ne.0.and.k2.ne.0) then
                              xdis = real(i1-i2)*0.5*xsizsup + xo
                              ydis = real(j1-j2)*0.5*ysizsup + yo
                              zdis = real(k1-k2)*0.5*zsizsup + zo
                              hsqd = sqdist_new(0.0,0.0,0.0,xdis,ydis,zdis,   &
                                            irot,MAXROT,rotmat)
                              if(hsqd.lt.shortest) shortest = hsqd
                        end if
                  end do
                  end do
                  end do
            end do
            end do
            end do
!
! Keep this super block if it is close enoutgh:
!
            if(real(shortest).le.radsqd) then
                  nsbtosr = nsbtosr + 1
                  ixsbtosr(nsbtosr) = i
                  iysbtosr(nsbtosr) = j
                  izsbtosr(nsbtosr) = k
            end if
      end do
      end do
      end do
!
! Finished:
!
      return
      end



      real*8 function sqdist_new(x1,y1,z1,x2,y2,z2,ind,MAXROT,rotmat)
!-----------------------------------------------------------------------
!
!    Squared Anisotropic Distance Calculation Given Matrix Indicator
!    ***************************************************************
!
! This routine calculates the anisotropic distance between two points
!  given the coordinates of each point and a definition of the
!  anisotropy.
!
!
! INPUT VARIABLES:
!
!   x1,y1,z1         Coordinates of first point
!   x2,y2,z2         Coordinates of second point
!   ind              The rotation matrix to use
!   MAXROT           The maximum number of rotation matrices dimensioned
!   rotmat           The rotation matrices
!
!
!
! OUTPUT VARIABLES:
!
!   sqdist           The squared distance accounting for the anisotropy
!                      and the rotation of coordinates (if any).
!
!
! NO EXTERNAL REFERENCES
!
!
!-----------------------------------------------------------------------
      implicit integer(i-n), real(a-h, o-z)                    !jd
      real*8 rotmat(MAXROT,3,3),cont,dx,dy,dz
!
! Compute component distance vectors and the squared distance:
!
      dx = dble(x1 - x2)
      dy = dble(y1 - y2)
      dz = dble(z1 - z2)
      sqdist_new = 0.0
      do i=1,3
            cont   = rotmat(ind,i,1) * dx      &
                   + rotmat(ind,i,2) * dy      &
                   + rotmat(ind,i,3) * dz
            sqdist_new = sqdist_new + cont * cont
      end do
      return
      end




      subroutine sortem_new(ib,ie,a,iperm,b,c,d,e,f,g,h)
!-----------------------------------------------------------------------
!
!                      Quickersort Subroutine
!                      **********************
!
! This is a subroutine for sorting a real array in ascending order. This
! is a Fortran translation of algorithm 271, quickersort, by R.S. Scowen
! in collected algorithms of the ACM.
!
! The method used is that of continually splitting the array into parts
! such that all elements of one part are less than all elements of the
! other, with a third part in the middle consisting of one element.  An
! element with value t is chosen arbitrarily (here we choose the middle
! element). i and j give the lower and upper limits of the segment being
! split.  After the split a value q will have been found such that
! a(q)=t and a(l)<=t<=a(m) for all i<=l<q<m<=j.  The program then
! performs operations on the two segments (i,q-1) and (q+1,j) as follows
! The smaller segment is split and the position of the larger segment is
! stored in the lt and ut arrays.  If the segment to be split contains
! two or fewer elements, it is sorted and another segment is obtained
! from the lt and ut arrays.  When no more segments remain, the array
! is completely sorted.
!
!
! INPUT PARAMETERS:
!
!   ib,ie        start and end index of the array to be sorteda
!   a            array, a portion of which has to be sorted.
!   iperm        0 no other array is permuted.
!                1 array b is permuted according to array a
!                2 arrays b,c are permuted.
!                3 arrays b,c,d are permuted.
!                4 arrays b,c,d,e are permuted.
!                5 arrays b,c,d,e,f are permuted.
!                6 arrays b,c,d,e,f,g are permuted.
!                7 arrays b,c,d,e,f,g,h are permuted.
!               >7 no other array is permuted.
!
!   b,c,d,e,f,g,h  arrays to be permuted according to array a.
!
! OUTPUT PARAMETERS:
!
!    a      = the array, a portion of which has been sorted.
!
!    b,c,d,e,f,g,h  =arrays permuted according to array a (see iperm)
!
! NO EXTERNAL ROUTINES REQUIRED:
!
!-----------------------------------------------------------------------
      implicit integer(i-n), real(a-h, o-z)                    !jd

      dimension a(*),b(*),c(*),d(*),e(*),f(*),g(*),h(*)
!
! The dimensions for lt and ut have to be at least log (base 2) n
!
      integer   lt(64),ut(64),i,j,k,m,p,q
!
! Initialize:
!
      j     = ie
      m     = 1
      i     = ib
      iring = iperm+1
      if (iperm.gt.7) iring=1
!
! If this segment has more than two elements  we split it
!
 10   if (j-i-1) 100,90,15
!
! p is the position of an arbitrary element in the segment we choose the
! middle element. Under certain circumstances it may be advantageous
! to choose p at random.
!
 15   p    = (j+i)/2
      ta   = a(p)
      a(p) = a(i)
      go to (21,19,18,17,16,161,162,163),iring
 163     th   = h(p)
         h(p) = h(i)
 162     tg   = g(p)
         g(p) = g(i)
 161     tf   = f(p)
         f(p) = f(i)
 16      te   = e(p)
         e(p) = e(i)
 17      td   = d(p)
         d(p) = d(i)
 18      tc   = c(p)
         c(p) = c(i)
 19      tb   = b(p)
         b(p) = b(i)
 21   continue
!
! Start at the beginning of the segment, search for k such that a(k)>t
!
      q = j
      k = i
 20   k = k+1
      if(k.gt.q)     go to 60
      if(a(k).le.ta) go to 20
!
! Such an element has now been found now search for a q such that a(q)<t
! starting at the end of the segment.
!
 30   continue
      if(a(q).lt.ta) go to 40
      q = q-1
      if(q.gt.k)     go to 30
      go to 50
!
! a(q) has now been found. we interchange a(q) and a(k)
!
 40   xa   = a(k)
      a(k) = a(q)
      a(q) = xa
      go to (45,44,43,42,41,411,412,413),iring
 413     xh   = h(k)
         h(k) = h(q)
         h(q) = xh
 412     xg   = g(k)
         g(k) = g(q)
         g(q) = xg
 411     xf   = f(k)
         f(k) = f(q)
         f(q) = xf
 41      xe   = e(k)
         e(k) = e(q)
         e(q) = xe
 42      xd   = d(k)
         d(k) = d(q)
         d(q) = xd
 43      xc   = c(k)
         c(k) = c(q)
         c(q) = xc
 44      xb   = b(k)
         b(k) = b(q)
         b(q) = xb
 45   continue
!
! Update q and search for another pair to interchange:
!
      q = q-1
      go to 20
 50   q = k-1
 60   continue
!
! The upwards search has now met the downwards search:
!
      a(i)=a(q)
      a(q)=ta
      go to (65,64,63,62,61,611,612,613),iring
 613     h(i) = h(q)
         h(q) = th
 612     g(i) = g(q)
         g(q) = tg
 611     f(i) = f(q)
         f(q) = tf
 61      e(i) = e(q)
         e(q) = te
 62      d(i) = d(q)
         d(q) = td
 63      c(i) = c(q)
         c(q) = tc
 64      b(i) = b(q)
         b(q) = tb
 65   continue
!
! The segment is now divided in three parts: (i,q-1),(q),(q+1,j)
! store the position of the largest segment in lt and ut
!
      if (2*q.le.i+j) go to 70
      lt(m) = i
      ut(m) = q-1
      i = q+1
      go to 80
 70   lt(m) = q+1
      ut(m) = j
      j = q-1
!
! Update m and split the new smaller segment
!
 80   m = m+1
      go to 10
!
! We arrive here if the segment has  two elements we test to see if
! the segment is properly ordered if not, we perform an interchange
!
 90   continue
      if (a(i).le.a(j)) go to 100
      xa=a(i)
      a(i)=a(j)
      a(j)=xa
      go to (95,94,93,92,91,911,912,913),iring
 913     xh   = h(i)
         h(i) = h(j)
         h(j) = xh
 912     xg   = g(i)
         g(i) = g(j)
         g(j) = xg
 911     xf   = f(i)
         f(i) = f(j)
         f(j) = xf
   91    xe   = e(i)
         e(i) = e(j)
         e(j) = xe
   92    xd   = d(i)
         d(i) = d(j)
         d(j) = xd
   93    xc   = c(i)
         c(i) = c(j)
         c(j) = xc
   94    xb   = b(i)
         b(i) = b(j)
         b(j) = xb
   95 continue
!
! If lt and ut contain more segments to be sorted repeat process:
!
 100  m = m-1
      if (m.le.0) go to 110
      i = lt(m)
      j = ut(m)
      go to 10
 110  continue
      return
      end



      subroutine geostat_3d_dealloc()

      use geostat_3d

      if(allocated(nisb)) deallocate(nisb,stat=ierr)
      if(allocated(ixsbtosr)) deallocate(ixsbtosr,stat=ierr)
      if(allocated(iysbtosr)) deallocate(iysbtosr,stat=ierr)
      if(allocated(izsbtosr)) deallocate(izsbtosr,stat=ierr)
      if(allocated(x)) deallocate(x,stat=ierr)
      if(allocated(y)) deallocate(y,stat=ierr)
      if(allocated(z)) deallocate(z,stat=ierr)
      if(allocated(vr)) deallocate(vr,stat=ierr)
      if(allocated(ve)) deallocate(ve,stat=ierr)
      if(allocated(dh)) deallocate(dh,stat=ierr)
      if(allocated(tmp)) deallocate(tmp,stat=ierr)
      if(allocated(close)) deallocate(close,stat=ierr)
      if(allocated(xa)) deallocate(xa,stat=ierr)
      if(allocated(ya)) deallocate(ya,stat=ierr)
      if(allocated(za)) deallocate(za,stat=ierr)
      if(allocated(vra)) deallocate(vra,stat=ierr)
      if(allocated(vea)) deallocate(vea,stat=ierr)
      if(allocated(xdb)) deallocate(xdb,stat=ierr)
      if(allocated(ydb)) deallocate(ydb,stat=ierr)
      if(allocated(zdb)) deallocate(zdb,stat=ierr)
      if(allocated(cut)) deallocate(cut,stat=ierr)
      if(allocated(cdf)) deallocate(cdf,stat=ierr)
      if(allocated(r)) deallocate(r,stat=ierr)
      if(allocated(rr)) deallocate(rr,stat=ierr)
      if(allocated(s)) deallocate(s,stat=ierr)
      if(allocated(a)) deallocate(a,stat=ierr)
      if(allocated(sec3)) deallocate(sec3,stat=ierr)

      return
      end subroutine geostat_3d_dealloc

       program driver11

! -- DRIVER11 tests structural overlay parameter functionality. It tests the building
!    and use of interpolation and blending factors that implement it.

       use function_interfaces
       use iso_c_binding, only : c_int,c_char,c_double
       implicit none

! -- Variables used in function calls.

       integer(kind=c_int)               :: ifail
       integer(kind=c_int)               :: npts,mpts
       integer(kind=c_int)               :: structype,factorfiletype,transtype
       integer(kind=c_int)               :: icount_interp,icount
       real(kind=c_double)               :: inverse_power
       character(kind=c_char,len=1)      :: lt_target,gt_target
       character(kind=c_char,len=1)      :: factorfile(256)
       character(kind=c_char,len=1)      :: messagestring(1500)
       integer(kind=c_int), allocatable  :: active(:),ids(:)
       real(kind=c_double), allocatable  :: ecs(:),ncs(:)
       real(kind=c_double), allocatable  :: ect(:),nct(:),zct(:)
       real(kind=c_double), allocatable  :: conwidth(:),aa(:)
       real(kind=c_double), allocatable  :: sourceval(:),targval(:)

! -- Other variables.

       integer                       :: jfail,ierr,iline
       integer                       :: ipt
       integer                       :: ibeg,iend
       integer                       :: lw(15),rw(15)
       double precision              :: dtemp
       character (len=1)             :: ah,aaa,al
       character (len=10)            :: aline,anum
       character (len=256)           :: infile,outfile,facfile,afile
       character (len=500)           :: cline
       character (len=1500)          :: amessage

       character (len=20), allocatable    :: apoint(:)

! -- Obtain coordinates of grid cell centres.

100    write(6,110,advance='no')
110    format(' Enter name of file containing grid cell centre coordinates: ')
       read(5,*,err=100) infile
       open(unit=10,file=infile,status='old',err=100)
115    write(6,116,advance='no')
116    format(' Skip header line? (y/n): ')
       read(5,*) ah
       if((ah.eq.'Y').or.(ah.eq.'y'))then
         ah='y'
       else if((ah.eq.'N').or.(ah.eq.'n'))then
         ah='n'
       else
         go to 115
       end if
       mpts=0
       do
         read(10,'(a)',end=200) cline
         if(cline.eq.' ')cycle
         mpts=mpts+1
       end do
200    continue
       if(ah.eq.'y')mpts=mpts-1
       if(mpts.eq.0)then
         write(6,201)
201      format(/,' *** No coordinates in file. Try again ***',/)
         close(unit=10)
         go to 100
       end if
       allocate(ect(mpts),nct(mpts),zct(mpts),active(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(targval(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200
       rewind (unit=10)
       iline=0
       if(ah.eq.'y')then
         iline=iline+1
         read(10,*)
       end if
       do ipt=1,mpts
210      continue
         iline=iline+1
         read(10,'(a)',err=9000,end=9050) cline
         if(cline.eq.' ') go to 210
         call linesplit(jfail,4,lw,rw,cline)
         if(jfail.ne.0) go to 9070
         call drealread(jfail,cline(lw(1):rw(1)),ect(ipt))
         if(jfail.ne.0) go to 9150
         call drealread(jfail,cline(lw(2):rw(2)),nct(ipt))
         if(jfail.ne.0) go to 9150
         call drealread(jfail,cline(lw(3):rw(3)),zct(ipt))
         if(jfail.ne.0) go to 9150
         call intread(jfail,cline(lw(4):rw(4)),active(ipt))
         if(jfail.ne.0) go to 9150
       end do
       close(unit=10)
       call writint(anum,mpts)
       write(6,220) trim(anum),trim(infile)
220    format(' - coordinates of ',a,' points read from file ',a,'.')

       write(6,*)
250    write(6,260,advance='no')
260    format(' Enter background value for grid cell properties: ')
       read(5,*,err=250) dtemp
       targval=dtemp      ! an array

       write(6,*)
300    write(6,310,advance='no')
310    format(' Enter name of file containing structural overlay details: ')
       read(5,*,err=300) infile
       open(unit=10,file=infile,status='old',err=300)
315    write(6,316,advance='no')
316    format(' Skip header line? (y/n): ')
       read(5,*) ah
       if((ah.eq.'Y').or.(ah.eq.'y'))then
         ah='y'
       else if((ah.eq.'N').or.(ah.eq.'n'))then
         ah='n'
       else
         go to 315
       end if
       npts=0
       do
         read(10,'(a)',end=400) cline
         if(cline.eq.' ')cycle
         npts=npts+1
       end do
400    continue
       if(ah.eq.'y')npts=npts-1
       if(npts.eq.0)then
         write(6,401)
401      format(/,' *** File appears to be empty. Try again ***',/)
         close(unit=10)
         go to 300
       end if
       allocate(ecs(npts),ncs(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(apoint(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(ids(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(conwidth(npts),aa(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(sourceval(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       rewind (unit=10)
       iline=0
       if(ah.eq.'y')then
         iline=iline+1
         read(10,*)
       end if
       do ipt=1,npts
410      continue
         iline=iline+1
         read(10,'(a)',err=9000,end=9050) cline
         if(cline.eq.' ') go to 410
         call linesplit(jfail,7,lw,rw,cline)
         if(jfail.ne.0) go to 9070
         apoint(ipt)=cline(lw(1):rw(1))
         call drealread(jfail,cline(lw(2):rw(2)),ecs(ipt))
         if(jfail.ne.0) go to 9150
         call drealread(jfail,cline(lw(3):rw(3)),ncs(ipt))
         if(jfail.ne.0) go to 9150
         call intread(jfail,cline(lw(4):rw(4)),ids(ipt))
         if(jfail.ne.0) go to 9150
         call drealread(jfail,cline(lw(5):rw(5)),conwidth(ipt))
         if(jfail.ne.0) go to 9150
         call drealread(jfail,cline(lw(6):rw(6)),aa(ipt))
         if(jfail.ne.0) go to 9150
         call drealread(jfail,cline(lw(7):rw(7)),sourceval(ipt))
         if(jfail.ne.0) go to 9150
       end do
       close(unit=10)
       call writint(anum,npts)
       write(6,420) trim(anum),trim(infile)
420    format(' - coordinates of ',a,' points read from file ',a,'.')

       write(6,*)
430    write(6,440,advance='no')
440    format(' Are structures polylinear or polygonal? (l/p): ')
       read(5,*,err=430) ah
       if((ah.eq.'l').or.(ah.eq.'L'))then
         structype=0
       else if ((ah.eq.'p').or.(ah.eq.'P'))then
         structype=1
       else
         go to 430
       end if
445    write(6,446,advance='no')
446    format(' Enter inv power of distance: ')
       read(5,*,err=445) inverse_power

! -- The name of the factor file is aquired.

       write(6,*)
450    write(6,460,advance='no')
460    format(' Enter name for factor file: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 450
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,facfile,ibeg,iend)
       if(ifail.ne.0) go to 450
       call char2string(256,facfile,factorfile)
471    write(6,480,advance='no')
480    format(' Is this a text or binary file? (t/b): ')
       read(5,*,err=471) aaa
       if((aaa.eq.'t').or.(aaa.eq.'T'))then
         factorfiletype=1
       else if ((aaa.eq.'b').or.(aaa.eq.'B'))then
         factorfiletype=0
       else
         go to 471
       end if

! -- Now call the function to calculate factors.

       write(6,*)
       write(6,520)
520    format(' Calling calc_structural_overlay_factors()....')
       ifail=calc_structural_overlay_factors(        &
                     npts,                           &
                     ecs,ncs,ids,                    &
                     conwidth,aa,                    &
                     structype,inverse_power,        &
                     mpts,                           &
                     ect,nct,active,                 &
                     factorfile,factorfiletype,      &
                     icount_interp)
       if(ifail.ne.0)then
         write(6,*)
         write(6,540)
540      format(' Function call unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       else
         write(anum,'(i0)') icount_interp
         anum=adjustl(anum)
         write(6,550) trim(anum)
550      format(' Interpolation factors calculated for ',a,' points.')
       end if

! -- We will now re-read the factor file and undertake interpolation.

       write(6,*)
       write(6,600)
600    format(' Now undertaking spatial interpolation.')
       write(6,*)
609    write(6,610,advance='no')
610    format(' Interpolate in natural or log domain? (n/l): ')
       read(5,*) al
       if((al.eq.'N').or.(al.eq.'n'))then
         transtype=0
       else if((al.eq.'l').or.(al.eq.'L'))then
         transtype=1
       else
         go to 609
       end if
       lt_target='y'
       gt_target='y'
       ifail=interpolate_blend_using_file(               &
                         factorfile,factorfiletype,      &
                         npts,mpts,                      &
                         transtype,                      &
                         lt_target,gt_target,            &
                         sourceval,targval,              &
                         icount)
       if(ifail.ne.0)then
         write(6,*)
         write(6,540)
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       else
         write(anum,'(i0)') icount
         anum=adjustl(anum)
         write(6,630) trim(anum)
630      format(' Interpolation undertaken to ',a,' points.')
       end if

! -- We now store the results as a list of numbers.

       write(6,*)
640    write(6,650,advance='no')
650    format(' Enter filename for target array storage: ')
       read(5,*,err=640) outfile
       open(unit=20,file=outfile,action='write',err=640)
       do ipt=1,mpts
         write(20,660) targval(ipt)
660      format(1pg16.9)
       end do
       close(unit=20)
       write(6,470) trim(outfile)
470    format(' - file ',a,' written ok.')

       go to 9900

9000   write(amessage,9010) trim(infile)
9010   format('Error encountered in reading file ',a,'.')
       go to 9890

9050   write(amessage,9060) trim(infile)
9060   format('Premature end encountered to file ',a,'.')
       go to 9890

9070   call writint(aline,iline)
       write(amessage,9080) trim(aline),trim(infile)
9080   format('Insufficient entries on line ',a,' of file ',a,'.')
       go to 9890

9150   call writint(aline,iline)
       write(amessage,9160) trim(aline),trim(infile)
9160   format('Error reading data on line ',a,' of file ',a,'.')
       go to 9890

9200   write(amessage,9210)
9210   format('Insufficient memory to continue execution.')
       go to 9890

9890   continue
       amessage=' '//trim(amessage)
       call writmess(6,amessage)

! -- Tidy up

9900   continue

! -- Free local memory

       deallocate(active,ids,stat=ierr)
       deallocate(ecs,ncs,stat=ierr)
       deallocate(ect,nct,zct,stat=ierr)
       deallocate(conwidth,aa,stat=ierr)
       deallocate(sourceval,targval,stat=ierr)
       deallocate(apoint,stat=ierr)

! -- Free function interface memory

       ifail=free_all_memory()

       end

module function_interfaces

! -- Interfaces to functions comprising proc_model_outputs.lib

  interface

    integer (kind=c_int) function inquire_modflow_binary_file_specs(            &
                         FileIn,FileOut,isim,itype,iprec,narray,ntime)          &
                     bind(C,name="inquire_modflow_binary_file_specs")
       use iso_c_binding, only: c_int,c_char
       character (kind=c_char), intent(in)        :: FileIn(*)
       character (kind=c_char), intent(in)        :: FileOut(*)
       integer(kind=c_int), intent(in)            :: isim
       integer(kind=c_int), intent(in)            :: itype
       integer(kind=c_int), intent(out)           :: iprec
       integer(kind=c_int), intent(out)           :: narray
       integer(kind=c_int), intent(out)           :: ntime
    end function inquire_modflow_binary_file_specs

    integer (kind=c_int) function retrieve_error_message(errormessage)             &
                    bind(c, name="retrieve_error_message")
       use iso_c_binding, only: c_int,c_char
       character (kind=c_char), intent(out) :: errormessage(*)
    end function retrieve_error_message

    integer (kind=c_int) function install_structured_grid                            &
                       (gridname,ncol,nrow,nlay,icorner,e0,n0,rotation,delr,delc)    &
                     bind(c,name="install_structured_grid")
       use iso_c_binding, only: c_int,c_char,c_double
       character (kind=c_char), intent(in)  :: gridname(*)
       integer (kind=c_int), intent(in)     :: ncol,nrow,nlay
       integer (kind=c_int), intent(in)     :: icorner
       real (kind=c_double), intent(in)     :: e0,n0,rotation
       real (kind=c_double), intent(in)     :: delr(ncol),delc(nrow)
    end function install_structured_grid

    integer (kind=c_int) function get_cell_centres_structured(         &
                         gridname,                                     &
                         ncpl,                                         &
                         cellx,celly)                                  &
                     bind(c,name="get_cell_centres_structured")
       use iso_c_binding, only: c_int,c_double,c_char
       character (kind=c_char,len=1), intent(in)  :: gridname(*)
       integer(kind=c_int), intent(in)            :: ncpl
       real(kind=c_double), intent(out)           :: cellx(ncpl)
       real(kind=c_double), intent(out)           :: celly(ncpl)
    end function get_cell_centres_structured

    integer (kind=c_int) function uninstall_structured_grid(gridname)                &
                     bind(c,name="uninstall_structured_grid")
       use iso_c_binding, only: c_int,c_char
       character (kind=c_char), intent(in)  :: gridname(*)
    end function uninstall_structured_grid

    integer (kind=c_int) function free_all_memory() &
                     bind(c,name="free_all_memory")
       use iso_c_binding, only: c_int
    end function free_all_memory

    integer (kind=c_int) function interp_from_structured_grid(               &
                             GridName,DepVarFile,isim,iprec,ntime,           &
                             VarType,InterpThresh,NoInterpVal,               &
                             npts,ecoord,ncoord,layer,                       &
                             nproctime,simtime,simstate)                     &
                     bind(c,name="interp_from_structured_grid")
       use iso_c_binding, only: c_int,c_double,c_char
       character (kind=c_char), intent(in)  :: gridname(*)
       character (kind=c_char), intent(in)  :: depvarfile(*)
       integer(kind=c_int), intent(in)      :: isim
       integer(kind=c_int), intent(in)      :: iprec
       integer(kind=c_int), intent(in)      :: ntime
       character (kind=c_char), intent(in)  :: vartype(*)
       real(kind=c_double), intent(in)      :: interpthresh
       real(kind=c_double), intent(in)      :: nointerpval
       integer(kind=c_int), intent(in)      :: npts
       real(kind=c_double), intent(in)      :: ecoord(npts),ncoord(npts)
       integer(kind=c_int), intent(in)      :: layer(npts)
       integer(kind=c_int), intent(out)     :: nproctime
       real(kind=c_double), intent(out)     :: simtime(ntime)
       real(kind=c_double), intent(out)     :: simstate(ntime,npts)
    end function interp_from_structured_grid

    integer (kind=c_int) function interp_to_obstime(                           &
                             nsimtime,nproctime,npts,simtime,simval,           &
                             interpthresh,how_extrap,time_extrap,nointerpval,  &
                             nobs,obspoint,obstime,obssimval)                  &
                     bind(c,name="interp_to_obstime")
       use iso_c_binding, only: c_int,c_double,c_char
       integer(kind=c_int), intent(in)         :: nsimtime
       integer(kind=c_int), intent(in)         :: nproctime
       integer(kind=c_int), intent(in)         :: npts
       real(kind=c_double), intent(in)         :: simtime(nsimtime)
       real(kind=c_double), intent(in)         :: simval(nsimtime,npts)
       real(kind=c_double), intent(in)         :: interpthresh
       character(kind=c_char,len=1),intent(in) :: how_extrap
       real(kind=c_double), intent(in)         :: time_extrap
       real(kind=c_double), intent(in)         :: nointerpval
       integer(kind=c_int), intent(in)         :: nobs
       integer(kind=c_int), intent(in)         :: obspoint(nobs)
       real(kind=c_double), intent(in)         :: obstime(nobs)
       real(kind=c_double), intent(out)        :: obssimval(nobs)
    end function interp_to_obstime

    integer (kind=c_int) function install_mf6_grid_from_file(         &
                         gridname,grbfile,                            &
                         idis,ncells,ndim1,ndim2,ndim3)               &
                     bind(c,name="install_mf6_grid_from_file")
       use iso_c_binding, only: c_int,c_char
       character (kind=c_char,len=1), intent(in)  :: gridname(*)
       character (kind=c_char,len=1), intent(in)  :: grbfile(*)
       integer(kind=c_int), intent(out)           :: idis
       integer(kind=c_int), intent(out)           :: ncells
       integer(kind=c_int), intent(out)           :: ndim1,ndim2,ndim3
    end function install_mf6_grid_from_file

    integer (kind=c_int) function get_cell_centres_mf6(gridname,        &
                              ncells,                                   &
                              cellx,celly,cellz)                        &
                     bind(c,name="get_cell_centres_mf6")
       use iso_c_binding, only: c_int,c_double,c_char
       character (kind=c_char,len=1), intent(in)  :: gridname(*)
       integer(kind=c_int), intent(in)            :: ncells
       real(kind=c_double), intent(out)           :: cellx(ncells)
       real(kind=c_double), intent(out)           :: celly(ncells)
       real(kind=c_double), intent(out)           :: cellz(ncells)
    end function get_cell_centres_mf6

    integer (kind=c_int) function uninstall_mf6_grid(gridname)         &
                     bind(c,name="uninstall_mf6_grid")
       use iso_c_binding, only: c_int,c_char
       character (kind=c_char,len=1), intent(in)  :: gridname(*)
    end function uninstall_mf6_grid

    integer (kind=c_int) function calc_mf6_interp_factors(             &
                              gridname,                                &
                              npts,ecoord,ncoord,layer,                &
                              factorfile, factorfiletype,              &
                              blnfile,interp_success)                  &
                     bind(c,name="calc_mf6_interp_factors")
       use iso_c_binding, only: c_int,c_double,c_char
       character (kind=c_char,len=1), intent(in)   :: gridname(*)
       integer(kind=c_int), intent(in)             :: npts
       real(kind=c_double), intent(in)             :: ecoord(npts),ncoord(npts)
       integer(kind=c_int), intent(in)             :: layer(npts)
       character(kind=c_char,len=1), intent(in)    :: factorfile(*)
       integer(kind=c_int), intent(in)             :: factorfiletype
       character(kind=c_char,len=1), intent(in)    :: blnfile(*)
       integer(kind=c_int), intent(out)            :: interp_success(npts)
    end function calc_mf6_interp_factors

    integer (kind=c_int) function interp_from_mf6_depvar_file(                 &
                         depvarfile,factorfile,factorfiletype,                 &
                         ntime,vartype,interpthresh,reapportion,nointerpval,   &
                         npts,nproctime,simtime,simstate)                      &
                     bind(c,name="interp_from_mf6_depvar_file")
           use iso_c_binding, only: c_int,c_char,c_double
           character(kind=c_char,len=1), intent(in)   :: depvarfile(*)
           character(kind=c_char,len=1), intent(in)   :: factorfile(*)
           integer(kind=c_int), intent(in)            :: factorfiletype
           integer(kind=c_int), intent(in)            :: ntime
           character (kind=c_char,len=1), intent(in)  :: vartype(*)
           real(kind=c_double), intent(in)            :: interpthresh
           integer(kind=c_int), intent(in)            :: reapportion
           real(kind=c_double), intent(in)            :: nointerpval
           integer(kind=c_int), intent(in)            :: npts
           integer(kind=c_int), intent(out)           :: nproctime
           real(kind=c_double), intent(out)           :: simtime(ntime)
           real(kind=c_double), intent(out)           :: simstate(ntime,npts)
    end function interp_from_mf6_depvar_file

    integer (kind=c_int) function extract_flows_from_cbc_file(     &
                         cbcfile,flowtype,isim,iprec,              &
                         ncell,izone,nzone,                        &
                         numzone,zonenumber,                       &
                         ntime,nproctime,                          &
                         timestep,stressperiod,simtime,simflow)    &
                     bind(c,name="extract_flows_from_cbc_file")
       use iso_c_binding, only: c_int,c_char,c_double
       character (kind=c_char,len=1), intent(in)  :: cbcfile(*)
       character (kind=c_char,len=1), intent(in)  :: flowtype(*)
       integer(kind=c_int), intent(in)            :: isim
       integer(kind=c_int), intent(in)            :: iprec
       integer(kind=c_int), intent(in)            :: ncell
       integer(kind=c_int), intent(in)            :: izone(ncell)
       integer(kind=c_int), intent(in)            :: nzone
       integer(kind=c_int), intent(out)           :: numzone
       integer(kind=c_int), intent(out)           :: zonenumber(nzone)
       integer(kind=c_int), intent(in)            :: ntime
       integer(kind=c_int), intent(out)           :: nproctime
       integer(kind=c_int), intent(out)           :: timestep(ntime)
       integer(kind=c_int), intent(out)           :: stressperiod(ntime)
       real(kind=c_double), intent(out)           :: simtime(ntime)
       real(kind=c_double), intent(out)           :: simflow(ntime,nzone)
    end function extract_flows_from_cbc_file

  end interface

! -- Interfaces to functions comprising proc_model_outputs.lib

  interface

    integer (kind=c_int) function calc_kriging_factors_2d(        &
                            npts,ecs,ncs,zns,                     &
                            mpts,ect,nct,znt,                     &
                            vartype,krigtype,                     &
                            aa,anis,bearing,                      &
                            searchrad,maxpts,minpts,              &
                            factorfile,factorfiletype,            &
                            icount_interp)                        &
                     bind(c,name="calc_kriging_factors_2d")
       use iso_c_binding, only: c_int,c_char,c_double
       integer(kind=c_int), intent(in)           :: npts
       real(kind=c_double), intent(in)           :: ecs(npts),ncs(npts)
       integer(kind=c_int), intent(in)           :: zns(npts)
       integer(kind=c_int), intent(in)           :: mpts
       real(kind=c_double), intent(in)           :: ect(mpts),nct(mpts)
       integer(kind=c_int), intent(in)           :: znt(mpts)
       integer(kind=c_int), intent(in)           :: vartype
       integer(kind=c_int), intent(in)           :: krigtype
       real(kind=c_double), intent(in)           :: aa(mpts)
       real(kind=c_double), intent(in)           :: anis(mpts)
       real(kind=c_double), intent(in)           :: bearing(mpts)
       real(kind=c_double), intent(in)           :: searchrad
       integer(kind=c_int), intent(in)           :: maxpts, minpts
       character (kind=c_char,len=1), intent(in) :: factorfile(*)
       integer(kind=c_int), intent(in)           :: factorfiletype
       integer(kind=c_int), intent(out)          :: icount_interp
    end function calc_kriging_factors_2d

    integer (kind=c_int) function calc_kriging_factors_auto_2d(     &
                                   npts,ecs,ncs,zns,                &
                                   mpts,ect,nct,znt,                &
                                   krigtype,                        &
                                   anis,bearing,                    &
                                   factorfile,factorfiletype,       &
                                   icount_interp)                   &
                     bind(c,name="calc_kriging_factors_auto_2d")
       use iso_c_binding, only: c_int,c_char,c_double
       integer(kind=c_int), intent(in)           :: npts
       real(kind=c_double), intent(in)           :: ecs(npts),ncs(npts)
       integer(kind=c_int), intent(in)           :: zns(npts)
       integer(kind=c_int), intent(in)           :: mpts
       real(kind=c_double), intent(in)           :: ect(mpts),nct(mpts)
       integer(kind=c_int), intent(in)           :: znt(mpts)
       integer(kind=c_int), intent(in)           :: krigtype
       real(kind=c_double), intent(in)           :: anis(mpts)
       real(kind=c_double), intent(in)           :: bearing(mpts)
       character (kind=c_char,len=1), intent(in) :: factorfile(*)
       integer(kind=c_int), intent(in)           :: factorfiletype
       integer(kind=c_int), intent(out)          :: icount_interp
    end function calc_kriging_factors_auto_2d

    integer (kind=c_int) function krige_using_file(      &
                         factorfile,factorfiletype,      &
                         npts,mpts,                      &
                         krigtype,transtype,             &
                         sourceval,targval,              &
                         icount_interp,                  &
                         meanval)                        &
                     bind(c,name="krige_using_file")
       use iso_c_binding, only: c_int,c_char,c_double
       character (kind=c_char,len=1), intent(in) :: factorfile(*)
       integer(kind=c_int), intent(in)           :: factorfiletype
       integer(kind=c_int), intent(in)           :: npts
       integer(kind=c_int), intent(in)           :: mpts
       integer(kind=c_int), intent(in)           :: krigtype
       integer(kind=c_int), intent(in)           :: transtype
       real(kind=c_double), intent(in)           :: sourceval(npts)
       real(kind=c_double), intent(out)          :: targval(mpts)
       integer(kind=c_int), intent(out)          :: icount_interp
       real(kind=c_double), intent(in), optional :: meanval(mpts)
    end function krige_using_file

    integer (kind=c_int) function calc_kriging_factors_3d(        &
                                   npts,ecs,ncs,zcs,zns,          &
                                   mpts,ect,nct,zct,znt,          &
                                   krigtype,                      &
                                   nzone,zonenum,                 &
                                   vartype,                       &
                                   ahmax,ahmin,avert,             &
                                   bearing,dip,rake,              &
                                   srhmax,srhmin,srvert,          &
                                   maxpts,minpts,                 &
                                   factorfile,factorfiletype,     &
                                   icount_interp)                 &
                     bind(c,name="calc_kriging_factors_3d")
       use iso_c_binding, only: c_int,c_char,c_double
       integer(kind=c_int), intent(in)         :: npts
       real(kind=c_double), intent(in)         :: ecs(npts),ncs(npts),zcs(npts)
       integer(kind=c_int), intent(in)         :: zns(npts)
       integer(kind=c_int), intent(in)         :: mpts
       real(kind=c_double), intent(in)         :: ect(mpts),nct(mpts),zct(mpts)
       integer(kind=c_int), intent(in)         :: znt(mpts)
       integer(kind=c_int), intent(in)         :: krigtype
       integer(kind=c_int), intent(in)         :: nzone
       integer(kind=c_int), intent(in)         :: zonenum(nzone)
       integer(kind=c_int), intent(in)         :: vartype(nzone)
       real(kind=c_double), intent(in)         :: ahmax(nzone),ahmin(nzone),avert(nzone)
       real(kind=c_double), intent(in)         :: bearing(nzone)
       real(kind=c_double), intent(in)         :: dip(nzone)
       real(kind=c_double), intent(in)         :: rake(nzone)
       real(kind=c_double), intent(in)         :: srhmax
       real(kind=c_double), intent(in)         :: srhmin
       real(kind=c_double), intent(in)         :: srvert
       integer(kind=c_int), intent(in)         :: maxpts, minpts
       character (kind=c_char,len=1), intent(in) :: factorfile(*)
       integer(kind=c_int), intent(in)         :: factorfiletype
       integer(kind=c_int), intent(out)        :: icount_interp
    end function calc_kriging_factors_3d

    integer (kind=c_int) function build_covar_matrix_2d(    &
                              npts,ec,nc,zn,                &
                              vartype,                      &
                              nugget,aa,sill,anis,bearing,  &
                              ldcovmat,covmat)              &
                     bind(c,name="build_covar_matrix_2d")
       use iso_c_binding, only: c_int,c_double
       integer(kind=c_int), intent(in)         :: npts
       real(kind=c_double), intent(in)         :: ec(npts),nc(npts)
       integer(kind=c_int), intent(in)         :: zn(npts)
       integer(kind=c_int), intent(in)         :: vartype
       real(kind=c_double), intent(in)         :: nugget(npts)
       real(kind=c_double), intent(in)         :: aa(npts)
       real(kind=c_double), intent(in)         :: sill(npts)
       real(kind=c_double), intent(in)         :: anis(npts)
       real(kind=c_double), intent(in)         :: bearing(npts)
       integer(kind=c_int), intent(in)         :: ldcovmat
       real(kind=c_double), intent(out)        :: covmat(ldcovmat,npts)
    end function build_covar_matrix_2d

    integer (kind=c_int) function build_covar_matrix_3d(        &
                                  npts,ec,nc,zc,zn,             &
                                  vartype,                      &
                                  nugget,sill,                  &
                                  ahmax,ahmin,avert,            &
                                  bearing,dip,rake,             &
                                  ldcovmat,covmat)              &
                     bind(c,name="build_covar_matrix_3d")
       use iso_c_binding, only: c_int,c_double
       integer(kind=c_int), intent(in)         :: npts
       real(kind=c_double), intent(in)         :: ec(npts),nc(npts),zc(npts)
       integer(kind=c_int), intent(in)         :: zn(npts)
       integer(kind=c_int), intent(in)         :: vartype
       real(kind=c_double), intent(in)         :: nugget(npts)
       real(kind=c_double), intent(in)         :: sill(npts)
       real(kind=c_double), intent(in)         :: ahmax(npts),ahmin(npts),avert(npts)
       real(kind=c_double), intent(in)         :: bearing(npts),dip(npts),rake(npts)
       integer(kind=c_int), intent(in)         :: ldcovmat
       real(kind=c_double), intent(out)        :: covmat(ldcovmat,npts)
    end function build_covar_matrix_3d

    integer (kind=c_int) function calc_structural_overlay_factors(     &
                         npts,                                         &
                         ecs,ncs,ids,                                  &
                         conwidth,aa,                                  &
                         structype,inverse_power,                      &
                         mpts,                                         &
                         ect,nct,active,                               &
                         factorfile,factorfiletype,                    &
                         icount_interp)                                &
                     bind(c,name="calc_structural_overlay_factors")
       use iso_c_binding, only: c_int,c_char,c_double
       integer(kind=c_int), intent(in)           :: npts
       real(kind=c_double), intent(in)           :: ecs(npts),ncs(npts)
       integer(kind=c_int), intent(in)           :: ids(npts)
       real(kind=c_double), intent(in)           :: conwidth(npts),aa(npts)
       integer(kind=c_int), intent(in)           :: structype
       real(kind=c_double), intent(in)           :: inverse_power
       integer(kind=c_int), intent(in)           :: mpts
       real(kind=c_double), intent(in)           :: ect(mpts),nct(mpts)
       integer(kind=c_int), intent(in)           :: active(mpts)
       character (kind=c_char,len=1), intent(in) :: factorfile(*)
       integer(kind=c_int), intent(in)           :: factorfiletype
       integer(kind=c_int), intent(out)          :: icount_interp
    end function calc_structural_overlay_factors

   integer (kind=c_int) function interpolate_blend_using_file(     &
                                 factorfile,factorfiletype,        &
                                 npts,mpts,                        &
                                 transtype,                        &
                                 lt_target,gt_target,              &
                                 sourceval,targval,                &
                                 icount_interp)                    &
                    bind(c,name="interpolate_blend_using_file")
       use iso_c_binding, only: c_int,c_char,c_double
       character (kind=c_char,len=1), intent(in) :: factorfile(*)
       integer(kind=c_int), intent(in)           :: factorfiletype
       integer(kind=c_int), intent(in)           :: npts
       integer(kind=c_int), intent(in)           :: mpts
       integer(kind=c_int), intent(in)           :: transtype
       character (kind=c_char,len=1), intent(in) :: lt_target,gt_target
       real(kind=c_double), intent(in)           :: sourceval(npts)
       real(kind=c_double), intent(inout)        :: targval(mpts)
       integer(kind=c_int), intent(out)          :: icount_interp
   end function interpolate_blend_using_file

   integer (kind=c_int) function ipd_interpolate_2d(     &
                              npts,                      &
                              ecs,ncs,zns,sourceval,     &
                              mpts,                      &
                              ect,nct,znt,targval,       &
                              transtype,                 &
                              anis,bearing,invpow)       &
                    bind(c,name="ipd_interpolate_2d")
       use iso_c_binding, only: c_int,c_double
       integer(kind=c_int), intent(in)           :: npts
       real(kind=c_double), intent(in)           :: ecs(npts),ncs(npts)
       integer(kind=c_int), intent(in)           :: zns(npts)
       real(kind=c_double), intent(in)           :: sourceval(npts)
       integer(kind=c_int), intent(in)           :: mpts
       real(kind=c_double), intent(in)           :: ect(mpts),nct(mpts)
       integer(kind=c_int), intent(in)           :: znt(mpts)
       real(kind=c_double), intent(out)          :: targval(mpts)
       integer(kind=c_int), intent(in)           :: transtype
       real(kind=c_double), intent(in)           :: anis(mpts)
       real(kind=c_double), intent(in)           :: bearing(mpts)
       real(kind=c_double), intent(in)           :: invpow(mpts)
   end function ipd_interpolate_2d

   integer (kind=c_int) function ipd_interpolate_3d(  &
                        npts,                         &
                        ecs,ncs,zcs,zns,sourceval,    &
                        mpts,                         &
                        ect,nct,zct,znt,targval,      &
                        transtype,                    &
                        ahmax,ahmin,avert,            &
                        bearing,dip,rake,             &
                        invpow)                       &
                    bind(c,name="ipd_interpolate_3d")
       use iso_c_binding, only: c_int,c_double
       integer(kind=c_int), intent(in)    :: npts
       real(kind=c_double), intent(in)    :: ecs(npts),ncs(npts),zcs(npts)
       integer(kind=c_int), intent(in)    :: zns(npts)
       real(kind=c_double), intent(in)    :: sourceval(npts)
       integer(kind=c_int), intent(in)    :: mpts
       real(kind=c_double), intent(in)    :: ect(mpts),nct(mpts),zct(mpts)
       integer(kind=c_int), intent(in)    :: znt(mpts)
       real(kind=c_double), intent(out)   :: targval(mpts)
       integer(kind=c_int), intent(in)    :: transtype
       real(kind=c_double), intent(in)    :: ahmax(mpts),ahmin(mpts),avert(mpts)
       real(kind=c_double), intent(in)    :: bearing(mpts),dip(mpts),rake(mpts)
       real(kind=c_double), intent(in)    :: invpow(mpts)
   end function ipd_interpolate_3d

   integer (kind=c_int) function initialize_randgen(iseed) &
                    bind(c,name="initialize_randgen")
       use iso_c_binding, only: c_int
       integer(kind=c_int), intent(in)    :: iseed
   end function initialize_randgen

   integer (kind=c_int) function fieldgen2d_sva(             &
                              nnode,                         &
                              ec,nc,area,active,             &
                              mean,var,aa,anis,bearing,      &
                              transtype,avetype,power,       &
                              ldrand,nreal,randfield)        &
                    bind(c,name="fieldgen2d_sva")
       use iso_c_binding, only: c_int,c_double
       integer(kind=c_int), intent(in)   :: nnode
       real(kind=c_double), intent(in)   :: ec(nnode),nc(nnode)
       real(kind=c_double), intent(in)   :: area(nnode)
       integer(kind=c_int), intent(in)   :: active(nnode)
       real(kind=c_double), intent(in)   :: mean(nnode)
       real(kind=c_double), intent(in)   :: var(nnode)
       real(kind=c_double), intent(in)   :: aa(nnode)
       real(kind=c_double), intent(in)   :: anis(nnode)
       real(kind=c_double), intent(in)   :: bearing(nnode)
       integer(kind=c_int), intent(in)   :: transtype
       integer(kind=c_int), intent(in)   :: avetype
       real(kind=c_double), intent(in)   :: power
       integer(kind=c_int), intent(in)   :: ldrand
       integer(kind=c_int), intent(in)   :: nreal
       real(kind=c_double), intent(out)  :: randfield(ldrand,nreal)
   end function fieldgen2d_sva

   integer (kind=c_int) function fieldgen3d_sva(             &
                              nnode,                         &
                              ec,nc,zc,                      &
                              area,height,active,            &
                              mean,var,                      &
                              ahmax,ahmin,avert,             &
                              bearing,dip,rake,              &
                              transtype,avetype,power,       &
                              ldrand,nreal,randfield)        &
                    bind(c,name="fieldgen3d_sva")
       use iso_c_binding, only: c_int,c_double
       integer(kind=c_int), intent(in)   :: nnode
       real(kind=c_double), intent(in)   :: ec(nnode),nc(nnode),zc(nnode)
       real(kind=c_double), intent(in)   :: area(nnode)
       real(kind=c_double), intent(in)   :: height(nnode)
       integer(kind=c_int), intent(in)   :: active(nnode)
       real(kind=c_double), intent(in)   :: mean(nnode)
       real(kind=c_double), intent(in)   :: var(nnode)
       real(kind=c_double), intent(in)   :: ahmax(nnode),ahmin(nnode),avert(nnode)
       real(kind=c_double), intent(in)   :: bearing(nnode)
       real(kind=c_double), intent(in)   :: dip(nnode)
       real(kind=c_double), intent(in)   :: rake(nnode)
       integer(kind=c_int), intent(in)   :: transtype
       integer(kind=c_int), intent(in)   :: avetype
       real(kind=c_double), intent(in)   :: power
       integer(kind=c_int), intent(in)   :: ldrand
       integer(kind=c_int), intent(in)   :: nreal
       real(kind=c_double), intent(out)  :: randfield(ldrand,nreal)
   end function fieldgen3d_sva

end interface

end module function_interfaces

       program driver3

! -- This driver tests temporal interpolation following spatial interpolation.

       use function_interfaces
       use iso_c_binding, only : c_int,c_char,c_double
       implicit none

       integer(kind=c_int)             :: nrow,ncol,nlay
       integer(kind=c_int)             :: icorner,ifail,npts
       integer(kind=c_int)             :: ntime,iprec,isim,proctime
       integer(kind=c_int)             :: numobsdat
       real(kind=c_double)             :: e0,n0,rotation
       real(kind=c_double)             :: interpthresh,nointerpval,time_extrap
       character(kind=c_char,len=1)    :: how_extrap
       character(kind=c_char,len=1)    :: texttype(17)
       character(kind=c_char,len=1)    :: gridname(200)
       character(kind=c_char,len=1)    :: depvarfile(256)
       character(kind=c_char,len=1)    :: messagestring(1500)

       integer(kind=c_int),allocatable :: layer(:)
       integer(kind=c_int),allocatable :: obspointnum(:)
       real(kind=c_double),allocatable :: delr(:),delc(:)
       real(kind=c_double),allocatable :: ee(:),nn(:)
       real(kind=c_double),allocatable :: simtime(:),simstate(:,:)
       real(kind=c_double),allocatable :: obstime(:),obsval(:)

       integer              :: ibeg,iend,ierr
       integer              :: irow,icol
       integer              :: ipts,itime
       integer              :: idat
       character (len=1)    :: aa
       character (len=17)   :: atext
       character (len=20)   :: atemp20
       character (len=200)  :: chargridname
       character (len=256)  :: afile,infile,outfile1,outfile2
       character (len=500)  :: cline
       character (len=1500) :: amessage

       character (len=20), allocatable :: apoint(:),obspoint(:)

! -- Obtain grid specifications from a grid specification file.

       write(6,*)
       write(6,50)
50     format(' Testing grid installation....')

100    write(6,*)
109    write(6,110,advance='no')
110    format(' Enter name of a GW Utils grid spec file: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 100
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,infile,ibeg,iend)
       if(ifail.ne.0) go to 100
       open(unit=10,file=infile,status='old',err=100)
       read(10,*,err=9000,end=9000) nrow,ncol
       read(10,*,err=9000,end=9000) e0,n0,rotation
       allocate(delr(ncol),delc(nrow),stat=ierr)
       if(ierr.ne.0) go to 9200
       read(10,*,err=9000,end=9000) (delr(icol),icol=1,ncol)
       read(10,*,err=9000,end=9000) (delc(irow),irow=1,nrow)
       close(unit=10)
       write(6,130) trim(infile)
130    format(' - file ',a,' read ok.')

! -- Obtain other details for this structured grid from the user.

140    write(6,145,advance='no')
145    format(' How many layers in this grid? ')
       read(5,*,err=140) nlay
       if(nlay.le.0) go to 140
150    write(6,160,advance='no')
160    format(' Supply a name for this grid: ')
       read(5,'(a)') afile
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,chargridname,ibeg,iend)
       if(ifail.ne.0) go to 150
       call char2string(200,chargridname,gridname)

! -- Install the grid.

       write(6,165)
165    format(' Installing structured grid specs...')
       icorner=1
       ifail=install_structured_grid(gridname,ncol,nrow,nlay,icorner,e0,n0,rotation,delr,delc)
       if(ifail.eq.0)then
         write(6,170)
170      format(' Installation successful.')
       else
         write(6,171)
171      format(' Installation unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       end if

! -- We will now read a file with point coordinates, layers and simulation times.
!    These are the points to which spatial interpolation from the grid will take place.

       write(6,*)
520    write(6,530,advance='no')
530    format(' Enter name of point data file: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 520
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,infile,ibeg,iend)
       if(ifail.ne.0) go to 520
       open(unit=10,file=infile,status='old',err=520)
       npts=0
       do
         read(10,'(a)',end=550) cline
         if(cline.ne.' ') npts=npts+1
       end do
550    if(npts.eq.0)then
         write(6,560)
560      format('No points in file. Try again.')
         close(unit=10)
         go to 520
       else
         rewind(unit=10)
       end if
       allocate(apoint(npts),ee(npts),nn(npts),layer(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       do ipts=1,npts
         read(10,*,err=9050,end=9050) apoint(ipts),ee(ipts),nn(ipts),layer(ipts)
         call lowcase(apoint(ipts))
       end do
       close(unit=10)
       write(6,570) trim(infile)
570    format(' - file ',a,' read ok.')

! -- Ascertain the name of the MODFLOW output file to read.

       write(6,*)
580    write(6,590,advance='no')
590    format(' Enter name of MODFLOW binary dep. var. output file: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 580
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,infile,ibeg,iend)
       if(ifail.ne.0) go to 580
595    write(6,596,advance='no')
596    format(' Enter grid name to which it pertains: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 595
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,chargridname,ibeg,iend)
       if(chargridname.eq.' ') go to 595
613    write(6,615,advance='no')
615    format(' Enter number of output times in this file: ')
       read(5,*,err=613) ntime
       if(ntime.le.0) go to 613
600    write(6,610,advance='no')
610    format(' Enter precision (1=single; 2=double): ')
       read(5,*,err=600) iprec
       if((iprec.ne.1).and.(iprec.ne.2)) go to 600
611    write(6,612,advance='no')
612    format(' Enter HDRY/HNOFLO threshold: ')
       read(5,*,err=611) interpthresh
       if(interpthresh.le.0) go to 611
617    write(6,618,advance='no')
618    format(' Enter header text of interest: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 617
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,atext,ibeg,iend)
       if(ifail.ne.0) go to 617

! -- Allocate some memory

       allocate(simtime(ntime),simstate(ntime,npts),stat=ierr)
       if(ierr.ne.0) go to 9200

! -- Convert pertinent character variables to strings.

       call char2string(200,infile,depvarfile)
       call char2string(200,chargridname,gridname)
       call char2string(17,atext,texttype)
       isim=1
       nointerpval=1.1d30

! -- Call the function.

       write(6,650)
650    format(' Calling interp_from_structured_grid()....')
       ifail=interp_from_structured_grid(                                     &
                             GridName,DepVarFile,isim,iprec,ntime,            &
                             TextType,InterpThresh,NoInterpVal,               &
                             npts,ee,nn,layer,                                &
                             proctime,simtime,simstate)
       if(ifail.ne.0)then
         write(6,710)
710      format(' Function call unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       end if
       write(6,670)
670    format(' Spatial interpolation successful.')
       write(6,680) proctime
680    format(' Number of output times =',i5)

       write(6,*)
620    write(6,630,advance='no')
630    format(' Enter name for post-spatial-interpolation output file: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 620
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,outfile1,ibeg,iend)
       if(ifail.ne.0) go to 620
       open(unit=20,file=outfile1,action='write',err=620)
       do ipts=1,npts
         do itime=1,ntime
           write(20,681) trim(apoint(ipts)),simtime(itime),simstate(itime,ipts)
681        format(1x,a,t25,1pg16.9,t45,1pg16.9)
         end do
       end do
       close(unit=20)
       write(6,682) trim(outfile1)
682    format(' - file ',a,' written ok.')

! -- Read observation time file.

       write(6,*)
690    write(6,720,advance='no')
720    format(' Enter name of observation time file: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 690
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,infile,ibeg,iend)
       if(ifail.ne.0) go to 690
       open(unit=10,file=infile,status='old',err=690)
       numobsdat=0
       do
         read(10,'(a)',end=730) cline
         if(cline.ne.' ') numobsdat=numobsdat+1
       end do
730    continue
       if(numobsdat.eq.0)then
         write(6,725)
725      format('No observation data in file. Try again.')
         close(unit=10)
         go to 690
       else
         rewind(unit=10)
       end if
       allocate(obspoint(numobsdat),obstime(numobsdat),obsval(numobsdat),    &
       obspointnum(numobsdat),stat=ierr)
       if(ierr.ne.0) go to 9200
       do idat=1,numobsdat
         read(10,*,err=9050,end=9050) obspoint(idat),obstime(idat)
         call lowcase(obspoint(idat))
       end do
       close(unit=10)
       write(6,570) trim(infile)

! -- Fill the OBSPOINTNUM array.

       do idat=1,numobsdat
         do ipts=1,npts
           if(obspoint(idat).eq.apoint(ipts)) go to 735
         end do
         obspointnum(idat)=-1
         cycle
735      obspointnum(idat)=ipts-1       ! Remember that external programs indices start at 0
       end do

! -- Gather a few more details on how to time-interpolate.

750    write(6,760,advance='no')
760    format(' Enter time-extrapolation option (L/C): ')
       read(5,*) how_extrap
       if((how_extrap.ne.'L').and.(how_extrap.ne.'l').and.   &
          (how_extrap.ne.'C').and.(how_extrap.ne.'c')) go to 750
769    write(6,770,advance='no')
770    format(' Enter extrapolation time limit: ')
       read(5,*) time_extrap
       if(time_extrap.lt.0.0d0) go to 769

! -- Undertaking temporal interpolation.

       write(6,775)
775    format(' Calling interp_to_obstime()....')
       ifail=interp_to_obstime(                                   &
             ntime,proctime,npts,simtime,simstate,interpthresh,   &
             how_extrap,time_extrap,nointerpval,                  &
             numobsdat,obspointnum,obstime,obsval)
       if(ifail.ne.0)then
         write(6,810)
810      format(' Function call unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       else
         write(6,820)
820      format(' Spatial interpolation successful.')
       end if

! -- Write the output file.

940    write(6,950,advance='no')
950    format(' Enter name for post-time-interpolation output file: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 940
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,outfile2,ibeg,iend)
       if(ifail.ne.0) go to 940
       open(unit=21,file=outfile2,action='write',err=940)
       do idat=1,numobsdat
         write(21,960) trim(obspoint(idat)),obstime(idat),obsval(idat)
960      format(1x,a,t25,1pg16.9,t50,1pg16.9)
       end do
       close(unit=21)
       write(6,970) trim(outfile2)
970    format(' - file ',a,' written ok.')

       go to 9900

9000   write(amessage,9010) trim(infile)
9010   format('Error reading grid specification file ',a,'.')
       go to 9890

9050   write(amessage,9060) trim(infile)
9060   format('Error encountered in reading file ',a,'.')
       go to 9890

9200   write(amessage,9210)
9210   format('Driver program suffers memory allocation error.')
       go to 9890

9890   continue
       amessage=' '//trim(amessage)
       call writmess(6,amessage)

! -- Tidy up

9900   continue
       write(6,*)
       write(6,9910)
9910   format(' Tidying up...')

       ifail=free_all_memory()
       if(ifail.eq.0)then
         write(6,9920)
9920     format(' Tidying up successful.')
         write(6,*)
       else
         write(6,9921)
9921     format(' Tidying up unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         amessage=' '//trim(amessage)
         call writmess(6,amessage)
       end if
       deallocate(layer,obspointnum,stat=ierr)
       deallocate(delr,delc,stat=ierr)
       deallocate(ee,nn,stat=ierr)
       deallocate(simtime,simstate,stat=ierr)
       deallocate(obstime,obsval,stat=ierr)
       deallocate(apoint,obspoint,stat=ierr)

       end

integer (kind=c_int) function fieldgen3d_sva(                &
                              nnode,                         &
                              ec,nc,zc,                      &
                              area,height,active,            &
                              mean,var,                      &
                              ahmax,ahmin,avert,             &
                              bearing,dip,rake,              &
                              transtype,avetype,power,       &
                              ldrand,nreal,randfield)

! -- This function generates 3D stochastic fields based on a spatially varying variogram.
! -- It does this by spatial convolution using an averaging function.

       use iso_c_binding, only: c_int,c_double
       use dimvar
       use utilities
       implicit none

       integer(kind=c_int), intent(in)   :: nnode                       ! Nodes in model grid
       real(kind=c_double), intent(in)   :: ec(nnode),nc(nnode),zc(node)! x,y, z coordinates of nodes
       real(kind=c_double), intent(in)   :: area(nnode)            ! Areas of grid cells
       real(kind=c_double), intent(in)   :: height(nnode)          ! Height of grid cells
       integer(kind=c_int), intent(in)   :: active(nnode)          ! 0=inactive cell
       real(kind=c_double), intent(in)   :: mean(nnode)            ! Mean value of stochastic field
       real(kind=c_double), intent(in)   :: var(nnode)             ! Variance of stochastic field
       real(kind=c_double), intent(in)   :: ahmax(nnode),ahmin(nnode),avert(nnode) ! Ave func. correlation lengths
       real(kind=c_double), intent(in)   :: bearing(nnode)         ! Bearing of ahmax direction
       real(kind=c_double), intent(in)   :: dip(nnode)             ! Dip of ahmax direction
       real(kind=c_double), intent(in)   :: rake(nnode)            ! Rotation of ahmin direction
       integer(kind=c_int), intent(in)   :: transtype              ! Stochastic field pertains to natural(0) or log(1) props
       integer(kind=c_int), intent(in)   :: avetype                ! 1:spher,2:exp,3:gauss,4:pow
       real(kind=c_double), intent(in)   :: power                  ! Power used in power AVETYPE
       integer(kind=c_int), intent(in)   :: ldrand                 ! Leading dimension of RANDFIELD
       integer(kind=c_int), intent(in)   :: nreal                  ! Number of realisations to generate
       real(kind=c_double), intent(out)  :: randfield(ldrand,nreal)! Realisations

       integer                 :: jnode,knode,ierr
       integer                 :: ireal
       double precision        :: xi,yi,zi
       double precision        :: aavert
       double precision        :: vvar,along,amid,cosang1,sinang1,ang1
       double precision        :: den_along,den_along2,den_amid,den_amid2,den
       double precision        :: den_avert,den_avert2
       double precision        :: xd,yd,zd,xdd,ydd,zdd
       double precision        :: xdiff,ydiff,zdiff,dlong,dmid,dvert
       double precision        :: dtemp,dtemp1,dtemp2,dtemp3
       double precision        :: dlim,pidiv180
       character(len=25)       :: varname

       double precision, allocatable :: diid(:,:)

! -- Initialisation

       fieldgen3d_sva=0
       function_name='fieldgen3d_sva()'
       pidiv180=3.1415926535898d0/180.0d0
       dlim=1.0d-5

! -- Check that the random number generator has been seeded.

       if(.not.allocated(seed))then
         write(amessage,90) trim(function_name)
90       format(' The random number generator must be seeded before calling function ',a,'.')
         go to 9890
       end if

! -- Check input arguments.

       if((transtype.ne.0).and.(transtype.ne.1))then
         write(amessage,100) 'TRANSTYPE',trim(function_name)
100      format('The ',a,' argument of function ',a,' must be ',  &
         'supplied as 0 or 1.')
         go to 9890
       end if
       if((avetype.ne.1).and.(avetype.ne.2).and.(avetype.ne.3).and.(avetype.ne.4))then
         write(amessage,105)  trim(function_name)
105      format('The AVETYPE argument of function ',a,' must be ',  &
         'supplied as 1, 2, 3 or 4.')
         go to 9890
       end if
       if(avetype.eq.4)then
         if(power.le.0.0d0)then
           write(amessage,106) trim(function_name)
106        format('If AVETYPE is set to 4, then the POWER argument of function ',a,    &
           ' must be greater than zero.')
           go to 9890
         end if
       end if
       if(nnode.le.0)then
         varname='NNODE'
         go to 9000
       end if
       if(nreal.le.0)then
         varname='NREAL'
         go to 9000
       end if
       if(ldrand.lt.nreal)then
         write(amessage,107) trim(function_name)
107      format(' LDRAND must equal or exceed NNODE in call to function ',a,'.')
         go to 9890
       end if
       if(all(active.eq.0))then
         varname='ACTIVE'
         go to 9100
       end if
       do jnode=1,nnode
         if(active(jnode).ne.0)then
           if(area(jnode).le.0.0d0)then
             write(amessage,170) 'AREA'
170          format('At least one ',a,' value is zero or negative for an active model node.')
             go to 9890
           end if
           if(height(jnode).le.0.0d0)then
             write(amessage,170) 'HEIGHT'
             go to 9890
           end if
           if(var(jnode).lt.0.0d0)then
             write(amessage,171) 'VAR'
171          format('At least one ',a,' value is negative for an active model node.')
             go to 9890
           end if
           if(ahmax(jnode).le.0.0d0)then
             write(amessage,170) 'AHMAX'
             go to 9890
           end if
           if(ahmin(jnode).le.0.0d0)then
             write(amessage,170) 'AHMIN'
             go to 9890
           end if
           if(avert(jnode).le.0.0d0)then
             write(amessage,170) 'AVERT'
             go to 9890
           end if
           if((bearing(jnode).lt.-360.0d0).or.(bearing(jnode).gt.360.0d0))then
             write(amessage,180)
180          format('At least one BEARING value is less than -360 degrees or greater than ',  &
             '360 degrees for an active model node.')
             go to 9890
           end if
           if((dip(jnode).lt.-180.0d0).or.(dip(jnode).gt.180.0d0))then
             write(amessage,181)
181          format('At least one DIP value is less than -180 degrees or greater than ',  &
             '180 degrees for an active model node.')
             go to 9890
           end if
           if((rake(jnode).lt.-90.0d0).or.(rake(jnode).gt.90.0d0))then
             write(amessage,182)
182          format('At least one RAKE value is less than -90 degrees or greater than ',  &
             '90 degrees for an active model node.')
             go to 9890
           end if
         end if
       end do

! -- Allocate the array that stores random numbers.

       allocate(diid(nnode,nreal),stat=ierr)
       if(ierr.ne.0) go to 9200
       if(utl_allocate_vector('d',1,nreal).ne.0) go to 9200

! -- Fill the diid array with random numbers.

       do ireal=1,nreal
         do jnode=1,nnode
           diid(jnode,ireal)=utl_random_normal()
         end do
       end do

! -- Evaluate limit threshold

       if(dlim.eq.0.0d0)then
         dlim=1.0d30
       else
         if(avetype.eq.2)then
           dlim=-log(dlim)
           dlim=dlim*dlim              ! applies to x^2
         else if(avetype.eq.3)then
           dlim=-log(dlim)             ! applies to x^2
         else if(avetype.eq.1)then
           dlim=1.0d0
         else if(avetype.eq.4)then
           dlim=1.0d0
         end if
       end if

! -- Do the convolution

       do jnode=1,nnode
         if(iarray(jnode).ne.0)then
           xi=xx(jnode)
           yi=yy(jnode)
           zi=zz(jnode)
           var=sill(jnode)
           along=ahmax(jnode)
           amid=ahmin(jnode)
           aavert=a_vert(jnode)
           ang1=90.0d0-bearing(jnode)
           cosang1=cos(ang1*pidiv180)
           sinang1=sin(ang1*pidiv180)
           cosang2=cos(dip(jnode)*pidiv180)
           sinang2=sin(dip(jnode)*pidiv180)
           cosang3=cos(rake(jnode)*pidiv180)
           sinang3=sin(rake(jnode)*pidiv180)
           den_along=1.0d0/along
           den_along2=den_along*den_along
           den_amid=1.0d0/amid
           den_amid2=den_amid*den_amid
           den_aavert=1.0d0/aavert
           den_avert2=den_avert*den_avert
           den=0.0d0
           dvector1=0.0d0   ! an array
           do knode=1,nnode
             if(active(knode).eq.0))cycle
             xdiff=xx(knode)-xi
             ydiff=yy(knode)-yi
             zdiff=zz(knode)-zi
             xd=xdiff*cosang1+ydiff*sinang1
             yd=-xdiff*sinang1+ydiff*cosang1
             zd=zdiff
             xdd=xd*cosang2+zd*sinang2
             ydd=yd
             zdd=-xd*sinang2+zd*cosang2
             dlong=xdd
             dmid=ydd*cosang3+zdd*sinang3
             dvert=-ydd*sinang3+zdd*cosang3
             if(transtype.eq.2)then
               dtemp1=dlong*dlong*den_along2
               if(dtemp1.gt.dlim) cycle
               dtemp2=dmid*dmid*den_amid2
               if(dtemp2.gt.dlim) cycle
               dtemp3=dvert*dvert*den_avert2
               if(dtemp3.gt.dlim) cycle
               dtemp=dtemp1+dtemp2+dtemp3
               if(dtemp.gt.dlim) cycle
               dtemp=sqrt(dtemp)
               dtemp=exp(-dtemp)
             else if(transtype.eq.3)then
               dtemp1=dlong*dlong*den_along2
               if(dtemp1.gt.dlim) cycle
               dtemp2=dmid*dmid*den_amid2
               if(dtemp2.gt.dlim) cycle
               dtemp3=dvert*dvert*den_avert2
               if(dtemp3.gt.dlim) cycle
               dtemp=dtemp1+dtemp2+dtemp3
               if(dtemp.gt.dlim) cycle
               dtemp=exp(-dtemp)
             else if(transtype.eq.1)then
               dtemp1=abs(dlong*den_along)
               if(dtemp1.gt.1.0d0)cycle
               dtemp2=abs(dmid*den_amid)
               if(dtemp2.gt.1.0d0) cycle
               dtemp3=abs(dvert*den_avert)
               if(dtemp3.gt.1.0d0) cycle
               dtemp=dtemp1*dtemp1+dtemp2*dtemp2+dtemp3*dtemp3
               dtemp=sqrt(dtemp)
               dtemp3=dtemp*dtemp*dtemp
               dtemp=1.0d0-1.5*dtemp+0.5*dtemp3
               if(dtemp.lt.0.0d0) cycle
             else if(transtype.eq.4)then
               dtemp1=abs(dlong*den_along)
               if(dtemp1.gt.1.0d0) cycle
               dtemp2=abs(dmid*den_amid)
               if(dtemp2.gt.1.0d0) cycle
               dtemp3=abs(dvert*den_avert)
               if(dtemp3.gt.1.0d0) cycle
               dtemp=dtemp1*dtemp1+dtemp2*dtemp2+dtemp3*dtemp3
               dtemp=sqrt(dtemp)
               dtemp=1.0d0-(dtemp**power)
               if(dtemp.lt.0.0d0) cycle
             end if
             dtemp=dtemp*area(knode)*height(knode)
             do ireal=1,nreal
               dvector1(ireal)=dvector1(ireal)+dtemp*diid(knode,ireal)
             end do
             den=den+dtemp*dtemp
           end do
           do ireal=1,nreal
             dtemp=dvector1(ireal)*sqrt(var/den)          ! Ensures that it has the correct variance
             if(transtype.eq.0)then
               darray(jnode,ireal)=meanarray(jnode)+dtemp
             else
               darray(jnode,ireal)=meanarray(jnode)*(10**dtemp)
             end if
           end do
         end if
       end do

       go to 9900

9000   write(amessage,9010) trim(varname),trim(function_name)
9010   format('The ',a,' argument of function ',a,' must be greater than zero.')
       go to 9890

9100   write(amessage,9110) trim(varname)
9110   format('All elements of the ',a,' array are supplied as zero.')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory management error encountered in function ',a,'.')
       go to 9890

9890   fieldgen3d_sva=1

9900   continue
       if(allocated(diid)) deallocate(diid,stat=ierr)

       return

end function fieldgen3d_sva

       program driver9

! -- DRIVER9 tests construction of a 2D covariance matrix based on a spatially-varying variogram.

       use function_interfaces
       use iso_c_binding, only : c_int,c_char,c_double
       implicit none

! -- Variables used in function calls.

       integer(kind=c_int)           :: ifail
       integer(kind=c_int)           :: npts,ldcovmat
       integer(kind=c_int)           :: vartype
       character(kind=c_char,len=1)  :: messagestring(1500)

! -- Other variables.

       integer                       :: jfail,ierr,iline
       integer                       :: ipt,jpt
       integer                       :: lw(15),rw(15)
       character (len=1)             :: ah
       character (len=10)            :: aline
       character (len=256)           :: infile,outfile
       character (len=500)           :: cline
       character (len=1500)          :: amessage

! -- Allocatable variables that are used in function calls.

       integer(kind=c_int), allocatable   :: zn(:)
       real(kind=c_double), allocatable   :: ec(:),nc(:)
       real(kind=c_double), allocatable   :: nugget(:),aa(:),sill(:),anis(:),bearing(:)
       real(kind=c_double), allocatable   :: covmat(:,:)

! -- Other allocatable variables.

       character (len=20), allocatable    :: apoint(:)

! -- Read the pilot point statistical specification file.

100    write(6,110,advance='no')
110    format(' Enter name of pilot points statistical specification file: ')
       read(5,*,err=100) infile
       open(unit=10,file=infile,status='old',err=100)
115    write(6,116,advance='no')
116    format(' Skip header line? (y/n): ')
       read(5,*) ah
       if((ah.eq.'Y').or.(ah.eq.'y'))then
         ah='y'
       else if((ah.eq.'N').or.(ah.eq.'n'))then
         ah='n'
       else
         go to 115
       end if
       npts=0
       do
         read(10,'(a)',end=200) cline
         if(cline.eq.' ')cycle
         npts=npts+1
       end do
200    continue
       if(ah.eq.'y')npts=npts-1
       if(npts.eq.0)then
         write(6,201)
201      format(/,' *** No points in file. Try again ***',/)
         close(unit=10)
         go to 100
       end if
       allocate(ec(npts),nc(npts),zn(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(nugget(npts),aa(npts),sill(npts),anis(npts),bearing(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(apoint(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       rewind (unit=10)
       iline=0
       if(ah.eq.'y')then
         iline=iline+1
         read(10,*)
       end if
       do ipt=1,npts
210      continue
         iline=iline+1
         read(10,'(a)',err=9000,end=9050) cline
         if(cline.eq.' ') go to 210
         call linesplit(jfail,9,lw,rw,cline)
         if(jfail.ne.0) go to 9070
         apoint(ipt)=cline(lw(1):rw(1))
         call lowcase(apoint(ipt))
         call drealread(jfail,cline(lw(2):rw(2)),ec(ipt))
         if(jfail.ne.0) go to 9150
         call drealread(jfail,cline(lw(3):rw(3)),nc(ipt))
         if(jfail.ne.0) go to 9150
         call intread(jfail,cline(lw(4):rw(4)),zn(ipt))
         if(jfail.ne.0) go to 9150
         call drealread(jfail,cline(lw(5):rw(5)),nugget(ipt))
         if(jfail.ne.0) go to 9150
         call drealread(jfail,cline(lw(6):rw(6)),sill(ipt))
         if(jfail.ne.0) go to 9150
         call drealread(jfail,cline(lw(7):rw(7)),aa(ipt))
         if(jfail.ne.0) go to 9150
         call drealread(jfail,cline(lw(8):rw(8)),anis(ipt))
         if(jfail.ne.0) go to 9150
         call drealread(jfail,cline(lw(9):rw(9)),bearing(ipt))
         if(jfail.ne.0) go to 9150
       end do
       close(unit=10)
       write(6,220) trim(infile)
220    format(' - file ',a,' read ok.')

       write(6,*)
230    write(6,240,advance='no')
240    format(' Enter variogram type (1:spher,2:exp,3:gauss,4:pow): ')
       read(5,*,err=230) vartype
       if((vartype.lt.1).or.(vartype.gt.4)) go to 230

! -- Now calculate the covariance matrix.

       allocate(covmat(npts,npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       ldcovmat=npts
       write(6,*)
       write(6,320)
320    format(' Calling build_covar_matrix_2d()....')
       ifail=build_covar_matrix_2d(                         &
                              npts,ec,nc,zn,                &
                              vartype,                      &
                              nugget,aa,sill,anis,bearing,  &
                              ldcovmat,covmat)
       if(ifail.ne.0)then
         write(6,340)
340      format(' Function call unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       else
         write(6,350)
350      format(' Covariance matrix calculated.')
       end if

! -- Now store the covariance matrix in a file.

       write(6,*)
370    write(6,380,advance='no')
380    format(' Enter name of file to store covariance matrix: ')
       read(5,*,err=370) outfile
       open(unit=20,file=outfile,action='write',err=370)
       write(20,'(3i6)') npts,npts,1
       do ipt=1,npts
         write(20,430) (covmat(ipt,jpt),jpt=1,npts)
430      format(8(1x,1pg14.7))
       end do
       write(20,440)
440    format('* row and column names')
       do ipt=1,npts
         write(20,'(a)') trim(apoint(ipt))
       end do
       close(unit=20)
       write(6,450) trim(outfile)
450    format(' - file ',a,' written ok.')

       go to 9900

9000   write(amessage,9010) trim(infile)
9010   format('Error encountered in reading file ',a,'.')
       go to 9890

9050   write(amessage,9060) trim(infile)
9060   format('Premature end encountered to file ',a,'.')
       go to 9890

9070   call writint(aline,iline)
       write(amessage,9080) trim(aline),trim(infile)
9080   format('Insufficient entries on line ',a,' of file ',a,'.')
       go to 9890

9150   call writint(aline,iline)
       write(amessage,9160) trim(aline),trim(infile)
9160   format('Error reading data on line ',a,' of file ',a,'.')
       go to 9890

9200   write(amessage,9210)
9210   format('Insufficient memory to continue execution.')
       go to 9890

9890   continue
       amessage=' '//trim(amessage)
       call writmess(6,amessage)

! -- Tidy up

9900   continue

! -- Free local memory

       deallocate(zn,stat=ierr)
       deallocate(ec,nc,stat=ierr)
       deallocate(nugget,aa,sill,anis,bearing,stat=ierr)
       deallocate(covmat,stat=ierr)
       deallocate(apoint,stat=ierr)

! -- Free function interface memory

       ifail=free_all_memory()

       end

module high_level_utilities

public
contains

integer function uth_strucmodgrid_deallocate(igrid)

! -- This function deallocates one incidence of structured grid specifications.

       use deftypes
       use utilities
       implicit none

       integer, intent(in)   :: igrid
       integer               :: ierr

! -- Initialization

       uth_strucmodgrid_deallocate=0

! -- Do the work

       if((igrid.ge.1).and.(igrid.le.MAXSTRUCMODGRID))then
         if(strucmodgrid(igrid)%nrow.gt.0)then
           deallocate(strucmodgrid(igrid)%delr,strucmodgrid(igrid)%delc,stat=ierr)
           strucmodgrid(igrid)%ncol=0
           strucmodgrid(igrid)%nrow=0
           strucmodgrid(igrid)%nlay=0
           strucmodgrid(igrid)%name=' '
           numstrucmodgrid=numstrucmodgrid-1
         end if
       end if
9990   continue
       return

end function uth_strucmodgrid_deallocate


integer function uth_mf6modgrid_deallocate(igrid)

! -- This function deallocates one incidence of a MF6 grid specification.

       use deftypes
       use utilities
       implicit none

       integer, intent(in)   :: igrid
       integer               :: ierr

! -- Initialization

       uth_mf6modgrid_deallocate=0

! -- Do the work

       if((igrid.ge.1).and.(igrid.le.MAXMF6MODGRID))then
         if(mf6modgrid(igrid)%distype.gt.0)then
           mf6modgrid(igrid)%distype=0
           mf6modgrid(igrid)%name=' '
           nummf6modgrid=nummf6modgrid-1
           if(associated(mf6modgrid(igrid)%idomain))deallocate(mf6modgrid(igrid)%idomain,stat=ierr)
           if(associated(mf6modgrid(igrid)%icelltype))deallocate(mf6modgrid(igrid)%icelltype,stat=ierr)
           if(associated(mf6modgrid(igrid)%iavert))deallocate(mf6modgrid(igrid)%iavert,stat=ierr)
           if(associated(mf6modgrid(igrid)%javert))deallocate(mf6modgrid(igrid)%javert,stat=ierr)
           if(associated(mf6modgrid(igrid)%idomainv))deallocate(mf6modgrid(igrid)%idomainv,stat=ierr)
           if(associated(mf6modgrid(igrid)%icelltypev))deallocate(mf6modgrid(igrid)%icelltypev,stat=ierr)
           if(associated(mf6modgrid(igrid)%ivv))deallocate(mf6modgrid(igrid)%ivv,stat=ierr)
           if(associated(mf6modgrid(igrid)%ibound))deallocate(mf6modgrid(igrid)%ibound,stat=ierr)
           if(associated(mf6modgrid(igrid)%nvertcon))deallocate(mf6modgrid(igrid)%nvertcon,stat=ierr)
           if(associated(mf6modgrid(igrid)%vertconcell))deallocate(mf6modgrid(igrid)%vertconcell,stat=ierr)
           if(associated(mf6modgrid(igrid)%identvert))deallocate(mf6modgrid(igrid)%identvert,stat=ierr)
           if(associated(mf6modgrid(igrid)%ia))deallocate(mf6modgrid(igrid)%ia,stat=ierr)
           if(associated(mf6modgrid(igrid)%ja))deallocate(mf6modgrid(igrid)%ja,stat=ierr)
           if(associated(mf6modgrid(igrid)%delc))deallocate(mf6modgrid(igrid)%delc,stat=ierr)
           if(associated(mf6modgrid(igrid)%delr))deallocate(mf6modgrid(igrid)%delr,stat=ierr)
           if(associated(mf6modgrid(igrid)%botm))deallocate(mf6modgrid(igrid)%botm,stat=ierr)
           if(associated(mf6modgrid(igrid)%botmv))deallocate(mf6modgrid(igrid)%botmv,stat=ierr)
           if(associated(mf6modgrid(igrid)%vertices))deallocate(mf6modgrid(igrid)%vertices,stat=ierr)
           if(associated(mf6modgrid(igrid)%cellx))deallocate(mf6modgrid(igrid)%cellx,stat=ierr)
           if(associated(mf6modgrid(igrid)%celly))deallocate(mf6modgrid(igrid)%celly,stat=ierr)
           if(associated(mf6modgrid(igrid)%bottom))deallocate(mf6modgrid(igrid)%bottom,stat=ierr)
         end if
       end if
9990   continue
       return

end function uth_mf6modgrid_deallocate



subroutine uth_strucfactors(igrid,east,north,fac1,fac2,fac3,fac4,&
       icellno,jcellno)

! -- Subroutine uth_strucfactors calculates interpolation factors from
!    a structured grid to a point. There are four factors, one for each
!    of the four cell centres surrounding the point. When interpolation
!    takes place, system states at the respective cell centres are
!    multiplied by these factors and added together to determine the state
!    at the point.

! -- Subroutine arguments are as follows:-
!      igrid                the index of the installed structured grid
!      east, north          east and north coordinates of point
!      fac1,fac2,fac3,fac4  interpolation factors for point
!      icellno              identifier for cell in which point is situated
!      jcellno              identifier for the cell centre to the top left
!                           of the point

       use deftypes
       use utilities
       implicit none

       integer, intent(in)              :: igrid
       double precision, intent(in)     :: east,north
       double precision, intent(out)    :: fac1,fac2,fac3,fac4
       integer, intent(out)             :: icellno,jcellno

       integer          :: i,irow,icol,jrow,jcol,nrow,ncol
       double precision :: x,y,etemp,ntemp,rtemp1,rtemp2, &
                           x1,y1,x2,y2,delx,dely
       double precision, dimension(:),pointer :: delr,delc

       nrow=strucmodgrid(igrid)%nrow
       ncol=strucmodgrid(igrid)%ncol
       delr=>strucmodgrid(igrid)%delr
       delc=>strucmodgrid(igrid)%delc

! -- First the point coordinates are expressed as local grid coordinates.

       etemp=east-strucmodgrid(igrid)%e0
       ntemp=north-strucmodgrid(igrid)%n0
       x=etemp*strucmodgrid(igrid)%cosang+ntemp*strucmodgrid(igrid)%sinang
       y=ntemp*strucmodgrid(igrid)%cosang-etemp*strucmodgrid(igrid)%sinang
       if((x.lt.0.0).or.(y.gt.0.0))then
         icellno=-999
         return
       end if

! -- The location of the point within the finite-difference grid is next
!    determined.

       rtemp1=0.0
       rtemp2=delr(1)/2.0
       do i=1,ncol+1
       if(x.le.rtemp2)then
         x1=x-rtemp1
         x2=rtemp2-x
         delx=rtemp2-rtemp1
         jcol=i-1
         if(i.eq.1)then
           icol=1
         else if(i.eq.ncol+1)then
           icol=ncol
         else
           if(x1.le.delr(i-1)/2.0)then
             icol=i-1
           else
             icol=i
           end if
         end if
         go to 100
       end if
       rtemp1=rtemp2
       if(i.lt.ncol)then
         rtemp2=rtemp2+(delr(i)+delr(i+1))/2.0
       else if(i.eq.ncol) then
         rtemp2=rtemp2+delr(i)/2.0
       end if
       end do
       icellno=-999
       return

100    rtemp1=0.0
       rtemp2=-delc(1)/2.0
       do i=1,nrow+1
         if(y.ge.rtemp2)then
           y1=rtemp1-y
           y2=y-rtemp2
           dely=rtemp1-rtemp2
           jrow=i-1
           if(i.eq.1)then
             irow=1
           else if(i.eq.nrow+1)then
             irow=nrow
           else if(y1.le.delc(i-1)/2.0)then
             irow=i-1
           else
             irow=i
           end if
           go to 200
         end if
         rtemp1=rtemp2
         if(i.lt.nrow)then
           rtemp2=rtemp2-(delc(i)+delc(i+1))/2.0
         else if(i.eq.nrow) then
           rtemp2=rtemp2-delc(i)/2.0
         end if
       end do
       icellno=-999
       return

! -- The interpolation factors are calculated.

200    jcellno=(ncol+1)*jrow+jcol+1
       icellno=ncol*(irow-1)+icol
       rtemp1=1.0/delx/dely
       fac1=x2*y2*rtemp1
       fac2=x1*y2*rtemp1
       fac3=x2*y1*rtemp1
       fac4=x1*y1*rtemp1

       return

end subroutine uth_strucfactors


subroutine uth_point_interp(ncol,nrow,thresh,nointerpval,    &
       fac1,fac2,fac3,fac4,icellno,jcellno,bhead,rarray)

! -- This subroutine multiplies calculated states at grid cell centres by
!    factors determined in subroutine uth_strucfactors to implement interpolation
!    to point locations. If a point is near the edge of the grid, or borders
!    one or more dry or inactive cells, dummy heads are assigned to the
!    cell centres or pseudo cell centres surrounding the point.

! -- Arguments are as follows:-
!       ncol, nrow:     number of columns and rows in finite-difference grid
!       thresh:         abs. value threshold above which cells are inactive
!       noninterpval:   value to assign to points to which interpolation cannot take place
!       fac1,fac2,fac3,fac4:  interpolation factors from grid to point
!       icellno:        index of grid cell containing point
!       jcellno:        index of cell centre to top right of point
!       bhead:          interpolated value at point
!       rarray:         array from which interpolation takes place


       integer, intent(in)                     :: ncol,nrow
       double precision, intent(in)            :: thresh
       double precision, intent(in)            :: nointerpval
       double precision, intent(in)            :: fac1,fac2,fac3,fac4
       integer, intent(in)                     :: icellno,jcellno
       double precision, intent(out)           :: bhead
       double precision, dimension(0:ncol+1,0:nrow+1),intent(in)  :: rarray

       integer          :: i,j,irow,icol,jrow,jcol,k
       integer          :: iact(2,2)
       double precision :: head(2,2)

       if(icellno.eq.-999) then
         bhead=nointerpval
         return
       end if
       irow=(icellno-1)/ncol+1
       icol=icellno-(irow-1)*ncol
       jrow=(jcellno-1)/(ncol+1)
       jcol=jcellno-jrow*(ncol+1)-1
       if(abs(rarray(icol,irow)).gt.thresh) then
         bhead=nointerpval
         return
       end if

       head(1,1)=rarray(jcol,jrow)
       head(1,2)=rarray(jcol+1,jrow)
       head(2,1)=rarray(jcol,jrow+1)
       head(2,2)=rarray(jcol+1,jrow+1)
       do k=1,2
         do j=1,2
           iact(j,k)=1
         end do
       end do
       if(abs(head(1,1)).gt.thresh) iact(1,1)=0
       if(abs(head(1,2)).gt.thresh) iact(1,2)=0
       if(abs(head(2,1)).gt.thresh) iact(2,1)=0
       if(abs(head(2,2)).gt.thresh) iact(2,2)=0

       if(iact(1,1).eq.0)then
         if(iact(1,2).eq.0)then
           if(iact(2,1).eq.0)then
             head(1,1)=head(2,2)
             head(1,2)=head(2,2)
             head(2,1)=head(2,2)
           else if(iact(2,2).eq.0)then
             head(1,1)=head(2,1)
             head(1,2)=head(2,1)
             head(2,2)=head(2,1)
           else
             head(1,1)=head(2,1)
             head(1,2)=head(2,2)
           end if
         else if(iact(2,1).eq.0)then
           if(iact(2,2).eq.0)then
             head(1,1)=head(1,2)
             head(2,1)=head(1,2)
             head(2,2)=head(1,2)
           else
             head(1,1)=head(1,2)
             head(2,1)=head(2,2)
           end if
         else if(iact(2,2).eq.0)then
           if(icol.eq.jcol+1)then
             head(1,1)=head(1,2)
             head(2,1)=head(1,2)
             head(2,2)=head(1,2)
           else
             head(1,1)=head(2,1)
             head(1,2)=head(2,1)
             head(2,2)=head(2,1)
          end if
         else
           if(fac2+fac3.le.1.0e-6)then
             head(1,1)=(head(1,2)+head(2,1))/2.0
           else
             head(1,1)=(head(1,2)*fac2+head(2,1)*fac3)/(fac2+fac3)
           end if
         end if
       else if(iact(1,2).eq.0)then
         if(iact(2,2).eq.0)then
           if(iact(2,1).eq.0)then
             head(1,2)=head(1,1)
             head(2,1)=head(1,1)
             head(2,2)=head(1,1)
           else
             head(1,2)=head(1,1)
             head(2,2)=head(2,1)
           end if
         else if(iact(2,1).eq.0)then
           if(icol.eq.jcol)then
             head(1,2)=head(1,1)
             head(2,1)=head(1,1)
             head(2,2)=head(1,1)
           else
             head(1,1)=head(2,2)
             head(1,2)=head(2,2)
             head(2,1)=head(2,2)
           end if
         else
           if(fac1+fac4.le.1.0e-6)then
             head(1,2)=(head(1,1)+head(2,2))/2.0
           else
             head(1,2)=(head(1,1)*fac1+head(2,2)*fac4)/(fac1+fac4)
           end if
         end if
       else if(iact(2,1).eq.0)then
         if(iact(2,2).eq.0)then
           head(2,1)=head(1,1)
           head(2,2)=head(1,2)
         else
           if(fac1+fac4.le.1.0e-6)then
             head(2,1)=(head(1,1)+head(2,2))/2.0
           else
             head(2,1)=(head(1,1)*fac1+head(2,2)*fac4)/(fac1+fac4)
           end if
         end if
       else if(iact(2,2).eq.0)then
         if(fac2+fac3.le.1.0e-6)then
           head(2,2)=(head(1,2)+head(2,1))/2.0
         else
           head(2,2)=(head(1,2)*fac2+head(2,1)*fac3)/(fac2+fac3)
         end if
       end if

       bhead=head(1,1)*fac1+head(1,2)*fac2+head(2,1)*fac3+ &
       head(2,2)*fac4

       return
end subroutine uth_point_interp


end module high_level_utilities

       program driver13

! -- DRIVER13 tests 3-D inverse power of distance interpolation.

       use function_interfaces
       use iso_c_binding, only : c_int,c_char,c_double
       implicit none

       integer, parameter :: MAXZONE=10

! -- Variables used in function calls.

       integer(kind=c_int)           :: ifail
       integer(kind=c_int)           :: npts
       integer(kind=c_int)           :: mpts
       integer(kind=c_int)           :: transtype
       character(kind=c_char,len=1)  :: messagestring(1500)

       integer(kind=c_int), allocatable   :: zns(:),znt(:)
       real(kind=c_double), allocatable   :: ecs(:),ncs(:),zcs(:),vals(:)
       real(kind=c_double), allocatable   :: ect(:),nct(:),zct(:),valt(:)
       real(kind=c_double), allocatable   :: bearing(:),dip(:),rake(:)
       real(kind=c_double), allocatable   :: ahmax(:),ahmin(:),avert(:)
       real(kind=c_double), allocatable   :: invpow(:)

! -- Other variables

       integer               :: ierr,ioption
       integer               :: nlay,nrow,ncol,ilay,irow,icol
       integer               :: ipt,iii
       integer               :: ncr,lastzone,itemp,izone,nzone
       integer               :: zonenum(MAXZONE)
       double precision      :: pi
       double precision      :: e0,n0,angle
       double precision      :: cosang,sinang
       double precision      :: nointerpval
       double precision      :: dtemp1,dtemp2
       double precision      :: z_ahmax(MAXZONE),z_ahmin(MAXZONE),z_avert(MAXZONE)
       double precision      :: z_bearing(MAXZONE),z_dip(MAXZONE),z_rake(MAXZONE)
       double precision      :: z_invpower(MAXZONE)
       character (len=1)     :: anl
       character (len=20)    :: anum
       character (len=200)   :: cline
       character (len=256)   :: infile,outfile
       character (len=1500)  :: amessage

! -- Other allocatable variables.

       double precision, allocatable      :: delr(:),delc(:)
       double precision, allocatable      :: x(:),y(:)
       double precision, allocatable      :: bot(:,:,:)
       character (len=20), allocatable    :: apoint(:)

! -- Initialization

       pi=3.14159265358979000

! -- Read the grid specification file.

100    write(6,110,advance='no')
110    format(' Enter name of MF grid spec file: ')
       read(5,*,err=100) infile
       open(unit=10,file=infile,status='old',err=100)
       read(10,*,err=9000,end=9050) nrow,ncol
       read(10,*,err=9000,end=9050) e0,n0,angle
       allocate(delr(ncol),delc(nrow),stat=ierr)
       if(ierr.ne.0) go to 9200
       read(10,*,err=9000,end=9050) (delr(icol),icol=1,ncol)
       read(10,*,err=9000,end=9050) (delc(irow),irow=1,nrow)
       close(unit=10)
       write(6,120) trim(infile)
120    format(' - file ',a,' read ok.')

! -- Acquire number of layers.

       write(6,*)
130    write(6,140,advance='no')
140    format(' Enter number of model layers: ')
       read(5,*,err=130) nlay
       if(nlay.le.0) go to 130
       ncr=ncol*nrow
       mpts=ncol*nrow*nlay

! -- Calculate layer bottom elevations.

       allocate(bot(ncol,nrow,0:nlay),stat=ierr)
       if(ierr.ne.0) go to 9200
       do ilay=0,nlay
         bot(:,:,ilay)=-ilay*20.0d0
       end do

! -- Acquire zones option

       write(6,*)
131    write(6,141,advance='no')
141    format(' Use option 1 or 2 for zones? ')
       read(5,*,err=131) ioption
       if((ioption.ne.1).and.(ioption.ne.2)) go to 131

! -- Calculate zones (zones are 0,1,2)

       allocate(znt(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200
       if(ioption.eq.2)then
         znt=1  ! an array
       else
         do ilay=1,nlay
           do irow=1,nrow
             do icol=1,ncol
               ipt=(ilay-1)*ncr+(irow-1)*ncol+icol
               if(irow.le.15)then
                 znt(ipt)=1
               else
                 znt(ipt)=2
               end if
             end do
           end do
         end do
         do ilay=1,5
           do irow=21,nrow
             do icol=16,ncol
               ipt=(ilay-1)*ncr+(irow-1)*ncol+icol
               znt(ipt)=0
             end do
           end do
         end do
       end if

! -- The pilot points file is read.

       write(6,*)
180    write(6,190,advance='no')
190    format(' Enter name of 3D pilot points file: ')
       read(5,*,err=180) infile
       open(unit=10,file=infile,status='old',err=180)
       npts=0
       do
         read(10,'(a)',end=200) cline
         if(cline.eq.' ')cycle
         npts=npts+1
       end do
200    continue
       if(npts.eq.0)then
         write(6,201)
201      format(/,' *** No points in file. Try again ***',/)
         close(unit=10)
         go to 180
       end if
       allocate(apoint(npts),ecs(npts),ncs(npts),zcs(npts),zns(npts),vals(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       rewind(10)
       do ipt=1,npts
         read(10,*,err=9000,end=9050) apoint(ipt),ecs(ipt),ncs(ipt),zcs(ipt),zns(ipt),vals(ipt)
       end do
       close(unit=10)
       write(6,120) trim(infile)

! -- We calculate the number of zones in the target array.

       nzone=0
       lastzone=huge(lastzone)
       do ipt=1,mpts
         itemp=znt(ipt)
         if(itemp.ne.lastzone)then
           if(nzone.eq.0)then
             nzone=1
             zonenum(nzone)=itemp
           else
             do izone=1,nzone
               if(zonenum(izone).eq.itemp) go to 203
             end do
             nzone=nzone+1
             if(nzone.gt.MAXZONE)then
               call writint(anum,MAXZONE)
               write(amessage,2031) trim(anum)
2031           format('DRIVER13 allows a maximum of only ',a,' different zones ', &
               'in model grid.')
               go to 9890
             end if
             zonenum(nzone)=itemp
203          continue
           end if
           lastzone=itemp
         end if
       end do

! -- Enter anisotropy and other variables for different zones.

       do izone=1,nzone
         if(zonenum(izone).eq.0)then
           z_ahmax(izone)=1000.0
           z_ahmin(izone)=500.0
           z_avert(izone)=20.0
           z_bearing(izone)=0.0
           z_dip(izone)=0.0
           z_rake(izone)=0.0
           z_invpower(izone)=0.0
         else
           write(6,*)
           call writint(anum,zonenum(izone))
           write(6,2035) trim(anum)
2035       format(' For zone ',a,' ---->')
2050       write(6,2060,advance='no')
2060       format(' Enter ahmax, ahmin, avert: ')
           read(5,*,err=2050) z_ahmax(izone),z_ahmin(izone),z_avert(izone)
2070       write(6,2080,advance='no')
2080       format(' Enter bearing, dip, rake: ')
           read(5,*,err=2070) z_bearing(izone), z_dip(izone), z_rake(izone)
2090       write(6,2095,advance='no')
2095       format(' Enter inverse power of distance: ')
           read(5,*,err=2090) z_invpower(izone)
         end if
       end do

! -- Provide some control variables.

       write(6,*)
401    write(6,402,advance='no')
402    format(' Interpolate in natural or log domain? [n/l]: ')
       read(5,*,err=401) anl
       if((anl.eq.'N').or.(anl.eq.'n'))then
         transtype=0
       else if((anl.eq.'L').or.(anl.eq.'l'))then
         transtype=1
       else
         go to 401
       end if
405    write(6,406,advance='no')
406    format(' Enter number indicating no interpolation to target array: ')
       read(5,*,err=405) nointerpval

! -- Calculate target coordinates.

       allocate(ect(mpts),nct(mpts),zct(mpts),valt(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200
       valt=nointerpval        ! an array
       allocate(x(ncol),y(nrow),stat=ierr)
       if(ierr.ne.0) go to 9200

       cosang=cos(angle*pi/180.0d0)
       sinang=sin(angle*pi/180.0d0)
       do icol=1,ncol
         if(icol.eq.1)then
           x(icol)=delr(1)*0.5
         else
           x(icol)=x(icol-1)+(delr(icol)+delr(icol-1))*0.5
         end if
       end do
       do irow=1,nrow
         if(irow.eq.1)then
           y(irow)=-delc(irow)*0.5
         else
           y(irow)=y(irow-1)-(delc(irow)+delc(irow-1))*0.5
         end if
       end do
       ipt=0
       do irow=1,nrow
         do icol=1,ncol
           ipt=ipt+1
           dtemp1=x(icol)*cosang-y(irow)*sinang+e0
           dtemp2=x(icol)*sinang+y(irow)*cosang+n0
           do ilay=1,nlay
             ect(ipt+(ilay-1)*ncr)=dtemp1
             nct(ipt+(ilay-1)*ncr)=dtemp2
           end do
         end do
       end do
       ipt=0
       do ilay=1,nlay
         do irow=1,nrow
           do icol=1,ncol
             ipt=ipt+1
             zct(ipt)=(bot(icol,irow,ilay-1)+bot(icol,irow,ilay))*0.5
           end do
         end do
       end do

! -- Allocate and populate the other target arrays.

       allocate(ahmax(mpts),ahmin(mpts),avert(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(bearing(mpts),dip(mpts),rake(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(invpow(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200

       do izone=1,nzone
         iii=zonenum(izone)
         do ipt=1,mpts
           if(znt(ipt).eq.iii)then
             ahmax(ipt)=z_ahmax(izone)
             ahmin(ipt)=z_ahmin(izone)
             avert(ipt)=z_avert(izone)
             bearing(ipt)=z_bearing(izone)
             dip(ipt)=z_dip(izone)
             rake(ipt)=z_rake(izone)
             invpow(ipt)=z_invpower(izone)
           end if
         end do
       end do

! -- Now call the function to do the interpolation.

       write(6,*)
       write(6,320)
320    format(' Calling ipd_interpolate_3d()....')
       ifail=ipd_interpolate_3d(                 &
                  npts,ecs,ncs,zcs,zns,vals,     &
                  mpts,ect,nct,zct,znt,valt,     &
                  transtype,                     &
                  ahmax,ahmin,avert,             &
                  bearing,dip,rake,              &
                  invpow)
       if(ifail.ne.0)then
         write(6,340)
         write(6,*)
340      format(' Function call unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       else
         write(6,350)
350      format(' Interpolation successful.')
       end if

! -- We now store the results as a real array.

       write(6,*)
440    write(6,450,advance='no')
450    format(' Enter filename for target array storage: ')
       read(5,*,err=440) outfile
       open(unit=20,file=outfile,action='write',err=440)
       write(20,455)
455    format(1x,'LAYER',t10,'ROW',t20,'COLUMN',t30'VALUE')
       ipt=0
       do ilay=1,nlay
         do irow=1,nrow
           do icol=1,ncol
             ipt=ipt+1
             write(20,460) ilay,irow,icol,valt(ipt)
460          format(1x,i8,t10,i8,t20,i8,t30,1pg16.9)
           end do
         end do
       end do
       close(unit=20)
       write(6,470) trim(outfile)
470    format(' - file ',a,' written ok.')

       go to 9900

9000   write(amessage,9010) trim(infile)
9010   format('Error encountered in reading file ',a,'.')
       go to 9890

9050   write(amessage,9060) trim(infile)
9060   format('Premature end encountered to file ',a,'.')
       go to 9890

9200   write(amessage,9210)
9210   format('Insufficient memory to continue execution.')
       go to 9890


9890   continue
       amessage=' '//trim(amessage)
       call writmess(6,amessage)

! -- Tidy up

9900   continue

! -- Free local memory

       deallocate(zns,znt,stat=ierr)
       deallocate(ecs,ncs,zcs,vals,stat=ierr)
       deallocate(ect,nct,zct,valt,stat=ierr)
       deallocate(bearing,dip,rake,stat=ierr)
       deallocate(ahmax,ahmin,avert,stat=ierr)
       deallocate(invpow,stat=ierr)
       deallocate(delr,delc,stat=ierr)
       deallocate(x,y,stat=ierr)
       deallocate(bot,stat=ierr)
       deallocate(apoint,stat=ierr)

! -- Free function interface memory

       ifail=free_all_memory()

       end

integer (kind=c_int) function calc_kriging_factors_2d(npts,ecs,ncs,zns,     &
                                   mpts,ect,nct,znt,                        &
                                   vartype,krigtype,                        &
                                   aa,anis,bearing,                         &
                                   searchrad,maxpts,minpts,                 &
                                   factorfile,factorfiletype,               &
                                   icount_interp)                           &
                 bind(C,name="calc_kriging_factors_2d")

! -- This function calculates 2D kriging factors. Anisotropy, and anisotropy bearing
!    can be spatially variable.

       use iso_c_binding, only: c_int,c_char,c_double
       use dimvar
       use utilities
       implicit none

       integer(kind=c_int), intent(in)           :: npts                    ! number of source points
       real(kind=c_double), intent(in)           :: ecs(npts),ncs(npts)     ! source point coordinates
       integer(kind=c_int), intent(in)           :: zns(npts)               ! source point zones
       integer(kind=c_int), intent(in)           :: mpts                    ! number of target points
       real(kind=c_double), intent(in)           :: ect(mpts),nct(mpts)     ! target point coords
       integer(kind=c_int), intent(in)           :: znt(mpts)               ! target point zones
       integer(kind=c_int), intent(in)           :: vartype                 ! 1:spher,2:exp,3:gauss,4:pow
       integer(kind=c_int), intent(in)           :: krigtype                ! 0:simple,1:ordinary
       real(kind=c_double), intent(in)           :: aa(mpts)                ! variogram "a" value
       real(kind=c_double), intent(in)           :: anis(mpts)              ! variogram anisotropies
       real(kind=c_double), intent(in)           :: bearing(mpts)           ! anisotropy bearings
       real(kind=c_double), intent(in)           :: searchrad               ! search radius
       integer(kind=c_int), intent(in)           :: maxpts, minpts          ! search specifications
       character (kind=c_char,len=1), intent(in) :: factorfile(LENFILENAME) ! file for kriging factors
       integer(kind=c_int), intent(in)           :: factorfiletype          ! 0:binary, 1:text
       integer(kind=c_int), intent(out)          :: icount_interp           ! number of interp points

       integer, parameter  :: MAXZONE=20

       integer                     :: izone,numzone,iizone
       integer                     :: ipt,jpt,itemp,ierr,nb
       integer                     :: nc_npts,nc_mpts
       integer                     :: zone(MAXZONE)
       double precision            :: dtor
       double precision            :: nugget,sill,mean
       double precision            :: xmin,ymin
       character (len=20)          :: anum
       character (len=25)          :: varname
       character (len=LENFACCODE)  :: acode
       character (len=LENFILENAME) :: facfile

! -- Required by SGSIM function.

       logical                       :: lexist
       integer                       :: nnpts,iunit
       integer                       :: unestimated,idummy_num2
       integer                       :: n_nst
       integer                       :: i_it(1)
       integer                       :: minpoints,maxpoints,krtype
       integer                       :: idummy_ivector2(1)
       real                          :: pmx,sr,smean,c_c0
       real                          :: c_cc(1),a_ang(1),a_anis(1),a_aa(1)
       real                          :: dummy_rvector3(1),dummy_rvector4(1) ! PLPROC names
       character (len=1)             :: outfiletype
       character (len=10)            :: af1,af2

! -- Initialisation

       calc_kriging_factors_2d=0
       function_name='calc_kriging_factors_2d()'
       dtor=3.1415926535898d0/180.0d0
       nugget=0.0d0
       sill=1.0d0
       mean=0.0d0
       iunit=0
       unestimated=0
       icount_interp=0

! -- Character arrays are translated to character variables.

       call utl_string2char(LENFILENAME,factorfile,facfile)
       facfile=adjustl(facfile)

! -- Check input arguments.

       if(npts.le.0)then
         varname='NPTS'
         go to 9000
       end if
       if(mpts.le.0)then
         varname='MPTS'
         go to 9000
       end if
       if(minpts.le.0)then
         varname='MINPTS'
         go to 9000
       end if
       if(maxpts.le.0)then
         varname='MAXPTS'
         go to 9000
       end if
       if(searchrad.le.0.0d0)then
         varname='SEARCHRAD'
         go to 9000
       end if
       if(maxpts.lt.minpts) then
         write(amessage,110) trim(function_name)
110      format('MAXPTS must not be less than MINPTS in call to function ',a,'.')
         go to 9890
       end if
       if((vartype.lt.1).or.(vartype.gt.4))then
         write(amessage,115) trim(function_name)
115      format('The VARTYPE argument of function ',a,' must be 1,2,3 or 4.')
         go to 9890
       end if

       if((factorfiletype.ne.0).and.(factorfiletype.ne.1))then
         varname='FACTORFILETYPE'
         go to 9050
       end if
       if((krigtype.ne.0).and.(krigtype.ne.1))then
         varname='KRIGTYPE'
         go to 9050
       end if

       if(all(zns.eq.0))then
         varname='ZNS'
         go to 9100
       end if
       if(all(znt.eq.0))then
         varname='ZNT'
         go to 9100
       end if

! -- Build up an array of zone numbers.

       izone=1
       numzone=0
       do ipt=1,mpts
         itemp=znt(ipt)
         if(itemp.ne.0)then
           if(numzone.eq.0)then
             numzone=1
             zone(numzone)=itemp
           else
             if(utl_whichone(numzone,izone,zone,itemp).ne.0)then
               numzone=numzone+1
               if(numzone.gt.MAXZONE)then
                 call utl_num2char(MAXZONE,anum)
                 write(amessage,150) trim(anum)
150              format('A maximum of only ',a,' different zones can feature in ZNT array.')
                 go to 9890
               end if
               zone(numzone)=itemp
             end if
           end if
         end if
       end do
       if(numzone.eq.0)then
         write(amessage,151)
151      format('All zone numbers in the ZNT array are zero.')
         go to 9890
       end if

! -- Check that all zones in the target array are respected in the source array.

       do izone=1,numzone
         itemp=zone(izone)
         do ipt=1,npts
           if(zns(ipt).eq.itemp) go to 165
         end do
         call utl_num2char(itemp,anum)
         write(amessage,160) trim(anum)
160      format('Zone ',a,' from the ZNT array is not represented in the ZNS array.')
         go to 9890
165      continue
       end do

! -- Establish legitimacy of anisotropy specifications.

       do ipt=1,mpts
         if(znt(ipt).ne.0)then
           if(anis(ipt).le.0.0d0)then
             write(amessage,170)
170          format('At least one ANIS value is zero or negative at a point to ',  &
             'which interpolation is required.')
             go to 9890
           end if
           if((bearing(ipt).lt.-360.0d0).or.(bearing(ipt).gt.360.0d0))then
             write(amessage,180)
180          format('At least one BEARING value is less than -360 or greater than ',  &
             '360 at a point to which interpolation is required.')
             go to 9890
           end if
         end if
       end do

! -- Establish acode

       if(krigtype.eq.0)then
         acode='2dks'
       else if(krigtype.eq.1)then
         acode='2dko'
       end if
       acode=adjustl(acode)

! -- We open the factor file. However if a binary file is requested, and the file is present
!    it is deleted.

       iunit=utl_nextunit()
       if(factorfiletype.eq.0)then
         inquire(file=facfile,exist=lexist)
         if(lexist)then
           open(unit=iunit,file=facfile,form='unformatted',access='stream',   &
           action='write',iostat=ierr)
           close(unit=iunit,status='delete',iostat=ierr)
         end if
         open(unit=iunit,file=facfile,form='unformatted',access='stream',   &
         action='write',err=9150)
       else
         open(unit=iunit,file=facfile,action='write',err=9170)
       end if

! -- Write a header to the file.

       nc_npts=npts             ! just in case of problems where a file is binary
       nc_mpts=mpts
       if(factorfiletype.eq.0)then
         write(iunit,err=9150) acode
         write(iunit,err=9150) nc_npts,nc_mpts
       else
         write(iunit,220,err=9170) trim(acode)
220      format(a)
         write(iunit,230,err=9170) nc_npts,nc_mpts
230      format(2i10)
       end if

! -- Allocate some work arrays. (Use same names as PLPROC.)

       if(utl_allocate_vector('r',1,npts).ne.0) go to 9200
       if(utl_allocate_vector('r',2,npts).ne.0) go to 9200
       if(utl_allocate_vector('i',1,npts).ne.0) go to 9200

! -- Evaluate reference coords.

       xmin=1.0d300
       ymin=1.0d300
       do ipt=1,mpts
         if(ect(ipt).lt.xmin)xmin=ect(ipt)
         if(nct(ipt).lt.ymin)ymin=nct(ipt)
       end do

! -- Give value to some variables.

       krtype=krigtype
       n_nst=1
       c_c0=nugget
       i_it(1)=vartype
       c_cc(1)=sill
       pmx=10000.0
       sr=min(searchrad,1.0e15)
       smean=mean
       if(factorfiletype.eq.0)then
         outfiletype='u'
       else
         outfiletype='f'
       end if
       idummy_num2=1

       call utl_num2char(npts,anum)
       anum=adjustl(anum)
       nb=len_trim(anum)
       nb=nb+1
       call utl_num2char(nb,af1)
       af1='i'//trim(af1)
       call utl_num2char(mpts,anum)
       anum=adjustl(anum)
       nb=len_trim(anum)
       nb=nb+1
       call utl_num2char(nb,af2)
       af2='i'//trim(af2)

! -- The zone loop starts here

       icount_interp=0
       zones: do izone=1,numzone
         iizone=zone(izone)

! -- Store the source points that we need in a dedicated array.
         nnpts=0
         do ipt=1,npts
           if(zns(ipt).eq.iizone)then
             nnpts=nnpts+1
             rvector1(nnpts)=ecs(ipt)-xmin
             rvector2(nnpts)=ncs(ipt)-ymin
             ivector1(nnpts)=ipt
           end if
         end do
         maxpoints=maxpts
         if(maxpoints.gt.nnpts)maxpoints=nnpts

! -- We now cycle through the individual points to which interpolation must take place.

         targpoints: do ipt=1,mpts
           if(znt(ipt).eq.iizone)then
             icount_interp=icount_interp+1
             dummy_rvector3(1)=ect(ipt)-xmin
             dummy_rvector4(1)=nct(ipt)-ymin
             idummy_ivector2(1)=ipt
             a_aa(1)=aa(ipt)
             a_ang(1)=bearing(ipt)
             a_anis(1)=1.0/anis(ipt)
             minpoints=minpts
             if(minpoints.gt.nnpts)minpoints=nnpts
             call kb2d_1(minpoints,maxpoints,sr,krtype,smean,                &
             n_nst,c_c0,i_it,c_cc,a_ang,a_aa,a_anis,                         &
             unestimated,idummy_num2,nnpts,ivector1,idummy_ivector2,dummy_rvector3,dummy_rvector4,  &
             outfiletype,iunit,pmx,rvector1,rvector2,af1,af2)
             if(unestimated.ne.0)then
               call utl_num2char(unestimated,anum)
               write(amessage,300) trim(anum)
300            format('Interpolation cannot take place to all target points. The ',     &
               'first element for which interpolation cannot take place is element ',   &
               'number ',a,'. Check that no interpolation source points are ',          &
               'coincident. Check that the search radius is large enough. ',            &
               'If you are using a Gaussian variogram, try using another.')
               go to 9890
             end if
           end if
         end do targpoints
       end do zones
       go to 9900

9000   write(amessage,9010) trim(varname),trim(function_name)
9010   format('The ',a,' argument of function ',a,' must be greater than zero.')
       go to 9890

9050   write(amessage,9060) trim(varname),trim(function_name)
9060   format('The ',a,' argument of function ',a,' must be supplied as 0 or 1.')
       go to 9890

9100   write(amessage,9110) trim(varname)
9110   format('All elements of the ',a,' array are supplied as zero.')
       go to 9890

9150   write(amessage,9160) trim(facfile)
9160   format('Cannot write to binary factor file ',a,'.')
       go to 9890

9170   write(amessage,9180) trim(facfile)
9180   format('Cannot write to text factor file ',a,'.')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory allocation error in function ',a,'.')
       go to 9890

9890   calc_kriging_factors_2d=1
       icount_interp=0

9900   continue
       if(iunit.ne.0)then
         close(unit=iunit,iostat=ierr)
       end if

       return

end function calc_kriging_factors_2d



integer (kind=c_int) function calc_kriging_factors_auto_2d(npts,ecs,ncs,zns,  &
                                   mpts,ect,nct,znt,                          &
                                   krigtype,                                  &
                                   anis,bearing,                              &
                                   factorfile,factorfiletype,                 &
                                   icount_interp)                             &
                 bind(C,name="calc_kriging_factors_auto_2d")

! -- This function calculates 2D kriging factors. Anisotropy, and anisotropy bearing
!    can be spatially variable. Some variogram properties are determined automatically.

       use iso_c_binding, only: c_int,c_char,c_double
       use dimvar
       use utilities
       implicit none

       integer(kind=c_int), intent(in)           :: npts                    ! number of source points
       real(kind=c_double), intent(in)           :: ecs(npts),ncs(npts)     ! source point coordinates
       integer(kind=c_int), intent(in)           :: zns(npts)               ! source point zones
       integer(kind=c_int), intent(in)           :: mpts                    ! number of target points
       real(kind=c_double), intent(in)           :: ect(mpts),nct(mpts)     ! target point coords
       integer(kind=c_int), intent(in)           :: znt(mpts)               ! target point zones
       integer(kind=c_int), intent(in)           :: krigtype                ! 0:simple,1:ordinary
       real(kind=c_double), intent(in)           :: anis(mpts)              ! variogram anisotropies
       real(kind=c_double), intent(in)           :: bearing(mpts)           ! anisotropy bearings
       character (kind=c_char,len=1), intent(in) :: factorfile(LENFILENAME) ! file for kriging factors
       integer(kind=c_int), intent(in)           :: factorfiletype          ! 0:binary, 1:text
       integer(kind=c_int), intent(out)          :: icount_interp           ! number of interp points

       integer, parameter  :: MAXZONE=20

       integer                     :: i,j
       integer                     :: vartype
       integer                     :: izone,numzone,iizone
       integer                     :: ipt,itemp,ierr,nb
       integer                     :: nc_npts,nc_mpts
       integer                     :: zone(MAXZONE)
       real                        :: rtemp
       double precision            :: nugget,sill,mean
       double precision            :: xmin,ymin
       double precision            :: distmin,dist2,sum,minmindist
       double precision            :: avemindist,basedist,basedist2
       double precision            :: den,dtemp,aa,xx1,yy1
       character (len=20)          :: anum
       character (len=25)          :: varname
       character (len=LENFACCODE)  :: acode
       character (len=LENFILENAME) :: facfile

! -- Required by SGSIM function.

       logical                       :: lexist
       integer                       :: nnpts,iunit
       integer                       :: unestimated,idummy_num2
       integer                       :: n_nst
       integer                       :: i_it(1)
       integer                       :: minpoints,maxpoints,krtype
       integer                       :: idummy_ivector2(1)
       real                          :: pmx,sr,smean,c_c0
       real                          :: c_cc(1),a_ang(1),a_anis(1),a_aa(1)
       real                          :: dummy_rvector3(1),dummy_rvector4(1) ! PLPROC names
       character (len=1)             :: outfiletype
       character (len=10)            :: af1,af2

! -- Initialisation

       calc_kriging_factors_auto_2d=0
       function_name='calc_kriging_factors_auto_2d()'
       vartype=2
       nugget=0.0d0
       sill=1.0d0
       mean=0.0d0
       iunit=0
       unestimated=0
       icount_interp=0

! -- Character arrays are translated to character variables.

       call utl_string2char(LENFILENAME,factorfile,facfile)
       facfile=adjustl(facfile)

! -- Check input arguments.

       if(npts.le.0)then
         varname='NPTS'
         go to 9000
       end if
       if(mpts.le.0)then
         varname='MPTS'
         go to 9000
       end if
       if((factorfiletype.ne.0).and.(factorfiletype.ne.1))then
         varname='FACTORFILETYPE'
         go to 9050
       end if
       if((krigtype.ne.0).and.(krigtype.ne.1))then
         varname='KRIGTYPE'
         go to 9050
       end if

       if(all(zns.eq.0))then
         varname='ZNS'
         go to 9100
       end if
       if(all(znt.eq.0))then
         varname='ZNT'
         go to 9100
       end if

! -- Build up an array of zone numbers.

       izone=1
       numzone=0
       do ipt=1,mpts
         itemp=znt(ipt)
         if(itemp.ne.0)then
           if(numzone.eq.0)then
             numzone=1
             zone(numzone)=itemp
           else
             if(utl_whichone(numzone,izone,zone,itemp).ne.0)then
               numzone=numzone+1
               if(numzone.gt.MAXZONE)then
                 call utl_num2char(MAXZONE,anum)
                 write(amessage,150) trim(anum)
150              format('A maximum of only ',a,' different zones can feature in ZNT array.')
                 go to 9890
               end if
               zone(numzone)=itemp
             end if
           end if
         end if
       end do
       if(numzone.eq.0)then
         write(amessage,151)
151      format('All zone numbers in the ZNT array are zero.')
         go to 9890
       end if

! -- Check that all zones in the target array are respected in the source array.

       do izone=1,numzone
         itemp=zone(izone)
         do ipt=1,npts
           if(zns(ipt).eq.itemp) go to 165
         end do
         call utl_num2char(itemp,anum)
         write(amessage,160) trim(anum)
160      format('Zone ',a,' from the ZNT array is not represented in the ZNS array.')
         go to 9890
165      continue
       end do

! -- Establish legitimacy of anisotropy specifications.

       do ipt=1,mpts
         if(znt(ipt).ne.0)then
           if(anis(ipt).le.0.0d0)then
             write(amessage,170)
170          format('At least one ANIS value is zero or negative at a point to ',  &
             'which interpolation is required.')
             go to 9890
           end if
           if((bearing(ipt).lt.-360.0d0).or.(bearing(ipt).gt.360.0d0))then
             write(amessage,180)
180          format('At least one BEARING value is less than -360 or greater than ',  &
             '360 at a point to which interpolation is required.')
             go to 9890
           end if
         end if
       end do

! -- Establish acode

       if(krigtype.eq.0)then
         acode='2dks'
       else if(krigtype.eq.1)then
         acode='2dko'
       end if
       acode=adjustl(acode)

! -- We open the factor file. However if a binary file is requested, and the file is present
!    it is deleted.

       iunit=utl_nextunit()
       if(factorfiletype.eq.0)then
         inquire(file=facfile,exist=lexist)
         if(lexist)then
           open(unit=iunit,file=facfile,form='unformatted',access='stream',   &
           action='write',iostat=ierr)
           close(unit=iunit,status='delete',iostat=ierr)
         end if
         open(unit=iunit,file=facfile,form='unformatted',access='stream',   &
         action='write',err=9150)
       else
         open(unit=iunit,file=facfile,action='write',err=9170)
       end if

! -- Write a header to the file.

       nc_npts=npts             ! just in case of KIND problems where a file is binary
       nc_mpts=mpts
       if(factorfiletype.eq.0)then
         write(iunit,err=9150) acode
         write(iunit,err=9150) nc_npts,nc_mpts
       else
         write(iunit,220,err=9170) trim(acode)
220      format(a)
         write(iunit,230,err=9170) nc_npts,nc_mpts
230      format(2i10)
       end if

! -- Allocate some work arrays. (Use same names as PLPROC.)

       if(utl_allocate_vector('r',1,npts).ne.0) go to 9200
       if(utl_allocate_vector('r',2,npts).ne.0) go to 9200
       if(utl_allocate_vector('i',1,npts).ne.0) go to 9200
       if(utl_allocate_vector('r',3,npts).ne.0) go to 9200

! -- Evaluate reference coords.

       xmin=1.0d300
       ymin=1.0d300
       do ipt=1,mpts
         if(ect(ipt).lt.xmin)xmin=ect(ipt)
         if(nct(ipt).lt.ymin)ymin=nct(ipt)
       end do

! -- Give values to some variables.

       krtype=krigtype
       n_nst=1
       c_c0=nugget
       i_it(1)=vartype
       c_cc(1)=sill
       pmx=10000.0
       smean=mean
       if(factorfiletype.eq.0)then
         outfiletype='u'
       else
         outfiletype='f'
       end if
       idummy_num2=1

       call utl_num2char(npts,anum)
       anum=adjustl(anum)
       nb=len_trim(anum)
       nb=nb+1
       call utl_num2char(nb,af1)
       af1='i'//trim(af1)
       call utl_num2char(mpts,anum)
       anum=adjustl(anum)
       nb=len_trim(anum)
       nb=nb+1
       call utl_num2char(nb,af2)
       af2='i'//trim(af2)

! -- The zone loop starts here

       icount_interp=0
       zones: do izone=1,numzone
         iizone=zone(izone)

! -- Store the source points that we need in a dedicated array.

         nnpts=0
         do ipt=1,npts
           if(zns(ipt).eq.iizone)then
             nnpts=nnpts+1
             rvector1(nnpts)=ecs(ipt)-xmin
             rvector2(nnpts)=ncs(ipt)-ymin
             ivector1(nnpts)=ipt
           end if
         end do
         maxpoints=nnpts

! -- We find the distance between each pilot point and its closest neighbour.
! -- This is assigned to rvector3.

         if(nnpts.gt.2)then
           do i=1,nnpts
             xx1=rvector1(i)
             yy1=rvector2(i)
             distmin=1.0d300
             do j=1,nnpts
               if(j.eq.i) cycle
               dist2=(xx1-rvector1(j))*(xx1-rvector1(j))+(yy1-rvector2(j))*(yy1-rvector2(j))
               if(dist2.lt.distmin)distmin=dist2
             end do
             rvector3(i)=sqrt(distmin)
           end do
         else if(nnpts.eq.2)then
           rvector3(1)=sqrt((rvector1(1)-rvector1(2))*(rvector1(1)-rvector1(2))+    &
                            (rvector2(1)-rvector2(2))*(rvector2(1)-rvector2(2)))
           rvector3(2)=rvector3(1)
         else if(nnpts.eq.1)then
           rvector3(1)=0.0
         end if

! -- We find the minimum minimum distance between any two points and the average
!    minimum distance between any two points.

         if(npts.le.2)then
           minmindist=rvector3(1)
           avemindist=rvector3(1)
         else
           sum=0.0d0
           minmindist=huge(rtemp)
           do i=1,nnpts
             if(minmindist.gt.rvector3(i))minmindist=rvector3(i)
             sum=sum+rvector3(i)
           end do
           avemindist=sum/nnpts
         end if
         basedist=minmindist
         if(avemindist.ne.0.0)then
           if(basedist/avemindist.lt.0.01) basedist=avemindist*0.01   ! arbitrary
         end if
         basedist2=basedist*basedist

! -- We now cycle through the individual points to which interpolation must take place.

         targpoints: do ipt=1,mpts
           if(znt(ipt).eq.iizone)then

! -- For each point to which we must interpolate we assign the variogram range a value as
!    equal to either the distance to the closest pilot point or weighted average of inter-point
!    distances, with weighting being inverse distance squared, whichever is greater.
! -- Actually the weights in determining average interpoint distance are maximized to be
!    equal to the minimum distance between any two points (just so the weight doesn't
!    become infinite as we approach a point.)

             xx1=ect(ipt)-xmin
             yy1=nct(ipt)-ymin
             distmin=1.0d300
             sum=0.0d0
             den=0.0d0
             do j=1,nnpts
               dist2=(xx1-rvector1(j))*(xx1-rvector1(j))+(yy1-rvector2(j))*(yy1-rvector2(j))
               if(dist2.lt.distmin) distmin=dist2
               dtemp=dist2
               if(dtemp.lt.basedist2)dtemp=basedist2
               if(dtemp.gt.0.0)then
                 dtemp=1.0/dtemp
               else
                 dtemp=1.0e30
               end if
!               dtemp=sqrt(dtemp)
               sum=sum+rvector3(j)*dtemp
               den=den+dtemp
             end do
             aa=sum/den
             distmin=sqrt(distmin)
             if(aa.lt.distmin)aa=distmin
             a_aa(1)=aa

! -- The search radius is assigned as a 4 times the variogram value.

             sr=3.0d0*aa                             ! arbitrary
             if(sr.gt.1.0e15)sr=1.0e15
             dummy_rvector3(1)=xx1
             dummy_rvector4(1)=yy1
             icount_interp=icount_interp+1
             idummy_ivector2(1)=ipt
             a_ang(1)=bearing(ipt)
             a_anis(1)=1.0/anis(ipt)
             minpoints=1                             ! may need review
             call kb2d_1(minpoints,maxpoints,sr,krtype,smean,                &
             n_nst,c_c0,i_it,c_cc,a_ang,a_aa,a_anis,                         &
             unestimated,idummy_num2,nnpts,ivector1,idummy_ivector2,dummy_rvector3,dummy_rvector4,  &
             outfiletype,iunit,pmx,rvector1,rvector2,af1,af2)
             if(unestimated.ne.0)then
               call utl_num2char(unestimated,anum)
               write(amessage,300) trim(anum)
300            format('Interpolation cannot take place to all target points. The ',     &
               'first element for which interpolation cannot take place is element ',   &
               'number ',a,'. Check that no interpolation source points are ',          &
               'coincident. Check that the search radius is large enough and ',         &
               'that MINPTS is large enough. If you are using a Gaussian variogram, ',  &
               ' then try using another.')
               go to 9890
             end if
           end if
         end do targpoints
       end do zones
       go to 9900

9000   write(amessage,9010) trim(varname),trim(function_name)
9010   format('The ',a,' argument of function ',a,' must be greater than zero.')
       go to 9890

9050   write(amessage,9060) trim(varname),trim(function_name)
9060   format('The ',a,' argument of function ',a,' must be supplied as 0 or 1.')
       go to 9890

9100   write(amessage,9110) trim(varname)
9110   format('All elements of the ',a,' array are supplied as zero.')
       go to 9890

9150   write(amessage,9160) trim(facfile)
9160   format('Cannot write to binary factor file ',a,'.')
       go to 9890

9170   write(amessage,9180) trim(facfile)
9180   format('Cannot write to text factor file ',a,'.')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory allocation error in function ',a,'.')
       go to 9890

9890   calc_kriging_factors_auto_2d=1
       icount_interp=0

9900   continue
       if(iunit.ne.0)then
         close(unit=iunit,iostat=ierr)
       end if

       return

end function calc_kriging_factors_auto_2d



integer (kind=c_int) function calc_kriging_factors_3d(            &
                                   npts,ecs,ncs,zcs,zns,          &
                                   mpts,ect,nct,zct,znt,          &
                                   krigtype,                      &
                                   nzone,zonenum,                 &
                                   vartype,                       &
                                   ahmax,ahmin,avert,             &
                                   bearing,dip,rake,              &
                                   srhmax,srhmin,srvert,          &
                                   maxpts,minpts,                 &
                                   factorfile,factorfiletype,     &
                                   icount_interp)                 &
                 bind(C,name="calc_kriging_factors_3d")

! -- This function calculates 3D kriging factors.

       use iso_c_binding, only: c_int,c_char,c_double
       use dimvar
       use geostat_3d, only: MAXDAT,x,y,z,vr
       use utilities
       implicit none

       integer(kind=c_int), intent(in)         :: npts                          ! number of source points
       real(kind=c_double), intent(in)         :: ecs(npts),ncs(npts),zcs(npts) ! source point coords
       integer(kind=c_int), intent(in)         :: zns(npts)                     ! source point zones
       integer(kind=c_int), intent(in)         :: mpts                          ! number of target points
       real(kind=c_double), intent(in)         :: ect(mpts),nct(mpts),zct(mpts) ! target point coords
       integer(kind=c_int), intent(in)         :: znt(mpts)                     ! target point zones
       integer(kind=c_int), intent(in)         :: krigtype                      ! 0:simple,1:ordinary
       integer(kind=c_int), intent(in)         :: nzone                         ! number of zones
       integer(kind=c_int), intent(in)         :: zonenum(nzone)                ! zone numbers
       integer(kind=c_int), intent(in)         :: vartype(nzone)                ! 1:spher,2:exp,3:gauss,4:pow
       real(kind=c_double), intent(in)         :: ahmax(nzone),ahmin(nzone),avert(nzone)  ! variogram "a" values in 3 orthog dirns
       real(kind=c_double), intent(in)         :: bearing(nzone)                ! bearing of hmax
       real(kind=c_double), intent(in)         :: dip(nzone)                    ! dip of hmax
       real(kind=c_double), intent(in)         :: rake(nzone)                   ! twist about hmax axis
       real(kind=c_double), intent(in)         :: srhmax                        ! search radius in hmax dirn
       real(kind=c_double), intent(in)         :: srhmin                        ! search radius in hmin dirn
       real(kind=c_double), intent(in)         :: srvert                        ! search radius in vert dirn
       integer(kind=c_int), intent(in)         :: maxpts, minpts                ! search specifications
       character (kind=c_char,len=1), intent(in) :: factorfile(LENFILENAME)     ! file for kriging factors
       integer(kind=c_int), intent(in)         :: factorfiletype                ! 0:binary, 1:text
       integer(kind=c_int), intent(out)        :: icount_interp                 ! number of interp points

       integer                     :: izone,iizone,lastzone
       integer                     :: ipt,jpt,itemp,ierr,nb
       integer                     :: nc_npts,nc_mpts
       double precision            :: nugget,sill,mean
       double precision            :: xmin,ymin,zmin,dtemp
       character (len=20)          :: anum
       character (len=25)          :: varname
       character (len=LENFACCODE)  :: acode
       character (len=LENFILENAME) :: facfile

! -- Required by SGSIM function.

       logical                       :: lexist
       integer                       :: nnpts,mmpts,iunit
       integer                       :: unestimated
       integer                       :: n_nst
       integer                       :: i_it(1)
       integer                       :: minpoints,maxpoints,krtype
       integer                       :: ncol_range,nrow_range
       integer                       :: iparmcall
       integer                       :: MAXDIS,MAXSBX,MAXSBY,MAXSBZ,MAXEQ
       real                          :: pmx,sr,s_skmean,c_c0
       real                          :: emin,emax,nmin,nmax,elevmin,elevmax
       real                          :: sradmax_hmax,sradmax_hmin,sradmax_vert
       real                          :: c_cc(1)
       real                          :: a_ang1(1),a_ang2(1),a_ang3(1)
       real                          :: a_a_hmax(1),a_a_hmin(1),a_a_vert(1)
       character (len=1)             :: aoutfile
       character (len=10)            :: af1,af2

! -- Initialisation

       calc_kriging_factors_3d=0
       function_name='calc_kriging_factors_3d()'
       nugget=0.0d0
       sill=1.0d0
       mean=0.0d0
       iunit=0
       unestimated=0
       icount_interp=0

! -- Character arrays are translated to character variables.

       call utl_string2char(LENFILENAME,factorfile,facfile)
       facfile=adjustl(facfile)

! -- Check input arguments.

       if(npts.le.0)then
         varname='NPTS'
         go to 9000
       end if
       if(mpts.le.0)then
         varname='MPTS'
         go to 9000
       end if
       if(minpts.le.0)then
         varname='MINPTS'
         go to 9000
       end if
       if(maxpts.le.0)then
         varname='MAXPTS'
         go to 9000
       end if
       if(maxpts.lt.minpts) then
         write(amessage,110) trim(function_name)
110      format('MAXPTS must not be less than MINPTS in call to function ',a,'.')
         go to 9890
       end if
       do izone=1,nzone
         if(zonenum(izone).ne.0)then
           if(ahmax(izone).le.0.0d0)then
             varname='AHMAX'
             go to 9070
           end if
         end if
       end do
       do izone=1,nzone
         if(zonenum(izone).ne.0)then
           if(ahmin(izone).le.0.0d0)then
             varname='AHMIN'
             go to 9070
           end if
         end if
       end do
       do izone=1,nzone
         if(zonenum(izone).ne.0)then
           if(avert(izone).le.0.0d0)then
             varname='AVERT'
             go to 9070
           end if
         end if
       end do
       if(srhmax.le.0.0d0)then
         varname='SRHMAX'
         go to 9000
       end if
       if(srhmin.le.0.0d0)then
         varname='SRHMIN'
         go to 9000
       end if
       if(srvert.le.0.0d0)then
         varname='SRVERT'
         go to 9000
       end if
       do izone=1,nzone
         if(zonenum(izone).ne.0)then
           if((vartype(izone).lt.1).or.(vartype(izone).gt.4))then
             call utl_num2char(zonenum(izone),anum)
             write(amessage,115) trim(anum)
115          format('The value of VARTYPE supplied for zone ',a,' must be 1,2,3 or 4.')
             go to 9890
           end if
         end if
       end do
       if((krigtype.ne.0).and.(krigtype.ne.1))then
         varname='KRIGTYPE'
         go to 9050
       end if

       if((factorfiletype.ne.0).and.(factorfiletype.ne.1))then
         varname='FACTORFILETYPE'
         go to 9050
       end if

       if(all(zns.eq.0))then
         varname='ZNS'
         go to 9100
       end if
       if(all(znt.eq.0))then
         varname='ZNT'
         go to 9100
       end if

       do izone=1,nzone
         if(zonenum(izone).ne.0)then
           if((bearing(izone).lt.-360.0d0).or.(bearing(izone).gt.360.0d0))then
             call utl_num2char(zonenum(izone),anum)
             write(amessage,180) trim(anum)
180          format('The value of BEARING for zone ',a,' must be greater than -360 ',  &
             'degrees and less than 360 degrees.')
             go to 9890
           end if
         end if
       end do
       do izone=1,nzone
         if(zonenum(izone).ne.0)then
           if((dip(izone).lt.-180.0d0).or.(dip(izone).gt.180.0d0))then
             call utl_num2char(zonenum(izone),anum)
             write(amessage,181) trim(anum)
181          format('The value of DIP for zone ',a,' must be greater than -180 degrees ',  &
            'and less than 180 degrees.')
             go to 9890
           end if
         end if
       end do
       do izone=1,nzone
         if(zonenum(izone).ne.0)then
           if((rake(izone).lt.-90.0d0).or.(rake(izone).gt.90.0d0))then
             call utl_num2char(zonenum(izone),anum)
             write(amessage,182) trim(anum)
182          format('The value of RAKE for zone ',a,' must be greater than -90 degrees ', &
             'and less than 90 degrees.')
             go to 9890
           end if
         endif
       end do

! -- Ensure that all zones are present in source and target arrays.

       lastzone=0
       izone=0
       do ipt=1,npts
         itemp=zns(ipt)
         if(itemp.ne.0)then
           if(itemp.ne.lastzone)then
             if(utl_whichone(nzone,izone,zonenum,itemp).ne.0)then
               call utl_num2char(itemp,anum)
               write(amessage,190) trim(anum),'ZNS','ZONENUM'
190            format('Zone ',a,' features in the ',a,' array, but does not ',  &
               'feature in the ',a,' array.')
               go to 9890
             end if
             lastzone=itemp
           end if
         end if
       end do
       lastzone=0
       do ipt=1,mpts
         itemp=znt(ipt)
         if(itemp.ne.0)then
           if(itemp.ne.lastzone)then
             if(utl_whichone(nzone,izone,zonenum,itemp).ne.0)then
               call utl_num2char(itemp,anum)
               write(amessage,190) trim(anum),'ZNT','ZONENUM'
               go to 9890
             end if
             lastzone=itemp
           end if
         end if
       end do
       do izone=1,nzone
         itemp=zonenum(izone)
         if(itemp.ne.0)then
           do ipt=1,npts
             if(zns(ipt).eq.itemp) go to 200
           end do
           call utl_num2char(itemp,anum)
           write(amessage,190) trim(anum),'ZONENUM','ZNS'
           go to 9890
200        continue
           do ipt=1,mpts
             if(znt(ipt).eq.itemp) go to 210
           end do
           call utl_num2char(itemp,anum)
           write(amessage,190) trim(anum),'ZONENUM','ZNT'
           go to 9890
210        continue
         end if
       end do

! -- Establish acode

       if(krigtype.eq.0)then
         acode='3dks'
       else if(krigtype.eq.1)then
         acode='3dko'
       end if
       acode=adjustl(acode)

! -- We open the factor file. However if a binary file is requested, and the file is present
!    it is deleted.

       iunit=utl_nextunit()
       if(factorfiletype.eq.0)then
         inquire(file=facfile,exist=lexist)
         if(lexist)then
           open(unit=iunit,file=facfile,form='unformatted',access='stream',   &
           action='write',iostat=ierr)
           close(unit=iunit,status='delete',iostat=ierr)
         end if
         open(unit=iunit,file=facfile,form='unformatted',access='stream',   &
         action='write',err=9150)
       else
         open(unit=iunit,file=facfile,action='write',err=9170)
       end if

! -- Write a header to the file.

       nc_npts=npts             ! just in case of problems where a file is binary
       nc_mpts=mpts
       if(factorfiletype.eq.0)then
         write(iunit,err=9150) acode
         write(iunit,err=9150) nc_npts,nc_mpts
       else
         write(iunit,220,err=9170) trim(acode)
220      format(a)
         write(iunit,230,err=9170) nc_npts,nc_mpts
230      format(2i10)
       end if

! -- Allocate some work arrays. (Use same names as PLPROC.)

       if(utl_allocate_vector('r',1,mpts).ne.0) go to 9200
       if(utl_allocate_vector('r',2,mpts).ne.0) go to 9200
       if(utl_allocate_vector('r',3,mpts).ne.0) go to 9200
       if(utl_allocate_vector('i',1,npts).ne.0) go to 9200
       if(utl_allocate_vector('i',2,mpts).ne.0) go to 9200
       MAXDAT=npts+1
       allocate(x(MAXDAT),y(MAXDAT),z(MAXDAT),vr(MAXDAT),stat=ierr)
       if(ierr.ne.0) go to 9200

! -- Evaluate reference coords.

       xmin=1.0d300
       ymin=1.0d300
       zmin=1.0d300
       do ipt=1,mpts
         if(znt(ipt).ne.0)then
           if(ect(ipt).lt.xmin)xmin=ect(ipt)
           if(nct(ipt).lt.ymin)ymin=nct(ipt)
           if(zct(ipt).lt.zmin)zmin=zct(ipt)
         end if
       end do

! -- Give value to some variables.

       krtype=krigtype
       n_nst=1
       c_c0=nugget
       c_cc(1)=sill
       dtemp=mpts
       ncol_range=sqrt(dtemp*0.5)
       if(ncol_range.lt.1)ncol_range=1
       nrow_range=sqrt(dtemp*0.5)
       if(nrow_range.lt.1)nrow_range=1
       iparmcall=1
       pmx=10000.0
       if(factorfiletype.eq.0)then
         aoutfile='u'
       else
         aoutfile='f'
       end if
       emin=1.0e35
       emax=-1.0e35
       nmin=1.0e35
       nmax=-1.0e35
       elevmin=1.0e35
       elevmax=-1.0e35
       sradmax_hmax=min(srhmax,1.0e15)
       sradmax_hmin=min(srhmin,1.0e15)
       sradmax_vert=min(srvert,1.0e15)
       s_skmean=0.0                                   ! a dummy value
       minpoints=minpts

! -- Evaluate formats for factor file storage

       call utl_num2char(npts,anum)
       anum=adjustl(anum)
       nb=len_trim(anum)
       nb=nb+1
       call utl_num2char(nb,af1)
       af1='i'//trim(af1)
       call utl_num2char(mpts,anum)
       anum=adjustl(anum)
       nb=len_trim(anum)
       nb=nb+1
       call utl_num2char(nb,af2)
       af2='i'//trim(af2)

! -- The zone loop starts here

       icount_interp=0
       zones: do izone=1,nzone
         iizone=zonenum(izone)
         if(iizone.eq.0) cycle

! -- Store some variables.

         i_it(1)=vartype(izone)
         a_ang1(1)=bearing(izone)
         a_ang2(1)=dip(izone)
         a_ang3(1)=rake(izone)
         a_a_hmax(1)=ahmax(izone)
         a_a_hmin(1)=ahmin(izone)
         a_a_vert(1)=avert(izone)

! -- Store the source and target points for the pertinent zone in dedicated arrays.

         mmpts=0
         do ipt=1,mpts
           if(znt(ipt).eq.iizone)then
             mmpts=mmpts+1
             icount_interp=icount_interp+1
             rvector1(mmpts)=ect(ipt)-xmin
             rvector2(mmpts)=nct(ipt)-ymin
             rvector3(mmpts)=zct(ipt)-zmin
             ivector2(mmpts)=ipt
           end if
         end do
         nnpts=0
         do ipt=1,npts
           if(zns(ipt).eq.iizone)then
             nnpts=nnpts+1
             x(nnpts)=ecs(ipt)-xmin
             y(nnpts)=ncs(ipt)-ymin
             z(nnpts)=zcs(ipt)-zmin
             ivector1(nnpts)=ipt
           end if
         end do
         maxpoints=maxpts
         if(maxpoints.gt.nnpts)maxpoints=nnpts
         vr=z             ! Pragmatic; achieves nothing but to have values in this array.

         do ipt=1,mmpts
           if(rvector1(ipt).lt.emin)emin=rvector1(ipt)
           if(rvector1(ipt).gt.emax)emax=rvector1(ipt)
         end do
         do ipt=1,mmpts
           if(rvector2(ipt).lt.nmin)nmin=rvector2(ipt)
           if(rvector2(ipt).gt.nmax)nmax=rvector2(ipt)
         end do
         do ipt=1,mmpts
           if(rvector3(ipt).lt.elevmin)elevmin=rvector3(ipt)
           if(rvector3(ipt).gt.elevmax)elevmax=rvector3(ipt)
         end do
         do ipt=1,nnpts
           if(x(ipt).lt.emin)emin=x(ipt)
           if(x(ipt).gt.emax)emax=x(ipt)
         end do
         do ipt=ipt,nnpts
           if(y(ipt).lt.nmin)nmin=y(ipt)
           if(y(ipt).gt.nmax)nmax=y(ipt)
         end do
         do ipt=1,nnpts
           if(z(ipt).lt.elevmin)elevmin=z(ipt)
           if(z(ipt).gt.elevmax)elevmax=z(ipt)
         end do
         unestimated=0

         call readparm_1(MAXDIS,MAXSBX,MAXSBY,MAXSBZ,MAXEQ,minpoints,maxpoints,  &
         sradmax_hmax,sradmax_hmin,sradmax_vert,krtype,s_skmean,                 &
         n_nst,c_c0,i_it,c_cc,a_ang1,a_ang2,a_ang3,a_a_hmax,a_a_hmin,a_a_vert,   &
         nnpts,ncol_range,nrow_range,iparmcall)
         iparmcall=0

         call kt3d_1(MAXDIS,MAXSBX,MAXSBY,MAXSBZ,MAXEQ,unestimated,              &
         mmpts,nnpts,ivector1,ivector2,rvector1,rvector2,rvector3,               &
         factorfile,aoutfile,iunit,pmx,                                          &
         ncol_range,nrow_range,emin,emax,nmin,nmax,elevmin,elevmax,af1,af2)
         if(unestimated.ne.0)then
           call utl_num2char(unestimated,anum)
           write(amessage,300) trim(anum)
300        format('Interpolation cannot take place to all target points. The ',     &
           'first element for which interpolation cannot take place is element ',   &
           'number ',a,'. Check that no interpolation source points are ',          &
           'coincident. Check that the search radius is large enough and ',         &
           'that MINPTS is large enough. If you are using a Gaussian variogram, ',  &
           ' then try using another.')
           go to 9890
         end if

       end do zones
       close(unit=iunit)
       go to 9900

9000   write(amessage,9010) trim(varname),trim(function_name)
9010   format('The ',a,' argument of function ',a,' must be greater than zero.')
       go to 9890

9050   write(amessage,9060) trim(varname),trim(function_name)
9060   format('The ',a,' argument of function ',a,' must be supplied as 0 or 1.')
       go to 9890

9070   call utl_num2char(zonenum(izone),anum)
       write(amessage,9080) trim(varname),trim(anum)
9080   format('The value of ',a,' supplied for zone ',a,' is not greater than zero.')
       go to 9890

9100   write(amessage,9110) trim(varname)
9110   format('All elements of the ',a,' array are supplied as zero.')
       go to 9890

9150   write(amessage,9160) trim(facfile)
9160   format('Cannot write to binary factor file ',a,'.')
       go to 9890

9170   write(amessage,9180) trim(facfile)
9180   format('Cannot write to text factor file ',a,'.')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory allocation error in function ',a,'.')
       go to 9890


9890   calc_kriging_factors_3d=1
       icount_interp=0

9900   continue
       if(iunit.ne.0)then
         close(unit=iunit,iostat=ierr)
       end if

       call geostat_3d_dealloc()
       return

end function calc_kriging_factors_3d



integer (kind=c_int) function krige_using_file(factorfile,factorfiletype,      &
                                               npts,mpts,                      &
                                               krigtype,transtype,             &
                                               sourceval,targval,              &
                                               icount_interp,                  &
                                               meanval)                        &
                 bind(C,name="krige_using_file")

! -- This function applies interpolation factors that are calculated by other functions.

       use iso_c_binding, only: c_int,c_char,c_double
       use utilities
       implicit none

       character (kind=c_char,len=1), intent(in) :: factorfile(LENFILENAME) ! file for kriging factors
       integer(kind=c_int), intent(in)           :: factorfiletype          ! 0:binary, 1:text
       integer(kind=c_int), intent(in)           :: npts                    ! number of source points
       integer(kind=c_int), intent(in)           :: mpts                    ! number of target points
       integer(kind=c_int), intent(in)           :: krigtype                ! 0:simple, 1:ordinary  (just a check)
       integer(kind=c_int), intent(in)           :: transtype               ! 1:log,0:none
       real(kind=c_double), intent(in)           :: sourceval(npts)         ! values at sources
       real(kind=c_double), intent(out)          :: targval(mpts)           ! values calculated for targets
       integer(kind=c_int), intent(out)          :: icount_interp           ! number of interpolation pts
       real(kind=c_double), intent(in), optional :: meanval(mpts)           ! mean values (if simple kriging)

! -- Note that mean values are supplied in a dedicated INTENT(IN) array so that they are not over-written
!    if an error condition is encountered midway through the interpolation process.

       integer                     :: iunit,ierr
       integer                     :: nnpts,mmpts
       integer                     :: icellno,j,na
       real                        :: rtemp
       double precision            :: sum,dtemp
       character (len=15)          :: afiletype
       character (len=20)          :: anum,anum1
       character (len=LENFACCODE)  :: acode
       character (len=LENFILENAME) :: facfile

! -- Initialisation

       krige_using_file=0
       function_name='krige_using_file()'
       iunit=0
       icount_interp=0

! -- Character arrays are translated to character variables.

       call utl_string2char(LENFILENAME,factorfile,facfile)
       facfile=adjustl(facfile)

! -- Check input arguments.

       if((transtype.ne.0).and.(transtype.ne.1))then
         write(amessage,100) 'TRANSTYPE',trim(function_name)
100      format('The ',a,' argument of function ',a,' must be ',  &
         'supplied as 0 or 1.')
         go to 9890
       end if
       if((npts.le.0).or.(mpts.le.0))then
         write(amessage,110) trim(function_name)
110      format('The NPTS and MPTS arguments of function ',a,  &
         ' must exceed zero.')
         go to 9890
       end if
       if((krigtype.ne.0).and.(krigtype.ne.1))then
         write(amessage,100) 'KRIGTYPE',trim(function_name)
         go to 9890
       end if
       if(krigtype.eq.0)then
         if(.not.present(meanval))then
           write(amessage,117) trim(function_name)
117        format('If kriging is simple, then a MEANVAL argument must be ',     &
           'supplied for function ',a,'.')
           go to 9890
         end if
       end if

! -- Open the input file.

       iunit=utl_nextunit()
       if(factorfiletype.eq.0)then
         afiletype='binary'
         open(unit=iunit,file=facfile,form='unformatted',access='stream',         &
         status='old',err=9000)
         read(10,err=9050,end=9100)acode
         read(10,err=9050,end=9100)nnpts,mmpts
       else
         afiletype='text'
         open(unit=iunit,file=facfile,status='old',err=9000)
         read(10,'(a)',err=9050,end=9100) acode
         read(10,*,err=9050,end=9100)nnpts,mmpts
       end if

! -- Read the code at the top.

       if((acode(1:2).ne.'2d').and.(acode(1:2).ne.'3d')) go to 9150
       if(acode(3:4).eq.'ks')then
         if(krigtype.ne.0)then
           write(amessage,130) trim(function_name),'1',trim(facfile),'simple'
130        format('The KRIGTYPE argument of function ',a,' is supplied as ',a,    &
           '. However the interpolation factor file ',a,' specifies ',a,' kriging.')
           go to 9890
         end if
       else if(acode(3:4).eq.'ko')then
         if(krigtype.ne.1)then
           write(amessage,130) trim(function_name),'0',trim(facfile),'ordinary'
           go to 9890
         end if
       else
         go to 9150
       end if

! -- Check dimensions

       if((npts.ne.nnpts).or.(mpts.ne.mmpts))then
         write(amessage,140) trim(facfile),trim(function_name)
140      format('The dimensions of the source and target arrays that ', &
         'are specified in file ',a,' are not in agreement with the ',  &
         'NPTS and MPTS arguments supplied to function ',a,'.')
         go to 9890
       end if

! -- Allocate some memory.

       if(utl_allocate_vector('i',1,npts).ne.0) go to 9200
       if(utl_allocate_vector('r',1,npts).ne.0) go to 9200

! -- Now we do the interpolation.

       do
         if(factorfiletype.eq.0)then
           read(iunit,err=9300,end=700) icellno,na,rtemp,(ivector1(j),rvector1(j),j=1,na)
         else
           read(iunit,*,err=9300,end=700) icellno,na,rtemp,(ivector1(j),rvector1(j),j=1,na)
         end if
         if((icellno.lt.0).or.(icellno.gt.mpts))then
           call utl_num2char(icellno,anum)
           write(amessage,142) trim(anum),'TARGVAL',trim(facfile)
142        format('Element number ',a,' of ',a,' array cited in file ',a,' is out of bounds.')
           go to 9890
         end if
         icount_interp=icount_interp+1
         if(krigtype.eq.1)then
           sum=0.0d0
         else
           dtemp=meanval(icellno)
           if(transtype.eq.1)then
             if(dtemp.le.0.0d0) then
               call utl_num2char(icellno,anum)
               call utl_num2char(dtemp,anum1)
               write(amessage,160) trim(function_name),trim(anum1),trim(anum)
160            format('Error in function ',a,': kriging is simple and transformation is ',  &
               'logarithmic. The value of ',a,' supplied for element number ',a,            &
               ' of MEANVAL array is illegal as it must be positive.')
               go to 9890
             end if
             dtemp=log10(dtemp)
           end if
           sum=dtemp*rtemp
         end if
         do j=1,na
           if((ivector1(j).lt.0).or.(ivector1(j).gt.npts))then
             call utl_num2char(ivector1(j),anum)
             write(amessage,161) trim(facfile),trim(anum)
161          format('File ',a,' cites element number ',a,' of SOURCEVAL array. This index ', &
             'is out of bounds.')
             go to 9890
           end if
           if(transtype.eq.0)then
             sum=sum+sourceval(ivector1(j))*rvector1(j)
           else
             dtemp=sourceval(ivector1(j))
             if(dtemp.le.0.0)then
               call utl_num2char(ivector1(j),anum)
               call utl_num2char(dtemp,anum1)
               write(amessage,280) trim(anum),trim(anum1)
280            format('Element number ',a,' of the SOURCEVAL array is ',a,'. This should be ',  &
               'positive as it is used in log-based interpolation.')
               go to 9890
             end if
             sum=sum+log10(dtemp)*rvector1(j)
           end if
         end do
         if(transtype.eq.0)then
           dtemp=sum
         else
           dtemp=10**(sum)
         end if
         targval(icellno)=dtemp
       end do
700    continue

       go to 9900

9000   write(amessage,9010) trim(afiletype),trim(facfile)
9010   format('Cannot open ',a,' factor file ',a,'.')
       go to 9890

9050   write(amessage,9060) trim(afiletype),trim(facfile)
9060   format('Error reading ',a,' factor file ',a,'.')
       go to 9890

9100   write(amessage,9110) trim(afiletype),trim(facfile)
9110   format('Premature end encountered to ',a,' factor file ',a,'.')
       go to 9890

9150   write(amessage,9160) trim(facfile),trim(function_name)
9160   format('File ',a,' is incompatible with function ',a,'.')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory allocation error in function ',a,'.')
       go to 9890

9300   write(amessage,9310) trim(afiletype),trim(facfile)
9310   format('Error encountered while reading interpolation factors from ',a,' interpolation ',   &
       'factor file ',a,'.')
       go to 9890

9890   krige_using_file=1

9900   continue
       if(iunit.ne.0)then
         close(unit=iunit,iostat=ierr)
       end if

       return

end function krige_using_file



integer (kind=c_int) function build_covar_matrix_2d(        &
                              npts,ec,nc,zn,                &
                              vartype,                      &
                              nugget,aa,sill,anis,bearing,  &
                              ldcovmat,covmat)              &
                 bind(C,name="build_covar_matrix_2d")

! -- This function calculates a covariance matrix for a set of 2D pilot points.
!    Variogram specifications can change with pilot point location.
!    Pilot points are assigned to zones. A zone number of zero is not allowed.

       use iso_c_binding, only: c_int,c_double
       use utilities
       implicit none

       integer(kind=c_int), intent(in)         :: npts                  ! number of pilot points
       real(kind=c_double), intent(in)         :: ec(npts),nc(npts)     ! pilot point coords
       integer(kind=c_int), intent(in)         :: zn(npts)              ! pilot point zones
       integer(kind=c_int), intent(in)         :: vartype               ! 1:spher,2:exp,3:gauss,4:pow
       real(kind=c_double), intent(in)         :: nugget(npts)          ! nugget
       real(kind=c_double), intent(in)         :: aa(npts)              ! variogram a
       real(kind=c_double), intent(in)         :: sill(npts)            ! variogram sill
       real(kind=c_double), intent(in)         :: anis(npts)            ! variogram anisotropy
       real(kind=c_double), intent(in)         :: bearing(npts)         ! variogram bearing
       integer(kind=c_int), intent(in)         :: ldcovmat              ! leading dimension of COVMAT
       real(kind=c_double), intent(out)        :: covmat(ldcovmat,npts) ! covariance matrix

       integer, parameter                      :: MAXZONE=10
       logical                                 :: uniform
       integer                                 :: ipt,jpt,kpt,izone,ierr,info
       integer                                 :: m,n,lda,ldu,ldvt,lwork
       integer                                 :: numzone,itemp
       integer                                 :: zone(MAXZONE)
       double precision                        :: e0,n0,dtemp,ecc,ncc
       double precision                        :: vt(1,1)
       character (len=1)                       :: jobu,jobvt
       character (len=10)                      :: anum,anum1,anum2
       character (len=25)                      :: varname

       double precision, allocatable           :: u(:,:)

! -- Variables used by GSLIB library functions (as well as related variables).

       logical                :: first
       integer                :: nst,it(1)
       real                   :: c0,pmx,x1,y1,x2,y2,rtemp1,rtemp2,passmaxcov,cova2
       real                   :: cc(1),ang(1),aaa(1),aanis(1)
       real                   :: oldcc,oldaaa,oldang,oldaanis,oldc0

! -- Initialisation

       build_covar_matrix_2d=0
       function_name='build_covar_matrix_2d()'

! -- Check input arguments.

       if(npts.le.0)then
         varname='NPTS'
         go to 9000
       end if
       if((vartype.lt.1).or.(vartype.gt.4))then
         write(amessage,115) trim(function_name)
115      format('The VARTYPE argument of function ',a,' must be 1,2,3 or 4.')
         go to 9890
       end if
       if(any(zn.eq.0))then
         varname='ZN'
         go to 9100
       end if
       if(ldcovmat.lt.npts)then
         write(amessage,116)
116      format('The value of the LDCOVMAT argument must not be less than that of the NPTS argument.')
         go to 9890
       end if

! -- Establish legitimacy of variogram specifications.

       do ipt=1,npts
         if(anis(ipt).le.0.0d0)then
           write(amessage,170) 'ANIS'
170        format('At least one value in the ',a,' array is zero or negative.')
           go to 9890
         end if
         if((bearing(ipt).lt.-360.0d0).or.(bearing(ipt).gt.360.0d0))then
           write(amessage,175)
175        format('At least one value in the BEARING array is less than -360 or ',  &
           'greater than 360.')
           go to 9890
         end if
         if(nugget(ipt).lt.0.0d0)then
           write(amessage,176) 'NUGGET'
176        format('At least one value in the ',a,' array is negative.')
           go to 9890
         end if
         if(aa(ipt).le.0.0d0)then
           write(amessage,170) 'variogram "a" value'
           go to 9890
         end if
         if(sill(ipt).lt.0.0d0)then
           write(amessage,176) 'SILL'
           go to 9890
         end if
       end do

! -- Build up an array of zone numbers.

       izone=1
       numzone=0
       do ipt=1,npts
         itemp=zn(ipt)
         if(numzone.eq.0)then
           numzone=1
           zone(numzone)=itemp
         else
           if(utl_whichone(numzone,izone,zone,itemp).ne.0)then
             numzone=numzone+1
             if(numzone.gt.MAXZONE)then
               call utl_num2char(MAXZONE,anum)
               write(amessage,150) trim(anum)
150            format('A maximum of only ',a,' different zones can feature in ZN array.')
               go to 9890
             end if
             zone(numzone)=itemp
           end if
         end if
       end do

! -- Test for uniformity

       uniform=.FALSE.
       do izone=1,numzone
         if(.not.utl_uniform_dvector(npts,nugget,zn,zone(izone))) go to 200
         if(.not.utl_uniform_dvector(npts,aa,zn,zone(izone))) go to 200
         if(.not.utl_uniform_dvector(npts,sill,zn,zone(izone))) go to 200
         if(.not.utl_uniform_dvector(npts,anis,zn,zone(izone))) go to 200
         if(.not.utl_uniform_dvector(npts,bearing,zn,zone(izone))) go to 200
       end do
       uniform=.TRUE.
200    continue

! -- See whether any two pilot points are in the same location.

       do ipt=1,npts-1
        ecc=ec(ipt)
        ncc=nc(ipt)
        izone=zn(ipt)
        do jpt=ipt+1,npts
          if(zn(jpt).eq.izone)then
            if(utl_equals(ec(jpt),ecc).and.utl_equals(nc(jpt),ncc))then
              call utl_num2char(ipt,anum1)
              call utl_num2char(jpt,anum2)
              write(amessage,210) trim(anum1),trim(anum2)
210           format('Points ',a,' and ',a,' are at the same location and are ',  &
              'in the same zone.')
              go to 9890
            end if
          end if
        end do
      end do

! -- Fill the covariance matrix.

        pmx=10000.0
        nst=1
        it(1)=vartype
        first=.TRUE.
        do ipt=1,npts
          e0=ec(ipt)
          n0=nc(ipt)
          covmat(ipt,ipt)=sill(ipt)+nugget(ipt)
          if(ipt.ne.npts)then
            izone=zn(ipt)
            x1=0.0
            y1=0.0
            do jpt=ipt+1,npts
              if(zn(jpt).ne.izone)then
                  covmat(jpt,ipt)=0.0
              else
                x2=ec(jpt)-e0
                y2=nc(jpt)-n0
                cc(1)=sill(ipt)
                aaa(1)=aa(ipt)
                ang(1)=bearing(ipt)
                aanis(1)=1.0d0/anis(ipt)
                c0=nugget(ipt)
                oldcc=cc(1)
                oldaaa=aaa(1)
                oldang=ang(1)
                oldaanis=aanis(1)
                oldc0=c0
                rtemp1 = cova2(x1,y1,x2,y2,nst,c0,PMX,cc,aaa,it,  &
                          ang,aanis,first,passmaxcov)
                cc(1)=sill(jpt)
                aaa(1)=aa(jpt)
                ang(1)=bearing(jpt)
                aanis(1)=1.0d0/anis(jpt)
                c0=nugget(jpt)
                if((cc(1).ne.oldcc).or.(aaa(1).ne.oldaaa).or.(ang(1).ne. oldang).or.   &
                  (aanis(1).ne.oldaanis).or.(c0.ne.oldc0))then
                  rtemp2 = cova2(x1,y1,x2,y2,nst,c0,PMX,cc,aaa,it,  &
                            ang,aanis,first,passmaxcov)
                else
                  rtemp2=rtemp1
                end if
                covmat(jpt,ipt)=min(rtemp1,rtemp2)
              end if
            end do
          end if
        end do
        if(npts.gt.1)then
          do ipt=2,npts
            do jpt=1,ipt-1
              covmat(jpt,ipt)=covmat(ipt,jpt)
            end do
          end do
        end if

! -- If necessary, the covariance matrix is now made into a positive definite matrix.

        if(.not.uniform)then
          jobu='A'
          jobvt='N'
          m=npts
          n=npts
          lda=ldcovmat
          ldu=npts
          ldvt=1
          lwork=8*npts
          allocate(u(npts,npts),stat=ierr)
          if(ierr.ne.0) go to 9200
          if(utl_allocate_vector('d',1,npts).ne.0) go to 9200
          if(utl_allocate_vector('d',2,lwork).ne.0) go to 9200
          call dgesvd(jobu,jobvt,m,n,covmat,lda,dvector1,u,ldu,vt,ldvt,dvector2,lwork,info )
          if(info.ne.0)then
            write(amessage,180)
180         format('Unable to conduct singular value decomposition on covariance matrix.')
            go to 9890
          end if
          do ipt=1,npts
            do jpt=1,ipt
              dtemp=0.0d0
              do kpt=1,npts
                dtemp=dtemp+u(ipt,kpt)*u(jpt,kpt)*dvector1(kpt)
              end do
              covmat(ipt,jpt)=dtemp
            end do
          end do
          if(npts.gt.1)then
            do ipt=1,npts-1
              do jpt=ipt+1,npts
                covmat(ipt,jpt)=covmat(jpt,ipt)
              end do
            end do
          end if
        end if

        go to 9900

9000   write(amessage,9010) trim(varname),trim(function_name)
9010   format('The ',a,' argument of function ',a,' must be greater than zero.')
       go to 9890

9100   write(amessage,9110) trim(varname)
9110   format('All elements of the ',a,' array must be supplied as nonzero.')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory allocation error encountered in function ',a,'.')
       go to 9890

9890   build_covar_matrix_2d=1

9900   continue
       if(allocated(u))deallocate(u,stat=ierr)

       return

end function build_covar_matrix_2d



integer (kind=c_int) function build_covar_matrix_3d(        &
                              npts,ec,nc,zc,zn,             &
                              vartype,                      &
                              nugget,sill,                  &
                              ahmax,ahmin,avert,            &
                              bearing,dip,rake,             &
                              ldcovmat,covmat)              &
                 bind(C,name="build_covar_matrix_3d")

! -- This function calculates a covariance matrix for a set of 3D pilot points.
!    Variogram specifications can change with pilot point location.
!    Pilot points are assigned to zones. A zone number of zero is not allowed.

       use iso_c_binding, only: c_int,c_double
       use utilities
       implicit none

       integer(kind=c_int), intent(in)         :: npts                       ! number of pilot points
       real(kind=c_double), intent(in)         :: ec(npts),nc(npts),zc(npts) ! pilot point coords
       integer(kind=c_int), intent(in)         :: zn(npts)              ! pilot point zones
       integer(kind=c_int), intent(in)         :: vartype               ! 1:spher,2:exp,3:gauss,4:pow
       real(kind=c_double), intent(in)         :: nugget(npts)          ! nugget
       real(kind=c_double), intent(in)         :: sill(npts)            ! sill
       real(kind=c_double), intent(in)         :: ahmax(npts),ahmin(npts),avert(npts) ! variogram "a" valies
       real(kind=c_double), intent(in)         :: bearing(npts),dip(npts),rake(npts)  ! variogram angles
       integer(kind=c_int), intent(in)         :: ldcovmat              ! leading dimension of COVMAT
       real(kind=c_double), intent(out)        :: covmat(ldcovmat,npts) ! covariance matrix

       integer, parameter                      :: MAXZONE=10
       logical                                 :: uniform
       integer                                 :: ipt,jpt,kpt,izone,ierr,info,lastzone
       integer                                 :: m,n,lda,ldu,ldvt,lwork
       integer                                 :: numzone,itemp
       integer                                 :: zone(MAXZONE)
       double precision                        :: e0,n0,z0,ecc,ncc,zcc
       double precision                        :: aa1,aa2
       double precision                        :: dtemp,dtemp1,dtemp2
       double precision                        :: vt(1,1)
       double precision                        :: rotmat(1,3,3)
       character (len=1)                       :: jobu,jobvt
       character (len=10)                      :: anum,anum1,anum2
       character (len=25)                      :: varname

       double precision, allocatable           :: u(:,:)

! -- Variables used by GSLIB library functions (as well as related variables).

       integer                :: one
       integer                :: n_nst(1),i_it(1)
       real, parameter        :: EPSLON = 0.000001
       real                   :: pmx
       real                   :: x1,y1,z1,x2,y2,z2
       real                   :: c_c0(1),c_cc(1)
       real                   :: a_ang1(1),a_ang2(1),a_ang3(1)
       real                   :: a_ahmax(1),a_ahmin(1),a_avert(1),aa(1)
       real                   :: anis1(1),anis2(1)
       real                   :: rtemp,covmax

! -- Initialisation

       build_covar_matrix_3d=0
       function_name='build_covar_matrix_3d()'

! -- Check input arguments.

       if(npts.le.0)then
         varname='NPTS'
         go to 9000
       end if
       if((vartype.lt.1).or.(vartype.gt.4))then
         write(amessage,115) trim(function_name)
115      format('The VARTYPE argument of function ',a,' must be 1,2,3 or 4.')
         go to 9890
       end if
       if(any(zn.eq.0))then
         varname='ZN'
         go to 9100
       end if
       if(ldcovmat.lt.npts)then
         write(amessage,116)
116      format('The value of the LDCOVMAT argument must not be less than that of the NPTS argument.')
         go to 9890
       end if

! -- Establish legitimacy of variogram specifications.

       do ipt=1,npts
         if(nugget(ipt).lt.0.0d0)then
           write(amessage,176) 'NUGGET'
176        format('At least one value in the user-supplied ',a,' array is negative.')
           go to 9890
         end if
         if(sill(ipt).lt.0.0d0)then
           write(amessage,176) 'SILL'
           go to 9890
         end if
         if(ahmax(ipt).le.0.0d0)then
           varname='AHMAX'
           go to 9300
         end if
         if(ahmin(ipt).le.0.0d0)then
           varname='AHMIN'
           go to 9300
         end if
         if(avert(ipt).le.0.0d0)then
           varname='AVERT'
           go to 9300
         end if
         if((bearing(ipt).lt.-360.0d0).or.(bearing(ipt).gt.360.0d0))then
           write(amessage,175)
175        format('At least one value in the user-supplied BEARING array is less than -360 '  &
           'degrees or greater than 360 degrees.')
           go to 9890
         end if
         if((dip(ipt).lt.-180.0d0).or.(dip(ipt).gt.180.0d0))then
           write(amessage,181)
181        format('At least one value in the user-supplied DIP array is less than -180 ',  &
           'degrees or greater than 180 degrees.')
           go to 9890
         end if
         if((rake(ipt).lt.-90.0d0).or.(rake(ipt).gt.90.0d0))then
           write(amessage,182)
182        format('At least one value in the user-supplied RAKE array is less -90 ', &
           'degrees or greater than 90 degrees.')
           go to 9890
         end if
       end do

! -- Build up an array of zone numbers.

       izone=1
       numzone=0
       lastzone=huge(lastzone)
       do ipt=1,npts
         itemp=zn(ipt)
         if(itemp.eq.lastzone)cycle
         if(numzone.eq.0)then
           numzone=1
           zone(numzone)=itemp
         else
           if(utl_whichone(numzone,izone,zone,itemp).ne.0)then
             numzone=numzone+1
             if(numzone.gt.MAXZONE)then
               call utl_num2char(MAXZONE,anum)
               write(amessage,150) trim(anum)
150            format('A maximum of only ',a,' different zones can feature in ZN array.')
               go to 9890
             end if
             zone(numzone)=itemp
           end if
         end if
         lastzone=itemp
       end do

! -- Test for uniformity

       uniform=.FALSE.
       do izone=1,numzone
         if(.not.utl_uniform_dvector(npts,nugget,zn,zone(izone))) go to 200
         if(.not.utl_uniform_dvector(npts,sill,zn,zone(izone))) go to 200
         if(.not.utl_uniform_dvector(npts,ahmax,zn,zone(izone))) go to 200
         if(.not.utl_uniform_dvector(npts,ahmin,zn,zone(izone))) go to 200
         if(.not.utl_uniform_dvector(npts,avert,zn,zone(izone))) go to 200
         if(.not.utl_uniform_dvector(npts,bearing,zn,zone(izone))) go to 200
         if(.not.utl_uniform_dvector(npts,dip,zn,zone(izone))) go to 200
         if(.not.utl_uniform_dvector(npts,rake,zn,zone(izone))) go to 200
       end do
       uniform=.TRUE.
200    continue

! -- See whether any two pilot points are in the same location.

       do ipt=1,npts-1
         ecc=ec(ipt)
         ncc=nc(ipt)
         zcc=zc(ipt)
         izone=zn(ipt)
         do jpt=ipt+1,npts
           if(zn(jpt).eq.izone)then
             if(utl_equals(ec(jpt),ecc).and.utl_equals(nc(jpt),ncc).and.   &
                utl_equals(zc(jpt),zcc))then
               call utl_num2char(ipt,anum1)
               call utl_num2char(jpt,anum2)
               write(amessage,210) trim(anum1),trim(anum2)
210            format('Points ',a,' and ',a,' are at the same location and are ',  &
               'in the same zone.')
               go to 9890
             end if
           end if
         end do
       end do

! -- Elements of the covariance matrix are now evaluated.

       one=1
       pmx=10000.0
       n_nst(1)=1
       i_it(1)=vartype
       x1=0.0
       y1=0.0
       z1=0.0
       do ipt=1,npts
         e0=ec(ipt)
         n0=nc(ipt)
         z0=zc(ipt)
         covmat(ipt,ipt)=sill(ipt)+nugget(ipt)
         izone=zn(ipt)
         c_c0(1)=nugget(ipt)
         c_cc(1)=sill(ipt)
         a_ang1(1)=bearing(ipt)
         a_ang2(1)=dip(ipt)
         a_ang3(1)=rake(ipt)
         a_ahmax(1)=ahmax(ipt)
         a_ahmin(1)=ahmin(ipt)
         a_avert(1)=avert(ipt)
         aa(1)=a_ahmax(1)
         aa1  =a_ahmin(1)
         aa2  =a_avert(1)
         anis1(1) = aa1 / max(aa(1),EPSLON)
         anis2(1) = aa2 / max(aa(1),EPSLON)
         call setrot_new(a_ang1(1),a_ang2(1),a_ang3(1),anis1(1),anis2(1),one,one,rotmat)
         do jpt=1,npts
           if(zn(jpt).ne.izone)then
             covmat(jpt,ipt)=0.0d0
           else if(ipt.ne.jpt)then
             x2=ec(jpt)-e0
             y2=nc(jpt)-n0
             z2=zc(jpt)-z0
             call cova3_jd(x1,y1,z1,x2,y2,z2,one,n_nst,one,c_c0,i_it,c_cc,aa,   &
                  one,one,rotmat,covmax,rtemp,PMX)
             covmat(jpt,ipt)=rtemp
           end if
         end do
       end do

! -- We select the smaller of the two covariances calculated between pairs of pilot points.

       if(npts.ne.1)then
         do ipt=1,npts
           do jpt=1,npts-1
             dtemp1=covmat(ipt,jpt)
             dtemp2=covmat(jpt,ipt)
             dtemp=min(dtemp1,dtemp2)
             covmat(ipt,jpt)=dtemp
             covmat(jpt,ipt)=dtemp
           end do
         end do

! -- If necessary,the covariance matrix is now made into a positive definite matrix.

         if(.not.uniform)then
           jobu='A'
           jobvt='N'
           m=npts
           n=npts
           lda=ldcovmat
           ldu=npts
           ldvt=1
           lwork=8*npts
           allocate(u(npts,npts),stat=ierr)
           if(ierr.ne.0) go to 9200
           if(utl_allocate_vector('d',1,npts).ne.0) go to 9200
           if(utl_allocate_vector('d',2,lwork).ne.0) go to 9200
           call dgesvd( jobu,jobvt,m,n,covmat,lda,dvector1,u,ldu,vt,ldvt,dvector2,lwork,info )
           if(info.ne.0)then
             write(amessage,180)
180          format('Unable to conduct singular value decomposition on covariance matrix.')
             go to 9890
           end if
           do ipt=1,npts
             do jpt=1,ipt
               dtemp=0.0d0
               do kpt=1,npts
                 dtemp=dtemp+u(ipt,kpt)*u(jpt,kpt)*dvector1(kpt)
               end do
               covmat(ipt,jpt)=dtemp
             end do
           end do
           do ipt=1,npts-1
             do jpt=ipt+1,npts
               covmat(ipt,jpt)=covmat(jpt,ipt)
             end do
           end do

! -- If two points are in different zones, then we re-instate zero correlation.

           if(numzone.gt.1)then
             do ipt=1,npts-1
               izone=zn(ipt)
               do jpt=ipt+1,npts
                 if(zn(jpt).ne.izone)then
                   covmat(ipt,jpt)=0.0d0
                   covmat(jpt,ipt)=0.0d0
                 end if
               end do
             end do
           end if
         end if
       end if

       go to 9900

9000   write(amessage,9010) trim(varname),trim(function_name)
9010   format('The ',a,' argument of function ',a,' must be greater than zero.')
       go to 9890

9100   write(amessage,9110) trim(varname)
9110   format('All elements of the ',a,' array must be supplied as nonzero.')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory allocation error encountered in function ',a,'.')
       go to 9890

9300   write(amessage,9310) trim(varname)
9310   format('At least one value in the user-supplied ',a,' array is zero or negative.')
       go to 9890

9890   build_covar_matrix_3d=1

9900   continue
       if(allocated(u))deallocate(u,stat=ierr)

       return

end function build_covar_matrix_3d



integer (kind=c_int) function calc_structural_overlay_factors(     &
                     npts,                                         &
                     ecs,ncs,ids,                                  &
                     conwidth,aa,                                  &
                     structype,inverse_power,                      &
                     mpts,                                         &
                     ect,nct,active,                               &
                     factorfile,factorfiletype,                    &
                     icount_interp)                                &
                 bind(C,name="calc_structural_overlay_factors")

! -- This function calculates interpolation/blending factors for structural overlay parameters.

       use iso_c_binding, only: c_int,c_char,c_double
       use utilities
       implicit none

       integer(kind=c_int), intent(in)           :: npts                    ! number of source points
       real(kind=c_double), intent(in)           :: ecs(npts),ncs(npts)     ! source point coordinates
       integer(kind=c_int), intent(in)           :: ids(npts)               ! source point structure number
       real(kind=c_double), intent(in)           :: conwidth(npts),aa(npts) ! blending parameters
       integer(kind=c_int), intent(in)           :: structype               ! 0=polylinear;1=polygonal
       real(kind=c_double), intent(in)           :: inverse_power           ! inverse power of distance
       integer(kind=c_int), intent(in)           :: mpts                    ! number of target points
       real(kind=c_double), intent(in)           :: ect(mpts),nct(mpts)     ! target point coords
       integer(kind=c_int), intent(in)           :: active(mpts)            ! target point activity
       character (kind=c_char,len=1), intent(in) :: factorfile(LENFILENAME) ! file for kriging factors
       integer(kind=c_int), intent(in)           :: factorfiletype          ! 0:binary, 1:text
       integer(kind=c_int), intent(out)          :: icount_interp           ! number of interp points

       logical                       :: lexist,lopened
       integer                       :: i_one,i_two
       integer                       :: iunit,iii_old,iii,jjj,iflag,ierr,i,ii
       integer                       :: ipt,jpt,nc_npts,nc_mpts
       integer                       :: num2,numinlist1
       integer                       :: numstruc,icountmax,icount,istruc,numelem1
       integer                       :: iend1,istart1
       integer                       :: inside,m
       integer                       :: minsector,ielem1,ielem2
       integer                       :: structtype

       real                          :: r_zero
       double precision              :: xx,yy
       double precision              :: mindist,dist,uu,minuu
       double precision              :: cw1,cw2,cw
       double precision              :: alp1,alp2,alp,dist_no_inform,gg,recip_alpha
       double precision              :: sum,dtemp2,dtemp,dtemp1

       character (len=LENFACCODE)    :: acode
       character (len=10)            :: anum
       character (len=25)            :: varname
       character (len=LENFILENAME)   :: facfile

! -- Initialisation

       calc_structural_overlay_factors=0
       function_name='calc_structural_overlay_factors()'
       iunit=0
       i_one=1
       i_two=2
       r_zero=0.0
       icount_interp=0

! -- Character arrays are translated to character variables.

       call utl_string2char(LENFILENAME,factorfile,facfile)
       facfile=adjustl(facfile)

! -- Check input arguments.

       if(npts.le.1)then
         varname='NPTS'
         go to 9000
       end if
       if(mpts.le.1)then
         varname='MPTS'
         go to 9000
       end if
       if(any(conwidth.lt.0.0d0))then
         write(amessage,100) 'CONWIDTH'
100      format('At least one element of the user-supplied ',a,' array is negative.')
         go to 9890
       end if
       if(any(aa.lt.0.0d0))then
         write(amessage,100) 'AA'
         go to 9890
       end if
       if((structype.ne.0).and.(structype.ne.1))then
         write(amessage,110) 'STRUCTYPE'
110      format(a,' must be supplied as 0 or 1.')
         go to 9890
       end if
       if((factorfiletype.ne.0).and.(factorfiletype.ne.1))then
         write(amessage,110) 'FACTORFILETYPE'
         go to 9890
       end if
       if(inverse_power.lt.0.0d0)then
           write(amessage,115)
115        format('The INVERSE_POWER argument must not be negative.')
           go to 9890
       end if
       if(all(active.eq.0))then
         write(amessage,120)
120      format('All elements of the ACTIVE array are zero.')
         go to 9890
       end if

       iii_old=huge(iii_old)
       do ipt=1,npts-1
         iii=ids(ipt)
         if(iii.eq.iii_old)then
           cycle
         else
           iii_old=iii
         end if
         iflag=0
         do jpt=ipt+1,npts
           jjj=ids(jpt)
           if(jjj.ne.iii)then
             iflag=1
           else
             if(iflag.eq.1)then
               write(amessage,130)
130            format('Entries of the same value provided in the IDS array ', &
               'must not be separated by entries of different value.')
               go to 9890
             end if
           end if
         end do
       end do

! -- For conformity with PLPROC.

       structtype=structype+1

! -- We find the number of elements to which interpolation/blending will take place.

       num2=0
       do ipt=1,mpts
         if(active(ipt).ne.0) num2=num2+1
       end do

! -- We find the maximum number of elements in any structure and count the number of structures.

       numstruc=0
       icountmax=0
       icount=0
       jjj=huge(jjj)
       do ipt=1,npts
         iii=ids(ipt)
         if(iii.ne.jjj)then
           numstruc=numstruc+1
           if(icount.gt.icountmax)icountmax=icount
           icount=0
           jjj=iii
         end if
         icount=icount+1
       end do
       if(icount.gt.icountmax)icountmax=icount
       num2=num2*numstruc        ! The number of lines that will appear in the factor file.
                                 ! Don't forget that interpolation is repeated for each overlay structure.

! -- Establish acode.

       acode='2dbl'

! -- We open the factor file. However if a binary file is requested, and the file is present
!    it is deleted.

       iunit=utl_nextunit()
       if(factorfiletype.eq.0)then
         inquire(file=facfile,exist=lexist)
         if(lexist)then
           open(unit=iunit,file=facfile,form='unformatted',access='stream',   &
           action='write',iostat=ierr)
           close(unit=iunit,status='delete',iostat=ierr)
         end if
         open(unit=iunit,file=facfile,form='unformatted',access='stream',   &
         action='write',err=9150)
       else
         open(unit=iunit,file=facfile,action='write',err=9170)
       end if

! -- Write a header to the file.

       nc_npts=npts             ! just in case of problems where a file is binary
       nc_mpts=mpts
       if(factorfiletype.eq.0)then
         write(iunit,err=9150) acode
         write(iunit,err=9150) nc_npts,nc_mpts,num2
       else
         write(iunit,220,err=9170) trim(acode)
220      format(a)
         write(iunit,230,err=9170) nc_npts,nc_mpts,num2
230      format(3i10)
       end if

! -- Allocate some memory.

       if(utl_allocate_vector('d',1,icountmax+2).ne.0) go to 9200
       if(utl_allocate_vector('d',2,icountmax+2).ne.0) go to 9200
       if(utl_allocate_vector('d',3,icountmax+2).ne.0) go to 9200
       if(utl_allocate_vector('i',1,icountmax+2).ne.0) go to 9200

! -- The big loop starts here.

       iend1=0
       do istruc=1,numstruc
         istart1=iend1+1
         if(numstruc.eq.1)then
           iend1=npts
         else
           iii=ids(istart1)
           if(istruc.eq.numstruc)then
             iend1=npts
           else
             do ipt=istart1,npts
               if(ids(ipt).ne.iii)then
                 iend1=ipt-1
                 go to 269
               end if
             end do
           end if
269        continue
         end if
         numelem1=iend1-istart1+1

         if(utl_equals(ecs(istart1),ecs(iend1)).and.      &
            utl_equals(ncs(istart1),ncs(iend1)))then
            call utl_num2char(iii,anum)
            write(amessage,270) trim(anum)
270         format('The first and last vertices of structure with index ',a,' have ',   &
            'the same east and north coordinates. This is not allowed.')
            go to 9890
         end if
         if(structtype.eq.2)then
           if(numelem1.lt.3)then
             call utl_num2char(iii,anum)
             write(amessage,285) trim(anum)
285          format('The polygonal structure with index ',a,' has only two points. ',    &
             'A polygon cannot be formed.')
             go to 9890
           end if
         end if

! -- Source coordinates are stored in DVECTORs.

         numinlist1=iend1-istart1+1
         if(structtype.eq.2)numinlist1=numinlist1+1
         dvector3=0.0d0           ! an array
         ii=0
         do ipt=istart1,iend1
           ii=ii+1
           dvector1(ii)=ecs(ipt)
           dvector2(ii)=ncs(ipt)
           ivector1(ii)=ipt
         end do
         if(structtype.eq.2)then
           dvector1(numinlist1)=ecs(istart1)
           dvector2(numinlist1)=ncs(istart1)
           ivector1(numinlist1)=istart1
         end if

! -- The work is now done.

         do ipt=1,mpts
           if(active(ipt).ne.0)then
             xx=ect(ipt)
             yy=nct(ipt)

! -- Is the target point inside the polygon?

             inside=-1
             if(structtype.eq.2)then
               call utl_locpt(xx,yy,dvector1,dvector2,numinlist1,inside,m)
             end if

             if(inside.lt.0)then
! -- So either structtype is 1 or the point is outside the polygon.
! -- We find the segment that the point is closest to.
               mindist=1.0d300
               do i=1,numinlist1-1
                 dist=utl_distance_to_segment(     &
                 dvector1(i),dvector2(i),dvector1(i+1),dvector2(i+1),xx,yy,uu)
                 if(dist.lt.mindist)then
                   mindist=dist
                   minsector=i
                   minuu=uu
                 end if
               end do
               if(minuu.lt.0.0d0)minuu=0.0d0
               if(minuu.gt.1.0d0)minuu=1.0d0
               ielem1=ivector1(minsector)
               ielem2=ivector1(minsector+1)
               cw1=conwidth(ielem1)
               cw2=conwidth(ielem2)
               cw=(1.0d0-minuu)*cw1+minuu*cw2
               cw=cw*0.5
               alp1=aa(ielem1)
               alp2=aa(ielem2)
               alp=(1.0d0-minuu)*alp1+minuu*alp2
               dist_no_inform=cw+alp*sqrt(-log(1.0d-30))       !   1e-30 is arbitrary
               if(dist_no_inform.eq.0.0d0)then
                 if(mindist.eq.0.0d0)then
                   gg=1.0d0
                 else
                   gg=0.0d0
                 end if
               else
                 if(mindist.gt.dist_no_inform)then
                   gg=0.0d0
                 else if(mindist.lt.cw)then
                   gg=1.0d0
                 else
                   if(alp.gt.0.0d0)then
                     recip_alpha=1.0d0/alp
                     dtemp=(mindist-cw)*recip_alpha
                     gg=exp(-dtemp*dtemp)
                   else
                     gg=0.0d0
                   end if
                 end if
               end if
             else
               gg=1.0d0
             end if
             if(structtype.eq.1)then
! -- We do a secondary inverse power of distance interpolation to supplement the interpolation that has already been done.
!    This gets rid of discontinuties on lines that bisect the inside of bends.
               dvector3=0.0 ! for safety
               sum=0.0d0
               do i=1,numelem1
                 dtemp1=xx-dvector1(i)
                 dtemp2=yy-dvector2(i)
                 dist=sqrt(dtemp1*dtemp1+dtemp2*dtemp2)
                 if(abs(dist).lt.1.0d-30) then
                   dvector3(i)=1.0d30
                 else
                   dvector3(i)=min(1.0d0/(dist**inverse_power),1.0e30)
                 end if
                 sum=sum+dvector3(i)
               end do
               if(abs(mindist).lt.1.0d-30)then
                 dtemp=1.0d30
               else
                 dtemp=min(1.0d0/(mindist**inverse_power),1.0d30)
               end if
               dvector3(minsector)=dvector3(minsector)+(1.0d0-minuu)*dtemp
               dvector3(minsector+1)=dvector3(minsector+1)+minuu*dtemp
               sum=sum+dtemp
               if(sum.gt.0.0d0)sum=1.0d0/sum
               do i=1,numelem1
                 dvector3(i)=dvector3(i)*sum
               end do
               do i=1,numelem1
                 dvector3(i)=dvector3(i)*gg
               end do
               if(factorfiletype.eq.0)then
                 write(iunit,err=9600) ipt,numelem1,r_zero,       &
                 (ivector1(i),dvector3(i),i=1,numelem1)
               else
                 write(iunit,310,err=9600) ipt,numelem1,r_zero,   &
                 (ivector1(i),dvector3(i),i=1,numelem1)
               end if
             else if(structtype.eq.2)then
! -- Undertake inverse power of distance interpolation regardless of whether we are
!    inside or outside of the polygon.
               sum=0.0d0
               do i=1,numelem1
                 dtemp1=xx-dvector1(i)
                 dtemp2=yy-dvector2(i)
                 dist=sqrt(dtemp1*dtemp1+dtemp2*dtemp2)
                 if(abs(dist).lt.1.0d-30) then
                   dvector3(i)=1.0d30
                 else
                   dvector3(i)=min(1.0d0/(dist**inverse_power),1.0d30)
                 end if
                 sum=sum+dvector3(i)
               end do
               if(sum.gt.0.0d0)sum=1.0d0/sum
               do i=1,numelem1
                 dvector3(i)=dvector3(i)*sum
               end do
               do i=1,numelem1
                 dvector3(i)=dvector3(i)*gg
               end do
               if(factorfiletype.eq.0)then
                 write(iunit,err=9600) ipt,numelem1,r_zero,       &
                 (ivector1(i),dvector3(i),i=1,numelem1)
               else
                 write(iunit,310,err=9600) ipt,numelem1,r_zero,   &
                 (ivector1(i),dvector3(i),i=1,numelem1)
310              format(2i10,1pg14.7,10000(i10,2x,1pg17.10))
               end if
             end if
           end if
         end do

       end do
       icount_interp=num2
       close(unit=iunit)
       go to 9900

9000   write(amessage,9010) trim(varname),trim(function_name)
9010   format('The ',a,' argument of function ',a,' must be greater than one.')
       go to 9890

9150   write(amessage,9160) trim(facfile)
9160   format('Cannot write to binary factor file ',a,'.')
       go to 9890

9170   write(amessage,9180) trim(facfile)
9180   format('Cannot write to text factor file ',a,'.')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory allocation error in function ',a,'.')
       go to 9890

9600   continue
       write(amessage,9650) trim(facfile)
9650   format('Cannot write interpolation factors to file ',a,'.')
       go to 9890

9890   calc_structural_overlay_factors=1
       if(iunit.ne.0)then
         inquire(unit=iunit,opened=lopened)
         if(lopened) then
           close(unit=iunit,iostat=ierr,status='delete')
         end if
       end if

9900   continue
       return

end function calc_structural_overlay_factors




integer (kind=c_int) function interpolate_blend_using_file(                    &
                                               factorfile,factorfiletype,      &
                                               npts,mpts,                      &
                                               transtype,                      &
                                               lt_target,gt_target,            &
                                               sourceval,targval,              &
                                               icount_interp)                  &
                 bind(C,name="interpolate_blend_using_file")

! -- This function applies interpolation factors calculated by function calc_structural_overlay_factors.

       use iso_c_binding, only: c_int,c_char,c_double
       use utilities
       implicit none

       character (kind=c_char,len=1), intent(in) :: factorfile(LENFILENAME) ! file for kriging factors
       integer(kind=c_int), intent(in)           :: factorfiletype          ! 0:binary, 1:text
       integer(kind=c_int), intent(in)           :: npts                    ! dimension of sourceval array
       integer(kind=c_int), intent(in)           :: mpts                    ! dimension of targval array
       integer(kind=c_int), intent(in)           :: transtype               ! 1:log,0:none
       character (kind=c_char,len=1), intent(in) :: lt_target,gt_target     ! whether to undercut or exceed target
       real(kind=c_double), intent(in)           :: sourceval(npts)         ! values at sources
       real(kind=c_double), intent(inout)        :: targval(mpts)           ! values at targets
       integer(kind=c_int), intent(out)          :: icount_interp           ! number of interpolation pts

       integer                     :: iunit,ierr
       integer                     :: nnpts,mmpts
       integer                     :: icellno,i,j,na,ivj
       integer                     :: ilow,ihigh,num2
       real                        :: rtemp
       double precision            :: sum,rtemp1,rtemp2,dval0
       character (len=15)          :: afiletype
       character (len=LENFACCODE)  :: acode
       character (len=LENFILENAME) :: facfile

! -- Initialisation

       interpolate_blend_using_file=0
       function_name='interpolate_blend_using_file()'
       iunit=0
       icount_interp=0

! -- Character arrays are translated to character variables.

       call utl_string2char(LENFILENAME,factorfile,facfile)
       facfile=adjustl(facfile)

! -- Check input arguments.

       if((transtype.ne.0).and.(transtype.ne.1))then
         write(amessage,100) 'TRANSTYPE',trim(function_name)
100      format('The ',a,' argument of function ',a,' must be ',  &
         'supplied as 0 or 1.')
         go to 9890
       end if
       if((factorfiletype.ne.0).and.(factorfiletype.ne.1))then
         write(amessage,100) 'FACTORFILETYPE',trim(function_name)
         go to 9890
       end if
       if((npts.le.0).or.(mpts.le.0))then
         write(amessage,110) trim(function_name)
110      format('The NPTS and MPTS arguments of function ',a,  &
         ' must exceed zero.')
         go to 9890
       end if
       if((lt_target.eq.'y').or.(lt_target.eq.'Y'))then
         ilow=1
       else if((lt_target.eq.'n').or.(lt_target.eq.'N'))then
         ilow=0
       else
         write(amessage,120) 'LT_TARGET',trim(function_name)
120      format('The value supplied for the ',a,' argument of function ',a,    &
         ' must be "y" or "n".')
         go to 9890
       end if
       if((gt_target.eq.'y').or.(gt_target.eq.'Y'))then
         ihigh=1
       else if((gt_target.eq.'n').or.(gt_target.eq.'N'))then
         ihigh=0
       else
         write(amessage,120) 'GT_TARGET',trim(function_name)
         go to 9890
       end if

! -- Open the input file.

       iunit=utl_nextunit()
       if(factorfiletype.eq.0)then
         afiletype='binary'
         open(unit=iunit,file=facfile,form='unformatted',access='stream',         &
         status='old',err=9000)
         read(iunit,err=9050,end=9100)acode
       else
         afiletype='text'
         open(unit=iunit,file=facfile,status='old',err=9000)
         read(iunit,'(a)',err=9050,end=9100) acode
       end if

! -- Read the code at the top.

       if((acode(1:2).ne.'2d').and.(acode(1:2).ne.'3d')) go to 9150
       if(acode(3:4).ne.'bl') go to 9150

! -- Read and check dimensions

       if(factorfiletype.eq.0)then
         read(iunit,err=9050,end=9100)nnpts,mmpts,num2
       else
         read(iunit,*,err=9050,end=9100)nnpts,mmpts,num2
       end if
       if((npts.ne.nnpts).or.(mpts.ne.mmpts))then
         write(amessage,140) trim(facfile),trim(function_name)
140      format('The dimensions of the source and/or target arrays that ', &
         'are specified in file ',a,' are not in agreement with the ',     &
         'NPTS and MPTS arguments supplied to function ',a,'.')
         go to 9890
       end if

! -- Allocate some memory.

       if(utl_allocate_vector('i',1,npts).ne.0) go to 9200
       if(utl_allocate_vector('d',3,npts).ne.0) go to 9200

! -- Now we do the interpolation.

       do i=1,num2
         if(factorfiletype.eq.0)then
           read(iunit,err=9300,end=9350) icellno,na,rtemp,(ivector1(j),dvector3(j),j=1,na)
         else
           read(iunit,*,err=9300,end=9350) icellno,na,rtemp,(ivector1(j),dvector3(j),j=1,na)
         end if
         if((icellno.lt.1).or.(icellno.gt.mpts)) go to 9400
         dval0=targval(icellno)
         if(transtype.eq.1)then
           if(dval0.le.0.0d0)then
             write(amessage,280) 'TARGVAL'
             go to 9890
           end if
           dval0=log10(dval0)
         end if
         sum=0.0d0
         do j=1,na
           ivj=ivector1(j)
           if((ivj.lt.1).or.(ivj.gt.npts)) go to 9400
           if(transtype.eq.0)then
             sum=sum+(sourceval(ivj)-dval0)*dvector3(j)
           else
             rtemp2=sourceval(ivj)
             if(rtemp2.le.0.0)then
               write(amessage,280) 'SOURCEVAL'
280            format('At least one element value of the ',a,' array is negative. ', &
               'TRANSTYPE cannot therefore be supplied as 1; it must be supplied as 0.')
               go to 9890
             end if
             sum=sum+(log10(rtemp2)-dval0)*dvector3(j)
           end if
         end do
         if(ihigh.eq.0)then
           rtemp1=min(sum+dval0,dval0)
         else if(ilow.eq.0)then
           rtemp1=max(sum+dval0,dval0)
         else
           rtemp1=sum+dval0
         end if
         if(transtype.eq.1)then
           if(rtemp1.gt.300)then
             write(amessage,290)
290          format('Out of range value calculated for target array.')
             go to 9890
           end if
           rtemp1=10**(rtemp1)
         end if
         targval(icellno)=rtemp1
       end do
       icount_interp=num2
       go to 9900

9000   write(amessage,9010) trim(afiletype),trim(facfile)
9010   format('Cannot open ',a,' factor file ',a,'.')
       go to 9890

9050   write(amessage,9060) trim(afiletype),trim(facfile)
9060   format('Error reading ',a,' factor file ',a,'.')
       go to 9890

9100   write(amessage,9110) trim(afiletype),trim(facfile)
9110   format('Premature end encountered to ',a,' factor file ',a,'.')
       go to 9890

9150   write(amessage,9160) trim(facfile),trim(function_name)
9160   format('File ',a,' is incompatible with function ',a,'.')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory allocation error in function ',a,'.')
       go to 9890

9300   write(amessage,9310) trim(afiletype),trim(facfile)
9310   format('Error encountered while reading interpolation factors from ',a,' interpolation ',   &
       'factor file ',a,'.')
       go to 9890

9350   write(amessage,9360) trim(afiletype),trim(facfile)
9360   format('Premature end encountered while reading interpolation factors from ',a,   &
       ' interpolation factor file ',a,'.')
       go to 9890

9400   write(amessage,9410) trim(afiletype),trim(facfile)
9410   format('Out-of-range array index encounted while reading ',a,' factor file ',a,'.')
       go to 9890

9890   interpolate_blend_using_file=1

9900   continue
       if(iunit.ne.0)then
         close(unit=iunit,iostat=ierr)
       end if

       return

end function interpolate_blend_using_file


integer (kind=c_int) function ipd_interpolate_2d(npts,             &
                                        ecs,ncs,zns,sourceval,     &
                                        mpts,                      &
                                        ect,nct,znt,targval,       &
                                        transtype,                 &
                                        anis,bearing,invpow)       &
                 bind(C,name="ipd_interpolate_2d")

! -- This function undertakes 2D inverse-power-of-distance spatial interpolation.

       use iso_c_binding, only: c_int,c_double
       use dimvar
       use utilities
       implicit none

       integer(kind=c_int), intent(in)           :: npts                    ! number of source points
       real(kind=c_double), intent(in)           :: ecs(npts),ncs(npts)     ! source point coordinates
       integer(kind=c_int), intent(in)           :: zns(npts)               ! source point zones
       real(kind=c_double), intent(in)           :: sourceval(npts)         ! source values
       integer(kind=c_int), intent(in)           :: mpts                    ! number of target points
       real(kind=c_double), intent(in)           :: ect(mpts),nct(mpts)     ! target point coords
       integer(kind=c_int), intent(in)           :: znt(mpts)               ! target point zones
       real(kind=c_double), intent(out)          :: targval(mpts)           ! target (i.e. interpolated) values
       integer(kind=c_int), intent(in)           :: transtype               ! 1:log,0:none
       real(kind=c_double), intent(in)           :: anis(mpts)              ! local anisotropy
       real(kind=c_double), intent(in)           :: bearing(mpts)           ! local anisotropy bearing
       real(kind=c_double), intent(in)           :: invpow(mpts)            ! local inverse power of distance

       integer, parameter  :: MAXZONE=20

       integer                     :: zone(MAXZONE)
       integer                     :: ipt,jpt
       integer                     :: izone,numzone
       integer                     :: iii,itemp
       double precision            :: dtor,power
       double precision            :: x1,y1,x2,y2
       double precision            :: aan,angle,cosang,sinang
       double precision            :: den,num
       double precision            :: dx,dy,dtempx,dtempy,dxs,dys,dists,dtemp,fac
       character (len=25)          :: anum,varname

! -- Initialisation

       ipd_interpolate_2d=0
       function_name='ipd_interpolate_2d()'
       dtor=3.1415926535898d0/180.0d0

! -- Check input arguments.

       if((transtype.ne.0).and.(transtype.ne.1))then
         write(amessage,100) 'TRANSTYPE',trim(function_name)
100      format('The ',a,' argument of function ',a,' must be ',  &
         'supplied as 0 or 1.')
         go to 9890
       end if
       if(npts.le.0)then
         varname='NPTS'
         go to 9000
       end if
       if(mpts.le.0)then
         varname='MPTS'
         go to 9000
       end if
       if(all(zns.eq.0))then
         varname='ZNS'
         go to 9100
       end if
       if(all(znt.eq.0))then
         varname='ZNT'
         go to 9100
       end if
       do ipt=1,mpts
         if(znt(ipt).ne.0)then
           if(anis(ipt).le.0.0d0)then
             write(amessage,170)
170          format('At least one ANIS value is zero or negative for a target point to ',  &
             'which interpolation is required.')
             go to 9890
           end if
           if((bearing(ipt).lt.-360.0d0).or.(bearing(ipt).gt.360.0d0))then
             write(amessage,180)
180          format('At least one BEARING value is less than -360 or greater than ',  &
             '360 for a target point to which interpolation is required.')
             go to 9890
           end if
           if(invpow(ipt).lt.0.0d0)then
             write(amessage,181)
181          format('At least one INVPOW value is less than zero ',                   &
             'for a target point to which interpolation is required.')
             go to 9890
           end if
         end if
       end do
       if(transtype.eq.1)then
         do ipt=1,npts
           if(zns(ipt).ne.0)then
             if(sourceval(ipt).le.0.0d0)then
               write(amessage,190)
190            format('If TRANSTYPE is set to 1 then all source values in non-zero ',  &
               'zones must be positive.')
               go to 9890
             end if
           end if
         end do
       end if

! -- Build up an array of zone numbers.

       izone=1
       numzone=0
       do ipt=1,mpts
         itemp=znt(ipt)
         if(itemp.ne.0)then
           if(numzone.eq.0)then
             numzone=1
             zone(numzone)=itemp
           else
             if(utl_whichone(numzone,izone,zone,itemp).ne.0)then
               numzone=numzone+1
               if(numzone.gt.MAXZONE)then
                 call utl_num2char(MAXZONE,anum)
                 write(amessage,150) trim(anum)
150              format('A maximum of only ',a,' different zones can feature in the ZNT array.')
                 go to 9890
               end if
               zone(numzone)=itemp
             end if
           end if
         end if
       end do

! -- Check that all zones in the target array are respected in the source array.

       do izone=1,numzone
         itemp=zone(izone)
         do ipt=1,npts
           if(zns(ipt).eq.itemp) go to 165
         end do
         call utl_num2char(itemp,anum)
         write(amessage,160) trim(anum)
160      format('Zone ',a,' from the ZNT array is not represented in the ZNS array.')
         go to 9890
165      continue
       end do

! -- Now we do the interpolation.

       zones: do izone=1,numzone
         iii=zone(izone)
         targpoints: do ipt=1,mpts
           if(znt(ipt).eq.iii)then
             x1=ect(ipt)
             y1=nct(ipt)
             aan=anis(ipt)
             angle=90.0d0-bearing(ipt)+90.0d0
             cosang=cos(angle*dtor)
             sinang=sin(angle*dtor)
             power=sqrt(invpow(ipt))
             den=0.0d0
             num=0.0d0
             do jpt=1,npts
               if(zns(jpt).eq.iii)then
                 x2=ecs(jpt)
                 y2=ncs(jpt)
                 dx=x2-x1
                 dy=y2-y1
                 dtempx=dx*cosang+dy*sinang
                 dtempy=-dx*sinang+dy*cosang
                 dtempx=dtempx*aan
                 dxs=dtempx*dtempx
                 dys=dtempy*dtempy
                 dists=dxs+dys
                 if(dists.lt.1.0d-30)then
                   fac=1.0d30
                 else
                   fac=1.0d0/(dists**power)
                 end if
                 if(transtype.eq.0)then
                   num=num+fac*sourceval(jpt)
                 else
                   num=num+fac*log(sourceval(jpt))
                 end if
                 den=den+fac
               end if
             end do
             dtemp=num/den
             if(transtype.eq.1)dtemp=exp(dtemp)
             targval(ipt)=dtemp
           end if
         end do targpoints
       end do zones

       go to 9900

9000   write(amessage,9010) trim(varname),trim(function_name)
9010   format('The ',a,' argument of function ',a,' must be greater than zero.')
       go to 9890

9100   write(amessage,9110) trim(varname)
9110   format('All elements of the ',a,' array are supplied as zero.')
       go to 9890

9890   ipd_interpolate_2d=1

9900   continue

       return

end function ipd_interpolate_2d



integer (kind=c_int) function ipd_interpolate_3d(npts,                &
                                        ecs,ncs,zcs,zns,sourceval,    &
                                        mpts,                         &
                                        ect,nct,zct,znt,targval,      &
                                        transtype,                    &
                                        ahmax,ahmin,avert,            &
                                        bearing,dip,rake,             &
                                        invpow)                       &
                 bind(C,name="ipd_interpolate_3d")

! -- This function undertakes 3D inverse-power-of-distance spatial interpolation.

       use iso_c_binding, only: c_int,c_double
       use dimvar
       use utilities
       implicit none

       integer(kind=c_int), intent(in)    :: npts                                ! number of source points
       real(kind=c_double), intent(in)    :: ecs(npts),ncs(npts),zcs(npts)       ! source point coordinates
       integer(kind=c_int), intent(in)    :: zns(npts)                           ! source point zones
       real(kind=c_double), intent(in)    :: sourceval(npts)                     ! source values
       integer(kind=c_int), intent(in)    :: mpts                                ! number of target points
       real(kind=c_double), intent(in)    :: ect(mpts),nct(mpts),zct(mpts)       ! target point coords
       integer(kind=c_int), intent(in)    :: znt(mpts)                           ! target point zones
       real(kind=c_double), intent(out)   :: targval(mpts)                       ! target (i.e. interpolated) values
       integer(kind=c_int), intent(in)    :: transtype                           ! 1:log,0:none
       real(kind=c_double), intent(in)    :: ahmax(mpts),ahmin(mpts),avert(mpts) ! relative correlation lengths
       real(kind=c_double), intent(in)    :: bearing(mpts),dip(mpts),rake(mpts)  ! correlation directions
       real(kind=c_double), intent(in)    :: invpow(mpts)                        ! local inverse power of distance

       integer, parameter  :: MAXZONE=10

       integer                     :: zone(MAXZONE)
       integer                     :: ipt,jpt
       integer                     :: izone,numzone
       integer                     :: iii,itemp
       double precision            :: pidiv180,power,angle
       double precision            :: x1,y1,z1
       double precision            :: cosang1,cosang2,cosang3
       double precision            :: sinang1,sinang2,sinang3
       double precision            :: den_along,den_along2,den_amid,den_amid2, &
                                      den_avert,den_avert2
       double precision            :: xdiff,ydiff,zdiff
       double precision            :: xd,yd,zd,xdd,ydd,zdd
       double precision            :: dlong,dmid,dvert
       double precision            :: dtemp,dtemp1,dtemp2,dtemp3
       double precision            :: den,num,fac
       character (len=25)          :: anum,varname

! -- Initialisation

       ipd_interpolate_3d=0
       function_name='ipd_interpolate_3d()'
       pidiv180=3.1415926535898d0/180.0d0

! -- Check input arguments.

       if((transtype.ne.0).and.(transtype.ne.1))then
         write(amessage,100) 'TRANSTYPE',trim(function_name)
100      format('The ',a,' argument of function ',a,' must be ',  &
         'supplied as 0 or 1.')
         go to 9890
       end if
       if(npts.le.0)then
         varname='NPTS'
         go to 9000
       end if
       if(mpts.le.0)then
         varname='MPTS'
         go to 9000
       end if
       if(all(zns.eq.0))then
         varname='ZNS'
         go to 9100
       end if
       if(all(znt.eq.0))then
         varname='ZNT'
         go to 9100
       end if
       do ipt=1,mpts
         if(znt(ipt).ne.0)then
           if(ahmax(ipt).le.0.0d0)then
             write(amessage,170) 'AHMAX'
170          format('At least one ',a,' value is zero or negative for a target point to ',  &
             'which interpolation is required.')
             go to 9890
           end if
           if(ahmin(ipt).le.0.0d0)then
             write(amessage,170) 'AHMIN'
             go to 9890
           end if
           if(avert(ipt).le.0.0d0)then
             write(amessage,170) 'AVERT'
             go to 9890
           end if
           if((bearing(ipt).lt.-360.0d0).or.(bearing(ipt).gt.360.0d0))then
             write(amessage,180)
180          format('At least one BEARING value is less than -360 degrees or greater than ',  &
             '360 degrees for a target point to which interpolation is required.')
             go to 9890
           end if
           if((dip(ipt).lt.-180.0d0).or.(dip(ipt).gt.180.0d0))then
             write(amessage,185)
185          format('At least one DIP value is less than -180 degrees or greater than ',  &
             '180 degrees for a target point to which interpolation is required.')
             go to 9890
           end if
           if((rake(ipt).lt.-90.0d0).or.(rake(ipt).gt.90.0d0))then
             write(amessage,186)
186          format('At least one RAKE value is less than -90 degrees or greater than ',  &
             '90 degrees for a target point to which interpolation is required.')
             go to 9890
           end if
           if(invpow(ipt).lt.0.0d0)then
             write(amessage,181)
181          format('At least one INVPOW value is less than zero ',                   &
             'for a target point to which interpolation is required.')
             go to 9890
           end if
         end if
       end do
       if(transtype.eq.1)then
         do ipt=1,npts
           if(zns(ipt).ne.0)then
             if(sourceval(ipt).le.0.0d0)then
               write(amessage,190)
190            format('If TRANSTYPE is set to 1 then all SOURCEVAL values in non-zero ',  &
               'zones must be positive.')
               go to 9890
             end if
           end if
         end do
       end if

! -- Build up an array of zone numbers.

       izone=1
       numzone=0
       do ipt=1,mpts
         itemp=znt(ipt)
         if(itemp.ne.0)then
           if(numzone.eq.0)then
             numzone=1
             zone(numzone)=itemp
           else
             if(utl_whichone(numzone,izone,zone,itemp).ne.0)then
               numzone=numzone+1
               if(numzone.gt.MAXZONE)then
                 call utl_num2char(MAXZONE,anum)
                 write(amessage,150) trim(anum)
150              format('A maximum of only ',a,' different zones can feature in the ZNT array.')
                 go to 9890
               end if
               zone(numzone)=itemp
             end if
           end if
         end if
       end do

! -- Check that all zones in the target array are respected in the source array.

       do izone=1,numzone
         itemp=zone(izone)
         do ipt=1,npts
           if(zns(ipt).eq.itemp) go to 165
         end do
         call utl_num2char(itemp,anum)
         write(amessage,160) trim(anum)
160      format('Zone ',a,' from the ZNT array is not represented in the ZNS array.')
         go to 9890
165      continue
       end do

! -- Now we do the interpolation.

       zones: do izone=1,numzone
         iii=zone(izone)
         targpoints: do ipt=1,mpts
           if(znt(ipt).eq.iii)then
             x1=ect(ipt)
             y1=nct(ipt)
             z1=zct(ipt)
             angle=90.0d0-bearing(ipt)
             cosang1=cos(angle*pidiv180)
             sinang1=sin(angle*pidiv180)
             cosang2=cos(dip(ipt)*pidiv180)
             sinang2=sin(dip(ipt)*pidiv180)
             cosang3=cos(rake(ipt)*pidiv180)
             sinang3=sin(rake(ipt)*pidiv180)
             den_along=1.0d0
             den_along2=1.0d0
             den_amid=ahmax(ipt)/ahmin(ipt)
             den_amid2=den_amid*den_amid
             den_avert=ahmax(ipt)/avert(ipt)
             den_avert2=den_avert*den_avert
             power=sqrt(invpow(ipt))
             den=0.0d0
             num=0.0d0
             do jpt=1,npts
               if(zns(jpt).eq.iii)then
                 xdiff=ecs(jpt)-x1
                 ydiff=ncs(jpt)-y1
                 zdiff=zcs(jpt)-z1
                 xd=xdiff*cosang1+ydiff*sinang1
                 yd=-xdiff*sinang1+ydiff*cosang1
                 zd=zdiff
                 xdd=xd*cosang2+zd*sinang2
                 ydd=yd
                 zdd=-xd*sinang2+zd*cosang2
                 dlong=xdd
                 dmid=ydd*cosang3+zdd*sinang3
                 dvert=-ydd*sinang3+zdd*cosang3
                 dtemp1=dlong*dlong*den_along2
                 dtemp2=dmid*dmid*den_amid2
                 dtemp3=dvert*dvert*den_avert2
                 dtemp=dtemp1+dtemp2+dtemp3
                 if(dtemp.lt.1.0d-30)then
                   fac=1.0d30
                 else
                   fac=1.0d0/(dtemp**power)
                 end if
                 if(transtype.eq.0)then
                   num=num+fac*sourceval(jpt)
                 else
                   num=num+fac*log(sourceval(jpt))
                 end if
                 den=den+fac
               end if
             end do
             dtemp=num/den
             if(transtype.eq.1)dtemp=exp(dtemp)
             targval(ipt)=dtemp
           end if
         end do targpoints
       end do zones
       go to 9900

9000   write(amessage,9010) trim(varname),trim(function_name)
9010   format('The ',a,' argument of function ',a,' must be greater than zero.')
       go to 9890

9100   write(amessage,9110) trim(varname)
9110   format('All elements of the ',a,' array are supplied as zero.')
       go to 9890

9070   write(amessage,9080) trim(varname)
9080   format('The value supplied for ',a,' for at least one target point is zero or less.')
       go to 9890


9890   ipd_interpolate_3d=1

9900   continue

       return

end function ipd_interpolate_3d



integer (kind=c_int) function initialize_randgen(iseed) &
                 bind(C,name="initialize_randgen")

! -- Initialize the random number generator.

       use iso_c_binding, only: c_int
       use utilities
       integer(kind=c_int), intent(in)   :: iseed
       integer                           :: seed_size

! -- Initialization

       function_name='initialize_randgen()'
       initialize_randgen=0

       call random_seed(size=seed_size) ! find out size of seed
       if(.not.allocated(seed))allocate(seed(seed_size))
       seed=iseed                 ! an array
       call random_seed(put=seed) ! set current seed
       return

end function initialize_randgen



integer (kind=c_int) function fieldgen2d_sva(                &
                              nnode,                         &
                              ec,nc,area,active,             &
                              mean,var,aa,anis,bearing,      &
                              transtype,avetype,power,       &
                              ldrand,nreal,randfield)        &
                 bind(C,name="fieldgen2d_sva")

! -- This function generates stochastic fields based on a spatially varying variogram.
! -- It does this by 2D spatial convolution of an averaging function.

       use iso_c_binding, only: c_int,c_double
       use dimvar
       use utilities
       implicit none

       integer(kind=c_int), intent(in)   :: nnode                  ! Nodes in model grid
       real(kind=c_double), intent(in)   :: ec(nnode),nc(nnode)    ! x and y coordinates of nodes
       real(kind=c_double), intent(in)   :: area(nnode)            ! Areas of grid cells
       integer(kind=c_int), intent(in)   :: active(nnode)          ! 0=inactive cell
       real(kind=c_double), intent(in)   :: mean(nnode)            ! Mean value of stochastic field
       real(kind=c_double), intent(in)   :: var(nnode)             ! Variance of stochastic field
       real(kind=c_double), intent(in)   :: aa(nnode)              ! Averaging function spatial dimension
       real(kind=c_double), intent(in)   :: anis(nnode)            ! Anisotropy ratio
       real(kind=c_double), intent(in)   :: bearing(nnode)         ! Bearing of principal anisotropy axis
       integer(kind=c_int), intent(in)   :: transtype              ! Stochastic field pertains to natural(0) or log(1) props
       integer(kind=c_int), intent(in)   :: avetype                ! 1:spher,2:exp,3:gauss,4:pow
       real(kind=c_double), intent(in)   :: power                  ! Power used in power AVETYPE
       integer(kind=c_int), intent(in)   :: ldrand                 ! Leading dimension of RANDFIELD
       integer(kind=c_int), intent(in)   :: nreal                  ! Number of realisations to generate
       real(kind=c_double), intent(out)  :: randfield(ldrand,nreal)! Realisations

       integer                 :: jnode,knode,ierr
       integer                 :: ireal
       double precision        :: xi,yi
       double precision        :: vvar,along,amid,cosang1,sinang1,ang1
       double precision        :: den_along,den_along2,den_amid,den_amid2,den
       double precision        :: xdiff,ydiff,dlong,dmid
       double precision        :: dtemp,dtemp1,dtemp2,dtemp3
       double precision        :: dlim,pidiv180
       character(len=25)       :: varname

       double precision, allocatable :: diid(:,:)

! -- Initialisation

       fieldgen2d_sva=0
       function_name='fieldgen2d_sva()'
       pidiv180=3.1415926535898d0/180.0d0
       dlim=1.0d-5

! -- Check that the random number generator has been seeded.

       if(.not.allocated(seed))then
         write(amessage,90) trim(function_name)
90       format(' The random number generator must be seeded before calling function ',a,'.')
         go to 9890
       end if

! -- Check input arguments.

       if((transtype.ne.0).and.(transtype.ne.1))then
         write(amessage,100) 'TRANSTYPE',trim(function_name)
100      format('The ',a,' argument of function ',a,' must be ',  &
         'supplied as 0 or 1.')
         go to 9890
       end if
       if((avetype.ne.1).and.(avetype.ne.2).and.(avetype.ne.3).and.(avetype.ne.4))then
         write(amessage,105)  trim(function_name)
105      format('The AVETYPE argument of function ',a,' must be ',  &
         'supplied as 1, 2, 3 or 4.')
         go to 9890
       end if
       if(avetype.eq.4)then
         if(power.le.0.0d0)then
           write(amessage,106) trim(function_name)
106        format('If AVETYPE is set to 4, then the POWER argument of function ',a,    &
           ' must be greater than zero.')
           go to 9890
         end if
       end if
       if(nnode.le.0)then
         varname='NNODE'
         go to 9000
       end if
       if(nreal.le.0)then
         varname='NREAL'
         go to 9000
       end if
       if(ldrand.lt.nnode)then
         write(amessage,107) trim(function_name)
107      format(' LDRAND must equal or exceed NNODE in call to function ',a,'.')
         go to 9890
       end if
       if(all(active.eq.0))then
         varname='ACTIVE'
         go to 9100
       end if
       do jnode=1,nnode
         if(active(jnode).ne.0)then
           if(area(jnode).le.0.0d0)then
             write(amessage,170) 'AREA'
170          format('At least one ',a,' value is zero or negative for an active model node.')
             go to 9890
           end if
           if(var(jnode).lt.0.0d0)then
             write(amessage,171) 'VAR'
171          format('At least one ',a,' value is negative for an active model node.')
             go to 9890
           end if
           if(aa(jnode).le.0.0d0)then
             write(amessage,170) 'AA'
             go to 9890
           end if
           if(anis(jnode).le.0.0d0)then
             write(amessage,170) 'ANIS'
             go to 9890
           end if
           if((bearing(jnode).lt.-360.0d0).or.(bearing(jnode).gt.360.0d0))then
             write(amessage,180)
180          format('At least one BEARING value is less than -360 degrees or greater than ',  &
             '360 degrees for an active model node.')
             go to 9890
           end if
         end if
       end do

! -- Allocate the array that stores random numbers.

       allocate(diid(nnode,nreal),stat=ierr)
       if(ierr.ne.0) go to 9200
       if(utl_allocate_vector('d',1,nreal).ne.0) go to 9200

! -- Fill the diid array with random numbers.

       do ireal=1,nreal
         do jnode=1,nnode
           diid(jnode,ireal)=utl_random_normal()
         end do
       end do

! -- Evaluate limit threshold

       if(dlim.eq.0.0d0)then
         dlim=1.0d30
       else
         if(avetype.eq.2)then
           dlim=-log(dlim)
           dlim=dlim*dlim              ! applies to x^2
         else if(avetype.eq.3)then
           dlim=-log(dlim)             ! applies to x^2
         else if(avetype.eq.1)then
           dlim=1.0d0
         else if(avetype.eq.4)then
           dlim=1.0d0
         end if
       end if

! -- Do the convolution

       do jnode=1,nnode
         if(active(jnode).ne.0)then
           xi=ec(jnode)
           yi=nc(jnode)
           vvar=var(jnode)
           along=aa(jnode)
           amid=aa(jnode)/anis(jnode)
           ang1=90.0d0-bearing(jnode)
           cosang1=cos(ang1*pidiv180)
           sinang1=sin(ang1*pidiv180)
           den_along=1.0d0/along
           den_along2=den_along*den_along
           den_amid=1.0d0/amid
           den_amid2=den_amid*den_amid
           den=0.0d0
           dvector1=0.0d0   ! an array
           do knode=1,nnode
             if(active(knode).eq.0) cycle
             xdiff=ec(knode)-xi
             ydiff=nc(knode)-yi
             dlong=xdiff*cosang1+ydiff*sinang1
             dmid=-xdiff*sinang1+ydiff*cosang1
             if(avetype.eq.2)then
               dtemp1=dlong*dlong*den_along2
               if(dtemp1.gt.dlim) cycle
               dtemp2=dmid*dmid*den_amid2
               if(dtemp2.gt.dlim) cycle
               dtemp=dtemp1+dtemp2
               if(dtemp.gt.dlim) cycle
               dtemp=sqrt(dtemp)
               dtemp=exp(-dtemp)
             else if(avetype.eq.3)then
               dtemp1=dlong*dlong*den_along2
               if(dtemp1.gt.dlim) cycle
               dtemp2=dmid*dmid*den_amid2
               if(dtemp2.gt.dlim) cycle
               dtemp=dtemp1+dtemp2
               if(dtemp.gt.dlim) cycle
               dtemp=exp(-dtemp)
             else if(avetype.eq.1)then
               dtemp1=abs(dlong*den_along)
               if(dtemp1.gt.1.0d0)cycle
               dtemp2=abs(dmid*den_amid)
               if(dtemp2.gt.1.0d0) cycle
               dtemp=dtemp1*dtemp1+dtemp2*dtemp2
               dtemp=sqrt(dtemp)
               dtemp3=dtemp*dtemp*dtemp
               dtemp=1.0d0-1.5*dtemp+0.5*dtemp3
               if(dtemp.lt.0.0d0) cycle
             else if(avetype.eq.4)then
               dtemp1=abs(dlong*den_along)
               if(dtemp1.gt.1.0d0) cycle
               dtemp2=abs(dmid*den_amid)
               if(dtemp2.gt.1.0d0) cycle
               dtemp=dtemp1*dtemp1+dtemp2*dtemp2
               dtemp=sqrt(dtemp)
               dtemp=1.0d0-(dtemp**power)
               if(dtemp.lt.0.0d0) cycle
             end if
             dtemp=dtemp*area(knode)
             do ireal=1,nreal
                dvector1(ireal)=dvector1(ireal)+dtemp*diid(knode,ireal)
             end do
             den=den+dtemp*dtemp
           end do
           do ireal=1,nreal
             dtemp=dvector1(ireal)*sqrt(vvar/den)              ! Ensures that it has the correct variance
             if(transtype.eq.0)then
               randfield(jnode,ireal)=mean(jnode)+dtemp
             else
               if(dtemp.gt.100.0d0) dtemp=100.0d0
               randfield(jnode,ireal)=mean(jnode)*(10**dtemp)
             end if
           end do
         end if
       end do
       go to 9900

9000   write(amessage,9010) trim(varname),trim(function_name)
9010   format('The ',a,' argument of function ',a,' must be greater than zero.')
       go to 9890

9100   write(amessage,9110) trim(varname)
9110   format('All elements of the ',a,' array are supplied as zero.')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory management error encountered in function ',a,'.')
       go to 9890

9890   fieldgen2d_sva=1

9900   continue
       if(allocated(diid)) deallocate(diid,stat=ierr)

       return

end function fieldgen2d_sva



integer (kind=c_int) function fieldgen3d_sva(                &
                              nnode,                         &
                              ec,nc,zc,                      &
                              area,height,active,            &
                              mean,var,                      &
                              ahmax,ahmin,avert,             &
                              bearing,dip,rake,              &
                              transtype,avetype,power,       &
                              ldrand,nreal,randfield)        &
                 bind(C,name="fieldgen3d_sva")

! -- This function generates 3D stochastic fields based on a spatially varying variogram.
! -- It does this by spatial convolution using an averaging function.

       use iso_c_binding, only: c_int,c_double
       use dimvar
       use utilities
       implicit none

       integer(kind=c_int), intent(in)   :: nnode                       ! Nodes in model grid
       real(kind=c_double), intent(in)   :: ec(nnode),nc(nnode),zc(nnode)! x,y,z coordinates of nodes
       real(kind=c_double), intent(in)   :: area(nnode)            ! Areas of grid cells
       real(kind=c_double), intent(in)   :: height(nnode)          ! Height of grid cells
       integer(kind=c_int), intent(in)   :: active(nnode)          ! 0=inactive cell
       real(kind=c_double), intent(in)   :: mean(nnode)            ! Mean value of stochastic field
       real(kind=c_double), intent(in)   :: var(nnode)             ! Variance of stochastic field
       real(kind=c_double), intent(in)   :: ahmax(nnode),ahmin(nnode),avert(nnode) ! Ave func. correlation lengths
       real(kind=c_double), intent(in)   :: bearing(nnode)         ! Bearing of ahmax direction
       real(kind=c_double), intent(in)   :: dip(nnode)             ! Dip of ahmax direction
       real(kind=c_double), intent(in)   :: rake(nnode)            ! Rotation of ahmin direction
       integer(kind=c_int), intent(in)   :: transtype              ! Stochastic field pertains to natural(0) or log(1) props
       integer(kind=c_int), intent(in)   :: avetype                ! 1:spher,2:exp,3:gauss,4:pow
       real(kind=c_double), intent(in)   :: power                  ! Power used in power AVETYPE
       integer(kind=c_int), intent(in)   :: ldrand                 ! Leading dimension of RANDFIELD
       integer(kind=c_int), intent(in)   :: nreal                  ! Number of realisations to generate
       real(kind=c_double), intent(out)  :: randfield(ldrand,nreal)! Realisations

       integer                 :: jnode,knode,ierr
       integer                 :: ireal
       double precision        :: xi,yi,zi
       double precision        :: aavert
       double precision        :: vvar,along,amid,cosang1,sinang1,ang1
       double precision        :: cosang2,sinang2,cosang3,sinang3
       double precision        :: den_along,den_along2,den_amid,den_amid2,den
       double precision        :: den_avert,den_avert2
       double precision        :: xd,yd,zd,xdd,ydd,zdd
       double precision        :: xdiff,ydiff,zdiff,dlong,dmid,dvert
       double precision        :: dtemp,dtemp1,dtemp2,dtemp3
       double precision        :: dlim,pidiv180
       character(len=25)       :: varname

       double precision, allocatable :: diid(:,:)

! -- Initialisation

       fieldgen3d_sva=0
       function_name='fieldgen3d_sva()'
       pidiv180=3.1415926535898d0/180.0d0
       dlim=1.0d-5

! -- Check that the random number generator has been seeded.

       if(.not.allocated(seed))then
         write(amessage,90) trim(function_name)
90       format(' The random number generator must be seeded before calling function ',a,'.')
         go to 9890
       end if

! -- Check input arguments.

       if((transtype.ne.0).and.(transtype.ne.1))then
         write(amessage,100) 'TRANSTYPE',trim(function_name)
100      format('The ',a,' argument of function ',a,' must be ',  &
         'supplied as 0 or 1.')
         go to 9890
       end if
       if((avetype.ne.1).and.(avetype.ne.2).and.(avetype.ne.3).and.(avetype.ne.4))then
         write(amessage,105)  trim(function_name)
105      format('The AVETYPE argument of function ',a,' must be ',  &
         'supplied as 1, 2, 3 or 4.')
         go to 9890
       end if
       if(avetype.eq.4)then
         if(power.le.0.0d0)then
           write(amessage,106) trim(function_name)
106        format('If AVETYPE is set to 4, then the POWER argument of function ',a,    &
           ' must be greater than zero.')
           go to 9890
         end if
       end if
       if(nnode.le.0)then
         varname='NNODE'
         go to 9000
       end if
       if(nreal.le.0)then
         varname='NREAL'
         go to 9000
       end if
       if(ldrand.lt.nnode)then
         write(amessage,107) trim(function_name)
107      format('LDRAND must equal or exceed NNODE in call to function ',a,'.')
         go to 9890
       end if
       if(all(active.eq.0))then
         varname='ACTIVE'
         go to 9100
       end if
       do jnode=1,nnode
         if(active(jnode).ne.0)then
           if(area(jnode).le.0.0d0)then
             write(amessage,170) 'AREA'
170          format('At least one ',a,' value is zero or negative for an active model node.')
             go to 9890
           end if
           if(height(jnode).le.0.0d0)then
             write(amessage,170) 'HEIGHT'
             go to 9890
           end if
           if(var(jnode).lt.0.0d0)then
             write(amessage,171) 'VAR'
171          format('At least one ',a,' value is negative for an active model node.')
             go to 9890
           end if
           if(ahmax(jnode).le.0.0d0)then
             write(amessage,170) 'AHMAX'
             go to 9890
           end if
           if(ahmin(jnode).le.0.0d0)then
             write(amessage,170) 'AHMIN'
             go to 9890
           end if
           if(avert(jnode).le.0.0d0)then
             write(amessage,170) 'AVERT'
             go to 9890
           end if
           if((bearing(jnode).lt.-360.0d0).or.(bearing(jnode).gt.360.0d0))then
             write(amessage,180)
180          format('At least one BEARING value is less than -360 degrees or greater than ',  &
             '360 degrees for an active model node.')
             go to 9890
           end if
           if((dip(jnode).lt.-180.0d0).or.(dip(jnode).gt.180.0d0))then
             write(amessage,181)
181          format('At least one DIP value is less than -180 degrees or greater than ',  &
             '180 degrees for an active model node.')
             go to 9890
           end if
           if((rake(jnode).lt.-90.0d0).or.(rake(jnode).gt.90.0d0))then
             write(amessage,182)
182          format('At least one RAKE value is less than -90 degrees or greater than ',  &
             '90 degrees for an active model node.')
             go to 9890
           end if
         end if
       end do

! -- Allocate the array that stores random numbers.

       allocate(diid(nnode,nreal),stat=ierr)
       if(ierr.ne.0) go to 9200
       if(utl_allocate_vector('d',1,nreal).ne.0) go to 9200

! -- Fill the diid array with random numbers.

       do ireal=1,nreal
         do jnode=1,nnode
           diid(jnode,ireal)=utl_random_normal()
         end do
       end do

! -- Evaluate limit threshold

       if(dlim.eq.0.0d0)then
         dlim=1.0d30
       else
         if(avetype.eq.2)then
           dlim=-log(dlim)
           dlim=dlim*dlim              ! applies to x^2
         else if(avetype.eq.3)then
           dlim=-log(dlim)             ! applies to x^2
         else if(avetype.eq.1)then
           dlim=1.0d0
         else if(avetype.eq.4)then
           dlim=1.0d0
         end if
       end if

! -- Do the convolution

       do jnode=1,nnode
         if(active(jnode).ne.0)then
           xi=ec(jnode)
           yi=nc(jnode)
           zi=zc(jnode)
           vvar=var(jnode)
           along=ahmax(jnode)
           amid=ahmin(jnode)
           aavert=avert(jnode)
           ang1=90.0d0-bearing(jnode)
           cosang1=cos(ang1*pidiv180)
           sinang1=sin(ang1*pidiv180)
           cosang2=cos(dip(jnode)*pidiv180)
           sinang2=sin(dip(jnode)*pidiv180)
           cosang3=cos(rake(jnode)*pidiv180)
           sinang3=sin(rake(jnode)*pidiv180)
           den_along=1.0d0/along
           den_along2=den_along*den_along
           den_amid=1.0d0/amid
           den_amid2=den_amid*den_amid
           den_avert=1.0d0/aavert
           den_avert2=den_avert*den_avert
           den=0.0d0
           dvector1=0.0d0   ! an array
           do knode=1,nnode
             if(active(knode).eq.0)cycle
             xdiff=ec(knode)-xi
             ydiff=nc(knode)-yi
             zdiff=zc(knode)-zi
             xd=xdiff*cosang1+ydiff*sinang1
             yd=-xdiff*sinang1+ydiff*cosang1
             zd=zdiff
             xdd=xd*cosang2+zd*sinang2
             ydd=yd
             zdd=-xd*sinang2+zd*cosang2
             dlong=xdd
             dmid=ydd*cosang3+zdd*sinang3
             dvert=-ydd*sinang3+zdd*cosang3
             if(avetype.eq.2)then
               dtemp1=dlong*dlong*den_along2
               if(dtemp1.gt.dlim) cycle
               dtemp2=dmid*dmid*den_amid2
               if(dtemp2.gt.dlim) cycle
               dtemp3=dvert*dvert*den_avert2
               if(dtemp3.gt.dlim) cycle
               dtemp=dtemp1+dtemp2+dtemp3
               if(dtemp.gt.dlim) cycle
               dtemp=sqrt(dtemp)
               dtemp=exp(-dtemp)
             else if(avetype.eq.3)then
               dtemp1=dlong*dlong*den_along2
               if(dtemp1.gt.dlim) cycle
               dtemp2=dmid*dmid*den_amid2
               if(dtemp2.gt.dlim) cycle
               dtemp3=dvert*dvert*den_avert2
               if(dtemp3.gt.dlim) cycle
               dtemp=dtemp1+dtemp2+dtemp3
               if(dtemp.gt.dlim) cycle
               dtemp=exp(-dtemp)
             else if(avetype.eq.1)then
               dtemp1=abs(dlong*den_along)
               if(dtemp1.gt.1.0d0)cycle
               dtemp2=abs(dmid*den_amid)
               if(dtemp2.gt.1.0d0) cycle
               dtemp3=abs(dvert*den_avert)
               if(dtemp3.gt.1.0d0) cycle
               dtemp=dtemp1*dtemp1+dtemp2*dtemp2+dtemp3*dtemp3
               dtemp=sqrt(dtemp)
               dtemp3=dtemp*dtemp*dtemp
               dtemp=1.0d0-1.5*dtemp+0.5*dtemp3
               if(dtemp.lt.0.0d0) cycle
             else if(avetype.eq.4)then
               dtemp1=abs(dlong*den_along)
               if(dtemp1.gt.1.0d0) cycle
               dtemp2=abs(dmid*den_amid)
               if(dtemp2.gt.1.0d0) cycle
               dtemp3=abs(dvert*den_avert)
               if(dtemp3.gt.1.0d0) cycle
               dtemp=dtemp1*dtemp1+dtemp2*dtemp2+dtemp3*dtemp3
               dtemp=sqrt(dtemp)
               dtemp=1.0d0-(dtemp**power)
               if(dtemp.lt.0.0d0) cycle
             end if
             dtemp=dtemp*area(knode)*height(knode)
             do ireal=1,nreal
               dvector1(ireal)=dvector1(ireal)+dtemp*diid(knode,ireal)
             end do
             den=den+dtemp*dtemp
           end do
           do ireal=1,nreal
             dtemp=dvector1(ireal)*sqrt(vvar/den)          ! Ensures that it has the correct variance
             if(transtype.eq.0)then
               randfield(jnode,ireal)=mean(jnode)+dtemp
             else
               if(dtemp.gt.100.0d0) dtemp=100.0d0
               randfield(jnode,ireal)=mean(jnode)*(10**dtemp)
             end if
           end do
         end if
       end do

       go to 9900

9000   write(amessage,9010) trim(varname),trim(function_name)
9010   format('The ',a,' argument of function ',a,' must be greater than zero.')
       go to 9890

9100   write(amessage,9110) trim(varname),trim(function_name)
9110   format('All elements of the ',a,' array are supplied as zero in call to ',  &
       'function ',a,'.')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory management error encountered in function ',a,'.')
       go to 9890

9890   fieldgen3d_sva=1

9900   continue
       if(allocated(diid)) deallocate(diid,stat=ierr)

       return

end function fieldgen3d_sva



subroutine free_param_memory1()
       use used_by_kb2d_1
       implicit none
       integer  :: ierr
       ! re-set maxsam to allow subsequent allocation
       maxsam=0
       if(allocated(xa))deallocate(xa,stat=ierr)
       if(allocated(ya))deallocate(ya,stat=ierr)
       if(allocated(dist))deallocate(dist,stat=ierr)
       if(allocated(r))deallocate(r,stat=ierr)
       if(allocated(rr))deallocate(rr,stat=ierr)
       if(allocated(s))deallocate(s,stat=ierr)
       if(allocated(a))deallocate(a,stat=ierr)
       if(allocated(nums))deallocate(nums,stat=ierr)
       return
end subroutine free_param_memory1


subroutine free_param_memory2
       use geostat_3d
       implicit none
       integer ierr
       if(allocated(nisb)) deallocate(nisb,stat=ierr)
       if(allocated(ixsbtosr)) deallocate(ixsbtosr,stat=ierr)
       if(allocated(iysbtosr)) deallocate(iysbtosr,stat=ierr)
       if(allocated(izsbtosr)) deallocate(izsbtosr,stat=ierr)
       if(allocated(x)) deallocate(x,stat=ierr)
       if(allocated(y)) deallocate(y,stat=ierr)
       if(allocated(z)) deallocate(z,stat=ierr)
       if(allocated(vr)) deallocate(vr,stat=ierr)
       if(allocated(ve)) deallocate(ve,stat=ierr)
       if(allocated(dh)) deallocate(dh,stat=ierr)
       if(allocated(tmp)) deallocate(tmp,stat=ierr)
       if(allocated(close)) deallocate(close,stat=ierr)
       if(allocated(xa)) deallocate(xa,stat=ierr)
       if(allocated(ya)) deallocate(ya,stat=ierr)
       if(allocated(za)) deallocate(za,stat=ierr)
       if(allocated(vra)) deallocate(vra,stat=ierr)
       if(allocated(vea)) deallocate(vea,stat=ierr)
       if(allocated(xdb)) deallocate(xdb,stat=ierr)
       if(allocated(ydb)) deallocate(ydb,stat=ierr)
       if(allocated(zdb)) deallocate(zdb,stat=ierr)
       if(allocated(cut)) deallocate(cut,stat=ierr)
       if(allocated(cdf)) deallocate(cdf,stat=ierr)
       if(allocated(r)) deallocate(r,stat=ierr)
       if(allocated(rr)) deallocate(rr,stat=ierr)
       if(allocated(s)) deallocate(s,stat=ierr)
       if(allocated(a)) deallocate(a,stat=ierr)
       if(allocated(sec3)) deallocate(sec3,stat=ierr)
end subroutine free_param_memory2

       program driver8

! -- DRIVER8 tests 3-D kriging interpolation

       use function_interfaces
       use iso_c_binding, only : c_int,c_char,c_double
       implicit none

       integer, parameter :: MAXZONE=10

! -- Variables used in function calls.

       integer(kind=c_int)           :: ifail
       integer(kind=c_int)           :: npts
       integer(kind=c_int)           :: mpts
       integer(kind=c_int)           :: vartype(MAXZONE)
       integer(kind=c_int)           :: krigtype
       integer(kind=c_int)           :: transtype
       integer(kind=c_int)           :: nzone
       integer(kind=c_int)           :: zonenum(MAXZONE)
       integer(kind=c_int)           :: maxpts,minpts
       integer(kind=c_int)           :: icount_interp,icount
       real(kind=c_double)           :: bearing(MAXZONE),dip(MAXZONE),rake(MAXZONE)
       real(kind=c_double)           :: ahmax(MAXZONE),ahmin(MAXZONE),avert(MAXZONE)
       real(kind=c_double)           :: srhmax,srhmin,srvert
       character (kind=c_char,len=1) :: factorfile(256)
       integer(kind=c_int)           :: factorfiletype
       character(kind=c_char,len=1)  :: messagestring(1500)

! -- Other variables

       integer               :: ierr,ifile,ioption
       integer               :: nlay,nrow,ncol,ilay,irow,icol
       integer               :: ipt,ibeg,iend,iptstart
       integer               :: ncr,lastzone,itemp,izone
       double precision      :: pi
       double precision      :: e0,n0,angle
       double precision      :: cosang,sinang
       double precision      :: nointerpval
       double precision      :: dtemp1,dtemp2
       character (len=1)     :: aaa,al
       character (len=20)    :: anum,alay
       character (len=200)   :: cline
       character (len=256)   :: infile,facfile,afile,outfile,inbase
       character (len=1500)  :: amessage

! -- Allocatable variables; first the ones that are used in function calls.

       integer(kind=c_int), allocatable   :: zns(:),znt(:)
       real(kind=c_double), allocatable   :: ecs(:),ncs(:),zcs(:),vals(:)
       real(kind=c_double), allocatable   :: ect(:),nct(:),zct(:),valt(:)
       real(kind=c_double), allocatable   :: mean(:)

! -- Other allocatable variables.

       double precision, allocatable      :: delr(:),delc(:)
       double precision, allocatable      :: x(:),y(:)
       double precision, allocatable      :: bot(:,:,:)
       character (len=20), allocatable    :: apoint(:)

! -- Initialization

       pi=3.14159265358979000
       icount_interp=0

! -- Read the grid specification file.

100    write(6,110,advance='no')
110    format(' Enter name of MF grid spec file: ')
       read(5,*,err=100) infile
       open(unit=10,file=infile,status='old',err=100)
       read(10,*,err=9000,end=9050) nrow,ncol
       read(10,*,err=9000,end=9050) e0,n0,angle
       allocate(delr(ncol),delc(nrow),stat=ierr)
       if(ierr.ne.0) go to 9200
       read(10,*,err=9000,end=9050) (delr(icol),icol=1,ncol)
       read(10,*,err=9000,end=9050) (delc(irow),irow=1,nrow)
       close(unit=10)
       write(6,120) trim(infile)
120    format(' - file ',a,' read ok.')

! -- Acquire number of layers.

       write(6,*)
130    write(6,140,advance='no')
140    format(' Enter number of model layers: ')
       read(5,*,err=130) nlay
       if(nlay.le.0) go to 130
       ncr=ncol*nrow
       mpts=ncol*nrow*nlay

! -- Calculate layer bottom elevations.

       allocate(bot(ncol,nrow,0:nlay),stat=ierr)
       if(ierr.ne.0) go to 9200
       do ilay=0,nlay
         bot(:,:,ilay)=-ilay*20.0d0
       end do

! -- Acquire zones option

       write(6,*)
131    write(6,141,advance='no')
141    format(' Use option 1 or 2 for zones? ')
       read(5,*,err=131) ioption
       if((ioption.ne.1).and.(ioption.ne.2)) go to 131

! -- Calculate zones (zones are 0,1,2)

       allocate(znt(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200
       if(ioption.eq.2)then
         znt=1  ! an array
       else
         do ilay=1,nlay
           do irow=1,nrow
             do icol=1,ncol
               ipt=(ilay-1)*ncr+(irow-1)*ncol+icol
               if(irow.le.15)then
                 znt(ipt)=1
               else
                 znt(ipt)=2
               end if
             end do
           end do
         end do
         do ilay=1,5
           do irow=21,nrow
             do icol=16,ncol
               ipt=(ilay-1)*ncr+(irow-1)*ncol+icol
               znt(ipt)=0
             end do
           end do
         end do
       end if

! -- The pilot points file is read.

       write(6,*)
180    write(6,190,advance='no')
190    format(' Enter name of 3D pilot points file: ')
       read(5,*,err=180) infile
       open(unit=10,file=infile,status='old',err=180)
       npts=0
       do
         read(10,'(a)',end=200) cline
         if(cline.eq.' ')cycle
         npts=npts+1
       end do
200    continue
       if(npts.eq.0)then
         write(6,201)
201      format(/,' *** No points in file. Try again ***',/)
         close(unit=10)
         go to 180
       end if
       allocate(apoint(npts),ecs(npts),ncs(npts),zcs(npts),zns(npts),vals(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       rewind(10)
       do ipt=1,npts
         read(10,*,err=9000,end=9050) apoint(ipt),ecs(ipt),ncs(ipt),zcs(ipt),zns(ipt),vals(ipt)
       end do
       close(unit=10)
       write(6,120) trim(infile)

! -- We calculate the number of zones in the target array.

       nzone=0
       lastzone=huge(lastzone)
       do ipt=1,mpts
         itemp=znt(ipt)
         if(itemp.ne.lastzone)then
           if(nzone.eq.0)then
             nzone=1
             zonenum(nzone)=itemp
           else
             do izone=1,nzone
               if(zonenum(izone).eq.itemp) go to 203
             end do
             nzone=nzone+1
             if(nzone.gt.MAXZONE)then
               call writint(anum,MAXZONE)
               write(amessage,2031) trim(anum)
2031           format('DRIVER8 allows a maximum of only ',a,' different zones ', &
               'in model grid.')
               go to 9890
             end if
             zonenum(nzone)=itemp
203          continue
           end if
           lastzone=itemp
         end if
       end do

! -- Enter kriging type

       write(6,*)
2090   write(6,2100,advance='no')
2100   format(' Enter kriging type (0=simple; 1=ordinary): ')
       read(5,*,err=2090) krigtype

! -- Enter variogram variables for different zones.

       allocate(mean(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200
       mean=0   ! an array
       do izone=1,nzone
         if(zonenum(izone).eq.0)then
           vartype(izone)=2
           ahmax(izone)=1000.0
           ahmin(izone)=500.0
           avert(izone)=20.0
           bearing(izone)=0.0
           dip(izone)=0.0
           rake(izone)=0.0
         else
           write(6,*)
           call writint(anum,zonenum(izone))
           write(6,2035) trim(anum)
2035       format(' For zone ',a,' ---->')
205        write(6,206,advance='no')
206        format(' Enter variogram type (1=spher;2=exp;3=gaus;4=pow): ')
           read(5,*,err=205) vartype(izone)
           if((vartype(izone).lt.1).or.(vartype(izone).gt.4)) go to 205
2050       write(6,2060,advance='no')
2060       format(' Enter ahmax, ahmin, avert: ')
           read(5,*,err=2050) ahmax(izone),ahmin(izone),avert(izone)
2070       write(6,2080,advance='no')
2080       format(' Enter bearing, dip, rake: ')
           read(5,*,err=2070) bearing(izone), dip(izone), rake(izone)
2110       write(6,2120,advance='no')
2120       format(' Enter mean value: ')
           read(5,*,err=2110) dtemp1
           itemp=zonenum(izone)
           do ipt=1,mpts
             if(znt(ipt).eq.itemp) mean(ipt)=dtemp1
           end do
         end if
       end do

! -- Enter control variables.

       write(6,*)
210    write(6,220,advance='no')
220    format(' Enter srhmax, srhmin, srvert: ')
       read(5,*,err=210) srhmax,srhmin,srvert
       if((srhmax.le.0.0).or.(srhmin.le.0.0).or.(srvert.le.0.0)) go to 210
230    write(6,240,advance='no')
240    format(' Enter maxpts, minpts: ')
       read(5,*,err=230) maxpts,minpts

! -- The name of the factor file is aquired.

       write(6,*)
250    write(6,260,advance='no')
260    format(' Enter name for factor file: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 250
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,facfile,ibeg,iend)
       if(ifail.ne.0) go to 250
       call char2string(256,facfile,factorfile)
270    write(6,280,advance='no')
280    format(' Is this a text or binary file? (t/b): ')
       read(5,*,err=270) aaa
       if((aaa.eq.'t').or.(aaa.eq.'T'))then
         factorfiletype=1
       else if ((aaa.eq.'b').or.(aaa.eq.'B'))then
         factorfiletype=0
       else
         go to 270
       end if

! -- Calculate target coordinates.

       allocate(ect(mpts),nct(mpts),zct(mpts),valt(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(x(ncol),y(nrow),stat=ierr)
       if(ierr.ne.0) go to 9200

       cosang=cos(angle*pi/180.0d0)
       sinang=sin(angle*pi/180.0d0)
       do icol=1,ncol
         if(icol.eq.1)then
           x(icol)=delr(1)*0.5
         else
           x(icol)=x(icol-1)+(delr(icol)+delr(icol-1))*0.5
         end if
       end do
       do irow=1,nrow
         if(irow.eq.1)then
           y(irow)=-delc(irow)*0.5
         else
           y(irow)=y(irow-1)-(delc(irow)+delc(irow-1))*0.5
         end if
       end do
       ipt=0
       do irow=1,nrow
         do icol=1,ncol
           ipt=ipt+1
           dtemp1=x(icol)*cosang-y(irow)*sinang+e0
           dtemp2=x(icol)*sinang+y(irow)*cosang+n0
           do ilay=1,nlay
             ect(ipt+(ilay-1)*ncr)=dtemp1
             nct(ipt+(ilay-1)*ncr)=dtemp2
           end do
         end do
       end do
       ipt=0
       do ilay=1,nlay
         do irow=1,nrow
           do icol=1,ncol
             ipt=ipt+1
             zct(ipt)=(bot(icol,irow,ilay-1)+bot(icol,irow,ilay))*0.5
           end do
         end do
       end do

! -- Now call the function to do the interpolation.

       write(6,*)
       write(6,320)
320    format(' Calling calc_kriging_factors_3d()....')
       ifail=calc_kriging_factors_3d(            &
                  npts,ecs,ncs,zcs,zns,          &
                  mpts,ect,nct,zct,znt,          &
                  krigtype,                      &
                  nzone,zonenum,                 &
                  vartype,                       &
                  ahmax,ahmin,avert,             &
                  bearing,dip,rake,              &
                  srhmax,srhmin,srvert,          &
                  maxpts,minpts,                 &
                  factorfile,factorfiletype,     &
                  icount_interp)
       if(ifail.ne.0)then
         write(6,340)
340      format(' Function call unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       else
         write(anum,'(i0)') icount_interp
         anum=adjustl(anum)
         write(6,350) trim(anum)
350      format(' Interpolation factors calculated for ',a,' points.')
       end if

! -- We will now re-read the factor file and undertake interpolation. The outcomes
!    will be written as a MODFLOW-compatible tabular data file (for use of MF2VTK1).

       write(6,*)
       write(6,400)
400    format(' Now undertaking spatial interpolation.')
       write(6,*)
409    write(6,410,advance='no')
410    format(' Interpolate in natural or log domain? (n/l): ')
       read(5,*) al
       if((al.eq.'N').or.(al.eq.'n'))then
         transtype=0
       else if((al.eq.'l').or.(al.eq.'L'))then
         transtype=1
       else
         go to 409
       end if
405    write(6,406,advance='no')
406    format(' Enter number indicating no interpolation to target array: ')
       read(5,*,err=405) nointerpval
       valt=nointerpval ! an array

       write(6,*)
       write(6,420)
420    format(' Calling krige_using_file()...')
       ifail=krige_using_file(factorfile,factorfiletype,   &
                              npts,mpts,                   &
                              krigtype,transtype,          &
                              vals,valt,                   &
                              icount,mean)
       if(ifail.ne.0)then
         write(6,430)
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       else
         write(anum,'(i0)') icount
         anum=adjustl(anum)
         write(6,430) trim(anum)
430      format(' Interpolation undertaken to ',a,' points.')
       end if

! -- We now store the results as a real array.

       write(6,*)
440    write(6,450,advance='no')
450    format(' Enter filename for target array storage: ')
       read(5,*,err=440) outfile
       open(unit=20,file=outfile,action='write',err=440)
       write(20,455)
455    format(1x,'LAYER',t10,'ROW',t20,'COLUMN',t30'VALUE')
       ipt=0
       do ilay=1,nlay
         do irow=1,nrow
           do icol=1,ncol
             ipt=ipt+1
             write(20,460) ilay,irow,icol,valt(ipt)
460          format(1x,i8,t10,i8,t20,i8,t30,1pg16.9)
           end do
         end do
       end do
       close(unit=20)
       write(6,470) trim(outfile)
470    format(' - file ',a,' written ok.')

       go to 9900

9000   write(amessage,9010) trim(infile)
9010   format('Error encountered in reading file ',a,'.')
       go to 9890

9050   write(amessage,9060) trim(infile)
9060   format('Premature end encountered to file ',a,'.')
       go to 9890

9100   write(amessage,9110) trim(infile)
9110   format('Cannot open file ',a,'.')
       go to 9890

9200   write(amessage,9210)
9210   format('Insufficient memory to continue execution.')
       go to 9890


9890   continue
       amessage=' '//trim(amessage)
       call writmess(6,amessage)

! -- Tidy up

9900   continue

! -- Free local memory

       deallocate(zns,znt,stat=ierr)
       deallocate(ecs,ncs,zcs,vals,stat=ierr)
       deallocate(ect,nct,zct,valt,stat=ierr)
       deallocate(delr,delc,stat=ierr)
       deallocate(bot,stat=ierr)
       deallocate(x,y,stat=ierr)
       deallocate(apoint,stat=ierr)
       deallocate(mean,stat=ierr)

! -- Free function interface memory

       ifail=free_all_memory()

       end

       program driver1

! -- This program is used as a driver for functions which read and report the contents of
!    MODFLOW binary output files.

       use function_interfaces
       use iso_c_binding, only : c_int,c_char
       implicit none

       integer (kind=c_int)  :: isim,itype,iprec
       integer (kind=c_int)  :: narray,ntime,ifail
       integer               :: ibeg,iend
       character (kind=c_char,len=1)     :: infilestring(256),outfilestring(256)
       character (kind=c_char,len=1)     :: messagestring(1500)
       character (len=30)                :: atype,aprec
       character (len=256)               :: infile,afile,outfile
       character (len=1500)              :: amessage

! -- Record what it does.

       write(6,*)
       write(6,20)
20     format(' Driver for function inquire_modflow_binary_file_specs()')
       write(6,*)

! -- Initialization

       amessage=' '

50     write(6,60)
60     format(' A simulation code is required.')
       write(6,70)
70     format(' (1=mf; 21=mfusg_s; 22=mfusg_us; 31=mf6_dis; 32=mfusg_disv; 33=mfusg_disu)')
79     write(6,80,advance='no')
80     format(' Enter simulation code: ')
       read(5,*,err=79) isim
       write(6,*)

! -- Acquire the name of the MODFLOW binary file that must be read.

100    write(6,110,advance='no')
110    format(' Enter name of MODFLOW binary output file (<Enter> if no more): ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 9990
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,infile,ibeg,iend)
       if(ifail.ne.0) go to 100
120    write(6,125,advance='no')
125    format(' Enter file type code (1=state; 2=flow): ')
       read(5,*,err=120) itype
!       if((itype.ne.1).and.(itype.ne.2)) go to 120

! -- Acquire the name of the file to which contents of this file must be recorded.

       write(6,*)
130    write(6,140,advance='no')
140    format(' Enter name for file details file (<Enter> if none): ')
       read(5,'(a)') afile
       if(afile.eq.' ')then
         outfile=' '
       else
         ibeg=1
         iend=len_trim(afile)
         call getfile(ifail,afile,outfile,ibeg,iend)
         if(ifail.ne.0) go to 130
       end if

! -- Convert to C-type character strings

       call char2string(256,infile,infilestring)
       call char2string(256,outfile,outfilestring)

! -- Call the function.

       write(6,*)
       write(6,150)
150    format(' Calling function inquire_modflow_binary_file_specs...')
       write(6,*)
       ifail=inquire_modflow_binary_file_specs(infilestring,outfilestring,  &
       isim,itype,iprec,narray,ntime)

! -- Report success or failure.

       write(6,160) ifail
160    format(' IFAIL = ',i1)
       if(ifail.ne.0)then
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         amessage=' '//trim(amessage)
         call writmess(6,amessage)
       else
         atype='xxxx'
         aprec='xxxx'
         if(itype.eq.1)then
           atype='dependent-variable'
         else if(itype.eq.2)then
           atype='cell-by-cell flow term'
         end if
         if(iprec.eq.1)then
           aprec='single'
         else if(iprec.eq.2)then
           aprec='double'
         endif
         write(6,170) trim(atype)
170      format(' FILE TYPE              = ',a)
         write(6,180) trim(aprec)
180      format(' PRECISION              = ',a)
         write(6,190) narray
190      format(' Number of arrays       =',i5)
         write(6,195) ntime
195      format(' Number of output times =',i5)

       end if
       write(6,*)
       go to 100

9990   end

       program driver16

! -- DRIVER16 tests functions related to interpolation from a MODFLOW 6 grid.

       use function_interfaces
       use iso_c_binding, only : c_int,c_char,c_double
       implicit none

       integer(kind=c_int)             :: ifail,idis,ncells,ndim1,ndim2,ndim3
       integer(kind=c_int)             :: npts,factorfiletype
       integer(kind=c_int)             :: ntime,nproctime,reapportion
       integer(kind=c_int)             :: numobsdat
       real(kind=c_double)             :: interpthresh,nointerpval,time_extrap
       character(kind=c_char,len=1)    :: how_extrap
       character(kind=c_char,len=1)    :: vartype(17)
       character(kind=c_char,len=1)    :: gridname(200)
       character(kind=c_char,len=1)    :: grbfile(256)
       character(kind=c_char,len=1)    :: factorfile(256)
       character(kind=c_char,len=1)    :: depvarfile(256)
       character(kind=c_char,len=1)    :: blnfile(256)
       character(kind=c_char,len=1)    :: messagestring(1500)

       integer(kind=c_int),allocatable :: layer(:),interp_success(:)
       integer(kind=c_int),allocatable :: obspointnum(:)
       real(kind=c_double),allocatable :: ecoord(:),ncoord(:)
       real(kind=c_double),allocatable :: simtime(:),simstate(:,:)
       real(kind=c_double),allocatable :: obstime(:),obsval(:)
       real(kind=c_double),allocatable :: cellx(:),celly(:),cellz(:)

       integer     :: ichoice,ierr
       integer     :: mpts,ipts,icount,itime,idat
       integer     :: ifailcount
       integer     :: icell,ncells_a,ncells_a_old
       character (len=10)    :: acount,anum
       character (len=16)    :: text
       character (len=20)    :: atemp20
       character (len=200)   :: agridname
       character (len=256)   :: agrbfile,infile,afile
       character (len=256)   :: outfile,dvfile,obstimfile
       character (len=500)   :: cline
       character (len=1500)  :: amessage
       character (len=20), allocatable :: pointname(:),obspoint(:)

! -- Initialisation

       npts=0
       ifailcount=0
       ncells_a_old=0

! -- Find out what to do.

90     write(6,*)
100    write(6,110)
110    format(' What do you want to do?')
       write(6,130)
130    format('     To end this program                             - enter 0')
       write(6,140)
140    format('     To install a set of MF6 grid specs              - enter 1')
       write(6,150)
150    format('     To uninstall a set of MF6 grid specs            - enter 2')
       write(6,160)
160    format('     To read a set of point coordinates              - enter 3')
       write(6,170)
170    format('     To write an interpolation factor file           - enter 4')
       write(6,180)
180    format('     To interpolate from an interp factor file       - enter 5')
       write(6,190)
190    format('     To time-interpolate after spatial interpolation - enter 6')
       write(6,195)
195    format('     To record grid cell centre coordinates          - enter 7')
199    write(6,200,advance='no')
200    format(' Enter your choice: ')
       read(5,*,err=199) ichoice
       if((ichoice.ne.0).and.(ichoice.ne.1).and.(ichoice.ne.2).and.  &
          (ichoice.ne.3).and.(ichoice.ne.4).and.(ichoice.ne.5).and.  &
          (ichoice.ne.6).and.(ichoice.ne.7)) go to 199
       if(ichoice.eq.0) go to 2000

! -- Installing grid specs.

       if(ichoice.eq.1)then
         write(6,*)
350      write(6,360,advance='no')
360      format(' Enter name of MF6 GRB file: ')
         read(5,*,err=350) agrbfile
         call char2string(200,agrbfile,grbfile)
370      write(6,380,advance='no')
380      format(' Enter name for grid: ')
         read(5,*,err=370) agridname
         call char2string(200,agridname,gridname)
         write(6,375)
375      format(' - calling function install_mf6_grid_from_file()...')
         ifail=install_mf6_grid_from_file(gridname,grbfile,                  &
               idis,ncells,ndim1,ndim2,ndim3)
         if(ifail.ne.0)then
           ifailcount=ifailcount+1
           write(6,2030)
           ifail=retrieve_error_message(messagestring)
           call string2char(1500,messagestring,amessage)
           amessage=' '//trim(amessage)
           call writmess(6,amessage)
         else
           write(6,2020)
           write(6,385) idis
385        format('   IDIS   = ',i2)
           write(6,390) ncells
390        format('   NCELLS = ',i6)
           write(6,400) ndim1,ndim2,ndim3
400        format('   IDIM1, IDIM2, IDIM3 = ',3i6)
         end if
       else if(ichoice.eq.2)then
         write(6,*)
420      write(6,430,advance='no')
430      format(' Enter name of MF6 grid to uninstall: ')
         read(5,*,err=420) agridname
         call char2string(200,agridname,gridname)
         write(6,440)
440      format(' - calling function uninstall_mf6_grid()...')
         ifail=uninstall_mf6_grid(gridname)
         if(ifail.ne.0)then
           ifailcount=ifailcount+1
           write(6,2030)
           ifail=retrieve_error_message(messagestring)
           call string2char(1500,messagestring,amessage)
           amessage=' '//trim(amessage)
           call writmess(6,amessage)
         else
           write(6,450)
450        format(' - uninstallation successful')
         end if
       else if (ichoice.eq.3)then
         write(6,*)
459      write(6,460,advance='no')
460      format(' Enter name of point coordinates file: ')
         read(5,*,err=459) infile
         open(unit=10,file=infile,status='old',err=459)
! -- Find out how many points
         mpts=0
         do
           read(10,*,end=480) atemp20
           mpts=mpts+1
         end do
480      continue
         if(mpts.eq.0)then
           close(unit=10)
           write(amessage,490)
490        format(' No points were found in this file.')
           call writmess(6,amessage)
         else
           if(npts.ne.0)then
             if(mpts.gt.npts)then
               deallocate(pointname,ecoord,ncoord,layer,interp_success)
               allocate(pointname(mpts),ecoord(mpts),ncoord(mpts),layer(mpts),interp_success(mpts))
             end if
           else
             allocate(pointname(mpts),ecoord(mpts),ncoord(mpts),layer(mpts),interp_success(mpts))
           end if
           rewind(unit=10)
           npts=mpts
           do ipts=1,npts
             read(10,*,err=500,end=500) pointname(ipts),ecoord(ipts),ncoord(ipts),layer(ipts)
             call lowcase(pointname(ipts))
           end do
           close(unit=10)
           write(6,495)
495        format(' - file read ok.')
           go to 550
500        continue
           write(amessage,510) trim(infile)
510        format(' Error reading file ',a,'.')
           call writmess(6,amessage)
           close(unit=10,iostat=ierr)
           npts=0
           deallocate(pointname,ecoord,ncoord,layer,interp_success)
550        continue
         end if
       else if(ichoice.eq.4)then
         if(npts.eq.0)then
           write(6,*)
           write(6,551)
551        format(' No point coordinates have been read.')
           go to 635
         end if
         write(6,*)
555      write(6,556,advance='no')
556      format(' Enter name of MF6 grid to interpolate from: ')
         read(5,*,err=555) afile
         call char2string(200,afile,gridname)
560      write(6,570,advance='no')
570      format(' Enter name of factor file to write: ')
         read(5,*,err=560) afile
         call char2string(200,afile,factorfile)
580      write(6,590,advance='no')
590      format(' Is this a binary or text file? [0/1]: ')
         read(5,*,err=580) factorfiletype
         if((factorfiletype.ne.0).and.(factorfiletype.ne.1)) go to 580
600      write(6,610,advance='no')
610      format(' Enter name of bln file to write: ')
         read(5,'(a)',err=600) afile                     ! use '(a)' because it may be blank
         call char2string(200,afile,blnfile)
         write(6,611)
611      format(' - calling function calc_mf6_interpolation_factors()...')
         ifail=calc_mf6_interp_factors(gridname,                      &
                                       npts,ecoord,ncoord,layer,      &
                                       factorfile, factorfiletype,    &
                                       blnfile,                       &
                                       interp_success)
         if(ifail.ne.0)then
           ifailcount=ifailcount+1
           write(6,2030)
           ifail=retrieve_error_message(messagestring)
           call string2char(1500,messagestring,amessage)
           amessage=' '//trim(amessage)
           call writmess(6,amessage)
         else
           write(6,620)
620        format(' - factor calculation and recording successful')
           icount=count(interp_success(1:npts).ne.0)
           call writint(acount,icount)
           call writint(anum,npts)
           write(6,630) trim(acount),trim(anum)
630        format(' - interpolation success rate = ',a,'/',a)
         end if
       else if(ichoice.eq.5)then
         if(npts.eq.0)then
           write(6,*)
           write(6,551)
           write(6,*)
           go to 635
         end if
         write(6,*)
700      write(6,710,advance='no')
710      format(' Enter name of MODFLOW 6 dependent variable file: ')
         read(5,*,err=700) dvfile
712      write(6,714,advance='no')
714      format(' How many times are represented in this file? ')
         read(5,*,err=712) ntime
         if(ntime.le.0) go to 712
715      write(6,716,advance='no')
716      format(' Enter text array identifier: ')
         read(5,*,err=715)text
         text=adjustl(text)
7160     write(6,7170,advance='no')
7170     format(' Enter inactive threshold: ')
         read(5,*,err=7160) interpthresh
7175     write(6,7176,advance='no')
7176     format(' Reapportion interp factors for dry/inact cells? [n/y = 0/1]: ')
         read(5,*,err=7175) reapportion
         if((reapportion.ne.0).and.(reapportion.ne.1)) go to 7175
7180     write(6,7190,advance='no')
7190     format(' Enter value indicating no interpolation: ')
         read(5,*,err=7180) nointerpval
         if(allocated(simtime)) deallocate(simtime)
         if(allocated(simstate)) deallocate(simstate)
         allocate(simtime(ntime))
         allocate(simstate(ntime,npts))
720      write(6,730,advance='no')
730      format(' Enter name of interpolation factor file: ')
         read(5,*,err=720) afile
740      write(6,590,advance='no')
         read(5,*,err=740) factorfiletype
         if((factorfiletype.ne.0).and.(factorfiletype.ne.1)) go to 740
         call char2string(200,dvfile,depvarfile)
         call char2string(200,afile,factorfile)
         call char2string(17,text,vartype)
         write(6,741)
741      format(' - calling function interp_from_mf6_depvar_file()...')
         ifail= interp_from_mf6_depvar_file(                          &
                 depvarfile,factorfile,factorfiletype,                &
                 ntime,vartype,interpthresh,reapportion,nointerpval,  &
                 npts,nproctime,simtime,simstate)
         if(ifail.ne.0)then
           ifailcount=ifailcount+1
           write(6,2030)
           ifail=retrieve_error_message(messagestring)
           call string2char(1500,messagestring,amessage)
           amessage=' '//trim(amessage)
           call writmess(6,amessage)
         else
           write(6,750)
750        format(' - interpolation successful')
           write(6,752) nproctime
752        format(' Number of interpolation times =',i5)
760        write(6,770,advance='no')
770        format(' Enter file to record interpolated values: ')
           read(5,*) outfile
           open(unit=20,file=outfile,action='write',err=760)
           do ipts=1,npts
             do itime=1,nproctime
               write(20,780) trim(pointname(ipts)),simtime(itime),simstate(itime,ipts)
780            format(1x,a,t25,1pg16.9,t45,1pg16.9)
             end do
           end do
           close(unit=20)
           write(6,790) trim(outfile)
790        format(' - file ',a,' written ok.')
         end if
       else if(ichoice.eq.6)then
         write(6,*)
820      write(6,825,advance='no')
825      format(' Enter name of observation time file: ')
         read(5,*,err=820) obstimfile
         open(unit=10,file=obstimfile,status='old',err=820)
         numobsdat=0
         do
           read(10,'(a)',end=830) cline
           if(cline.ne.' ') numobsdat=numobsdat+1
         end do
830      continue
         if(numobsdat.eq.0)then
           write(amessage,826)
826        format('No observation data in this file.')
           amessage=' '//trim(amessage)
           call writmess(6,amessage)
           close(unit=10)
           go to 90
         else
           rewind(unit=10)
         end if
         if(allocated(obspoint)) deallocate(obspoint)
         if(allocated(obstime)) deallocate(obstime)
         if(allocated(obsval)) deallocate(obsval)
         if(allocated(obspointnum)) deallocate(obspointnum)
         allocate(obspoint(numobsdat),obstime(numobsdat),obsval(numobsdat),    &
         obspointnum(numobsdat))
         do idat=1,numobsdat
           read(10,*,err=821,end=821) obspoint(idat),obstime(idat)
           call lowcase(obspoint(idat))
         end do
         close(unit=10)
         call writint(atemp20,numobsdat)
         write(6,827) trim(atemp20),trim(obstimfile)
827      format(' - ',a,' measurement times read from file ',a,'.')
         go to 849
821      continue
         write(amessage,845) trim(obstimfile)
845      format('Error encountered in reading file ',a,'.')
         close(unit=10,iostat=ierr)
         go to 90
! -- Fill the OBSPOINTNUM array.
849      continue
         do idat=1,numobsdat
           do ipts=1,npts
             if(obspoint(idat).eq.pointname(ipts)) go to 850
           end do
           obspointnum(idat)=-1
           cycle
850        obspointnum(idat)=ipts-1       ! Remember that external programs indices start at 0
         end do
         open(unit=30,file='debug.dat')   !debug
         do idat=1,numobsdat              !debug
           write(30,*) obspointnum(idat)  !debug
         end do                           !debug
         close(unit=30)                   !debug
! -- Gather a few more details on how to time-interpolate.
851      write(6,852,advance='no')
852      format(' Enter inactive threshold in spatially-interpolated data: ')
         read(5,*,err=851) interpthresh
860      write(6,870,advance='no')
870      format(' Enter time-extrapolation option (L/C): ')
         read(5,*,err=860) how_extrap
         if((how_extrap.ne.'L').and.(how_extrap.ne.'l').and.   &
          (how_extrap.ne.'C').and.(how_extrap.ne.'c')) go to 860
880      write(6,890,advance='no')
890      format(' Enter extrapolation time limit: ')
         read(5,*,err=880) time_extrap
         if(time_extrap.lt.0.0d0) go to 880
895      write(6,896,advance='no')
896      format(' Enter value indicating no time interpolation: ')
         read(5,*,err=895) nointerpval
         write(6,900)
900      format(' - calling function interp_to_obstime()....')
         ifail=interp_to_obstime(                                   &
               ntime,nproctime,npts,simtime,simstate,interpthresh,  &
               how_extrap,time_extrap,nointerpval,                  &
               numobsdat,obspointnum,obstime,obsval)
         if(ifail.ne.0)then
           ifailcount=ifailcount+1
           ifail=retrieve_error_message(messagestring)
           call string2char(1500,messagestring,amessage)
           amessage=' '//trim(amessage)
           call writmess(6,amessage)
         else
           write(6,920)
920        format(' - temporal interpolation successful.')
! -- Write the output file.
940        write(6,950,advance='no')
950        format(' Enter name for post-time-interpolation output file: ')
           read(5,*,err=940) outfile
           open(unit=21,file=outfile,action='write',err=940)
           do idat=1,numobsdat
             write(21,960) trim(obspoint(idat)),obstime(idat),obsval(idat)
960          format(1x,a,t25,1pg16.9,t50,1pg16.9)
           end do
           close(unit=21)
           write(6,970) trim(outfile)
970        format(' - file ',a,' written ok.')
         end if
       else if(ichoice.eq.7)then
         write(6,*)
1020     write(6,1030,advance='no')
1030     format(' Enter name of installed MF6 grid: ')
         read(5,*,err=1020) agridname
         call char2string(200,agridname,gridname)
1040     write(6,1050,advance='no')
1050     format(' Enter number of cells in grid: ')
         read(5,*,err=1040) ncells_a
         if(ncells_a_old.eq.0)then
           allocate(cellx(ncells_a),celly(ncells_a),cellz(ncells_a))
           ncells_a_old=ncells_a
         else
           if(ncells_a_old.lt.ncells_a)then
             deallocate(cellx,celly,cellz)
             allocate(cellx(ncells_a),celly(ncells_a),cellz(ncells_a))
             ncells_a_old=ncells_a
           end if
         end if
1080     write(6,1090,advance='no')
1090     format(' Enter file to record grid cell centre coordinates: ')
         read(5,*,err=1080) outfile
         open(unit=21,file=outfile,action='write',err=1080)
         write(6,1100)
1100     format(' - calling function get_cell_centres_mf6()...')
         ifail=get_cell_centres_mf6(gridname,               &
                              ncells_a,                     &
                              cellx,celly,cellz)
         if(ifail.ne.0)then
           ifailcount=ifailcount+1
           write(6,2030)
           ifail=retrieve_error_message(messagestring)
           call string2char(1500,messagestring,amessage)
           amessage=' '//trim(amessage)
           call writmess(6,amessage)
           close(unit=21)
         else
           write(21,1110)
1110       format(' CELL',t20,'CELLX',t40,'CELLY',t60,'CELLZ')
           do icell=1,ncells
             write(21,1120) icell,cellx(icell),celly(icell),cellz(icell)
1120         format(2x,i8,t20,f16.4,t40,f16.4,t60,f16.4)
           end do
           close(unit=21)
           write(6,1130) trim(outfile)
1130       format(' - file ',a,' written ok.')
         end if
       end if
635    continue
       go to 90

2000   write(6,*)
       write(6,2010)
2010   format(' Calling free_all_memory()...')
       ifail = free_all_memory()
       if(ifail.eq.0)then
         write(6,2020)
2020     format(' - function call successful.')
       else
         ifailcount=ifailcount+1
         write(6,2030)
2030     format(/,' Function call unsuccessful: error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         amessage=' '//trim(amessage)
         call writmess(6,amessage)
       end if

       if(ifailcount.ne.0)then
         call writint(anum,ifailcount)
         write(6,2031) trim(anum)
2031     format(/,' WARNING: function call failure count = ',a,'.')
       end if
       deallocate(pointname,ecoord,ncoord,layer,interp_success,stat=ierr)
       deallocate(simtime,simstate,stat=ierr)
       deallocate(cellx,celly,cellz,stat=ierr)

       end

       program driver12

! -- DRIVER12 tests inverse power-of-distance interpolation.

       use function_interfaces
       use iso_c_binding, only : c_int,c_char,c_double
       implicit none

! -- Variables used in function calls.

       integer(kind=c_int)           :: ifail
       integer(kind=c_int)           :: npts
       integer(kind=c_int)           :: mpts
       integer(kind=c_int)           :: transtype
       character(kind=c_char,len=1)  :: messagestring(1500)

       integer(kind=c_int), allocatable   :: zns(:),znt(:)
       real(kind=c_double), allocatable   :: ecs(:),ncs(:),sval(:)
       real(kind=c_double), allocatable   :: ect(:),nct(:),tval(:)
       real(kind=c_double), allocatable   :: anis(:),bearing(:),invpow(:)

! -- Other variables

       integer               :: ierr,ifile
       integer               :: nrow,ncol,irow,icol
       integer               :: ipt
       double precision      :: pi
       double precision      :: e0,n0,angle
       double precision      :: cosang,sinang
       double precision      :: nointerpval
       character (len=1)     :: anl
       character (len=20)    :: arraytype,anum
       character (len=200)   :: cline
       character (len=256)   :: infile,outfile
       character (len=1500)  :: amessage

! -- Other allocatable variables.

       double precision, allocatable      :: delr(:),delc(:)
       double precision, allocatable      :: x(:),y(:)
       character (len=20), allocatable    :: apoint(:)

! -- Initialization

       pi=3.14159265358979000

! -- Read the grid specification file.

100    write(6,110,advance='no')
110    format(' Enter name of MF grid spec file: ')
       read(5,*,err=100) infile
       open(unit=10,file=infile,status='old',err=100)
       read(10,*,err=9000,end=9050) nrow,ncol
       read(10,*,err=9000,end=9050) e0,n0,angle
       allocate(delr(ncol),delc(nrow),stat=ierr)
       if(ierr.ne.0) go to 9200
       read(10,*,err=9000,end=9050) (delr(icol),icol=1,ncol)
       read(10,*,err=9000,end=9050) (delc(irow),irow=1,nrow)
       close(unit=10)
       write(6,120) trim(infile)
120    format(' - file ',a,' read ok.')
       mpts=ncol*nrow

! -- Allocate target arrays.

       allocate(anis(mpts),bearing(mpts),znt(mpts),invpow(mpts),tval(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(ect(mpts),nct(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200

! -- Read arrays associated with this grid.

       do ifile=1,4
         write(6,*)
         if(ifile.eq.1)then
           arraytype='anisotropy ratio'
         else if(ifile.eq.2)then
           arraytype='anisotropy bearing'
         else if(ifile.eq.3)then
           arraytype='inverse power'
         else if(ifile.eq.4)then
           arraytype='zone'
         end if
149      write(6,150,advance='no') trim(arraytype)
150      format(' Enter name of ',a,' array file: ')
         read(5,*,err=149) infile
         open(unit=10,file=infile,status='old',err=149)
         if(ifile.eq.1)then
           read(10,*,err=9000,end=9050) (anis(ipt),ipt=1,mpts)
         else if(ifile.eq.2)then
           read(10,*,err=9000,end=9050) (bearing(ipt),ipt=1,mpts)
         else if(ifile.eq.3)then
           read(10,*,err=9000,end=9050) (invpow(ipt),ipt=1,mpts)
         else if(ifile.eq.4)then
           read(10,*,err=9000,end=9050) (znt(ipt),ipt=1,mpts)
         end if
         close(unit=10)
         write(6,120) trim(infile)
       end do

! -- The pilot points file is read.

       write(6,*)
180    write(6,190,advance='no')
190    format(' Enter name of pilot points file: ')
       read(5,*,err=180) infile
       open(unit=10,file=infile,status='old',err=180)
       npts=0
       do
         read(10,'(a)',end=200) cline
         if(cline.eq.' ')cycle
         npts=npts+1
       end do
200    continue
       if(npts.eq.0)then
         write(6,201)
201      format(/,' *** No points in file. Try again ***',/)
         close(unit=10)
         go to 180
       end if
       allocate(apoint(npts),ecs(npts),ncs(npts),zns(npts),sval(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       rewind(10)
       do ipt=1,npts
         read(10,*,err=9000,end=9050) apoint(ipt),ecs(ipt),ncs(ipt),zns(ipt),sval(ipt)
       end do
       close(unit=10)
       write(6,120) trim(infile)

! -- Enter some control variables.

       write(6,*)
401    write(6,402,advance='no')
402    format(' Interpolate in natural or log domain? [n/l]: ')
       read(5,*,err=401) anl
       if((anl.eq.'N').or.(anl.eq.'n'))then
         transtype=0
       else if((anl.eq.'L').or.(anl.eq.'l'))then
         transtype=1
       else
         go to 401
       end if
405    write(6,406,advance='no')
406    format(' Enter number indicating no interpolation to target array: ')
       read(5,*,err=405) nointerpval
       tval=nointerpval ! an array

! -- Convert the array centre coordinates to lists.

       cosang=cos(angle*pi/180.0d0)
       sinang=sin(angle*pi/180.0d0)
       allocate(x(ncol),y(nrow),stat=ierr)
       if(ierr.ne.0) go to 9200

       do icol=1,ncol
         if(icol.eq.1)then
           x(icol)=delr(1)*0.5
         else
           x(icol)=x(icol-1)+(delr(icol)+delr(icol-1))*0.5
         end if
       end do
       do irow=1,nrow
         if(irow.eq.1)then
           y(irow)=-delc(irow)*0.5
         else
           y(irow)=y(irow-1)-(delc(irow)+delc(irow-1))*0.5
         end if
       end do
       ipt=0
       do irow=1,nrow
         do icol=1,ncol
           ipt=ipt+1
           ect(ipt)=x(icol)*cosang-y(irow)*sinang+e0
           nct(ipt)=x(icol)*sinang+y(irow)*cosang+n0
         end do
       end do

! -- Now call the function to do the interpolation.

       write(6,*)
       write(6,320)
320    format(' Calling ipd_interpolate_2d()....')
       ifail=ipd_interpolate_2d(npts,ecs,ncs,zns,sval,        &
                                   mpts,ect,nct,znt,tval,     &
                                   transtype,                 &
                                   anis,bearing,invpow)

       if(ifail.ne.0)then
         write(6,*)
         write(6,340)
340      format(' Function call unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       else
         write(6,350)
350      format(' Function call successful.')
       end if

! -- We now store the results as a real array.

       write(6,*)
440    write(6,450,advance='no')
450    format(' Enter filename for real array storage: ')
       read(5,*,err=440) outfile
       open(unit=20,file=outfile,action='write',err=440)
       write(20,460) (tval(ipt),ipt=1,mpts)
460    format(1pg16.9)
       close(unit=20)
       write(6,470) trim(outfile)
470    format(' - file ',a,' written ok.')

       go to 9900

9000   write(amessage,9010) trim(infile)
9010   format('Error encountered in reading file ',a,'.')
       go to 9890

9050   write(amessage,9060) trim(infile)
9060   format('Premature end encountered to file ',a,'.')
       go to 9890

9200   write(amessage,9210)
9210   format('Insufficient memory to continue execution.')
       go to 9890


9890   continue
       amessage=' '//trim(amessage)
       call writmess(6,amessage)

! -- Tidy up

9900   continue

! -- Free local memory

       deallocate(zns,znt,stat=ierr)
       deallocate(ecs,ncs,sval,stat=ierr)
       deallocate(ect,nct,tval,stat=ierr)
       deallocate(anis,bearing,invpow,stat=ierr)
       deallocate(delr,delc,stat=ierr)
       deallocate(x,y,stat=ierr)
       deallocate(apoint,stat=ierr)

! -- Free function interface memory

       ifail=free_all_memory()

       end

       program driver2

! -- This driver tests functions that install structured grid specs and
!    perform spatial interpolation from an installed grid to arbitrary points.

       use function_interfaces
       use iso_c_binding, only : c_int,c_char,c_double
       implicit none

       integer (kind=c_int)            :: icorner,ifail
       integer (kind=c_int)            :: nrow,ncol,nlay
       integer (kind=c_int)            :: npts
       integer (kind=c_int)            :: proctime,ntime,iprec,isim
       real (kind=c_double)            :: e0,n0,rotation
       real (kind=c_double)            :: interpthresh,nointerpval
       character (len=1,kind=c_char)   :: messagestring(1500)
       character (len=1,kind=c_char)   :: depvarfile(256)
       character (len=1,kind=c_char)   :: texttype(17)
       character (len=1,kind=c_char)   :: gridname(200)

       integer (kind=c_int), allocatable :: layer(:)
       real (kind=c_double), allocatable :: delr(:),delc(:)
       real (kind=c_double), allocatable :: ee(:),nn(:)
       real (kind=c_double), allocatable :: simtime(:),simstate(:,:)

       integer              :: ibeg,iend,ierr
       integer              :: irow,icol,ncolold,nrowold
       integer              :: ipts
       integer              :: itime
       character (len=1)    :: aa
       character (len=17)   :: atext
       character (len=200)  :: chargridname
       character (len=256)  :: afile,infile,outfile
       character (len=500)  :: cline
       character (len=1500) :: amessage
       character (len=20), allocatable :: apoint(:)

! -- Initialization

       nrowold=0
       ncolold=0

! -- Obtain grid specifications from a grid specification file.

       write(6,*)
       write(6,50)
50     format(' Testing grid installation....')

100    write(6,*)
       write(6,110,advance='no')
110    format(' Enter name of a GW Utils grid spec file (<Enter> if no more): ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 300
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,infile,ibeg,iend)
       if(ifail.ne.0) go to 100
       open(unit=10,file=infile,status='old',err=100)
       read(10,*,err=9000,end=9000) nrow,ncol
       read(10,*,err=9000,end=9000) e0,n0,rotation
       if(nrowold.eq.0)then
         allocate(delr(ncol),delc(nrow),stat=ierr)
         if(ierr.ne.0) go to 9200
       else
         if(ncol.gt.ncolold)then
           deallocate(delr,stat=ierr)
           allocate(delr(ncol),stat=ierr)
           if(ierr.ne.0) go to 9200
         end if
         if(nrow.gt.nrowold)then
           deallocate(delc,stat=ierr)
           allocate(delc(nrow),stat=ierr)
           if(ierr.ne.0) go to 9200
         end if
       end if
       ncolold=ncol
       nrowold=nrow
       read(10,*,err=9000,end=9000) (delr(icol),icol=1,ncol)
       read(10,*,err=9000,end=9000) (delc(irow),irow=1,nrow)
       close(unit=10)
       write(6,130) trim(infile)
130    format(' - file ',a,' read ok.')

140    write(6,145,advance='no')
145    format(' How many layers in this grid? ')
       read(5,*,err=140) nlay
       if(nlay.le.0) go to 140

! -- Obtain a name for this structured grid from the user.

150    write(6,160,advance='no')
160    format(' Supply a name for this grid: ')
       read(5,'(a)') afile
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,chargridname,ibeg,iend)
       if(ifail.ne.0) go to 150
       call char2string(200,chargridname,gridname)

! -- Install the grid.

       write(6,165)
165    format(' Installing structured grid specs...')
       icorner=1
       ifail=install_structured_grid(gridname,ncol,nrow,nlay,icorner,e0,n0,rotation,delr,delc)
       if(ifail.eq.0)then
         write(6,170)
170      format(/,' Installation successful.')
       else
         write(6,171)
171      format(/,' Installation unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         amessage=' '//trim(amessage)
         call writmess(6,amessage)
       end if
       go to 100

300    continue

! -- Test de-installation.

       write(6,*)
       write(6,*)
       write(6,350)
350    format(' Testing grid deinstallation....')

400    write(6,*)
420    write(6,430,advance='no')
430    format(' Enter name of grid to uninstall (<Enter> if no more): ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 500
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,chargridname,ibeg,iend)
       if(ifail.ne.0) go to 420
       call char2string(200,chargridname,gridname)
       ifail=uninstall_structured_grid(gridname)
       if(ifail.eq.0)then
         write(6,470)
470      format(' Uninstallation successful.')
       else
         write(6,471)
471      format(/,' Uninstallation unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         amessage=' '//trim(amessage)
         call writmess(6,amessage)
       end if
       go to 400

500    continue
       write(6,*)
509    write(6,510,advance='no')
510    format(' Install more grids? [y/n]: ')
       read(5,'(a)') aa
       if((aa.eq.'y').or.(aa.eq.'Y'))then
         go to 100
       else if((aa.eq.'n').or.(aa.eq.'N'))then
         continue
       else
         go to 509
       end if

! -- We will now read a file with point coordinates and layers.

       write(6,*)
520    write(6,530,advance='no')
530    format(' Enter name of point coordinates file (<Enter> if none): ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 9900
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,infile,ibeg,iend)
       if(ifail.ne.0) go to 520
       open(unit=10,file=infile,status='old',iostat=ierr)
       if(ierr.ne.0)then
         write(6,540)
540      format(' Cannot open file. Try again.')
         go to 520
       end if
       npts=0
       do
         read(10,'(a)',end=550) cline
         if(cline.ne.' ') npts=npts+1
       end do
550    if(npts.eq.0)then
         write(6,560)
560      format(' No points in file. Try again.')
         close(unit=10)
         go to 520
       else
         rewind(unit=10)
       end if
       allocate(apoint(npts),ee(npts),nn(npts),layer(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       do ipts=1,npts
         read(10,*,err=9050,end=9050) apoint(ipts),ee(ipts),nn(ipts),layer(ipts)
       end do
       close(unit=10)
       write(6,570) trim(infile)
570    format(' - file ',a,' read ok.')

! -- Find out the MODFLOW output file to read.

580    write(6,590,advance='no')
590    format(' Enter name of MODFLOW binary dep. var. output file: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 580
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,infile,ibeg,iend)
       if(ifail.ne.0) go to 580
595    write(6,596,advance='no')
596    format(' Enter grid name to which it pertains: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 595
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,chargridname,ibeg,iend)
       if(chargridname.eq.' ') go to 595
613    write(6,615,advance='no')
615    format(' Enter number of output times in this file: ')
       read(5,*,err=613) ntime
       if(ntime.le.0) go to 613
600    write(6,610,advance='no')
610    format(' Enter precision (1=single; 2=double): ')
       read(5,*,err=600) iprec
       if((iprec.ne.1).and.(iprec.ne.2)) go to 600
611    write(6,612,advance='no')
612    format(' Enter HDRY/HNOFLO threshold: ')
       read(5,*,err=611) interpthresh
       if(interpthresh.le.0) go to 611
617    write(6,618,advance='no')
618    format(' Enter header text of interest: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 617
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,atext,ibeg,iend)
620    write(6,630,advance='no')
630    format(' Enter name for output file: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 620
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,outfile,ibeg,iend)
       if(ifail.ne.0) go to 620
       open(unit=20,file=outfile,action='write',err=620)

! -- Allocate some memory

       allocate(simtime(ntime),simstate(ntime,npts),stat=ierr)
       if(ierr.ne.0) go to 9200

! -- Convert pertinent character variables to strings.

       call char2string(200,infile,depvarfile)
       call char2string(200,chargridname,gridname)
       call char2string(17,atext,texttype)
       isim=1
       nointerpval=1.1d30

! -- Call the function.

       write(6,650)
650    format(' Calling interp_from_structured_grid()....')
       ifail=interp_from_structured_grid(                                     &
                             GridName,DepVarFile,isim,iprec,ntime,            &
                             TextType,InterpThresh,NoInterpVal,               &
                             npts,ee,nn,layer,                                &
                             proctime,simtime,simstate)
       if(ifail.eq.0)then
         write(6,670)
670      format(' Spatial interpolation successful.')
         write(6,680) proctime
680      format(' Number of output times =',i5)
         do ipts=1,npts
           do itime=1,ntime
             write(20,690) trim(apoint(ipts)),simtime(itime),simstate(itime,ipts)
690          format(1x,a,t25,1pg16.9,t45,1pg16.9)
           end do
         end do
         close(unit=20)
         write(6,700) trim(outfile)
700      format(' - file ',a,' written ok.')
       else
         write(6,710)
710      format(' Function call unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         amessage=' '//trim(amessage)
         call writmess(6,amessage)
       end if

! -- Repeat the cycle

       deallocate(simtime,simstate,stat=ierr)
       deallocate(apoint,ee,nn,layer,stat=ierr)
       write(6,*)
       go to 520

9000   write(amessage,9010) trim(infile)
9010   format('Error reading grid specification file ',a,'.')
       go to 9890

9050   write(amessage,9060) trim(infile)
9060   format('Error encountered in reading file ',a,'.')
       go to 9890

9200   write(amessage,9210)
9210   format('Driver program suffers memory allocation error.')
       go to 9890

9890   continue
       amessage=' '//trim(amessage)
       call writmess(6,amessage)

! -- Tidy up

9900   continue
       write(6,*)
       write(6,9910)
9910   format(' Tidying up...')

       ifail=free_all_memory()
       if(ifail.eq.0)then
         write(6,9920)
9920     format(' Tidying up successful.')
         write(6,*)
       else
         write(6,9921)
9921     format(' Tidying up unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         amessage=' '//trim(amessage)
         call writmess(6,amessage)
       end if
       deallocate(delr,delc,stat=ierr)
       deallocate(layer,ee,nn,stat=ierr)
       deallocate(simtime,simstate,stat=ierr)
       deallocate(apoint,stat=ierr)

       end

       program driver17

! -- This driver records the coordinates of cell centres of one layer of a structured grid.

       use function_interfaces
       use iso_c_binding, only : c_int,c_char,c_double
       implicit none

       integer(kind=c_int)             :: nrow,ncol,nlay,ncpl
       integer(kind=c_int)             :: icorner,ifail
       real(kind=c_double)             :: e0,n0,rotation
       character(kind=c_char,len=1)    :: gridname(200)
       character(kind=c_char,len=1)    :: messagestring(1500)

       real(kind=c_double),allocatable :: delr(:),delc(:)
       real(kind=c_double),allocatable :: cellx(:),celly(:)

       integer              :: ibeg,iend,ierr
       integer              :: irow,icol,icell
       character (len=200)  :: chargridname
       character (len=256)  :: afile,infile,outfile
       character (len=1500) :: amessage

! -- Obtain grid specifications from a grid specification file.

       write(6,*)
       write(6,50)
50     format(' Testing grid installation....')

100    write(6,*)
109    write(6,110,advance='no')
110    format(' Enter name of a GW Utils grid spec file: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 100
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,infile,ibeg,iend)
       if(ifail.ne.0) go to 100
       open(unit=10,file=infile,status='old',err=100)
       read(10,*,err=9000,end=9000) nrow,ncol
       read(10,*,err=9000,end=9000) e0,n0,rotation
       allocate(delr(ncol),delc(nrow),stat=ierr)
       if(ierr.ne.0) go to 9200
       read(10,*,err=9000,end=9000) (delr(icol),icol=1,ncol)
       read(10,*,err=9000,end=9000) (delc(irow),irow=1,nrow)
       close(unit=10)
       write(6,130) trim(infile)
130    format(' - file ',a,' read ok.')

! -- Other details of the grid are supplied automatically.

       nlay=5
       chargridname='grid1'
       call char2string(200,chargridname,gridname)

! -- Install the grid.

       write(6,165)
165    format(' Installing structured grid specs...')
       icorner=1
       ifail=install_structured_grid(gridname,ncol,nrow,nlay,icorner,e0,n0,rotation,delr,delc)
       if(ifail.eq.0)then
         write(6,170)
170      format(' Installation successful.')
       else
         write(6,171)
171      format(' Installation unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       end if

! -- Request coordinates of grid cell centres.

       write(6,*)
180    write(6,190,advance='no')
190    format(' Enter name of file to store cell centre coordinates: ')
       read(5,*) outfile
       open(unit=20,file=outfile,action='write',err=180)
       write(20,200)
200    format(' ICOL',t15,'IROW',t30,'CELLX',t50,'CELLY')
       write(6,*)
       write(6,220)
220    format(' Retrieving cell centre coordinates...')
       ncpl=ncol*nrow
       allocate(cellx(ncpl),celly(ncpl),stat=ierr)
       if(ierr.ne.0) go to 9200
       ifail=get_cell_centres_structured(gridname,ncpl,cellx,celly)
       if(ifail.eq.0)then
         write(6,230)
230      format(' Retrieval successful.')
       else
         write(6,240)
240      format(' Retrieval unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       end if
       icell=0
       do irow=1,nrow
         do icol=1,ncol
           icell=icell+1
           write(20,245) icol,irow,cellx(icell),celly(icell)
245        format(2x,i5,t15,i5,t30,f16.4,t50,f16.4)
         end do
       end do
       close(unit=20)
       write(6,250) trim(outfile)
250    format(' - file ',a,' written ok.')

       go to 9900

9000   write(amessage,9010) trim(infile)
9010   format('Error reading grid specification file ',a,'.')
       go to 9890

9050   write(amessage,9060) trim(infile)
9060   format('Error encountered in reading file ',a,'.')
       go to 9890

9200   write(amessage,9210)
9210   format('Driver program suffers memory allocation error.')
       go to 9890

9890   continue
       amessage=' '//trim(amessage)
       call writmess(6,amessage)

! -- Tidy up

9900   continue
       write(6,*)
       write(6,9910)
9910   format(' Tidying up...')

       ifail=free_all_memory()
       if(ifail.eq.0)then
         write(6,9920)
9920     format(' Tidying up successful.')
         write(6,*)
       else
         write(6,9921)
9921     format(' Tidying up unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         amessage=' '//trim(amessage)
         call writmess(6,amessage)
       end if
       deallocate(delr,delc,stat=ierr)
       deallocate(cellx,celly,stat=ierr)

       end

module dimvar

! -- Dimensioning and size

       integer, parameter :: LENCLINE=1000
       integer, parameter :: LENFILENAME=257
       integer, parameter :: LENMESSAGE=1500
       integer, parameter :: LENGRIDNAME=201
       integer, parameter :: LENFUNCNAME=150
       integer, parameter :: MAXSTRUCMODGRID=5
       integer, parameter :: MAXMF6MODGRID=5
       integer, parameter :: MAXINTERPVERT=10  ! Maximum no. of vertices for interpolation
       integer, parameter :: LENFACCODE=20     ! Characters in factor file code

end module dimvar

       subroutine char2string(ndim,textchar,textstring)

! -- Converts a FORTRAN character variable to a C type string.

       use iso_c_binding, only: c_char
       implicit none
       integer, intent(in)                        :: ndim
       character (len=*), intent(in)              :: textchar
       character (kind=c_char,len=1), intent(out) :: textstring(ndim)

       integer    :: ns,is

       ns=min(len_trim(textchar),ndim-1)
       do is=1,ns
         textstring(is)=textchar(is:is)
       end do
       textstring(ns+1)=achar(0)
       return

       end



       subroutine string2char(ndim,textstring,textchar)

! -- Converts a C type character string to a FORTRAN character variable.

       use iso_c_binding, only: c_char
       implicit none
       integer, intent(in)                        :: ndim
       character (kind=c_char,len=1), intent(in)  :: textstring(ndim)
       character (len=*), intent(out)             :: textchar

       integer       :: ns,is

       ns=len(textchar)
       textchar=' '
       do is=1,min(ns,ndim)
         if(textstring(is).eq.char(0))exit
         textchar(is:is)=textstring(is)
       end do
       return

       end

        subroutine getfile(ifail,cline,filename,ibeg,iend)

!-- Subroutine getfile extracts a filename from a string.

! -- Arguments are as follows:-
!       ifail: returned as zero if filename successfully read
!       cline: a character string containing the file name
!       filename: the name of the file read from the string
!       ibeg: character position at which to begin search for filename
!       iend: on input  - character position at which to end search for filename
!             on output - character postion at which filename ends


        integer, intent(out)               :: ifail
        integer, intent(in)                :: ibeg
        integer, intent(inout)             :: iend
        character (len=*), intent(in)      :: cline
        character (len=*), intent(out)     :: filename

        integer                            :: i,j,k
        character (len=1)                  :: aa

        ifail=0
        do i=ibeg,iend
          aa=cline(i:i)
          if((aa.ne.' ').and.(aa.ne.',').and.(aa.ne.char(9)))go to 50
        end do
        ifail=1
        return

50      if((aa.eq.'"').or.(aa.eq.''''))then
          do j=i+1,iend
            if(cline(j:j).eq.aa) go to 60
          end do
          ifail=1
          return
60        iend=j
          if(i+1.gt.j-1)then
            ifail=1
            return
          else
            filename=cline(i+1:j-1)
          end if
        else
          do j=i+1,iend
            if((cline(j:j).eq.' ').or.(cline(j:j).eq.',').or.(cline(j:j).eq.char(9)))then
              k=j-1
              go to 100
            end if
          end do
          k=iend
100       filename=cline(i:k)
          if(cline(k:k).eq.'"')then
            ifail=1
            return
          else if(cline(k:k).eq.'''')then
            ifail=1
            return
          end if

          iend=k
        end if
        filename=adjustl(filename)
        return

        end


      subroutine writmess(iunit,amessage)

        implicit none

        integer iunit,jend,i,nblc,junit,leadblank,itake,j
        character*(*) amessage
        character (len=20) ablank

        ablank=' '
        itake=0
        j=0
        junit=iunit

        if(amessage.eq.' ')then
          write(junit,*)
          return
        end if
        write(junit,*)
        do i=1,min(20,len(amessage))
          if(amessage(i:i).ne.' ')go to 21
20      end do
21      leadblank=i-1
        nblc=len_trim(amessage)
5       jend=j+78-itake
        if(jend.ge.nblc) go to 100
        do i=jend,j+1,-1
        if(amessage(i:i).eq.' ') then
          if(itake.eq.0) then
             write(junit,'(a)') amessage(j+1:i)
             itake=2+leadblank
          else
             write(junit,'(a)') ablank(1:leadblank+2)//amessage(j+1:i)
          end if
          j=i
          go to 5
        end if
        end do
        if(itake.eq.0)then
          write(junit,'(a)') amessage(j+1:jend)
          itake=2+leadblank
        else
          write(junit,'(a)') ablank(1:leadblank+2)//amessage(j+1:jend)
        end if
        j=jend
        go to 5
100     jend=nblc
        if(itake.eq.0)then
          write(junit,'(a)') amessage(j+1:jend)
        else
          write(junit,'(a)') ablank(1:leadblank+2)//amessage(j+1:jend)
        end if
        return

      end


        SUBROUTINE LOWCASE(ASTRNG)

! -- Subroutine LOWCASE converts a string to lower case.

        INTEGER I,J
        CHARACTER*(*) ASTRNG

        DO 10 I=1,len_trim(ASTRNG)
        J=ICHAR(ASTRNG(I:I))
        IF((J.GE.65).AND.(J.LE.90)) ASTRNG(I:I)=CHAR(J+32)
10      CONTINUE
        RETURN
        END


        subroutine writint(atemp,ival)

!       Subroutine WRITINT writes an integer to a character variable.

        integer(kind=4) ival
        character*6 afmt
        character*(*) atemp

        afmt='(i   )'
        write(afmt(3:5),'(i3)') len(atemp)
        write(atemp,afmt)ival
        atemp=adjustl(atemp)
        return
        end



SUBROUTINE intREAD(IFAIL,CLINE,iTEMP)

! -- Subroutine intREAD reads a real number from a string.

        INTEGER IFAIL
        integer iTEMP
        CHARACTER*6 AFMT
        CHARACTER*(*) CLINE

        IFAIL=0
        AFMT='(i   )'
        WRITE(AFMT(3:5),'(I3)') LEN(CLINE)
        READ(CLINE,AFMT,ERR=100) iTEMP
        RETURN

100     IFAIL=1
        RETURN

END SUBROUTINE INTREAD


        SUBROUTINE DREALREAD(IFAIL,CLINE,RTEMP)

! -- Subroutine REALREAD reads a real number from a string.

        INTEGER IFAIL
        double precision RTEMP
        CHARACTER*8 AFMT
        CHARACTER*(*) CLINE

        IFAIL=0
        AFMT='(F   .0)'
        WRITE(AFMT(3:5),'(I3)') len_trim(CLINE)
        READ(CLINE,AFMT,ERR=100) RTEMP
        RETURN

100     IFAIL=1
        RETURN
        END


SUBROUTINE LINESPLIT(IFAIL,NUM,LW,RW,CLINE)

! -- Subroutine LINESPLIT splits a string into blank-delimited fragments.

        INTEGER IFAIL,NW,NBLC,J,I
        INTEGER NUM,NBLNK
        INTEGER LW(NUM),RW(NUM)
        CHARACTER*(*) CLINE

        IFAIL=0
        NW=0
        NBLC=len_trim(CLINE)
        IF((NBLC.NE.0).AND.(INDEX(CLINE,CHAR(9)).NE.0)) THEN
          CALL TABREM(CLINE)
          NBLC=len_trim(CLINE)
        ENDIF
        IF(NBLC.EQ.0) THEN
          IFAIL=-1
          RETURN
        END IF
        J=0
5       IF(NW.EQ.NUM) RETURN
        DO 10 I=J+1,NBLC
          IF((CLINE(I:I).NE.' ').AND.(CLINE(I:I).NE.',').AND.   &
          (ICHAR(CLINE(I:I)).NE.9)) GO TO 20
10      CONTINUE
        IFAIL=1
        RETURN
20      NW=NW+1
        LW(NW)=I
        DO 30 I=LW(NW)+1,NBLC
          IF((CLINE(I:I).EQ.' ').OR.(CLINE(I:I).EQ.',').OR.     &
          (ICHAR(CLINE(I:I)).EQ.9)) GO TO 40
30      CONTINUE
        RW(NW)=NBLC
        IF(NW.LT.NUM) IFAIL=1
        RETURN
40      RW(NW)=I-1
        J=RW(NW)
        GO TO 5

END SUBROUTINE LINESPLIT


SUBROUTINE TABREM(CLINE)

! -- Subroutine TABREM removes tabs from a string.

        INTEGER I
        CHARACTER*(*) CLINE

        DO 10 I=1,LEN(CLINE)
10      IF(ICHAR(CLINE(I:I)).EQ.9) CLINE(I:I)=' '

        RETURN
END SUBROUTINE TABREM

MODULE DEFTYPES

! -- General dimensioning parameters.

       use dimvar

! -- MF6-specific parameters and grid-independent data

       integer, parameter           :: MF6HEADERLEN=50
       integer, parameter           :: MAXLENTXT=120
       integer, parameter           :: NTXT_DIS=16
       integer, parameter           :: NTXT_DISV=20
       integer                      :: expect_dis_type(NTXT_DIS),expect_disv_type(NTXT_DISV)
       character (len=10)           :: expectdefn_dis(NTXT_DIS),expectdefn_disv(NTXT_DISV)
       character (len=MF6HEADERLEN) :: mf6header(4)
       character (len=MAXLENTXT)    :: definition(max(NTXT_DIS,NTXT_DISV))

       data expectdefn_dis  /'NCELLS    ','NLAY      ','NROW      ','NCOL      ',              &
                             'NJA       ','XORIGIN   ','YORIGIN   ','ANGROT    ',              &
                             'DELR      ','DELC      ','TOP       ','BOTM      ',              &
                             'IA        ','JA        ','IDOMAIN   ','ICELLTYPE ' /

       data expect_dis_type /1,1,1,1,1,2,2,2,2,2,2,2,1,1,1,1/


       data expectdefn_disv /'NCELLS    ','NLAY      ','NCPL      ','NVERT     ',              &
                             'NJAVERT   ','NJA       ','XORIGIN   ','YORIGIN   ',              &
                             'ANGROT    ','TOP       ','BOTM      ','VERTICES  ',              &
                             'CELLX     ','CELLY     ','IAVERT    ','JAVERT    ',              &
                             'IA        ','JA        ','IDOMAIN   ','ICELLTYPE ' /

       data expect_disv_type /1,1,1,1,1,1,2,2,2,2,2,2,2,2,1,1,1,1,1,1/

! -- Structured grid type

       type strucgrid
         character (len=LENGRIDNAME)              :: name=' '
         integer                                  :: ncol=0
         integer                                  :: nrow=0
         integer                                  :: nlay=0
         double precision                         :: e0,n0    ! top left corner
         double precision                         :: rotation,cosang,sinang
         double precision, dimension(:), pointer  :: delr,delc
       end type strucgrid

! -- MF6 grid type

       type mf6grid
         integer                     :: distype=0
         integer                     :: ncells=0
         integer                     :: ncrl=0
         integer                     :: ncr=0
         integer                     :: ncol=0
         integer                     :: nrow=0
         integer                     :: nlay=0
         integer                     :: ncpl=0
         integer                     :: nvert=0
         integer                     :: njavert=0
         integer                     :: nja=0
         double precision            :: xorigin,yorigin,angrot
         character (len=LENGRIDNAME) :: name=' '

         integer, pointer                   :: idomain(:,:,:),icelltype(:,:,:)
         integer, pointer                   :: iavert(:),javert(:)
         integer, pointer                   :: idomainv(:,:),icelltypev(:,:)
         integer, pointer                   :: ivv(:,:,:)
         integer, pointer                   :: ibound(:,:)
         integer, pointer                   :: nvertcon(:),vertconcell(:,:),identvert(:,:)
         integer, pointer                   :: ia(:),ja(:)
         double precision, pointer          :: delc(:),delr(:)
         double precision, pointer          :: botm(:,:,:)
         double precision, pointer          :: botmv(:,:)
         double precision, pointer          :: vertices(:,:),cellx(:),celly(:)
         double precision, pointer          :: bottom(:,:)
       end type mf6grid

! -- Incidences of grids.

       type (strucgrid), dimension(MAXSTRUCMODGRID) :: strucmodgrid
       integer                                      :: numstrucmodgrid=0
       type (mf6grid), dimension(MAXMF6MODGRID)     :: mf6modgrid
       integer                                      :: nummf6modgrid=0

END MODULE DEFTYPES

       program driver7

! -- DRIVER7 tests 2-D kriging interpolation using calc_kriging_factors_auto_2d().
!    This is a slightly-modified version of DRIVER6.

       use function_interfaces
       use iso_c_binding, only : c_int,c_char,c_double
       implicit none

! -- Variables used in function calls.

       integer(kind=c_int)           :: ifail
       integer(kind=c_int)           :: npts
       integer(kind=c_int)           :: mpts
       integer(kind=c_int)           :: krigtype
       integer(kind=c_int)           :: transtype
       character (kind=c_char,len=1) :: factorfile(256)
       integer(kind=c_int)           :: factorfiletype
       character(kind=c_char,len=1)  :: messagestring(1500)
       integer(kind=c_int)           :: icount_interp,icount

! -- Other variables

       integer               :: ierr,ifile
       integer               :: nrow,ncol,irow,icol
       integer               :: ipt,ibeg,iend
       double precision      :: pi
       double precision      :: e0,n0,angle
       double precision      :: cosang,sinang
       double precision      :: nointerpval
       character (len=1)     :: aaa,al
       character (len=20)    :: arraytype,anum
       character (len=200)   :: cline
       character (len=256)   :: infile,facfile,afile,outfile
       character (len=1500)  :: amessage

! -- Allocatable variables; first the ones that are used in function calls.

       integer(kind=c_int), allocatable   :: zns(:),znt(:)
       real(kind=c_double), allocatable   :: ecs(:),ncs(:),vals(:)
       real(kind=c_double), allocatable   :: ect(:),nct(:),valt(:)
       real(kind=c_double), allocatable   :: mean(:),anis(:),bearing(:)

! -- Other allocatable variables.

       double precision, allocatable      :: delr(:),delc(:)
       double precision, allocatable      :: x(:),y(:)
       character (len=20), allocatable    :: apoint(:)

! -- Initialization

       pi=3.14159265358979000
       icount_interp=0

! -- Read the grid specification file.

100    write(6,110,advance='no')
110    format(' Enter name of MF grid spec file: ')
       read(5,*,err=100) infile
       open(unit=10,file=infile,status='old',err=100)
       read(10,*,err=9000,end=9050) nrow,ncol
       read(10,*,err=9000,end=9050) e0,n0,angle
       allocate(delr(ncol),delc(nrow),stat=ierr)
       if(ierr.ne.0) go to 9200
       read(10,*,err=9000,end=9050) (delr(icol),icol=1,ncol)
       read(10,*,err=9000,end=9050) (delc(irow),irow=1,nrow)
       close(unit=10)
       write(6,120) trim(infile)
120    format(' - file ',a,' read ok.')
       mpts=ncol*nrow

! -- Allocate target arrays.

       allocate(mean(mpts),anis(mpts),bearing(mpts),znt(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200

! -- Read arrays associated with this grid.

       do ifile=1,5
         if(ifile.eq.1) cycle
         write(6,*)
         if(ifile.eq.2)then
           arraytype='mean'
         else if(ifile.eq.3)then
           arraytype='anisotropy'
         else if(ifile.eq.4)then
           arraytype='anis. bearing'
         else if(ifile.eq.5)then
           arraytype='zone'
         end if
149      write(6,150,advance='no') trim(arraytype)
150      format(' Enter name of ',a,' array file: ')
         read(5,*,err=149) infile
         open(unit=10,file=infile,status='old',err=149)
         if(ifile.eq.2)then
           read(10,*,err=9000,end=9050) (mean(ipt),ipt=1,mpts)
         else if(ifile.eq.3)then
           read(10,*,err=9000,end=9050) (anis(ipt),ipt=1,mpts)
         else if(ifile.eq.4)then
           read(10,*,err=9000,end=9050) (bearing(ipt),ipt=1,mpts)
         else if(ifile.eq.5)then
           read(10,*,err=9000,end=9050) (znt(ipt),ipt=1,mpts)
         end if
         close(unit=10)
         write(6,120) trim(infile)
       end do

! -- The pilot points file is read.

       write(6,*)
180    write(6,190,advance='no')
190    format(' Enter name of pilot points file: ')
       read(5,*,err=180) infile
       open(unit=10,file=infile,status='old',err=180)
       npts=0
       do
         read(10,'(a)',end=200) cline
         if(cline.eq.' ')cycle
         npts=npts+1
       end do
200    continue
       if(npts.eq.0)then
         write(6,201)
201      format(/,' *** No points in file. Try again ***',/)
         close(unit=10)
         go to 180
       end if
       allocate(apoint(npts),ecs(npts),ncs(npts),zns(npts),vals(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       rewind(10)
       do ipt=1,npts
         read(10,*,err=9000,end=9050) apoint(ipt),ecs(ipt),ncs(ipt),zns(ipt),vals(ipt)
       end do
       close(unit=10)
       write(6,120) trim(infile)

! -- Enter some control variables.

       write(6,*)
230    write(6,240,advance='no')
240    format(' Enter kriging type (0=simple; 1=ordinary): ')
       read(5,*,err=230) krigtype
       write(6,*)
250    write(6,260,advance='no')
260    format(' Enter name for factor file: ')
       read(5,'(a)') afile
       if(afile.eq.' ') go to 250
       ibeg=1
       iend=len_trim(afile)
       call getfile(ifail,afile,facfile,ibeg,iend)
       if(ifail.ne.0) go to 250
       call char2string(256,facfile,factorfile)
270    write(6,280,advance='no')
280    format(' Is this a text or binary file? (t/b): ')
       read(5,*,err=270) aaa
       if((aaa.eq.'t').or.(aaa.eq.'T'))then
         factorfiletype=1
       else if ((aaa.eq.'b').or.(aaa.eq.'B'))then
         factorfiletype=0
       else
         go to 270
       end if

! -- Convert the array centre coordinates to lists.

       cosang=cos(angle*pi/180.0d0)
       sinang=sin(angle*pi/180.0d0)
       allocate(ect(mpts),nct(mpts),valt(mpts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(x(ncol),y(nrow),stat=ierr)
       if(ierr.ne.0) go to 9200

       do icol=1,ncol
         if(icol.eq.1)then
           x(icol)=delr(1)*0.5
         else
           x(icol)=x(icol-1)+(delr(icol)+delr(icol-1))*0.5
         end if
       end do
       do irow=1,nrow
         if(irow.eq.1)then
           y(irow)=-delc(irow)*0.5
         else
           y(irow)=y(irow-1)-(delc(irow)+delc(irow-1))*0.5
         end if
       end do
       ipt=0
       do irow=1,nrow
         do icol=1,ncol
           ipt=ipt+1
           ect(ipt)=x(icol)*cosang-y(irow)*sinang+e0
           nct(ipt)=x(icol)*sinang+y(irow)*cosang+n0
         end do
       end do

! -- Now call the function to to the interpolation.

       write(6,*)
       write(6,320)
320    format(' Calling calc_kriging_factors_2d()....')
       ifail=calc_kriging_factors_auto_2d(npts,ecs,ncs,zns,                 &
                                   mpts,ect,nct,znt,                        &
                                   krigtype,                                &
                                   anis,bearing,                            &
                                   factorfile,factorfiletype,               &
                                   icount_interp)
       if(ifail.ne.0)then
         write(6,340)
340      format(' Function call unsuccessful. Error message follows.')
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       else
         write(anum,'(i0)') icount_interp
         anum=adjustl(anum)
         write(6,350) trim(anum)
350      format(' Interpolation factors calculated for ',a,' points.')
       end if

! -- We will now re-read the file and undertake interpolation. The outcomes
!    will be written as a MODFLOW-compatible real array.

       write(6,*)
       write(6,400)
400    format(' Now undertaking spatial interpolation.')
       write(6,*)
409    write(6,410,advance='no')
410    format(' Interpolate in natural or log domain? (n/l): ')
       read(5,*) al
       if((al.eq.'N').or.(al.eq.'n'))then
         transtype=0
       else if((al.eq.'l').or.(al.eq.'L'))then
         transtype=1
       else
         go to 409
       end if
405    write(6,406,advance='no')
406    format(' Enter number indicating no interpolation to target array: ')
       read(5,*,err=405) nointerpval
       valt=nointerpval ! an array

       write(6,*)
       write(6,420)
420    format(' Calling krige_using_file()...')
       ifail=krige_using_file(factorfile,factorfiletype,   &
                              npts,mpts,                   &
                              krigtype,transtype,          &
                              vals,valt,                   &
                              icount,mean)
       if(ifail.ne.0)then
         write(6,430)
         ifail=retrieve_error_message(messagestring)
         call string2char(1500,messagestring,amessage)
         go to 9890
       else
         write(anum,'(i0)') icount
         anum=adjustl(anum)
         write(6,430) trim(anum)
430      format(' Interpolation undertaken to ',a,' points.')
       end if

! -- We now store the results as a real array.

       write(6,*)
440    write(6,450,advance='no')
450    format(' Enter filename for real array storage: ')
       read(5,*,err=440) outfile
       open(unit=20,file=outfile,action='write',err=440)
       write(20,460) (valt(ipt),ipt=1,mpts)
460    format(1pg16.9)
       close(unit=20)
       write(6,470) trim(outfile)
470    format(' - file ',a,' written ok.')

       go to 9900

9000   write(amessage,9010) trim(infile)
9010   format('Error encountered in reading file ',a,'.')
       go to 9890

9050   write(amessage,9060) trim(infile)
9060   format('Premature end encountered to file ',a,'.')
       go to 9890

9200   write(amessage,9210)
9210   format('Insufficient memory to continue execution.')
       go to 9890


9890   continue
       amessage=' '//trim(amessage)
       call writmess(6,amessage)

! -- Tidy up

9900   continue

! -- Free local memory

       deallocate(zns,znt,stat=ierr)
       deallocate(ecs,ncs,vals,stat=ierr)
       deallocate(ect,nct,valt,stat=ierr)
       deallocate(mean,anis,bearing,stat=ierr)
       deallocate(delr,delc,stat=ierr)
       deallocate(x,y,stat=ierr)
       deallocate(apoint,stat=ierr)

! -- Free function interface memory

       ifail=free_all_memory()

       end

       program driver15

! -- DRIVER15 tests 3-D random field generation.

       use function_interfaces
       use iso_c_binding, only : c_int,c_char,c_double
       implicit none

! -- Variables used in function calls.

       integer(kind=c_int)           :: ifail
       integer(kind=c_int)           :: iseed
       integer(kind=c_int)           :: nnode
       integer(kind=c_int)           :: transtype,avetype
       integer(kind=c_int)           :: ldrand,nreal
       real(kind=c_double)           :: power
       character(kind=c_char,len=1)  :: messagestring(1500)

       integer(kind=c_int), allocatable   :: iarray(:)
       real(kind=c_double), allocatable   :: xx(:),yy(:),zz(:)
       real(kind=c_double), allocatable   :: mean(:),area(:),height(:),var(:)
       real(kind=c_double), allocatable   :: ahmax(:),ahmin(:),avert(:)
       real(kind=c_double), allocatable   :: bearing(:),dip(:),rake(:)
       real(kind=c_double), allocatable   :: darray(:,:)

! -- Other variables

        character (len=:), allocatable :: textout
        integer             :: nbb,nb,jfail,ierr,iline,nrecl
        integer             :: ireal
        integer             :: jnode,itemp
        integer             :: lw(15),rw(15)
        character (len=1)   :: anl
        character (len=15)  :: aline
        character (len=20)  :: ama1
        character (len=20)  :: atemp,anum2,anum
        character (len=256) :: afile,gridfile,avefile,outfile
        character (len=700) :: cline
        character (len=1500):: amessage

        integer, allocatable :: layer(:)

! -- Read specifications of general grid.

100     write(6,110,advance='no')
110     format(' Enter name of 3D node specifications file: ')
        read(5,'(a)') afile
        if(afile.eq.' ') go to 100
        afile=adjustl(afile)
        nbb=len_trim(afile)
        call getfile(jfail,afile,gridfile,1,nbb)
        if(jfail.ne.0) go to 100
        afile=gridfile
        open(unit=10,file=gridfile,status='old',iostat=ierr)
        if(ierr.ne.0) then
          write(6,150) trim(afile)
150       format(' Cannot open file ',a,'. Try again.')
          go to 100
        end if

! -- See if the column headers are ok.

        iline=1
        read(10,'(a)',err=9000,end=9000) cline
        if(cline.eq.' ') go to 9050
        call linesplit(jfail,8,lw,rw,cline)
        if(jfail.ne.0) go to 9050
        call lowcase(cline)
        atemp=cline(lw(1):rw(1))
        if(atemp(1:4).ne.'node') go to 9050
        atemp=cline(lw(2):rw(2))
        if(atemp(1:1).ne.'x') go to 9050
        atemp=cline(lw(3):rw(3))
        if(atemp(1:1).ne.'y') go to 9050
        atemp=cline(lw(4):rw(4))
        if(atemp(1:1).ne.'z') go to 9050
        atemp=cline(lw(5):rw(5))
        if(atemp(1:3).ne.'lay') go to 9050
        atemp=cline(lw(6):rw(6))
        if(atemp(1:4).ne.'area') go to 9050
        atemp=cline(lw(7):rw(7))
        if(atemp.ne.'height') go to 9050
        atemp=cline(lw(8):rw(8))
        if(atemp.ne.'active') go to 9050

! -- Establish number of non-blank lines.

        iline=1
        nnode=0
        do
          iline=iline+1
          read(10,'(a)',err=9000,end=180) cline
          if(cline.eq.' ') cycle
          nnode=nnode+1
        end do
180     continue
        if(nnode.eq.0)then
          write(amessage,190) trim(afile)
190       format(' File ',a,' appears to be empty.')
          go to 9890
        end if
        rewind(unit=10)

! -- Allocate memory.

        allocate(xx(nnode),yy(nnode),zz(nnode),layer(nnode),area(nnode),    &
        height(nnode),iarray(nnode),stat=ierr)
        if(ierr.ne.0) go to 9200

! -- Now read the file.

        read(10,*)
        iline=1
        jnode=0
        do
          iline=iline+1
          read(10,'(a)',err=9000,end=9000) cline
          if(cline.eq.' ') cycle
          jnode=jnode+1
          call linesplit(jfail,8,lw,rw,cline)
          if(jfail.ne.0) go to 9100
          call intread(jfail,cline(lw(1):rw(1)),itemp)
          if(jfail.ne.0) go to 9000
          if(itemp.ne.jnode)then
            call writint(aline,iline)
            write(amessage,210) trim(aline),trim(afile)
210         format('Node numbers should start at 1 and be sequential. This is ',  &
            'violated at line ',a,' of file ',a,'.')
            go to 9890
          end if
          call drealread(jfail,cline(lw(2):rw(2)),xx(jnode))
          if(jfail.ne.0) go to 9000
          call drealread(jfail,cline(lw(3):rw(3)),yy(jnode))
          if(jfail.ne.0) go to 9000
          call drealread(jfail,cline(lw(4):rw(4)),zz(jnode))
          if(jfail.ne.0) go to 9000
          call intread(jfail,cline(lw(5):rw(5)),layer(jnode))
          if(jfail.ne.0) go to 9000
          call drealread(jfail,cline(lw(6):rw(6)),area(jnode))
          if(jfail.ne.0) go to 9000
          call drealread(jfail,cline(lw(7):rw(7)),height(jnode))
          if(jfail.ne.0) go to 9000
          call intread(jfail,cline(lw(8):rw(8)),iarray(jnode))
          if(jfail.ne.0) go to 9000
          if(jnode.eq.nnode) exit
        end do
        close(unit=10)
        call writint(anum,nnode)
        write(6,221) trim(anum),trim(afile)
221     format(' - data for ',a,' nodes read from file ',a,'.')

! -- Allocate more memory.

        allocate(mean(nnode),var(nnode),ahmax(nnode),ahmin(nnode),    &
        avert(nnode),bearing(nnode),dip(nnode),rake(nnode),stat=ierr)
        if(ierr.ne.0) go to 9200

! -- Read the averaging function specification file.

        write(6,*)
250     write(6,260,advance='no')
260     format(' Enter name of 3D averaging function specification file: ')
        read(5,'(a)') afile
        if(afile.eq.' ') go to 250
        afile=adjustl(afile)
        nbb=len_trim(afile)
        call getfile(jfail,afile,avefile,1,nbb)
        if(jfail.ne.0) go to 250
        afile=avefile
        open(unit=10,file=avefile,status='old',iostat=ierr)
        if(ierr.ne.0) then
          write(6,150) trim(afile)
          go to 250
        end if

! -- See if the column headers are ok.

        iline=1
        read(10,'(a)',err=9000,end=9000) cline
        if(cline.eq.' ') go to 9070
        call linesplit(jfail,9,lw,rw,cline)
        if(jfail.ne.0) go to 9070
        call lowcase(cline)
        atemp=cline(lw(1):rw(1))
        if(atemp(1:4).ne.'node') go to 9070
        atemp=cline(lw(2):rw(2))
        if(atemp.ne.'mean') go to 9070
        atemp=cline(lw(3):rw(3))
        if((atemp(1:4).ne.'sill').and.(atemp(1:3).ne.'var')) go to 9070
        atemp=cline(lw(4):rw(4))
        if(atemp.ne.'a_hmax') go to 9070
        atemp=cline(lw(5):rw(5))
        if(atemp.ne.'a_hmin') go to 9070
        atemp=cline(lw(6):rw(6))
        if(atemp.ne.'a_vert') go to 9070
        atemp=cline(lw(7):rw(7))
        if(atemp.ne.'bearing') go to 9070
        atemp=cline(lw(8):rw(8))
        if(atemp.ne.'dip') go to 9070
        atemp=cline(lw(9):rw(9))
        if(atemp.ne.'rake') go to 9070

! -- Now read the file.

        jnode=0
        do
          iline=iline+1
          read(10,'(a)',err=9000,end=9000) cline
          if(cline.eq.' ') cycle
          jnode=jnode+1
          call linesplit(jfail,9,lw,rw,cline)
          if(jfail.ne.0) go to 9100
          call intread(jfail,cline(lw(1):rw(1)),itemp)
          if(jfail.ne.0) go to 9000
          if(itemp.ne.jnode)then
            call writint(aline,iline)
            write(amessage,210) trim(aline),trim(afile)
            go to 9890
          end if
          call drealread(jfail,cline(lw(2):rw(2)),mean(jnode))
          if(jfail.ne.0) go to 9000
          call drealread(jfail,cline(lw(3):rw(3)),var(jnode))
          if(jfail.ne.0) go to 9000
          call drealread(jfail,cline(lw(4):rw(4)),ahmax(jnode))
          if(jfail.ne.0) go to 9000
          call drealread(jfail,cline(lw(5):rw(5)),ahmin(jnode))
          if(jfail.ne.0) go to 9000
          call drealread(jfail,cline(lw(6):rw(6)),avert(jnode))
          if(jfail.ne.0) go to 9000
          call drealread(jfail,cline(lw(7):rw(7)),bearing(jnode))
          if(jfail.ne.0) go to 9000
          call drealread(jfail,cline(lw(8):rw(8)),dip(jnode))
          if(jfail.ne.0) go to 9000
          call drealread(jfail,cline(lw(9):rw(9)),rake(jnode))
          if(jfail.ne.0) go to 9000
          if(jnode.eq.nnode) exit
        end do
        close(unit=10)
        write(6,220) trim(afile)
220     format(' - file ',a,' read ok.')

! -- Acquire data pertaing to averaging function.

        write(6,*)
351     write(6,361,advance='no')
361     format(' Express stochasticity in natural or log domain? [n/l]: ')
        read(5,'(a)') anl
        if(anl.eq.' ') go to 351
        call lowcase(anl)
        if((anl.ne.'n').and.(anl.ne.'l'))go to 351
        if(anl.eq.'n')then
          transtype=0
        else
          transtype=1
        end if

        power=0.0d0
        write(6,*)
370     write(6,371,advance='no')
371     format(' Is moving ave spherical, exponential, gaussian or power? [s/x/g/p(..)]: ')
        read(5,'(a)') ama1
        if(ama1.eq.' ') go to 370
        call lowcase(ama1)
        ama1=adjustl(ama1)
        if(ama1.eq.'s')then
          avetype=1
        else if(ama1.eq.'x')then
          avetype=2
        else if(ama1.eq.'g')then
          avetype=3
        else if(ama1(1:1).eq.'p')then
          avetype=4
          ama1=adjustl(ama1(2:))
          if(ama1(1:1).ne.'(') go to 370
          ama1=adjustl(ama1(2:))
          nb=len_trim(ama1)
          if(nb.eq.0) go to 370
          if(ama1(nb:nb).ne.')') go to 370
          ama1(nb:nb)=' '
          if(ama1.eq.' ') go to 370
          call drealread(jfail,ama1,power)
          if(jfail.ne.0) go to 370
        else
          go to 370
        end if

! -- Acquire number of realisations.

        write(6,*)
381     write(6,382,advance='no')
382     format(' How many realizations do you wish to generate? ')
        read(5,*,err=381) nreal
        if(nreal.le.0) go to 381

! -- Obtain the name of the output file.

        write(6,*)
400     write(6,410,advance='no')
410     format(' Enter name for csv output file: ')
        read(5,'(a)') afile
        if(afile.eq.' ') go to 400
        nbb=len_trim(afile)
        call getfile(jfail,afile,outfile,1,nbb)
        if(jfail.ne.0) go to 400
        outfile=adjustl(outfile)
        afile=outfile
        nrecl=nreal*20+20
        open(unit=20,file=outfile,action='write',recl=nrecl,iostat=ierr)
        if(ierr.ne.0)then
          write(6,420) trim(afile)
420       format(' Cannot write to file ',a,'. Try again.')
          go to 400
        end if

! -- The random seed is acquired.

        write(6,*)
1309    write(6,1315,advance='no')
1315    format(' Enter integer seed for random number generator [324853]: ')
        read(5,'(a)') anum2
        if(anum2.eq.' ') then
          iseed=324853
        else
          call intread(jfail,anum2,iseed)
          if(jfail.ne.0)go to 1309
        end if

! -- Initialize the random number generator.

        write(6,*)
        write(6,320)
320     format(' Calling initialze_randgen()....')
        ifail=initialize_randgen(iseed)
        if(ifail.ne.0)then
          write(6,340)
          write(6,*)
340       format(' Function call unsuccessful. Error message follows.')
          ifail=retrieve_error_message(messagestring)
          call string2char(1500,messagestring,amessage)
          go to 9890
        else
          write(6,350)
350       format(' Function call successful.')
        end if

! -- Allocate the array that holds random fields.

        ldrand=nnode
        allocate(darray(ldrand,nreal),stat=ierr)
        if(ierr.ne.0) go to 9200
        darray=0.0d0      ! an array

! -- Call the function to fill the array.

        write(6,*)
        write(6,421)
421     format(' Calling fieldgen3d_sva()....')
        ifail=fieldgen3d_sva(            &
              nnode,                     &
              xx,yy,zz,                  &
              area,height,iarray,        &
              mean,var,                  &
              ahmax,ahmin,avert,         &
              bearing,dip,rake,          &
              transtype,avetype,power,   &
              ldrand,nreal,darray)
        if(ifail.ne.0)then
          write(6,340)
          write(6,*)
          ifail=retrieve_error_message(messagestring)
          call string2char(1500,messagestring,amessage)
          go to 9890
        else
          write(6,350)
        end if

! -- Write file header.

        write(6,*)
        write(6,430)
430     format(' Writing CSV output file...')
        textout='node'
        do ireal=1,nreal
          call writint(anum,ireal)
          textout=trim(textout)//','//'sim'//trim(anum)
        end do
        write(20,'(a)') trim(textout)

! -- Write the CSV output file.

        do jnode=1,nnode
          call writint(anum,jnode)
          textout=trim(anum)
          do ireal=1,nreal
            write(anum2,'(1pg16.9)')darray(jnode,ireal)
            textout=trim(textout)//','//trim(anum2)
          end do
          write(20,'(a)',err=9400) trim(textout)
        end do
        close(unit=20)
        write(6,1500) trim(afile)
1500    format(' File ',a,' written ok.')

        go to 9900

9000    continue
        call writint(aline,iline)
        write(amessage,9010) trim(aline),trim(afile)
9010    format('Error encountered in reading line ',a,' of file ',a,'.')
        go to 9890

9050    write(amessage,9060) trim(afile)
9060    format('Header on first line of file ',a,' expected to be ',   &
        '"node, x, y, z, layer, area, height, active".')
        go to 9890

9070    write(amessage,9080) trim(afile)
9080    format('Header on first line of file ',a,' expected to be ',   &
        '"node, mean, var, a_hmax, a_hmin, a_vert, bearing, dip, rake".')
        go to 9890

9100    call writint(aline,iline)
        write(amessage,9110) trim(aline),trim(afile)
9110    format('Insufficient items on line ',a,' of file ',a,'.')
        go to 9890

9200    write(amessage,9210)
9210    format('Cannot allocate sufficient memory to continue execution.')
        go to 9890

9250    write(amessage,9260)
9260    format('Memory deallocation error. Cannot continue execution.')
        go to 9890

9400    write(amessage,9410) trim(afile)
9410    format('Cannot write to file ',a,'.')
        go to 9890

9890   continue
       amessage=' '//trim(amessage)
       call writmess(6,amessage)

! -- Tidy up

9900   continue

! -- Free local memory

       deallocate(iarray,stat=ierr)
       deallocate(xx,yy,zz,stat=ierr)
       deallocate(mean,area,height,var,stat=ierr)
       deallocate(ahmax,ahmin,avert,stat=ierr)
       deallocate(bearing,dip,rake,stat=ierr)
       deallocate(darray,stat=ierr)
       deallocate(layer,stat=ierr)

! -- Free function interface memory

       ifail=free_all_memory()

       end

integer (kind=c_int) function inquire_modflow_binary_file_specs(FileIn,FileOut,isim,                          &
                                                   itype,iprec,narray,ntime)                     &
                 bind(C,name="inquire_modflow_binary_file_specs")

! -- This function reports some of the details of a MODFLOW-written binary file. This file may be single or double
!    precision. It may be a system state or budget file.

       use iso_c_binding, only: c_int,c_char
       use dimvar
       use utilities

       implicit none

       character (kind=c_char), intent(in)        :: FileIn(LENFILENAME)
       character (kind=c_char), intent(in)        :: FileOut(LENFILENAME)
       integer(kind=c_int), intent(in)            :: isim             ! Simulator
       integer(kind=c_int), intent(in)            :: itype            ! 1 = system state; 2 = flows
       integer(kind=c_int), intent(out)           :: iprec            ! 1 = single; 2 = double
       integer(kind=c_int), intent(out)           :: narray
       integer(kind=c_int), intent(out)           :: ntime

       logical                        :: lout,lopened
       integer                        :: NDimFileIn,NDimFileOut
       integer                        :: ibig,itemp
       integer                        :: kstp,kper,kstpold,kperold,ilay
       integer                        :: iturn,ns,nss,is,i,j,itemp1,itemp2
       integer                        :: inunit,ierr,outunit,imeth,numread,nlist,ndat
       integer                        :: ndim1,ndim2,ndim3

       real                           :: rbig,rtemp
       real                           :: pertim,totim,delt
       double precision               :: dbig,dtemp
       double precision               :: dpertim,dtotim,ddelt

       character (len=16)             :: text,atemp16,txt1id1,txt2id1,txt1id2,txt2id2
       character (len=LENFILENAME)    :: infile,outfile

! -- Initialisation

       function_name='inquire_modflow_binary_file_specs()'
       inquire_modflow_binary_file_specs=0
       ibig=huge(ibig)/2                   ! arbitrary
       rbig=huge(rbig)*0.5                 ! arbitrary
       dbig=huge(dbig)*0.5d0               ! arbitrary
       iprec=0
       iturn=1
       inunit=0
       outunit=0
       amessage=' '
!       NDimFileIn=size(FileIn)               ! Inherited from declaration
!       NDimFileOut=size(FileOut)             ! Inherited from declaration
       NDimFileIn=LENFILENAME         ! I assume that FORTRAN cannot determine size of C-passed array.
       NDimFileOut=LENFILENAME        ! We rely on termination character to know end of string.

! -- Input arguments are checked.

       if((itype.ne.1).and.(itype.ne.2))then
         write(amessage,15) trim(function_name)
15       format(' The ITYPE argument of function ',a,' must be supplied as ',  &
         'either 1 or 2.')
         go to 9890
       end if

! -- Text strings are converted to character variables.

       call utl_string2char(NdimFileIn,FileIn,infile)
       infile=adjustl(infile)
       call utl_addquote(infile,afile1)

       call utl_string2char(NdimFileOut,FileOut,outfile)
       outfile=adjustl(outfile)
       if(outfile.eq.' ')then
         lout=.false.
       else
         lout=.true.
         call utl_addquote(outfile,afile2)
       end if

       if((isim.ne.0).and.(isim.ne.1).and.(isim.ne.21).and.(isim.ne.22).and.   &
          (isim.ne.31).and.(isim.ne.32).and.(isim.ne.33))then
          write(amessage,5)
5         format('The isim argument must be 0, 1, 21, 22, 31, 32 or 33.')
         go to 9890
       end if

! -- The MODFLOW output file is opened.

       inunit=utl_nextunit()
       open(unit=inunit,file=infile,status='old',form='unformatted',access='stream',iostat=ierr)
       if(ierr.ne.0) then
         write(amessage,10) trim(afile1)
10       format('Cannot open binary file ',a,'.')
         go to 9890
       end if

! -- An attempt is made to gather information by reading the first line of the file.

       if(utl_mfbinopspecs(inunit,itype,infile,iprec).ne.0) go to 9890
       rewind(unit=inunit)

! -- Read and report contents of system state file.

       if(itype.eq.2) go to 230
25     continue
       kstpold=huge(kstp)
       kperold=huge(kper)
       ntime=0
       narray=0
       if(lout)then
         outunit=utl_nextunit()
         open(unit=outunit,file=outfile,action='write',iostat=ierr)
         if(ierr.ne.0)then
           write(amessage,30) trim(afile2)
30         format('Cannot open file ',a,' for output.')
           go to 9890
         end if
         if((isim.eq.1).or.(isim.eq.21).or.(isim.eq.31))then
           write(outunit,40,err=9100)
40         format('KSTP,KPER,PERTIM,TOTIM,TEXT,NCOL,NROW,ILAY')
         else if(isim.eq.22)then
           write(outunit,41,err=9100)
41         format('KSTP,KPER,PERTIM,TOTIM,TEXT,NSTRT,NVAL,ILAY')
         else if(isim.eq.32)then
           write(outunit,42,err=9100)
42         format('KSTP,KPER,PERTIM,TOTIM,TEXT,NCPL,INT1,ILAY')
         else if(isim.eq.33)then
           write(outunit,43,err=9100)
43         format('KSTP,KPER,PERTIM,TOTIM,TEXT,NODES,INT1,INT2')
         else
           write(outunit,44,err=9100)
44         format('KSTP,KPER,PERTIM,TOTIM,TEXT,INT1,INT2,INT3')
         end if
       end if
       narray=0
       ntime=0
       do
         if(iprec.eq.1)then
           read(inunit,err=800,end=200) kstp,kper,pertim,totim, &
           text,itemp1,itemp2,ilay
         else
           read(inunit,err=800,end=200) kstp,kper,dpertim,dtotim, &
           text,itemp1,itemp2,ilay
         end if
         if((kstp.lt.0).or.(kper.lt.0).or.(itemp1.lt.0).or.(itemp2.lt.0).or.(ilay.le.0)) go to 800
         if(iprec.eq.1)then
           if((pertim.lt.0.0).or.(totim.lt.0.0)) go to 800
           if((pertim.gt.rbig).or.(totim.gt.rbig)) go to 800
         else
           if((dpertim.lt.0.0).or.(dtotim.lt.0.0)) go to 800
           if((dpertim.gt.dbig).or.(dtotim.gt.dbig)) go to 800
         end if
         if(utl_textcheck(text).ne.0) go to 800
         narray=narray+1
         if((kstp.ne.kstpold).or.(kper.ne.kperold))then
           ntime=ntime+1
           kstpold=kstp
           kperold=kper
         end if
         if(iprec.eq.1)then
           if(isim.eq.22)then
             read(inunit,err=800,end=800)(rtemp,i=itemp1,itemp2)
           else
             read(inunit,err=800,end=800) (rtemp,i=1,itemp1*itemp2)
           end if
         else
           if(isim.eq.22)then
             read(inunit,err=800,end=800)(dtemp,i=itemp1,itemp2)
           else
             read(inunit,err=800,end=800) (dtemp,i=1,itemp1*itemp2)
           end if
         end if
         if(lout)then
           if(iprec.eq.1)then
             write(outunit,120) kstp,kper,pertim,totim,trim(adjustl(text)),itemp1,itemp2,ilay
120          format(i0,',',i0,',',1pg0.9,',',1pg0.9,',',a,',',i0,',',i0,',',i0)
           else
             write(outunit,120) kstp,kper,dpertim,dtotim,trim(adjustl(text)),itemp1,itemp2,ilay
           end if
         end if
       end do
200    continue
       go to 1000

! -- Read and report contents of cell-by-cell flow term file.

230    continue
       if(lout)then
         outunit=utl_nextunit()
         open(unit=outunit,file=outfile,action='write',iostat=ierr)
         if(ierr.ne.0)then
           write(amessage,30) trim(afile2)
           go to 9890
         end if
         if((isim.eq.1).or.(isim.eq.21).or.(isim.eq.31))then
           if(isim.eq.31)then
             write(outunit,239)
239          format('KSTP,KPER,TEXT,NCOL,NROW,NLAY,IMETH,DELT,PERTIM,TOTIM,TXT1ID1,TXT2ID1,TXT1ID2,TXT2ID2')
           else
             write(outunit,240)
240          format('KSTP,KPER,TEXT,NCOL,NROW,NLAY,IMETH,DELT,PERTIM,TOTIM')
           end if
         else if(isim.eq.22)then
           write(outunit,241)
241        format('KSTP,KPER,TEXT,NVAL,INT1,ICODE,IMETH,DELT,PERTIM,TOTIM')
         else if(isim.eq.32)then
           write(outunit,242)
242        format('KSTP,KPER,TEXT,NCPL,INT1,INT2,IMETH,DELT,PERTIM,TOTIM,TXT1ID1,TXT2ID1,TXT1ID2,TXT2ID2')
         else if(isim.eq.33)then
           write(outunit,2431)
2431       format('KSTP,KPER,TEXT,NDIM1,NDIM2,NDIM3,IMETH,DELT,PERTIM,TOTIM,TXT1ID1,TXT2ID1,TXT1ID2,TXT2ID2')
         else
           write(outunit,243)
243        format('KSTP,KPER,TEXT,NDIM1,NDIM2,NDIM3,IMETH,DELT,PERTIM,TOTIM')
         end if
       end if
       kperold=huge(kperold)
       kstpold=huge(kstpold)
       narray=0
       ntime=0
       do
         read(inunit,err=800,end=1000) kstp,kper,text,ndim1,ndim2,ndim3
         if((kstp.lt.0).or.(kper.lt.0).or.(ndim1.lt.0).or.(ndim2.lt.0)) go to 800
         if(utl_textcheck(text).ne.0) go to 800
         if((kstp.gt.ibig).or.(kper.gt.ibig).or.(ndim1.gt.ibig).or.(ndim2.gt.ibig)     &
                          .or.(abs(ndim3).gt.ibig))go to 800
         if(ndim3.gt.0)then
           if(lout)then
             write(outunit,250) kstp,kper,trim(adjustl(text)),ndim1,ndim2,ndim3
250          format(i0,',',i0,',',a,',',i0,',',i0,',',i0)
             if(iprec.eq.1)then
               read(inunit,err=800,end=800) (rtemp,i=1,ndim1*ndim2*ndim3)
             else
               read(inunit,err=800,end=800) (dtemp,i=1,ndim1*ndim2*ndim3)
             end if
           end if
         else
           if(iprec.eq.1)then
             read(inunit,err=800,end=800) imeth,delt,pertim,totim
           else
             read(inunit,err=800,end=800) imeth,ddelt,dpertim,dtotim
           end if
           if((imeth.lt.1).or.(imeth.gt.6))go to 800
           if(imeth.eq.6)then
             read(inunit,err=800,end=800) txt1id1
             if(utl_textcheck(txt1id1).ne.0) go to 800
             read(inunit,err=800,end=800) txt2id1
             if(utl_textcheck(txt2id1).ne.0) go to 800
             read(inunit,err=800,end=800) txt1id2
             if(utl_textcheck(txt1id2).ne.0) go to 800
             read(inunit,err=800,end=800) txt2id2
             if(utl_textcheck(txt2id2).ne.0) go to 800
           end if
           if(iprec.eq.1)then
             if(delt.lt.0.0) go to 800
             if(pertim.lt.0.0) go to 800
             if(totim.lt.0.0) go to 800
             if(delt.gt.rbig) go to 800
             if(pertim.gt.rbig) go to 800
             if(totim.gt.rbig) go to 800
           else
             if(ddelt.lt.0.0d0) go to 800
             if(dpertim.lt.0.0d0) go to 800
             if(dtotim.lt.0.0d0) go to 800
             if(ddelt.gt.dbig) go to 800
             if(dpertim.gt.dbig) go to 800
             if(dtotim.gt.dbig) go to 800
           end if
           if(lout)then
             if(imeth.eq.6)then    ! mf6 and therefore double precision
               write(outunit,2601) kstp,kper,trim(adjustl(text)),ndim1,ndim2,ndim3,imeth,ddelt,dpertim,dtotim,  &
               trim(txt1id1),trim(txt2id1),trim(txt1id2),trim(txt2id2)
2601           format(i0,',',i0,',',a,',',i0,',',i0,',',i0,',',i0,',',1pg0.9,              &
                      ',',1pg0.9,',',1pg0.9,',',a,',',a,',',a,',',a)
             else
               if(iprec.eq.1)then
                 write(outunit,260) kstp,kper,trim(adjustl(text)),ndim1,ndim2,ndim3,imeth,delt,pertim,totim
260              format(i0,',',i0,',',a,',',i0,',',i0,',',i0,',',i0,',',1pg0.9,            &
                        ',',1pg0.9,',',1pg0.9)
               else
                 write(outunit,260) kstp,kper,trim(adjustl(text)),ndim1,ndim2,ndim3,imeth,ddelt,dpertim,dtotim
               end if
             end if
           end if
           if((imeth.eq.1).or.(imeth.eq.4))then
             if(isim.eq.22)then
               numread=ndim1
             else
               numread=abs(ndim1*ndim2*ndim3)
             end if
             if(iprec.eq.1)then
               read(inunit,err=800,end=800) (rtemp,i=1,numread)
             else
               read(inunit,err=800,end=800) (dtemp,i=1,numread)
             end if
           else if(imeth.eq.2)then
             read(inunit,err=800,end=800) nlist
             if(nlist.lt.0) go to 800
             if(nlist.gt.ibig) go to 800
             if(iprec.eq.1)then
               read(inunit,err=800,end=800) (itemp,rtemp,i=1,nlist)
             else
               read(inunit,err=800,end=800) (itemp,dtemp,i=1,nlist)
             end if
           else if(imeth.eq.3)then
             if(isim.eq.22)then
               numread=ndim1
             else
               numread=ndim1*ndim2
             end if
             read(inunit,err=800,end=800) (itemp,i=1,numread)
             if(iprec.eq.1)then
               read(inunit,err=800,end=800) (rtemp,i=1,numread)
             else
               read(inunit,err=800,end=800) (dtemp,i=1,numread)
             end if
           else if(imeth.eq.5)then
             read(inunit,err=800,end=800) ndat
             if(ndat.lt.-1) go to 800
             if(ndat.gt.ibig) go to 800
             if(ndat.gt.1)then
               read(inunit,err=800,end=800) (atemp16,i=1,ndat-1)
             end if
             read(inunit,err=800,end=800) nlist
             if(nlist.lt.0) go to 800
             if(nlist.gt.ibig) go to 800
             if((nlist.gt.0).and.(ndat.gt.0))then
               if(iprec.eq.1)then
                 read(inunit,err=800,end=800)(itemp,(rtemp,i=1,ndat),j=1,nlist)
               else
                 read(inunit,err=800,end=800)(itemp,(dtemp,i=1,ndat),j=1,nlist)
               end if
             end if
           else if(imeth.eq.6)then
             read(inunit,err=800,end=800) ndat
             if(ndat.gt.ibig) go to 800
             if(ndat.lt.0) go to 800
             if(ndat-1.ge.1)then
               read(inunit,err=800,end=800) (atemp16,i=1,ndat-1)
             end if
             read(inunit,err=800,end=800) nlist
             if(nlist.lt.0) go to 800
             if(nlist.gt.ibig) go to 800
             if(nlist.gt.0)then
               if(iprec.eq.1)then
                 read(inunit,err=800,end=800) (itemp,itemp,(rtemp,i=1,ndat),j=1,nlist)
               else
                 read(inunit,err=800,end=800) (itemp,itemp,(dtemp,i=1,ndat),j=1,nlist)
               end if
             end if
           end if
         end if
         narray=narray+1
         if((kstp.ne.kstpold).or.(kper.ne.kperold))then
           kstpold=kstp
           kperold=kper
           ntime=ntime+1
         end if
       end do

800    continue
       if(iturn.eq.1)then
         iturn=2
         if(lout)close(unit=outunit,iostat=ierr)
         if(iprec.eq.1)then
           iprec=2
         else
           iprec=1
         end if
         inquire(unit=inunit,opened=lopened)
         if(lopened)then
           rewind(unit=inunit)
         else
           inunit=utl_nextunit()
           open(unit=inunit,file=infile,status='old',form='unformatted',access='stream',iostat=ierr)
           if(ierr.ne.0) go to 9150
         end if
         if(itype.eq.1)then
           go to 25
         else
           go to 230
         end if
       else
         go to 9150
       end if

! -- Tidy up

1000   go to 9999

9100   write(amessage,9110) trim(afile2)
9110   format('Cannot write to file ',a,'.')
       go to 9890

9150   write(amessage,9160) trim(afile1)
9160   format('Cannot interpret contents of file ',a,'.')
       go to 9890

9890   continue
       inquire_modflow_binary_file_specs=1
       iprec=0
       narray=0
       ntime=0

9999   continue
       if(inunit.ne.0) close(unit=inunit,iostat=ierr)
       if(outunit.ne.0) close(unit=outunit,iostat=ierr)
       return

end function inquire_modflow_binary_file_specs


integer (kind=c_int) function retrieve_error_message(errormessage) &
                bind(c, name="retrieve_error_message")


! -- This function retrieves a previously-recorded error message.
! -- It returns the size of the error message. This may be greater than the size
!    of the array that is provided in the calling program. This length does not
!    include the string termination character.

       use iso_c_binding, only: c_int,c_char
       use utilities
       implicit none

       character (kind=c_char,len=1), intent(out) :: errormessage(LENMESSAGE)
       integer                                    :: lenmess

       if(amessage.eq.' ')then
         retrieve_error_message=0
       else
         lenmess=size(errormessage)
         call utl_char2string(lenmess,amessage,errormessage)
         retrieve_error_message=len_trim(amessage)
       end if
       return

end function retrieve_error_message



integer (kind=c_int) function install_structured_grid(gridname,ncol,nrow,nlay,icorner,    &
                                      e0,n0,rotation,delr,delc)                           &
                 bind(c,name="install_structured_grid")

! -- This function installs specifications for a structured grid.

       use iso_c_binding, only: c_int,c_char,c_double
       use dimvar
       use deftypes
       use utilities
       implicit none

       character (kind=c_char), intent(in)  :: gridname(LENGRIDNAME)
       integer (kind=c_int), intent(in)     :: ncol,nrow,nlay
       integer (kind=c_int), intent(in)     :: icorner             ! 1=top left; 2=bottom left
       real (kind=c_double), intent(in)     :: e0,n0,rotation
       real (kind=c_double), intent(in)     :: delr(ncol),delc(nrow)

       integer                        :: ierr
       integer                        :: igrid,icol,irow,jgrid
       double precision               :: side
       character (len=10)             :: atemp10
       character (len=LENGRIDNAME)    :: aname

! -- Initialisation

       install_structured_grid=0
       igrid=0

! -- A spare array element is located.

       if(numstrucmodgrid.ge.MAXSTRUCMODGRID)then
         call utl_num2char(MAXSTRUCMODGRID,atemp10)
         write(amessage,40) trim(atemp10)
40       format('A maximum of ',a,' structured model grid specifications ',       &
         'can be installed. You must uninstall at least one structured model ',   &
         'grid specification before you can install a new one.')
         go to 9890
       end if
       if(numstrucmodgrid.eq.0)then
         igrid=1
       else
         do igrid=1,MAXSTRUCMODGRID
           if(strucmodgrid(igrid)%nrow.eq.0) go to 60
         end do
         write(amessage,50)
50       format('Programming error in install_structured_grid(): contact programmer.')
         go to 9890
60       continue
       end if

! -- The name is translated to a character variable.

       call utl_string2char(LENGRIDNAME,gridname,aname)
       aname=adjustl(aname)
       call utl_casetrans(aname,'lo')
       if(aname.eq.' ')then
         write(amessage,100)
100      format('Gridname argument is supplied as blank.')
         go to 9890
       end if
       if(numstrucmodgrid.gt.0)then
         do jgrid=1,MAXSTRUCMODGRID
           if(strucmodgrid(jgrid)%nrow.ne.0)then
             if(aname.eq.strucmodgrid(jgrid)%name)then
               write(amessage,110) trim(aname)
110            format('The name "',a,'" belongs to an already-installed ',  &
               'structured grid.')
               go to 9890
             end if
           endif
         enddo
       end if
       strucmodgrid(igrid)%name=aname

! -- Some error checking is done.

       if(nrow.le.0)then
         write(amessage,120) 'NROW'
120      format('Input argument ',a,' must be positive.')
         go to 9890
       end if
       if(ncol.le.0)then
         write(amessage,120) 'NCOL'
         go to 9890
       end if
       if(nlay.le.0)then
         write(amessage,120) 'NLAY'
         go to 9890
       end if
       if((icorner.ne.1).and.(icorner.ne.2))then
         write(amessage,130)
130      format('Input argument ICORNER must be 1 or 2.')
         go to 9890
       end if
       if(any(delr.le.0.0d0))then
         write(amessage,135) 'DELR'
135      format('At least one element of the ',a,' array is non-positive.')
         go to 9890
       end if
       if(any(delc.le.0.0d0))then
         write(amessage,135) 'DELC'
         go to 9890
       end if
       if((rotation.gt.180.0d0).or.(rotation.lt.-180.0d0))then
         write(amessage,140)
140      format('Input argument ROTATION must not be less than -180 degrees or ',  &
         'greater than 180 degrees.')
         go to 9890
       end if

! -- Memory is allocated.

       strucmodgrid(igrid)%ncol=ncol
       strucmodgrid(igrid)%nrow=nrow
       strucmodgrid(igrid)%nlay=nlay
       strucmodgrid(igrid)%rotation=rotation
       strucmodgrid(igrid)%cosang=cos(rotation*pi/180.0d0)
       strucmodgrid(igrid)%sinang=sin(rotation*pi/180.0d0)
       allocate(strucmodgrid(igrid)%delr(ncol),strucmodgrid(igrid)%delc(nrow),stat=ierr)
       if(ierr.ne.0)then
         write(amessage,160)
160      format('Memory allocation error.')
         go to 9890
       end if
       do irow=1,nrow
         strucmodgrid(igrid)%delc(irow)=delc(irow)
       end do
       do icol=1,ncol
         strucmodgrid(igrid)%delr(icol)=delr(icol)
       end do
       if(icorner.eq.1)then
         strucmodgrid(igrid)%e0=e0
         strucmodgrid(igrid)%n0=n0
       else
         side=0.0d0
         do irow=1,nrow
           side=side+delc(irow)
         end do
         strucmodgrid(igrid)%e0=e0-side*strucmodgrid(igrid)%sinang
         strucmodgrid(igrid)%n0=n0+side*strucmodgrid(igrid)%cosang
       end if
       numstrucmodgrid=numstrucmodgrid+1
       go to 9999

9890   continue
       install_structured_grid=1
       if(igrid.ne.0)then
         if(associated(strucmodgrid(igrid)%delr)) deallocate(strucmodgrid(igrid)%delr,stat=ierr)
         if(associated(strucmodgrid(igrid)%delc)) deallocate(strucmodgrid(igrid)%delc,stat=ierr)
         strucmodgrid(igrid)%ncol=0
         strucmodgrid(igrid)%nrow=0
         strucmodgrid(igrid)%nlay=0
         strucmodgrid(igrid)%name=' '
       end if

9999   continue
       return

end function install_structured_grid


integer (kind=c_int) function uninstall_structured_grid(gridname)               &
                 bind(c,name="uninstall_structured_grid")

! -- This function uninstalls a previously installed set of structured grid specifications.

       use iso_c_binding, only: c_int,c_char
       use dimvar
       use deftypes
       use utilities
       use high_level_utilities
       implicit none

       character (kind=c_char), intent(in)  :: gridname(LENGRIDNAME)
       integer                              :: igrid,ierr
       character (len=LENGRIDNAME)          :: aname

! -- Initialisation

       uninstall_structured_grid=0

! -- The name is translated to a character variable.

       call utl_string2char(LENGRIDNAME,gridname,aname)
       aname=adjustl(aname)
       call utl_casetrans(aname,'lo')
       if(aname.eq.' ')then
         write(amessage,100)
100      format('GRIDNAME argument is supplied as blank.')
         go to 9890
       end if

! -- Does this correspond to a stored structured grid?

       if(numstrucmodgrid.eq.0) go to 9000
       do igrid=1,MAXSTRUCMODGRID
         if(strucmodgrid(igrid)%name.eq.aname) go to 200
       end do
       go to 9000
200    continue

! -- The grid is now deallocated.

       ierr=uth_strucmodgrid_deallocate(igrid)
       if(ierr.ne.0) go to 9890
       go to 9990

9000   write(amessage,9010) trim(aname)
9010   format('The name "',a,'" does not correspond to an installed structured grid.')
       go to 9890

9890   continue
       uninstall_structured_grid=1

9990   continue
       return

end function uninstall_structured_grid



integer (kind=c_int) function free_all_memory() &
                 bind(c,name="free_all_memory")

! -- This function deallocates all memory that is being used.

       use dimvar
       use deftypes
       use utilities
       use high_level_utilities
       use iso_c_binding, only: c_int
       implicit none

       integer   :: ifail,igrid,jfail,ierr

! -- Initialisation

       free_all_memory=0
       jfail=0

! -- First structured grids.

       if(numstrucmodgrid.gt.0)then
         do igrid=1,MAXSTRUCMODGRID
           if(strucmodgrid(igrid)%nrow.ne.0)then
             ifail=uth_strucmodgrid_deallocate(igrid)
             if(ifail.ne.0) jfail=1
           end if
         end do
       end if

       if(nummf6modgrid.gt.0)then
         do igrid=1,MAXMF6MODGRID
           if(mf6modgrid(igrid)%distype.ne.0)then
             ifail=uth_mf6modgrid_deallocate(igrid)
             if(ifail.ne.0) jfail=1
           end if
         end do
       end if

       call free_param_memory1()
       call free_param_memory2()
       if(allocated(seed))deallocate(seed,stat=ierr)
       if(allocated(ivector1))deallocate(ivector1,stat=ierr)
       if(allocated(ivector2))deallocate(ivector2,stat=ierr)
       if(allocated(rvector1))deallocate(rvector1,stat=ierr)
       if(allocated(rvector2))deallocate(rvector2,stat=ierr)
       if(allocated(rvector3))deallocate(rvector3,stat=ierr)
       if(allocated(dvector1))deallocate(dvector1,stat=ierr)
       if(allocated(dvector2))deallocate(dvector2,stat=ierr)
       if(allocated(dvector3))deallocate(dvector3,stat=ierr)

       if(jfail.ne.0)then
         free_all_memory=1
         write(amessage,100)
100      format('Unable to free all memory.')
       end if

       return

end function free_all_memory



integer (kind=c_int) function interp_from_structured_grid(                   &
                             GridName,DepVarFile,isim,iprec,ntime,           &
                             VarType,InterpThresh,NoInterpVal,               &
                             npts,ecoord,ncoord,layer,                       &
                             nproctime,simtime,simstate)                     &
                 bind(c,name="interp_from_structured_grid")

! -- This function performs spatial interpolation from a structured grid to a set of points.

       use iso_c_binding, only: c_int,c_double,c_char
       use dimvar
       use deftypes
       use utilities
       use high_level_utilities
       implicit none

       character (kind=c_char), intent(in)  :: gridname(LENGRIDNAME)      ! name of installed structured grid
       character (kind=c_char), intent(in)  :: depvarfile(LENFILENAME)    ! name of binary file to read
       integer(kind=c_int), intent(in)      :: isim                       ! -1 for MT3D; 1 for MODFLOW
       integer(kind=c_int), intent(in)      :: iprec                      ! 1 for single; 2 for double
       integer(kind=c_int), intent(in)      :: ntime                      ! number of output times
       character (kind=c_char), intent(in)  :: vartype(17)                ! only read arrays of this type
       real(kind=c_double), intent(in)      :: interpthresh               ! abs threshold for dry or inactive
       real(kind=c_double), intent(in)      :: nointerpval                ! no-interpolation-possible value
       integer(kind=c_int), intent(in)      :: npts                       ! number of points for which interpolation required
       real(kind=c_double), intent(in)      :: ecoord(npts),ncoord(npts)  ! eastings and northing of points
       integer(kind=c_int), intent(in)      :: layer(npts)                ! layers of points
       integer(kind=c_int), intent(out)     :: nproctime                  ! number of processed simulation times
       real(kind=c_double), intent(out)     :: simtime(ntime)             ! simulation time
       real(kind=c_double), intent(out)     :: simstate(ntime,npts)       ! interpolated system state

       integer                        :: kstp,kper,ntrans,kstpold,kperold,ntransold
       integer                        :: inunit,ierr,ipts,igrid
       integer                        :: ncol,nrow,icol,irow,nlay
       integer                        :: iarray,itime,mcol,mrow,ilay,ibig,icount
       real                           :: rinterpthresh,rgt_thresh,pertim,totim
       double precision               :: gt_thresh
       double precision               :: dpertim,dtotim
       character (len=10)             :: alay
       character (len=16)             :: atext,text
       character (len=LENGRIDNAME)    :: chargridname
       character (len=LENFILENAME)    :: infile

! -- Allocatable data objects.

       integer, allocatable           :: icellno(:),jcellno(:)           ! Could be automatic (but worried about stack)
       real, allocatable              :: rarray(:,:)
       double precision, allocatable  :: darray(:,:)
       double precision, allocatable  :: fac1(:),fac2(:),fac3(:),fac4(:)

! -- Initialisation

       interp_from_structured_grid=0
       function_name='interp_from_structured_grid()'
       simtime=nointerpval      ! default output value
       simstate=nointerpval     ! an array
       inunit=0
       kstpold=-99999999
       kperold=-99999999
       ntransold=-99999999
       kstp=kstpold
       kper=kperold
       ntrans=ntransold
       nproctime=0
       icount=0
       ibig=huge(ibig)/2                   ! arbitrary

! -- Character arrays are translated to character variables.

       call utl_string2char(LENGRIDNAME,gridname,chargridname)
       chargridname=adjustl(chargridname)
       call utl_casetrans(chargridname,'lo')
       call utl_string2char(LENFILENAME,depvarfile,infile)
       infile=adjustl(infile)
       call utl_string2char(17,vartype,atext)
       atext=adjustl(atext)
       call utl_casetrans(atext,'lo')

! -- We check for errors in input arguments.

       if((isim.ne.1).and.(isim.ne.-1))then
         write(amessage,90)
90       format('ISIM argument must be supplied as -1 (MT3D) or +1 (MODFLOW).')
         go to 9890
       end if
       if((iprec.ne.1).and.(iprec.ne.2))then
         write(amessage,100)
100      format('IPREC argument must be supplied as 1 (single) or 2 (double).')
         go to 9890
       end if
       if(ntime.le.0)then
         write(amessage,110) 'NTIME'
110      format(a,' argument must be positive.')
         go to 9890
       end if
       if(npts.le.0)then
         write(amessage,110) 'NPTS'
         go to 9890
       end if
       if(chargridname.eq.' ')then
         write(amessage,130) 'GRIDNAME'
130      format(a,' argument must not be an empty string.')
         go to 9890
       end if
       if(infile.eq.' ')then
         write(amessage,130) 'DEPVARFILE'
         go to 9890
       end if
       if(iprec.eq.1)then
         if(interpthresh.gt.huge(rinterpthresh)-2.0*spacing(huge(rinterpthresh)))then
           write(amessage,135)
135        format('Value supplied for INTERPTHRESH argument is greater ',  &
           'than single precision allows.')
           go to 9890
         end if
         rinterpthresh=min(huge(rinterpthresh)-2.0*spacing(huge(rinterpthresh)),real(interpthresh))
       end if

! -- Identify the grid.

       do igrid=1,MAXSTRUCMODGRID
         if(strucmodgrid(igrid)%name.eq.chargridname) go to 150
       end do
       write(amessage,140) trim(chargridname)
140    format('"',a,'" is not an installed grid.')
       go to 9890
150    continue
       nrow=strucmodgrid(igrid)%nrow
       ncol=strucmodgrid(igrid)%ncol
       nlay=strucmodgrid(igrid)%nlay

! -- Open the system state file.

       call utl_addquote(infile,afile1)
       inunit=utl_nextunit()
       open(unit=inunit,file=infile,status='old',form='unformatted',access='stream',iostat=ierr)
       if(ierr.ne.0) then
         write(amessage,160) trim(afile1)
160      format('Cannot open binary simulator output file ',a,'.')
         go to 9890
       end if

! -- Allocate memory

       if(iprec.eq.1)then
         allocate(rarray(0:ncol+1,0:nrow+1),stat=ierr)
         if(ierr.ne.0) go to 9200
       else
         allocate(darray(0:ncol+1,0:nrow+1),stat=ierr)
         if(ierr.ne.0) go to 9200
       end if
       allocate(icellno(npts),jcellno(npts),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(fac1(npts),fac2(npts),fac3(npts),fac4(npts),stat=ierr)
       if(ierr.ne.0) go to 9200

! -- Calculate interpolation factors

       do ipts=1,npts
         call uth_strucfactors(igrid,ecoord(ipts),ncoord(ipts),fac1(ipts),fac2(ipts),  &
         fac3(ipts),fac4(ipts),icellno(ipts),jcellno(ipts))
       end do
       if(all(icellno.eq.-999)) then
         write(amessage,170) trim(strucmodgrid(igrid)%name)
170      format('None of the user-supplied points are within the bounds of ',    &
         'the "',a,'" structured grid.')
         go to 9890
       end if

! -- Pre-fill the cells of the array that are not in the model grid.

       if(iprec.eq.1)then
         rgt_thresh=rinterpthresh+2.0*(spacing(rinterpthresh))
         rarray(0,:)=rgt_thresh
         rarray(ncol+1,:)=rgt_thresh
         rarray(:,0)=rgt_thresh
         rarray(:,nrow+1)=rgt_thresh
       else
         gt_thresh=interpthresh+2.0d0*spacing(interpthresh)
         darray(0,:)=gt_thresh
         darray(ncol+1,:)=gt_thresh
         darray(:,0)=gt_thresh
         darray(:,nrow+1)=gt_thresh
       end if

! -- Read the input file

       iarray=0
       itime=0
       read_an_array: do
         iarray=iarray+1
         mrow=0
         mcol=0
         if(isim.eq.1)then
           if(iprec.eq.1)then
             read(inunit,err=9000,end=1000) kstp,kper,pertim,totim, &
             text,mcol,mrow,ilay
           else
             read(inunit,err=9000,end=1000) kstp,kper,dpertim,dtotim, &
             text,mcol,mrow,ilay
           end if
         else if(isim.eq.-1)then
           if(iprec.eq.1)then
             read(inunit,err=9000,end=1000) ntrans,kstp,kper,&
             totim,text,mcol,mrow,ilay
           else
             read(inunit,err=9000,end=1000) ntrans,kstp,kper,&
             dtotim,text,mcol,mrow,ilay
           end if
         end if
         if((mrow.lt.1).or.(mcol.lt.1).or.(ilay.lt.1).or.               &
            (mrow.gt.ibig).or.(mcol.gt.ibig).or.(ilay.gt.ibig))then
            write(amessage,180) trim(afile1)
180         format('An array header in file ',a,' does not make sense. Is this ', &
            'file being read using the correct precision?')
            go to 9890
          end if
         if((mrow.ne.nrow).or.(mcol.ne.ncol))then
           write(amessage,185) trim(chargridname),trim(afile1)
185        format('There is a NCOL or NROW mismatch between structured model ',  &
           'grid "',a,'" and arrays in file ',a,'. Alternatively this file is ', &
           'being read using the wrong precision.')
           go to 9890
         end if
         if(ilay.gt.nlay)then
           call utl_num2char(ilay,alay)
           write(amessage,190) trim(afile1),trim(alay),trim(chargridname)
190        format('An array in file ',a,' pertains to layer number ',a,'. This is ', &
           'larger than the number of layers in structured model grid "',a,'".')
           go to 9890
         end if
         text=adjustl(text)
         call utl_casetrans(text,'lo')
         if(iarray.ne.1)then
           if((kstp.ne.kstpold).or.(ntrans.ne.ntransold).or. &
             (kper.ne.kperold)) then
             itime=itime+1
             if(itime.gt.ntime) then
               itime=itime-1
               go to 1000
             end if
             if(iprec.eq.1)then
               simtime(itime)=totim
             else
               simtime(itime)=dtotim
             end if
           end if
         else
           itime=itime+1
           if(iprec.eq.1)then
             simtime(itime)=totim
           else
             simtime(itime)=dtotim
           end if
         end if
         if(iprec.eq.1)then
           read(inunit,err=9000,end=9050) ((rarray(icol,irow),icol=1,ncol), &
           irow=1,nrow)
           darray=rarray      ! arrays
         else
           read(inunit,err=9000,end=9050) ((darray(icol,irow),icol=1,ncol), &
           irow=1,nrow)
         end if
         kstpold=kstp
         kperold=kper
         ntransold=ntrans
         if(index(text,trim(atext)).ne.0)then
           icount=icount+1
           do ipts=1,npts
             if(layer(ipts).eq.ilay) then
                call uth_point_interp(ncol,nrow,interpthresh,nointerpval,fac1(ipts),    &
                fac2(ipts),fac3(ipts),fac4(ipts),icellno(ipts),jcellno(ipts),           &
                simstate(itime,ipts),darray)
             end if
           end do
         end if
       end do read_an_array
1000   if(iarray.eq.1) then
         write(amessage,1010) trim(afile1)
1010     format('No arrays were found in file ',a,'.')
         go to 9890
       end if
       nproctime=itime
       if(icount.eq.0)then
         write(amessage,1020) trim(atext),trim(afile1)
1020     format('No "',a,'" arrays found in file ',a,'.')
         go to 9890
       end if
       go to 9900

9000   continue
       if(isim.eq.-1)then
         write(amessage,9010) 'MT3D',trim(afile1)
       else
         write(amessage,9010) 'MODFLOW',trim(afile1)
       end if
9010   format('An error was encountered in reading ',a,' binary output file ',a,'.')
       go to 9890

9050   continue
       if(isim.eq.-1)then
         write(amessage,9060) 'MT3D',trim(afile1)
       else
         write(amessage,9060) 'MODFLOW',trim(afile1)
       end if
9060   format('An unexpected end was encountered when reading ',a,    &
       ' binary output file ',a,'.')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory allocation error in call to function ',a,'.')
       go to 9890

9890   continue
       interp_from_structured_grid=1

9900   continue

! -- Tidy up

       if(inunit.ne.0)then
         close(unit=inunit,iostat=ierr)
       end if
       if(allocated(rarray))deallocate(rarray,stat=ierr)
       if(allocated(darray))deallocate(darray,stat=ierr)
       if(allocated(icellno))deallocate(icellno,stat=ierr)
       if(allocated(jcellno))deallocate(jcellno,stat=ierr)
       if(allocated(fac1))deallocate(fac1,stat=ierr)
       if(allocated(fac2))deallocate(fac2,stat=ierr)
       if(allocated(fac3))deallocate(fac3,stat=ierr)
       if(allocated(fac4))deallocate(fac4,stat=ierr)

       return

end function interp_from_structured_grid



integer (kind=c_int) function interp_to_obstime(                               &
                             nsimtime,nproctime,npts,simtime,simval,           &
                             interpthresh,how_extrap,time_extrap,nointerpval,  &
                             nobs,obspoint,obstime,obssimval)                  &
                 bind(c,name="interp_to_obstime")

! -- This function performs temporal interpolation for simulation times to observation times.
! -- Note that observation times do not need to be supplied in increasing order for each
!    observation point. However simulation times in the SIMTIME array must be in increasing order.

       use iso_c_binding, only: c_int,c_double,c_char
       use utilities
       implicit none

       integer(kind=c_int), intent(in)         :: nsimtime           ! first dimension of simtime and simval arrays
       integer(kind=c_int), intent(in)         :: nproctime          ! number of times in simtime and simval arrays
       integer(kind=c_int), intent(in)         :: npts               ! number of points in simval array (second dimension)
       real(kind=c_double), intent(in)         :: simtime(nsimtime)      ! simulation times
       real(kind=c_double), intent(in)         :: simval(nsimtime,npts)  ! simulated values
       real(kind=c_double), intent(in)         :: interpthresh       ! values equal or above this in simval have no meaning
       character(kind=c_char,len=1),intent(in) :: how_extrap         ! L=linear; C=constant
       real(kind=c_double), intent(in)         :: time_extrap        ! permitted extrapolation time
       real(kind=c_double), intent(in)         :: nointerpval        ! dummy output value if interpolation impossible
       integer(kind=c_int), intent(in)         :: nobs               ! number of elements in obspoint, obstime and obssimval arrays
       integer(kind=c_int), intent(in)         :: obspoint(nobs)     ! indices of observation points (start at 0; -1 means no index)
       real(kind=c_double), intent(in)         :: obstime(nobs)      ! observation times
       real(kind=c_double), intent(out)        :: obssimval(nobs)    ! time-interpolated simulation values

       character (len=1)                :: aextrap
       character (len=20)               :: atemp20
       integer                          :: istime,ipts,iobs
       double precision                 :: ttime,dtime,dsim1,dsim2

! -- Initialisation

       interp_to_obstime=0
       function_name='interp_to_obstime()'
       obssimval=nointerpval      ! default value

! -- Checks are made

       if(interpthresh.le.0.0d0)then
         write(amessage,110) 'INTERPTHRESH', trim(function_name)
         go to 9890
       end if
       if(nsimtime.le.0)then
         write(amessage,110) 'NSIMTIME',trim(function_name)
110      format('The ',a,' argument of function ',a,' must be greater than zero.')
         go to 9890
       end if
       if(npts.le.0)then
         write(amessage,110) 'NPTS',trim(function_name)
         go to 9890
       end if
       if(nobs.le.0)then
         write(amessage,110) 'NOBS',trim(function_name)
         go to 9890
       end if
       if(nproctime.le.0)then
         write(amessage,110) 'NPROCTIME',trim(function_name)
         go to 9890
       end if
       if(nproctime.gt.nsimtime)then
         write(amessage,115)
115      format('Value for NPROCTIME argument must not exceed that of NSIMTIME argument.')
         go to 9890
       end if
       aextrap=how_extrap
       call utl_casetrans(aextrap,'lo')
       if((aextrap.ne.'l').and.(aextrap.ne.'c'))then
         write(amessage,120) trim(function_name)
120      format('The value supplied for the HOW_EXTRAP argument of function ',a,  &
         ' must be "L" or "C".')
         go to 9890
       end if
       if(nproctime.eq.1) aextrap='c'
       if(time_extrap.lt.0.0d0)then
         write(amessage,130) trim(function_name)
130      format('The TIME_EXTRAP argument of function ',a,' must be nonnegative.')
         go to 9890
       end if

       if(nproctime.gt.1)then
         do istime=2,nproctime
           if(simtime(istime).le.simtime(istime-1))then
             write(amessage,140)
140          format('Times provided in the SIMTIME array must be in increasing order.')
             go to 9890
           end if
         end do
       end if

! -- Interpolation is now performed.

       do iobs=1,nobs
         ipts=obspoint(iobs)+1              ! Recall that indices supplied by users begin at zero
         if(ipts.gt.0)then
           ttime=obstime(iobs)
           if(ttime.le.simtime(1))then
             dtime=simtime(1)-ttime
             if(dtime.le.time_extrap)then
               dsim1=simval(1,ipts)
               if(abs(dsim1).lt.interpthresh)then
                 if(aextrap.eq.'c')then
                   obssimval(iobs)=dsim1
                 else
                   dsim2=simval(2,ipts)
                   if(abs(dsim2).lt.interpthresh)then
                     obssimval(iobs)=dsim1-(dsim2-dsim1)/(simtime(2)-simtime(1))*dtime
                   else
                     obssimval(iobs)=dsim1
                   end if
                 end if
               end if
             end if
           else
             if(nproctime.gt.1)then
               do istime=2,nproctime
                 if(ttime.le.simtime(istime))then
                   dsim2=simval(istime,ipts)
                   if(ttime.eq.simtime(istime))then
                     if(abs(dsim2).lt.interpthresh) obssimval(iobs)=dsim2
                     go to 300
                   else
                     dsim1=simval(istime-1,ipts)
                     if(abs(dsim1).lt.interpthresh)then
                       if(abs(dsim2).lt.interpthresh)then
                         obssimval(iobs)=dsim1+(dsim2-dsim1)/(simtime(istime)-simtime(istime-1))  &
                                             *(ttime-simtime(istime-1))
                       end if
                     end if
                   end if
                   go to 300
                 end if
               end do
             end if
             dtime=ttime-simtime(nproctime)
             if(dtime.le.time_extrap)then
               dsim2=simval(nproctime,ipts)
               if(abs(dsim2).lt.interpthresh)then
                 if(aextrap.eq.'c')then
                   obssimval(iobs)=dsim2
                 else
                   dsim1=simval(nproctime-1,ipts)
                   if(abs(dsim1).lt.interpthresh)then
                     obssimval(iobs)=dsim2+(dsim2-dsim1)/(simtime(nproctime)-simtime(nproctime-1))*dtime
                   else
                     obssimval(iobs)=dsim2
                   end if
                 end if
               end if
             end if
300          continue
           end if
         end if
       end do

       go to 9900

9890   continue
       interp_to_obstime=1

9900   continue

end function interp_to_obstime



integer (kind=c_int) function install_mf6_grid_from_file(gridname,grbfile,        &
                              idis,ncells,ndim1,ndim2,ndim3)                      &
                 bind(c,name="install_mf6_grid_from_file")

! -- This function installs specifications for a MF6 grid from the contents of a GRB file.

       use iso_c_binding, only: c_int,c_char
       use dimvar
       use deftypes
       use utilities
       use high_level_utilities
       implicit none

       character (kind=c_char,len=1), intent(in)  :: gridname(LENGRIDNAME)   ! Name of installed grid
       character (kind=c_char,len=1), intent(in)  :: grbfile(LENFILENAME)    ! MF6 GRB file from which grid specs read
       integer(kind=c_int), intent(out)           :: idis                    ! 1=DIS; 2=DISV
       integer(kind=c_int), intent(out)           :: ncells                  ! Number of cells in the grid
       integer(kind=c_int), intent(out)           :: ndim1,ndim2,ndim3       ! Grid dimensions

       integer                        :: i,ierr,itype
       integer                        :: igrid,gridunit,jgrid,itemp
       integer                        :: nlay,nrow,ncol,ncpl,nvert
       integer                        :: ntxt,lentxt
       integer                        :: ndimgridname,ndimgrbfile
       integer                        :: icol,irow,ilay,icpl,nja,njavert

       character (len=10)             :: atemp10
       character (len=20)             :: atype,anum,avar,aword
       character (len=LENGRIDNAME)    :: aname
       character (len=LENFILENAME)    :: agrbfile

! -- Initialisation

       function_name='install_mf6_grid_from_file()'
       install_mf6_grid_from_file=0
       igrid=0
       idis=0
       ncells=0; ndim1=0; ndim2=0; ndim3=0
       gridunit=0
!       ndimgridname=size(gridname)           ! Inherited from declaration
!       ndimgrbfile=size(grbfile)             ! Inherited from declaration
       ndimgridname=LENGRIDNAME
       ndimgrbfile=LENFILENAME

! -- Text strings are converted to character variables.

       call utl_string2char(ndimgridname,gridname,aname)
       aname=adjustl(aname)
       call utl_casetrans(aname,'lo')
       if(aname.eq.' ')then
         write(amessage,50) 'gridname', trim(function_name)
50       format('The ',a,' argument of function ',a,' is supplied as blank.')
         go to 9890
       end if

       call utl_string2char(ndimgrbfile,grbfile,agrbfile)
       agrbfile=adjustl(agrbfile)
       if(agrbfile.eq.' ')then
         write(amessage,50) 'grbfile',trim(function_name)
         go to 9890
       end if
       call utl_addquote(agrbfile,afile1)

! -- An empty array element is found.

       if(nummf6modgrid.ge.MAXMF6MODGRID)then
         call utl_num2char(MAXMF6MODGRID,atemp10)
         write(amessage,40) trim(atemp10)
40       format('A maximum of ',a,' MODFLOW 6 model grid specifications ',  &
         'can be installed. You must uninstall at least one MODFLOW 6 model ', &
         'grid specification before you can install a new one.')
         go to 9890
       end if
       if(nummf6modgrid.eq.0)then
         igrid=1
       else
         do igrid=1,MAXMF6MODGRID
           if(mf6modgrid(igrid)%distype.eq.0) go to 60
         end do
         write(amessage,45) trim(function_name)
45       format('Programming error in function ',a,': contact programmer.')
         go to 9890
60       continue
       end if

       if(nummf6modgrid.gt.0)then
         do jgrid=1,MAXMF6MODGRID
           if(mf6modgrid(jgrid)%distype.ne.0)then
             if(aname.eq.mf6modgrid(jgrid)%name)then
               write(amessage,110) trim(aname)
110            format('The name "',a,'" belongs to an already-installed ',  &
               'MODFLOW 6 grid.')
               go to 9890
             end if
           endif
         enddo
       end if
       mf6modgrid(igrid)%name=aname

! -- Open the GRB file.

       gridunit=utl_nextunit()
       open(unit=gridunit,file=agrbfile,status='old',form='unformatted',    &
       access='stream',iostat=ierr)
       if(ierr.ne.0)then
         write(amessage,150) trim(afile1)
150      format('Cannot open file ',a,'.')
         go to 9890
       end if

! -- We read the 4 header lines.

        mf6header=' '   ! An array
        atype='header'
        do i=1,4
          read(gridunit,err=9000,end=9050) mf6header(i)
        end do

! -- We obtain data from these header lines.

        mf6header(1)=adjustl(mf6header(1))
        if(mf6header(1)(1:9).eq.'GRID DIS ')then
          mf6modgrid(igrid)%distype=1
        else if(mf6header(1)(1:9).eq.'GRID DISV')then
          mf6modgrid(igrid)%distype=2
        else if(mf6header(1)(1:9).eq.'GRID DISU')then
          mf6modgrid(igrid)%distype=3
        else
          write(amessage,120) trim(mf6header(1)(1:49)),trim(afile1)
120       format('Unknown grid type: "',a,'" cited in file ',a,'.')
          go to 9890
        end if
        if(mf6modgrid(igrid)%distype.eq.3)then
          write(amessage,121)
121       format('As presently programmed, a DISU GRB file cannot be read.')
          go to 9890
        end if
        mf6header(3)=adjustl(mf6header(3))
        if(mf6header(3)(1:4).ne.'NTXT')then
          write(amessage,130) trim(afile1)
130       format('Third header line of file ',a,' expeced to begin with "NTXT".')
          go to 9890
        end if
        anum=adjustl(mf6header(3)(5:))
        if(utl_char2num(anum,ntxt).ne.0)then
          avar='NTXT'
          write(amessage,140) trim(avar),trim(afile1)
140       format('Cannot read ',a,' variable from header line of file ',a,'.')
          go to 9890
        end if
        mf6header(4)=adjustl(mf6header(4))
        if(mf6header(4)(1:6).ne.'LENTXT')then
          write(amessage,145) trim(afile1)
145       format('Fourth header line of file ',a,' expected to begin with "LENTXT".')
          go to 9890
        end if
        anum=adjustl(mf6header(4)(7:))
        if(utl_char2num(anum,lentxt).ne.0)then
          avar='LENTXT'
          write(amessage,140) trim(avar),trim(afile1)
          go to 9890
        end if
        if(lentxt.gt.MAXLENTXT)then
          write(amessage,160) trim(afile1)
160       format('Cannot read definition strings from file ',a,'. Increase MAXLENTXT ',   &
          'and re-compile program.')
          go to 9890
        end if

        idis=mf6modgrid(igrid)%distype
        if(idis.eq.1)then
          if(ntxt.ne.NTXT_DIS) go to 9070
        else if(idis.eq.2)then
          if(ntxt.ne.NTXT_DISV) go to 9070
        end if

! -- Next we read the definition lines.

        atype='definition'
        do i=1,ntxt
161       continue
          read(gridunit,err=9000,end=9050) definition(i)(1:lentxt)
          if(definition(i)(1:1).eq.'#') go to 161
          definition(i)=adjustl(definition(i)(1:lentxt-1))
        end do

! -- We now check that the definition lines are what we expect.

        do i=1,ntxt
          cline=definition(i)
          if(utl_wordsplit(2,lw,rw,cline).ne.0) go to 9150
          aword=cline(lw(2):rw(2))
          if(aword.eq.'INTEGER')then
            itype=1
          else if(aword.eq.'DOUBLE')then
            itype=2
          else
            itype=3
          end if
          if(idis.eq.1)then
            if(cline(lw(1):rw(1)).ne.expectdefn_dis(i)) go to 9150
            if(itype.ne.expect_dis_type(i)) go to 9150
          else if (idis.eq.2)then
            if(cline(lw(1):rw(1)).ne.expectdefn_disv(i)) go to 9150
            if(itype.ne.expect_disv_type(i)) go to 9150
          end if
        end do

! -- We now read the data and dimension arrays.

        if(idis.eq.1)then
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%ncells
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%nlay
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%nrow
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%ncol
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%nja
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%xorigin
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%yorigin
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%angrot
          nlay=mf6modgrid(igrid)%nlay
          ncol=mf6modgrid(igrid)%ncol
          nrow=mf6modgrid(igrid)%nrow
          nja=mf6modgrid(igrid)%nja
          ncells=mf6modgrid(igrid)%ncells
          itemp=nlay*nrow*ncol
          if(mf6modgrid(igrid)%ncells.ne.itemp)then
            write(amessage,170) trim(afile1)
170         format('NCELLS expected to be NCOL*NROW*NLAY in file ',a,'.')
            go to 9890
          end if
          allocate(mf6modgrid(igrid)%delr(0:ncol+1),mf6modgrid(igrid)%delc(0:nrow+1),stat=ierr)
          if(ierr.ne.0) go to 9200
          mf6modgrid(igrid)%ncr=nrow*ncol
          allocate(mf6modgrid(igrid)%botm(ncol,nrow,0:nlay),stat=ierr)
          if(ierr.ne.0) go to 9200
          allocate(mf6modgrid(igrid)%idomain(ncol,nrow,nlay),stat=ierr)
          if(ierr.ne.0) go to 9200
          allocate(mf6modgrid(igrid)%icelltype(ncol,nrow,nlay),stat=ierr)
          if(ierr.ne.0) go to 9200
          allocate(mf6modgrid(igrid)%ia(ncells+1),mf6modgrid(igrid)%ja(nja),stat=ierr)
          if(ierr.ne.0) go to 9200

          read(gridunit,err=9220,end=9240) (mf6modgrid(igrid)%delr(icol),icol=1,ncol)
          read(gridunit,err=9220,end=9240) (mf6modgrid(igrid)%delc(irow),irow=1,nrow)
          read(gridunit,err=9220,end=9240) ((mf6modgrid(igrid)%botm(icol,irow,0),icol=1,ncol),irow=1,nrow)
          read(gridunit,err=9220,end=9240) (((mf6modgrid(igrid)%botm(icol,irow,ilay),   &
                                              icol=1,ncol),irow=1,nrow),ilay=1,nlay)
          read(gridunit,err=9220,end=9240) (mf6modgrid(igrid)%ia(i),i=1,ncells+1)
          read(gridunit,err=9220,end=9240) (mf6modgrid(igrid)%ja(i),i=1,nja)
          read(gridunit,err=9220,end=9240) (((mf6modgrid(igrid)%idomain(icol,irow,ilay), &
                                              icol=1,ncol),irow=1,nrow),ilay=1,nlay)
          read(gridunit,err=9220,end=9240) (((mf6modgrid(igrid)%icelltype(icol,irow,ilay),  &
                                              icol=1,ncol),irow=1,nrow),ilay=1,nlay)
          mf6modgrid(igrid)%delr(0)=mf6modgrid(igrid)%delr(1)
          mf6modgrid(igrid)%delr(ncol+1)=mf6modgrid(igrid)%delr(ncol)
          mf6modgrid(igrid)%delc(0)=mf6modgrid(igrid)%delc(1)
          mf6modgrid(igrid)%delc(nrow+1)=mf6modgrid(igrid)%delc(nrow)
          if(any(mf6modgrid(igrid)%delr.le.0.0d0))then
            write(amessage,171) trim(afile1)
171         format('At least one member of the DELR array is zero or negative in file ',a,'.')
            go to 9890
          end if
          if(any(mf6modgrid(igrid)%delc.le.0.0d0))then
            write(amessage,172) trim(afile1)
172         format('At least one member of the DELC array is zero or negative in file ',a,'.')
            go to 9890
          end if

        else if (idis.eq.2)then

          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%ncells
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%nlay
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%ncpl
          ncpl=mf6modgrid(igrid)%ncpl
          nlay=mf6modgrid(igrid)%nlay
          ncells=mf6modgrid(igrid)%ncells
          if(mf6modgrid(igrid)%ncells.ne.nlay*ncpl)then
            write(amessage,180) trim(afile1)
180         format('NCELLS should equal NLAY*NCPL in file ',a,'.')
            go to 9890
          end if
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%nvert
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%njavert
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%nja
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%xorigin
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%yorigin
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%angrot
          nja=mf6modgrid(igrid)%nja
          nvert=mf6modgrid(igrid)%nvert
          njavert=mf6modgrid(igrid)%njavert

          allocate(mf6modgrid(igrid)%botmv(ncpl,0:nlay),stat=ierr)
          if(ierr.ne.0) go to 9200
          allocate(mf6modgrid(igrid)%vertices(2,nvert),stat=ierr)
          if(ierr.ne.0) go to 9200
          allocate(mf6modgrid(igrid)%cellx(ncpl),mf6modgrid(igrid)%celly(ncpl),stat=ierr)
          if(ierr.ne.0) go to 9200
          allocate(mf6modgrid(igrid)%iavert(ncpl+1),mf6modgrid(igrid)%javert(njavert),stat=ierr)
          if(ierr.ne.0) go to 9200
          allocate(mf6modgrid(igrid)%idomainv(ncpl,nlay),     &
          mf6modgrid(igrid)%icelltypev(ncpl,nlay),stat=ierr)
          if(ierr.ne.0) go to 9200
          allocate(mf6modgrid(igrid)%ia(ncells+1),mf6modgrid(igrid)%ja(nja),stat=ierr)
          if(ierr.ne.0) go to 9200

          read(gridunit,err=9220,end=9240) (mf6modgrid(igrid)%botmv(icpl,0),icpl=1,ncpl)
          read(gridunit,err=9220,end=9240) ((mf6modgrid(igrid)%botmv(icpl,ilay),icpl=1,ncpl),ilay=1,nlay)
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%vertices
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%cellx
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%celly
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%iavert
          read(gridunit,err=9220,end=9240) mf6modgrid(igrid)%javert
          read(gridunit,err=9220,end=9240) (mf6modgrid(igrid)%ia(i),i=1,ncells+1)
          read(gridunit,err=9220,end=9240) (mf6modgrid(igrid)%ja(i),i=1,nja)
          read(gridunit,err=9220,end=9240) ((mf6modgrid(igrid)%idomainv(icpl,ilay),icpl=1,ncpl),ilay=1,nlay)
          read(gridunit,err=9220,end=9240) ((mf6modgrid(igrid)%icelltypev(icpl,ilay),icpl=1,ncpl),ilay=1,nlay)

        end if
        nummf6modgrid=nummf6modgrid+1
        idis=mf6modgrid(igrid)%distype
        ncells=mf6modgrid(igrid)%ncells
        if(idis.eq.1)then
          ndim1=ncol
          ndim2=nrow
          ndim3=nlay
        else if(idis.eq.2)then
          ndim1=ncpl
          ndim2=1
          ndim3=nlay
        end if

        go to 9900

9000    write(amessage,9010) trim(atype),trim(afile1)
9010    format('Error encountered in reading ',a,' lines from file ',a,'.')
        go to 9890

9050    write(amessage,9060) trim(afile1),trim(atype)
9060    format('Premature end encountered to file ',a,' while reading ',a,' lines.')
        go to 9890

9070    write(amessage,9080) trim(afile1)
9080    format('Unexpected value for NTXT variable in file ',a,'.')
        go to 9890

9150    write(amessage,9160) trim(definition(i)),trim(afile1)
9160    format('Unexpected definition line "',a,'" in file ',a,'.')
        go to 9890

9200    write(amessage,9210)
9210    format('Cannot allocate memory required to store grid specifications.')
        go to 9890

9220    write(amessage,9230) trim(afile1)
9230    format('Error encountered in reading file ',a,'.')
        go to 9890

9240    write(amessage,9250) trim(afile1)
9250    format('Premature end encountered to file ',a,'.')
        go to 9890

9890   continue
       install_mf6_grid_from_file=1
       if(igrid.ne.0)then
         itemp=uth_mf6modgrid_deallocate(igrid)
       end if

9900   continue
       if(gridunit.ne.0) close(unit=gridunit,iostat=ierr)

       return

end function install_mf6_grid_from_file



integer (kind=c_int) function uninstall_mf6_grid(gridname)            &
                 bind(c,name="uninstall_mf6_grid")

! -- This function uninstalls a previously installed mf6 grid specification.

       use iso_c_binding, only: c_int,c_char
       use dimvar
       use deftypes
       use utilities
       use high_level_utilities
       implicit none

       character (kind=c_char,len=1), intent(in)  :: gridname(LENGRIDNAME)  ! Grid name to uninstall

       integer                        :: igrid,ierr
       character (len=LENGRIDNAME)    :: aname

! -- Initialisation

       uninstall_mf6_grid=0

! -- The name is translated to a character variable.

       call utl_string2char(LENGRIDNAME,gridname,aname)
       aname=adjustl(aname)
       call utl_casetrans(aname,'lo')
       if(aname.eq.' ')then
         write(amessage,100)
100      format('GRIDNAME argument is supplied as blank.')
         go to 9890
       end if

! -- Does this correspond to a stored mf6 grid?

       if(nummf6modgrid.eq.0) go to 9000
       do igrid=1,MAXMF6MODGRID
         if(mf6modgrid(igrid)%distype.ne.0)then
           if(mf6modgrid(igrid)%name.eq.aname) go to 200
         end if
       end do
       go to 9000
200    continue

! -- The grid is now deallocated.

       ierr=uth_mf6modgrid_deallocate(igrid)
       if(ierr.ne.0) go to 9890
       go to 9990

9000   write(amessage,9010) trim(aname)
9010   format('The name "',a,'" does not correspond to an installed MODFLOW 6 grid.')
       go to 9890

9890   continue
       uninstall_mf6_grid=1

9990   continue
       return

end function uninstall_mf6_grid



integer (kind=c_int) function calc_mf6_interp_factors(gridname,        &
                              npts,ecoord,ncoord,layer,                &
                              factorfile, factorfiletype,              &
                              blnfile,interp_success)                  &
                 bind(c,name="calc_mf6_interp_factors")

! -- This function calculates interpolation factors from a MODFLOW 6 DIS or DISV
!    grid to a set of user-supplied points.

       use iso_c_binding, only: c_int,c_double,c_char
       use dimvar
       use deftypes
       use utilities
       implicit none

       character (kind=c_char,len=1), intent(in)   :: gridname(LENGRIDNAME)      ! name of installed MF6 grid
       integer(kind=c_int), intent(in)             :: npts                       ! number of points for which interpolation required
       real(kind=c_double), intent(in)             :: ecoord(npts),ncoord(npts)  ! eastings and northing of points
       integer(kind=c_int), intent(in)             :: layer(npts)                ! layers of points
       character(kind=c_char,len=1), intent(in)    :: factorfile(LENFILENAME)    ! name of factor file
       integer(kind=c_int), intent(in)             :: factorfiletype             ! 0=binary; 1=text
       character(kind=c_char,len=1), intent(in)    :: blnfile(LENFILENAME)       ! name of bln file to write
       integer(kind=c_int), intent(out)            :: interp_success(npts)       ! 1=success; 0=failure

       integer                        :: ierr,i
       integer                        :: outunit1,outunit2
       integer                        :: igrid,nlay,ncol,nrow,ilay,icol,irow,ncr
       integer                        :: ncpl,icpl,distype
       integer                        :: ipos,ivert,ipts
       integer                        :: iicol,iirow,iilay,iicpl
       integer                        :: ndim1,ndim2,ndim3
       integer                        :: in1,in2,in3,in4
       integer                        :: nvcell,nvert,jvert,itemp,l,m
       integer                        :: numtri
       integer                        :: jlayoffset,mincon,icell,icon
       integer                        :: ic1,ic2,ic3,ic4
       integer                        :: i1,i2,i3
       integer                        :: ncon1,ncon2,ncon3,icon1,icon2,icon3,numcon,ncon
       integer                        :: icell_keep,ic1_keep,ic2_keep,ic3_keep

       double precision               :: xxmin,xxmax,yymin,yymax
       double precision               :: eee,nnn
       double precision               :: x,y,xorigin,yorigin,cosang,sinang
       double precision               :: ee,nn,xx,yy
       double precision               :: dx,dy,ddx,ddy,den
       double precision               :: fac1,fac2,fac3,fac4,dtemp,eps
       double precision               :: y23,x13,x32,y13
       double precision               :: b1,b2,b3
       double precision               :: bb1,bb2,bb3,bb4
       double precision               :: xpoly(MAXINTERPVERT+1),ypoly(MAXINTERPVERT+1)
       double precision               :: xpoly_keep(MAXINTERPVERT+1),ypoly_keep(MAXINTERPVERT+1)

       character (len=20)             :: apts,anum
       character (len=LENGRIDNAME)    :: chargridname
       character (len=LENFILENAME)    :: outfile1,outfile2

! -- Pointers

       integer, pointer, dimension(:)            :: iavert, javert,ia,ja
       double precision, pointer, dimension(:)   :: delr,delc
       double precision, pointer, dimension(:)   :: cellx,celly
       double precision, pointer, dimension(:,:) :: vertices

! -- Allocatable arrays

       double precision, allocatable  :: xcell(:),ycell(:)
       double precision, allocatable  :: cellxmax(:),cellxmin(:),cellymax(:),cellymin(:)

! -- Initialisation

       calc_mf6_interp_factors=0
       function_name='calc_mf6_interp_factors()'
       outunit1=0
       outunit2=0
       eps=1.0d-7              !arbitrary


! -- Character arrays are translated to character variables.

       call utl_string2char(LENGRIDNAME,gridname,chargridname)
       chargridname=adjustl(chargridname)
       call utl_casetrans(chargridname,'lo')
       call utl_string2char(LENFILENAME,factorfile,outfile1)
       outfile1=adjustl(outfile1)
       call utl_string2char(LENFILENAME,blnfile,outfile2)
       outfile2=adjustl(outfile2)

! -- Other checks of input arguments are made.

       if(npts.le.0)then
         write(amessage,110) trim(function_name)
110      format('The NPTS argument of function ',a,' must be greater than zero.')
         go to 9890
       end if

       do igrid=1,MAXMF6MODGRID
         if(mf6modgrid(igrid)%name.eq.chargridname) go to 150
       end do
       write(amessage,140) trim(chargridname)
140    format('"',a,'" is not an installed grid.')
       go to 9890
150    continue
       distype=mf6modgrid(igrid)%distype
       nlay=mf6modgrid(igrid)%nlay
       if(any(layer.le.0))then
         write(amessage,160)
160      format('At least one element of the LAYER array argument is zero or less.')
         go to 9890
       end if
       if(any(layer.gt.nlay))then
         write(amessage,170) trim(chargridname)
170      format('At least one element of the LAYER array argument has a value that is ',  &
         'greater than NLAY for MF6 grid "',a,'".')
         go to 9890
       end if
       if(outfile1.eq.' ')then
         write(amessage,180)
180      format('The value of the factorfile argument must not be blank.')
         go to 9890
       end if
       if((factorfiletype.ne.0).and.(factorfiletype.ne.1))then
         write(amessage,185) trim(function_name)
185      format('The factorfiletype argument of function ',a,' must be supplied as 0 or 1.')
         go to 9890
       end if
       call utl_addquote(outfile1,afile1)
       if(outfile2.ne.' ') call utl_addquote(outfile2,afile2)

! -- We find the maximum and minimum local x and y coordinates in the grid.

        if(distype.eq.1)then
          nrow=mf6modgrid(igrid)%nrow
          ncol=mf6modgrid(igrid)%ncol
          ncr=mf6modgrid(igrid)%ncr
          delr=>mf6modgrid(igrid)%delr
          delc=>mf6modgrid(igrid)%delc
          xxmin=0.0d0
          xxmax=0.0d0
          do icol=1,ncol
            xxmax=xxmax+delr(icol)
          end do
          yymin=0.0d0
          yymax=0.0d0
          do irow=nrow,1,-1
            yymax=yymax+delc(irow)
          end do
! -- Find cell centre coords in local coordinate system.
          allocate(xcell(ncol),ycell(nrow),stat=ierr)
          if(ierr.ne.0) go to 9200
          xcell(1)=delr(1)*0.5
          do icol=2,ncol
            xcell(icol)=xcell(icol-1)+(delr(icol-1)+delr(icol))*0.5
          end do
          ycell(nrow)=delc(nrow)*0.5
          do irow=nrow-1,1,-1
            ycell(irow)=ycell(irow+1)+(delc(irow+1)+delc(irow))*0.5
          end do
        else if(distype.eq.2)then    ! The following assumes that there are no "stray vertices".
          xxmin=1.0d300
          xxmax=-1.0d300
          yymin=1.0d300
          yymax=-1.0d300
          ncpl=mf6modgrid(igrid)%ncpl
          nvert=mf6modgrid(igrid)%nvert
          vertices=>mf6modgrid(igrid)%vertices
          iavert=>mf6modgrid(igrid)%iavert
          javert=>mf6modgrid(igrid)%javert
          ia=>mf6modgrid(igrid)%ia
          ja=>mf6modgrid(igrid)%ja
          cellx=>mf6modgrid(igrid)%cellx
          celly=>mf6modgrid(igrid)%celly
          do ivert=1,nvert
            if(vertices(1,ivert).gt.xxmax)xxmax=vertices(1,ivert)
            if(vertices(1,ivert).lt.xxmin)xxmin=vertices(1,ivert)
            if(vertices(2,ivert).gt.yymax)yymax=vertices(2,ivert)
            if(vertices(2,ivert).lt.yymin)yymin=vertices(2,ivert)
          end do
! -- To make the following search easier, we find max coordinates of each grid cell.
          allocate(cellxmax(ncpl),cellxmin(ncpl),cellymax(ncpl),cellymin(ncpl),stat=ierr)
          if(ierr.ne.0) go to 9200
          cellxmax=-1.0d300          !an array
          cellymax=-1.0d300          !an array
          cellxmin=1.0d300           !an array
          cellymin=1.0d300           !an array
          do icpl=1,ncpl
            do ipos=iavert(icpl),iavert(icpl+1)-1
              ivert=javert(ipos)
              x=vertices(1,ivert)
              y=vertices(2,ivert)
              if(x.gt.cellxmax(icpl))cellxmax(icpl)=x
              if(x.lt.cellxmin(icpl))cellxmin(icpl)=x
              if(y.gt.cellymax(icpl))cellymax(icpl)=y
              if(y.lt.cellymin(icpl))cellymin(icpl)=y
            end do
          end do
        end if

! -- The factor file is opened.

        outunit1=utl_nextunit()
        if(factorfiletype.eq.0)then
          open(unit=outunit1,file=outfile1,form='unformatted',access='stream',   &
          action='write',iostat=ierr)
        else
          open(unit=outunit1,file=outfile1,action='write',iostat=ierr)
        end if
        if(ierr.ne.0)then
          write(amessage,190) trim(afile1)
190       format('Cannot write to file ',a,'.')
          go to 9890
        end if
        if(outfile2.ne.' ')then
          outunit2=utl_nextunit()
          open(unit=outunit2,file=outfile2,action='write',iostat=ierr)
          if(ierr.ne.0)then
            write(amessage,190) trim(afile2)
            go to 9890
          end if
        end if

! -- Record data at the top of the file.

        if(distype.eq.1)then
          ndim1=ncol
          ndim2=nrow
        else if(distype.eq.2)then
          ndim1=ncpl
          ndim2=1
        end if
        ndim3=nlay
        if(factorfiletype.eq.0)then
          write(outunit1,err=9300) npts,distype,ndim1,ndim2,ndim3
          do ipts=1,npts
            write(outunit1,err=9300) ecoord(ipts),ncoord(ipts),layer(ipts)
          end do
        else
          write(outunit1,220,err=9300) npts,distype,ndim1,ndim2,ndim3
220       format(5i10)
          do ipts=1,npts
            write(outunit1,230,err=9300) ecoord(ipts),ncoord(ipts),layer(ipts)
230         format(2(' ',1pg23.16),1x,i10)
          end do
        end if

! -- The points are now processed one by one.

        xorigin=mf6modgrid(igrid)%xorigin
        yorigin=mf6modgrid(igrid)%yorigin
        cosang=cos(mf6modgrid(igrid)%angrot*pi/180.0d0)
        sinang=sin(mf6modgrid(igrid)%angrot*pi/180.0d0)
        do ipts=1,npts
          interp_success(ipts)=1
          ilay=layer(ipts)
! -- Express point coordinates in local coordinates if necessary.
          ee=ecoord(ipts)
          nn=ncoord(ipts)
          xx=(ee-xorigin)*cosang+(nn-yorigin)*sinang
          yy=-(ee-xorigin)*sinang+(nn-yorigin)*cosang
          if((xx.lt.xxmin).or.(xx.gt.xxmax).or.(yy.lt.yymin).or.(yy.gt.yymax)) go to 459
! -- Now we locate the cell (DISV grid) or the cell centres surrounding the bore (DIS grid).
          if(distype.eq.1)then
            if(xx.lt.xcell(1)) go to 459
            do icol=2,ncol
              if(xx.le.xcell(icol))then
                iicol=icol-1
                go to 300
              end if
            end do
            go to 459
300         continue
            if(yy.gt.ycell(1)) go to 459
            do irow=2,nrow
              if(yy.ge.ycell(irow))then
                iirow=irow-1
                go to 310
              end if
            end do
            go to 459
310         continue
          else if(distype.eq.2)then
            do icpl=1,ncpl
              if((xx.le.cellxmax(icpl)).and.(xx.ge.cellxmin(icpl)))then
                if((yy.le.cellymax(icpl)).and.(yy.ge.cellymin(icpl)))then
                  nvcell = iavert(icpl+1) - iavert(icpl)
                  if(nvcell+1.gt.MAXINTERPVERT)then
                    call utl_num2char(nvcell,anum)
                    write(amessage,320) trim(anum)
320                 format(' At least one cell in the MODFLOW 6 grid has ',a,' or more vertices. ',   &
                    'Increase MAXINTERPVERT to greater than this and re-compile program.')
                    go to 9890
                  end if
                  i=0
                  do ipos = iavert(icpl), iavert(icpl + 1) - 1
                    ivert=javert(ipos)
                    i=i+1
                    xpoly(i)=vertices(1,ivert)
                    ypoly(i)=vertices(2,ivert)
                  end do
                  jvert=ivert
                  ipos = iavert(icpl)
                  ivert=javert(ipos)
                  itemp=nvcell
                  if(ivert.ne.jvert)then
                    i=i+1
                    xpoly(i)=vertices(1,ivert)
                    ypoly(i)=vertices(2,ivert)
                    itemp=nvcell+1
                  end if
                  call utl_locpt(xx,yy,xpoly,ypoly,itemp,l,m)
                  if(l.ge.0) then
                    iicpl=icpl
                    go to 340
                  end if
                end if
              end if
            end do
            go to 459
340         continue
          end if
! -- We record interpolation factors.
350       continue
          if(distype.eq.1)then
            iilay=layer(ipts)
            in1=(iilay-1)*ncr+(iirow-1)*ncol+iicol
            in2=in1+1
            in3=in2+ncol
            in4=in3-1
            dx=xx-xcell(iicol)
            dy=ycell(iirow)-yy
            ddx=xcell(iicol+1)-xx
            ddy=yy-ycell(iirow+1)
            den=(dx+ddx)*(dy+ddy)
            fac1=ddx*ddy/den
            fac2=dx*ddy/den
            fac3=dx*dy/den
            fac4=ddx*dy/den
! -- Quality assurance
            if((fac1.lt.-eps).or.(fac2.lt.-eps).or.(fac3.lt.-eps).or.(fac4.lt.-eps)) go to 9170
            dtemp=1.0d0+eps
            if((fac1.gt.dtemp).or.(fac2.gt.dtemp).or.(fac3.gt.dtemp).or.(fac4.gt.dtemp)) go to 9170
            dtemp=fac1+fac2+fac3+fac4
            if((dtemp.lt.1.0d0-3.0d0*eps).or.(dtemp.gt.1.0d0+3.0d0*eps)) go to 9170
            if(factorfiletype.eq.0)then
              write(outunit1) 4,in1,fac1,in2,fac2,in3,fac3,in4,fac4
            else
              write(outunit1,360) 4,in1,fac1,in2,fac2,in3,fac3,in4,fac4
360           format(i6,100(' ',i10,' ',1pg23.16))
            end if
            if(outunit2.ne.0)then
              call utl_num2char(ipts,apts)
              write(outunit2,440) 5,0,trim(apts)
              eee=xcell(iicol)*cosang-ycell(iirow)*sinang+xorigin
              nnn=xcell(iicol)*sinang+ycell(iirow)*cosang+yorigin
              write(outunit2,450) eee,nnn
              eee=xcell(iicol+1)*cosang-ycell(iirow)*sinang+xorigin
              nnn=xcell(iicol+1)*sinang+ycell(iirow)*cosang+yorigin
              write(outunit2,450) eee,nnn
              eee=xcell(iicol+1)*cosang-ycell(iirow+1)*sinang+xorigin
              nnn=xcell(iicol+1)*sinang+ycell(iirow+1)*cosang+yorigin
              write(outunit2,450) eee,nnn
              eee=xcell(iicol)*cosang-ycell(iirow+1)*sinang+xorigin
              nnn=xcell(iicol)*sinang+ycell(iirow+1)*cosang+yorigin
              write(outunit2,450) eee,nnn
              eee=xcell(iicol)*cosang-ycell(iirow)*sinang+xorigin
              nnn=xcell(iicol)*sinang+ycell(iirow)*cosang+yorigin
              write(outunit2,450) eee,nnn
            end if
          else if(distype.eq.2)then
            iilay=layer(ipts)
            jlayoffset=(iilay-1)*ncpl
            mincon=99999999
! -- We look for a three or four connection path back to the cell.
! -- Make sure that this works for layers other than the first.
            icell=(iilay-1)*ncpl+iicpl
            ncon=ia(icell+1)-ia(icell)-1
            do icon=1,ncon
              ic1=ja(ia(icell)+icon)
              if((ic1.eq.icell-ncpl).or.(ic1.eq.icell+ncpl))cycle
              ncon1=ia(ic1+1)-ia(ic1)-1
              do icon1=1,ncon1
                ic2=ja(ia(ic1)+icon1)
                if(ic2.eq.ic1)cycle
                if((ic2.eq.ic1-ncpl).or.(ic2.eq.ic1+ncpl))cycle
                ncon2=ia(ic2+1)-ia(ic2)-1
                do icon2=1,ncon2
                  ic3=ja(ia(ic2)+icon2)
                  if(ic3.eq.ic2)cycle
                  if((ic3.eq.ic2-ncpl).or.(ic3.eq.ic2+ncpl))cycle
                  if(ic3.eq.icell)then
                    numcon=3
                    xpoly(1)=cellx(icell-jlayoffset)
                    ypoly(1)=celly(icell-jlayoffset)
                    xpoly(2)=cellx(ic1-jlayoffset)
                    ypoly(2)=celly(ic1-jlayoffset)
                    xpoly(3)=cellx(ic2-jlayoffset)
                    ypoly(3)=celly(ic2-jlayoffset)
                    xpoly(4)=cellx(icell-jlayoffset)
                    ypoly(4)=celly(icell-jlayoffset)
                    call utl_locpt(xx,yy,xpoly,ypoly,4,l,m)
                    if(l.ge.0) then
                      mincon=3
                      go to 430
                    end if
                  end if
                  ncon3=ia(ic3+1)-ia(ic3)-1
                  do icon3=1,ncon3
                    ic4=ja(ia(ic3)+icon3)
                    if(ic4.eq.ic3)cycle
                    if((ic4.eq.ic3-ncpl).or.(ic4.eq.ic3+ncpl))cycle
                    if(ic4.eq.icell)then
                      numcon=4
                      xpoly(1)=cellx(icell-jlayoffset)
                      ypoly(1)=celly(icell-jlayoffset)
                      xpoly(2)=cellx(ic1-jlayoffset)
                      ypoly(2)=celly(ic1-jlayoffset)
                      xpoly(3)=cellx(ic2-jlayoffset)
                      ypoly(3)=celly(ic2-jlayoffset)
                      xpoly(4)=cellx(ic3-jlayoffset)
                      ypoly(4)=celly(ic3-jlayoffset)
                      xpoly(5)=cellx(icell-jlayoffset)
                      ypoly(5)=celly(icell-jlayoffset)
                      call utl_locpt(xx,yy,xpoly,ypoly,5,l,m)
                      if(l.ge.0) then
                        if(numcon.lt.mincon)then
                          mincon=numcon
                          xpoly_keep(1)=xpoly(1)
                          ypoly_keep(1)=ypoly(1)
                          xpoly_keep(2)=xpoly(2)
                          ypoly_keep(2)=ypoly(2)
                          xpoly_keep(3)=xpoly(3)
                          ypoly_keep(3)=ypoly(3)
                          xpoly_keep(4)=xpoly(4)
                          ypoly_keep(4)=ypoly(4)
                          xpoly_keep(5)=xpoly(5)
                          ypoly_keep(5)=ypoly(5)
                          icell_keep=icell
                          ic1_keep=ic1
                          ic2_keep=ic2
                          ic3_keep=ic3
                        end if
                      end if
                    end if
                  end do
                end do
              end do
            end do
            if(mincon.lt.99999999)then
              numcon=mincon
              xpoly(1)=xpoly_keep(1)
              ypoly(1)=ypoly_keep(1)
              xpoly(2)=xpoly_keep(2)
              ypoly(2)=ypoly_keep(2)
              xpoly(3)=xpoly_keep(3)
              ypoly(3)=ypoly_keep(3)
              xpoly(4)=xpoly_keep(4)
              ypoly(4)=ypoly_keep(4)
              icell=icell_keep
              ic1=ic1_keep
              ic2=ic2_keep
              if(numcon.eq.4)then
                xpoly(5)=xpoly_keep(5)
                ypoly(5)=ypoly_keep(5)
                ic3=ic3_keep
              end if
            else
              go to 459
            end if
430         continue

! -- Record interpolation factors
            if(numcon.eq.3)then
              y23=ypoly(2)-ypoly(3)
              x13=xpoly(1)-xpoly(3)
              x32=xpoly(3)-xpoly(2)
              y13=ypoly(1)-ypoly(3)
              den=y23*x13+x32*y13
              if(den.eq.0.0d0) go to 459
              b1=(y23*(xx-xpoly(3))+x32*(yy-ypoly(3)))/den
              b2=(-y13*(xx-xpoly(3))+x13*(yy-ypoly(3)))/den
              b3=1.0d0-b1-b2
              dtemp=0.0d0-eps
              if((b1.lt.dtemp).or.(b2.lt.dtemp).or.(b3.lt.dtemp)) go to 9000
              dtemp=1.0d0+eps
              if((b1.gt.dtemp).or.(b2.gt.dtemp).or.(b3.gt.dtemp)) go to 9000
              dtemp=b1+b2+b3
              if((dtemp.lt.1.0d0-eps).or.(dtemp.gt.1.0d0+eps)) go to 9100
              if(factorfiletype.eq.0)then
                write(outunit1,err=9300)3,icell,b1,ic1,b2,ic2,b3
              else
                write(outunit1,360,err=9300) 3,icell,b1,ic1,b2,ic2,b3
              end if
            else if(numcon.eq.4)then
! -- We average over all possible triangles; normally there will be 2.
              numtri=0
              bb1=0.0d0
              bb2=0.0d0
              bb3=0.0d0
              bb4=0.0d0
              do i=1,4
                if(i.eq.1)then
                  i1=1
                  i2=2
                  i3=4
                else if(i.eq.2)then
                  i1=2
                  i2=3
                  i3=4
                else if(i.eq.3)then
                  i1=1
                  i2=2
                  i3=3
                else if(i.eq.4)then
                  i1=1
                  i2=3
                  i3=4
                end if
                y23=ypoly(i2)-ypoly(i3)
                x13=xpoly(i1)-xpoly(i3)
                x32=xpoly(i3)-xpoly(i2)
                y13=ypoly(i1)-ypoly(i3)
                den=y23*x13+x32*y13
                if(den.eq.0.0d0) cycle
                b1=(y23*(xx-xpoly(i3))+x32*(yy-ypoly(i3)))/den
                b2=(-y13*(xx-xpoly(i3))+x13*(yy-ypoly(i3)))/den
                b3=1.0d0-b1-b2
                dtemp=0.0d0-eps
                if((b1.lt.dtemp).or.(b2.lt.dtemp).or.(b3.lt.dtemp)) cycle
                dtemp=1.0d0+eps
                if((b1.gt.dtemp).or.(b2.gt.dtemp).or.(b3.gt.dtemp)) cycle
                numtri=numtri+1
                if(i.eq.1)then
                  bb1=bb1+b1
                  bb2=bb2+b2
                  bb4=bb4+b3
                else if(i.eq.2)then
                  bb2=bb2+b1
                  bb3=bb3+b2
                  bb4=bb4+b3
                else if(i.eq.3)then
                  bb1=bb1+b1
                  bb2=bb2+b2
                  bb3=bb3+b3
                else if(i.eq.4)then
                  bb1=bb1+b1
                  bb3=bb3+b2
                  bb4=bb4+b3
                end if
              end do
              if(numtri.eq.0) go to 9050
              if(numtri.gt.1)then
                bb1=bb1/numtri
                bb2=bb2/numtri
                bb3=bb3/numtri
                bb4=bb4/numtri
              end if
              dtemp=bb1+bb2+bb3+bb4
              if((dtemp.lt.1.0d0-3.0d0*eps).or.(dtemp.gt.1.0d0+3.0d0*eps)) go to 9150
              if(factorfiletype.eq.0)then
                write(outunit1,err=9300) 4,icell,bb1,ic1,bb2,ic2,bb3,ic3,bb4
              else
                write(outunit1,360,err=9300) 4,icell,bb1,ic1,bb2,ic2,bb3,ic3,bb4
              end if
            end if
! -- Record the subtending polygon.
            if(outunit2.ne.0)then
              call utl_num2char(ipts,apts)
              write(outunit2,440) numcon+1,0,trim(apts)
440           format(i10,i5,5x,'"',a,'"')
              do i=1,numcon+1
                eee=xpoly(i)*cosang-ypoly(i)*sinang+xorigin
                nnn=xpoly(i)*sinang+ypoly(i)*cosang+yorigin
                write(outunit2,450) eee,nnn
450             format(1x,f20.4,3x,f20.4)
              end do
            end if
          end if
          cycle
459       continue
          interp_success(ipts)=0
          if(factorfiletype.eq.0)then
            write(outunit1,err=9300) 0
          else
            write(outunit1,361,err=9300) 0
361         format(i6)
          end if
        end do

        go to 9900

9000    continue
        call utl_num2char(1,anum)
        write(amessage,9010) trim(anum),trim(function_name)
9010    format('Error type ',a,' encountered in function ',a,': contact programmer.')
        go to 9890

9050    continue
        call utl_num2char(2,anum)
        write(amessage,9010) trim(anum),trim(function_name)
        go to 9890

9100    continue
        call utl_num2char(3,anum)
        write(amessage,9010) trim(anum),trim(function_name)
        go to 9890

9150    continue
        call utl_num2char(4,anum)
        write(amessage,9010) trim(anum),trim(function_name)
        go to 9890

9170    continue
        call utl_num2char(5,anum)
        write(amessage,9010) trim(anum),trim(function_name)
        go to 9890

9200    write(amessage,9210)
9210    format('Cannot allocate sufficient memory to continue execution.')
        go to 9890

9300    write(amessage,9310) trim(afile1)
9310    format('Error writing to file ',a,'.')
        go to 9890

9890    continue
        calc_mf6_interp_factors=1

9900    continue
        if(outunit1.ne.0) close(unit=outunit1,iostat=ierr)
        if(outunit2.ne.0) close(unit=outunit2,iostat=ierr)

        if(allocated(xcell)) deallocate(xcell,stat=ierr)
        if(allocated(ycell)) deallocate(ycell,stat=ierr)
        if(allocated(cellxmax)) deallocate(cellxmax,stat=ierr)
        if(allocated(cellxmin)) deallocate(cellxmin,stat=ierr)
        if(allocated(cellymax)) deallocate(cellymax,stat=ierr)
        if(allocated(cellymin)) deallocate(cellymax,stat=ierr)

        if(associated(iavert)) nullify(iavert)
        if(associated(javert)) nullify(javert)
        if(associated(ia)) nullify(ia)
        if(associated(ja)) nullify(ja)
        if(associated(delr)) nullify(delr)
        if(associated(delc)) nullify(delc)
        if(associated(cellx)) nullify(cellx)
        if(associated(celly)) nullify(celly)
        if(associated(vertices)) nullify(vertices)

end function calc_mf6_interp_factors



integer (kind=c_int) function interp_from_mf6_depvar_file(             &
                 depvarfile,factorfile,factorfiletype,                 &
                 ntime,vartype,interpthresh,reapportion,nointerpval,   &
                 npts,nproctime,simtime,simstate)                      &
                 bind(c,name="interp_from_mf6_depvar_file")

! -- This function interpolates to a set of points using previously-calculated
!    interpolation factors.

       use iso_c_binding, only: c_int,c_char,c_double
       use dimvar
       use utilities
       implicit none

       character(kind=c_char,len=1), intent(in)   :: depvarfile(LENFILENAME)   ! Dependent variable file written by MODFLOW 6
       character(kind=c_char,len=1), intent(in)   :: factorfile(LENFILENAME)   ! File containing spatial interpolation factors
       integer(kind=c_int), intent(in)            :: factorfiletype       ! 0 for binary; 1 for ascii
       integer(kind=c_int), intent(in)            :: ntime                ! First dimension of simtime and simstate arrays
       character (kind=c_char,len=1), intent(in)  :: vartype(17)           ! Only read arrays of this type
       real(kind=c_double), intent(in)            :: interpthresh         ! Abs threshold for dry or inactive
       integer(kind=c_int), intent(in)            :: reapportion          ! 0 for no; 1 for yes
       real(kind=c_double), intent(in)            :: nointerpval          ! No-interpolation-possible value
       integer(kind=c_int), intent(in)            :: npts                 ! Second dimension of simstate
       integer(kind=c_int), intent(out)           :: nproctime            ! Number of processed simulation times
       real(kind=c_double), intent(out)           :: simtime(ntime)       ! Simulation times
       real(kind=c_double), intent(out)           :: simstate(ntime,npts) ! Interpolated system states

       integer                        :: ierr,itemp
       integer                        :: dvunit,facunit
       integer                        :: mpts,distype,ndim1,ndim2,ndim3
       integer                        :: ipts,icell,itime,inode
       integer                        :: ncol,nrow,ncpl,nlay,mcol,mrow,mlay,mcpl,icpl,ilay
       integer                        :: kstpold,kperold,kstp,kper
       double precision               :: dtemp,dpertim,dtotim,sum,dtotimold,den
       character (len=16)             :: atext,text,textold
       character (len=256)            :: dvfile,facfile

       integer, allocatable           :: ncell(:),ifac(:,:)
       double precision, allocatable  :: dfac(:,:)
       double precision, allocatable  :: darray(:,:)

! -- Initialisation

       interp_from_mf6_depvar_file=0
       function_name='interp_from_mf6_depvar_file()'
       dvunit=0
       facunit=0
       simtime=nointerpval     ! an array
       simstate=nointerpval    ! an array
       kstpold=-99999999
       kperold=-99999999
       textold=' '
       dtotimold=-1.0d30
       nproctime=0

! -- Character arrays are translated to character variables.

       call utl_string2char(LENFILENAME,depvarfile,dvfile)
       dvfile=adjustl(dvfile)
       call utl_string2char(LENFILENAME,factorfile,facfile)
       facfile=adjustl(facfile)
       call utl_string2char(17,vartype,atext)
       atext=adjustl(atext)
       call utl_casetrans(atext,'lo')

! -- Check input arguments.

       if(ntime.le.0)then
         write(amessage,110) 'NTIME', trim(function_name)
110      format('The ', a,' argument of function ',a,' must be positive.')
         go to 9890
       end if
       if(npts.le.0)then
         write(amessage,110) 'NPTS', trim(function_name)
         go to 9890
       end if
       if(dvfile.eq.' ')then
         write(amessage,120) 'DEPVARFILE',trim(function_name)
120      format('The ',a,' argument of function ',a,' must not be blank.')
         go to 9890
       end if
       if(facfile.eq.' ')then
         write(amessage,120) 'FACTORFILE',trim(function_name)
         go to 9890
       end if
       if(atext.eq.' ')then
         write(amessage,120) 'VARTYPE',trim(function_name)
         go to 9890
       end if
       if((factorfiletype.ne.0).and.(factorfiletype.ne.1))then
         write(amessage, 130) trim(function_name)
130      format('The FACTORFILETYPE argument of function ',a,' must be supplied as 0 or 1.')
         go to 9890
       end if
       if(interpthresh.le.0.0d0)then
         write(amessage,140) trim(function_name)
140      format('The INTERPTHRESH argument of function ',a,' must be positive.')
         go to 9890
       end if

! -- Open the dependent variable file.

       call utl_addquote(dvfile,afile1)
       dvunit=utl_nextunit()
       open(unit=dvunit,file=dvfile,status='old',form='unformatted',access='stream',iostat=ierr)
       if(ierr.ne.0) then
         write(amessage,160) trim(afile1)
160      format('Cannot open binary MODFLOW 6 output file ',a,'.')
         go to 9890
       end if

! -- Open the factor file.

       call utl_addquote(facfile,afile2)
       facunit=utl_nextunit()
       if(factorfiletype.eq.0)then
         open(unit=facunit,file=facfile,status='old',form='unformatted',access='stream',iostat=ierr)
         if(ierr.ne.0) then
           write(amessage,180) trim(afile2)
180        format('Cannot open binary interpolation factor file ',a,'.')
           go to 9890
         end if
       else
         open(unit=facunit,file=facfile,status='old',iostat=ierr)
         if(ierr.ne.0) then
           write(amessage,185) trim(afile2)
185        format('Cannot open ASCII interpolation factor file ',a,'.')
           go to 9890
         end if
       end if

! -- Read the first line of the factor file to ascertain the number of points and some model details.

       if(factorfiletype.eq.0)then
         read(facunit,err=9000,end=9000) mpts,distype,ndim1,ndim2,ndim3
       else
         read(facunit,*,err=9000,end=9000) mpts,distype,ndim1,ndim2,ndim3
       end if
       if(mpts.ne.npts)then
         write(amessage,190) trim(afile2)
190      format('The value for NPTS recorded in the header to file ',a,' does not ', &
         'agree with the value of the user-supplied NPTS function argument.')
         go to 9890
       end if
       if(distype.eq.1)then
         ncol=ndim1
         nrow=ndim2
         ncpl=nrow*ncol
       else
         ncpl=ndim1
       end if
       nlay=ndim3

! -- Arrays are allocated

       allocate(darray(ncpl,nlay),stat=ierr)
       if(ierr.ne.0) go to 9200
       allocate(ncell(npts),ifac(MAXINTERPVERT,npts),dfac(MAXINTERPVERT,npts),stat=ierr)
       if(ierr.ne.0) go to 9200

! -- The first NPTS lines of the factor file are read.

       if(factorfiletype.eq.0)then
         do ipts=1,npts
           read(facunit,err=9000,end=9000) dtemp,dtemp,itemp
         end do
       else
         do ipts=1,npts
           read(facunit,*,err=9000,end=9000) dtemp,dtemp,itemp
         end do
       end if

! -- Interpolation factors are read.

       if(factorfiletype.eq.0)then
         do ipts=1,npts
           read(facunit,err=9000,end=9000) ncell(ipts),                &
               (ifac(icell,ipts),dfac(icell,ipts),icell=1,ncell(ipts))
         end do
       else
         do ipts=1,npts
           read(facunit,*,err=9000,end=9000) ncell(ipts),              &
               (ifac(icell,ipts),dfac(icell,ipts),icell=1,ncell(ipts))
         end do
       end if
       close(unit=facunit)

! -- The dependent variable file is read.

       itime=0
       do
         if(distype.eq.1)then
           read(dvunit,err=9100,end=500) kstp,kper,dpertim,dtotim,text,mcol,mrow,mlay
           if((mcol.ne.ncol).or.(mrow.ne.nrow)) go to 9300
         else
           read(dvunit,err=9100,end=500) kstp,kper,dpertim,dtotim,text,mcpl,itemp,mlay
           if(mcpl.ne.ncpl) go to 9300
         end if
         if((mlay.le.0).or.(mlay.gt.nlay)) go to 9300
         if((kstp.ne.kstpold).or.(kper.ne.kperold))then
           textold=adjustl(textold)
           call utl_casetrans(textold,'lo')
           if(index(textold,trim(atext)).ne.0) then
             itime=itime+1
             if(itime.gt.ntime) go to 500
             simtime(itime)=dtotimold
             do ipts=1,npts
               if(ncell(ipts).gt.0)then
                 sum=0.0d0
                 den=0.0d0
                 do icell=1,ncell(ipts)
                   inode=ifac(icell,ipts)
                   ilay=(inode-1)/ncpl+1
                   icpl=inode-(ilay-1)*ncpl
                   dtemp=darray(icpl,ilay)
                   if(abs(dtemp).ge.interpthresh)then
                     if(reapportion.eq.0) go to 210
                   end if
                   sum=sum+dtemp*dfac(icell,ipts)
                   den=den+dfac(icell,ipts)
                 end do
                 if(den.ne.0.0d0) simstate(itime,ipts)=sum/den
210              continue
               end if
             end do
           end if
           kstpold=kstp
           kperold=kper
           dtotimold=dtotim
           textold=text
           darray=interpthresh+2.0d0*spacing(interpthresh)
         end if
         read(dvunit,err=9100,end=9150) (darray(icpl,mlay),icpl=1,ncpl)
       end do

500    continue
       textold=adjustl(textold)
       call utl_casetrans(textold,'lo')
       if(index(textold,trim(atext)).ne.0) then
         if(itime+1.le.ntime) then
           itime=itime+1
           simtime(itime)=dtotimold
           do ipts=1,npts
             if(ncell(ipts).gt.0)then
               sum=0.0d0
               den=0.0d0
               do icell=1,ncell(ipts)
                 inode=ifac(icell,ipts)
                 ilay=(inode-1)/ncpl+1
                 icpl=inode-(ilay-1)*ncpl
                 dtemp=darray(icpl,ilay)
                 if(abs(dtemp).ge.interpthresh) then
                   if(reapportion.eq.0) go to 520
                 end if
                 sum=sum+dtemp*dfac(icell,ipts)
                 den=den+dfac(icell,ipts)
               end do
               if(den.ne.0.0d0) simstate(itime,ipts)=sum/den
520            continue
             end if
           end do
         end if
       end if

       if(itime.eq.0)then
         write(amessage,510) trim(atext),trim(afile1)
510      format('No dependent variable arrays characterized by text "',a,   &
         '" were found in file ',a,'.')
         go to 9890
       end if
       nproctime=itime
       go to 9900

9000   continue
       if(factorfiletype.eq.0)then
         write(amessage,9010) trim(afile2)
9010     format('Error encountered when reading binary interpolation factor ', &
         'file ',a,'.')
       else
         write(amessage,9011) trim(afile2)
9011     format('Error encountered when reading ASCII interpolation factor ', &
         'file ',a,'.')
       end if
       go to 9890

9100   write(amessage,9110) trim(afile1)
9110   format('Error encountered when reading binary MODFLOW 6 dependent variable file ',a,'.')
       go to 9890

9150   write(amessage,9160) trim(afile1)
9160   format('Premature end encountered to binary MODFLOW 6 dependent variable file ',a,'.')
       go to 9890


9200   write(amessage,9210) trim(function_name)
9210   format('Memory allocation error in function ',a,'.')
       go to 9890

9300   write(amessage,9310) trim(afile1),trim(afile2)
9310   format('Grid dimensions listed in array headers in file ',a,' are not ', &
       'in accordance with those of model grid for which interpolation factors ', &
       'are recorded in file ',a,'.')
       go to 9890

9890   continue
       interp_from_mf6_depvar_file=1

9900   continue
       if(dvunit.ne.0) close(unit=dvunit,iostat=ierr)
       if(facunit.ne.0) close(unit=facunit,iostat=ierr)

       if(allocated(ncell))deallocate(ncell,stat=ierr)
       if(allocated(ifac))deallocate(ifac,stat=ierr)
       if(allocated(dfac))deallocate(dfac,stat=ierr)
       if(allocated(darray))deallocate(darray,stat=ierr)

end function interp_from_mf6_depvar_file



integer (kind=c_int) function extract_flows_from_cbc_file(     &
                 cbcfile,flowtype,isim,iprec,                  &
                 ncell,izone,nzone,                            &
                 numzone,zonenumber,                           &
                 ntime,nproctime,                              &
                 timestep,stressperiod,simtime,simflow)        &
                 bind(c,name="extract_flows_from_cbc_file")

! -- This function reads and accumulates flows (as read from a cell-by-cell flow term file)
!    to a user-specified boundary condition.

       use iso_c_binding, only: c_int,c_char,c_double
       use dimvar
       use utilities
       implicit none

       character (kind=c_char,len=1), intent(in)  :: cbcfile(LENFILENAME)  ! Cell-by-cell flow term file written by any MF version.
       character (kind=c_char,len=1), intent(in)  :: flowtype(17)           ! Type of flow to read.
       integer(kind=c_int), intent(in)            :: isim                  ! Simulator type
       integer(kind=c_int), intent(in)            :: iprec                 ! Precision used to record real variables in cbc file
       integer(kind=c_int), intent(in)            :: ncell                 ! Number of cells in the model
       integer(kind=c_int), intent(in)            :: izone(ncell)          ! Zonation of model domain
       integer(kind=c_int), intent(in)            :: nzone                 ! Equals or exceeds number of zones; zone 0 doesn't count
       integer(kind=c_int), intent(out)           :: numzone               ! Number of non-zero-valued zones
       integer(kind=c_int), intent(out)           :: zonenumber(nzone)     ! Zone numbers (processed from izone)
       integer(kind=c_int), intent(in)            :: ntime                 ! Equals or exceed number of model output times for flow type
       integer(kind=c_int), intent(out)           :: nproctime             ! Number of processed simulation times
       integer(kind=c_int), intent(out)           :: timestep(ntime)       ! Simulation time step
       integer(kind=c_int), intent(out)           :: stressperiod(ntime)   ! Simulation stress period
       real(kind=c_double), intent(out)           :: simtime(ntime)        ! Simulation time; a time of -1.0 indicates unknown
       real(kind=c_double), intent(out)           :: simflow(ntime,nzone)  ! Interpolated flows

! -- Note that for older versions of MODFLOW the simulation time may not be recorded in the cbc flow term file.
!    This is why time step and stress period are also reported.

       integer                        :: inunit,ibig,itemp,iflag,ierr,ndimtemp
       integer                        :: ialloci,iallocr
       integer                        :: icell,iz
       integer                        :: kstp,kper,ndim1,ndim2,ndim3,imeth
       integer                        :: ilist,nlist,idat,ndat,numread,ilay,jcell
       real                           :: rbig,delt,pertim,totim
       real                           :: rtemp
       double precision               :: dbig,ddelt,dpertim,dtotim
       double precision               :: dtemp

       character (len=16)             :: atext,text
       character (len=16)             :: txt1id1,txt2id1,txt1id2,txt2id2,atemp16
       character (len=20)             :: atemp20
       character (len=LENFILENAME)    :: infile

! -- Allocatable arrays

       integer, allocatable           :: cell2zone(:)  ! Could be automatic, but worried about stack.
       integer, allocatable           :: iarray(:)
       real, allocatable              :: rarray(:)
       double precision, allocatable  :: darray(:)

! -- Initialisation

       extract_flows_from_cbc_file=0
       function_name='extract_flows_from_cbc_file()'
       inunit=0
       timestep=0       ! an array
       stressperiod=0   ! an array
       simtime=0.0d0
       simflow=0.0d0    ! an array
       numzone=0
       zonenumber=0     ! an array
       ibig=huge(ibig)/2                   ! arbitrary
       rbig=huge(rbig)*0.5                 ! arbitrary
       dbig=huge(dbig)*0.5d0               ! arbitrary
       ialloci=0
       iallocr=0
       nproctime=0

! -- Character arrays are translated to character variables.

       call utl_string2char(LENFILENAME,cbcfile,infile)
       infile=adjustl(infile)
       call utl_string2char(17,flowtype,atext)
       atext=adjustl(atext)
       call utl_casetrans(atext,'lo')

! -- Check input arguments.

       if((isim.ne.0).and.(isim.ne.1).and.(isim.ne.21).and.(isim.ne.22).and.   &
          (isim.ne.31).and.(isim.ne.32).and.(isim.ne.33))then
          write(amessage,90)
90         format('The isim argument must be 0, 1, 21, 22, 31, 32 or 33')
         go to 9890
       end if
       if(ntime.le.0)then
         write(amessage,110) 'NTIME', trim(function_name)
110      format('The ', a,' argument of function ',a,' must be positive.')
         go to 9890
       end if
       if(nzone.le.0)then
         write(amessage,110) 'NZONE', trim(function_name)
         go to 9890
       end if
       if(ncell.le.0)then
         write(amessage,110) 'NCELL',trim(function_name)
         go to 9890
       end if
       if(infile.eq.' ')then
         write(amessage,120) 'CBCFILE',trim(function_name)
120      format('The ',a,' argument of function ',a,' must not be blank.')
         go to 9890
       end if
       if((atext.eq.'flow right face').or.    &
          (atext.eq.'flow front face').or.    &
          (atext.eq.'flow lower face').or.    &
          (atext.eq.'flow-ja-face'))then
          write(amessage,125)
125       format('Flowtypes of FLOW RIGHT FACE, FLOW-JA-FACE etc ',  &
          'are not allowed. Flows must be to/from a boundary condition.')
          go to 9890
       end if

! -- Open the cell-by-cell flow term file.

       call utl_addquote(infile,afile1)
       inunit=utl_nextunit()
       open(unit=inunit,file=infile,status='old',form='unformatted',access='stream',iostat=ierr)
       if(ierr.ne.0) then
         write(amessage,160) trim(afile1)
160      format('Cannot open binary cell-by-cell flow term file ',a,'.')
         go to 9890
       end if

! -- Extract zones from izone array

       iz=0
       do icell=1,ncell
         if(izone(icell).ne.0)then
           if(numzone.eq.0)then
             numzone=numzone+1
             zonenumber(numzone)=izone(icell)
           else
             itemp=utl_whichone(numzone,iz,zonenumber,izone(icell))
             if(itemp.ne.0)then
               numzone=numzone+1
               if(numzone.gt.nzone)then
                 write(amessage,180)
180              format('The number of different non-zero integers that are featured ',  &
                 'in the IZONE input array exceeds the user-supplied values for NZONE.')
                 go to 9890
               end if
               zonenumber(numzone)=izone(icell)
             end if
           end if
         end if
       end do
       if(numzone.eq.0)then
         write(amessage,190)
190      format('Input array IZONE features no nonzero zone numbers.')
         go to 9890
       end if

! -- Zones within the zonenumber array are now sorted.

       call utl_sort(numzone,zonenumber)

! -- Create an indexing array.

       allocate(cell2zone(ncell),stat=ierr)
       if(ierr.ne.0) go to 9200
       iz=0
       do icell=1,ncell
         if(izone(icell).eq.0)then
           cell2zone(icell)=0
         else
           itemp=utl_whichone(numzone,iz,zonenumber,izone(icell))
           if(itemp.ne.0)then
             write(amessage,210) trim(function_name)
210          format('Programming error encountered in function ',a,': - contact programmer.')
             go to 9890
           end if
           cell2zone(icell)=iz
         end if
       end do

! -- Progress through the budget file.

       do
         if(nproctime+1.gt.ntime) go to 1000
         read(inunit,err=9000,end=1000) kstp,kper,text,ndim1,ndim2,ndim3
         if((kstp.lt.0).or.(kper.lt.0).or.(ndim1.lt.0).or.(ndim2.lt.0)) go to 9000
         if(utl_textcheck(text).ne.0) go to 9000
         if((kstp.gt.ibig).or.(kper.gt.ibig).or.(ndim1.gt.ibig).or.(ndim2.gt.ibig)     &
                          .or.(abs(ndim3).gt.ibig))go to 9000
         call utl_casetrans(text,'lo')
         text=adjustl(text)
         iflag=0
         if(index(text,trim(atext)).ne.0) iflag=1
         if(ndim3.gt.0)then
           if(iflag.eq.0)then
             if(iprec.eq.1)then
               read(inunit,err=9100,end=9100) (rtemp,icell=1,ndim1*ndim2*ndim3)
             else
               read(inunit,err=9100,end=9100) (dtemp,icell=1,ndim1*ndim2*ndim3)
             end if
           else
             itemp=ndim1*ndim2*ndim3
             if(itemp.ne.ncell)go to 9050
             if(iallocr.eq.0)then
               iallocr=ncell
               if(iprec.eq.1)then
                 allocate(rarray(ncell),stat=ierr)
               else
                 allocate(darray(ncell),stat=ierr)
               end if
               if(ierr.ne.0) go to 9200
             else
               if(iallocr.lt.ncell)then
                 if(iprec.eq.1)then
                   deallocate(rarray,stat=ierr)
                   if(ierr.ne.0) go to 9200
                   allocate(rarray(ncell),stat=ierr)
                 else
                   deallocate(darray,stat=ierr)
                   if(ierr.ne.0) go to 9200
                   allocate(darray(ncell),stat=ierr)
                 end if
                 if(ierr.ne.0) go to 9200
               end if
             end if
             nproctime=nproctime+1
             timestep(nproctime)=kstp
             stressperiod(nproctime)=kper
             simtime(nproctime)=-1.0d0
             if(iprec.eq.1)then
               read(inunit,err=9100,end=9100) (rarray(icell),icell=1,ncell)
             else
               read(inunit,err=9100,end=9100) (darray(icell),icell=1,ncell)
             end if
             do icell=1,ncell
               iz=cell2zone(icell)
               if(iz.ne.0)then
                 if(iprec.eq.1)then
                   simflow(nproctime,iz)=simflow(nproctime,iz)+rarray(icell)
                 else
                   simflow(nproctime,iz)=simflow(nproctime,iz)+darray(icell)
                 end if
               end if
             end do
           end if
         else
           ndim3=-ndim3
           if(iprec.eq.1)then
             read(inunit,err=9000,end=9000) imeth,delt,pertim,totim
             dtotim=totim
           else
             read(inunit,err=9000,end=9000) imeth,ddelt,dpertim,dtotim
           end if
           if((imeth.lt.1).or.(imeth.gt.ibig))go to 9000
           if(imeth.gt.6)then
             write(amessage,217) trim(afile1)
217          format('An array header in file ',a,' cites an IMETH value that is ',  &
             'greater than 6.')
             go to 9890
           end if
           if(imeth.eq.6)then
             read(inunit,err=9000,end=9000) txt1id1
             if(utl_textcheck(txt1id1).ne.0) go to 9000
             read(inunit,err=9000,end=9000) txt2id1
             if(utl_textcheck(txt2id1).ne.0) go to 9000
             read(inunit,err=9000,end=9000) txt1id2
             if(utl_textcheck(txt1id2).ne.0) go to 9000
             read(inunit,err=9000,end=9000) txt2id2
             if(utl_textcheck(txt2id2).ne.0) go to 9000
           end if
           if(iprec.eq.1)then
             if(delt.lt.0.0) go to 9000
             if(pertim.lt.0.0) go to 9000
             if(totim.lt.0.0) go to 9000
             if(delt.gt.rbig) go to 9000
             if(pertim.gt.rbig) go to 9000
             if(totim.gt.rbig) go to 9000
           else
             if(ddelt.lt.0.0d0) go to 9000
             if(dpertim.lt.0.0d0) go to 9000
             if(dtotim.lt.0.0d0) go to 9000
             if(ddelt.gt.dbig) go to 9000
             if(dpertim.gt.dbig) go to 9000
             if(dtotim.gt.dbig) go to 9000
           end if
           if(iflag.ne.0)then
             nproctime=nproctime+1
             timestep(nproctime)=kstp
             stressperiod(nproctime)=kper
             simtime(nproctime)=dtotim
           end if
           if(imeth.eq.1)then
             if(iflag.eq.0)then
               if(iprec.eq.1)then
                 read(inunit,err=9100,end=9100) (rtemp,icell=1,ndim1*ndim2*ndim3)
               else
                 read(inunit,err=9100,end=9100) (dtemp,icell=1,ndim1*ndim2*ndim3)
               end if
             else
               itemp=abs(ndim1*ndim2*ndim3)
               if(itemp.ne.ncell)go to 9050
               if(iallocr.eq.0)then
                 if(iprec.eq.1)then
                   allocate(rarray(ncell),stat=ierr)
                 else
                   allocate(darray(ncell),stat=ierr)
                 end if
                 if(ierr.ne.0) go to 9200
                 iallocr=ncell
               else
                 if(iallocr.lt.ncell)then
                   if(iprec.eq.1)then
                     deallocate(rarray,stat=ierr)
                     if(ierr.ne.0) go to 9200
                     allocate(rarray(ncell),stat=ierr)
                   else
                     deallocate(darray,stat=ierr)
                     if(ierr.ne.0) go to 9200
                     allocate(darray(ncell),stat=ierr)
                   end if
                   if(ierr.ne.0) go to 9200
                   iallocr=ncell
                 end if
               end if
               if(iprec.eq.1)then
                 read(inunit,err=9100,end=9100) (rarray(icell),icell=1,ncell)
               else
                 read(inunit,err=9100,end=9100) (darray(icell),icell=1,ncell)
               end if
               do icell=1,ncell
                 iz=cell2zone(icell)
                 if(iz.ne.0)then
                   if(iprec.eq.1)then
                     simflow(nproctime,iz)=simflow(nproctime,iz)+rarray(icell)
                   else
                     simflow(nproctime,iz)=simflow(nproctime,iz)+darray(icell)
                   end if
                 end if
               end do
             end if
           else if(imeth.eq.2)then
             read(inunit,err=9100,end=9100) nlist
             if(nlist.lt.0) go to 9000
             if(nlist.gt.ibig) go to 9000
             if(iflag.eq.0)then
               if(iprec.eq.1)then
                 read(inunit,err=9100,end=9100) (itemp,rtemp,ilist=1,nlist)
               else
                 read(inunit,err=9100,end=9100) (itemp,dtemp,ilist=1,nlist)
               end if
             else
               ndimtemp=max(nlist,ncell)
               if(iallocr.eq.0)then
                 if(iprec.eq.1)then
                   allocate(rarray(ndimtemp),stat=ierr)
                 else
                   allocate(darray(ndimtemp),stat=ierr)
                 end if
                 if(ierr.ne.0) go to 9200
                 iallocr=ndimtemp
               else if(iallocr.lt.nlist)then
                 if(iprec.eq.1)then
                   deallocate(rarray,stat=ierr)
                   if(ierr.ne.0) go to 9200
                   allocate(rarray(ndimtemp),stat=ierr)
                 else
                   deallocate(darray,stat=ierr)
                   if(ierr.ne.0) go to 9200
                   allocate(darray(ndimtemp),stat=ierr)
                 end if
                 if(ierr.ne.0) go to 9200
                 iallocr=ndimtemp
               end if
               if(ialloci.eq.0)then
                 allocate(iarray(ndimtemp),stat=ierr)
                 if(ierr.ne.0) go to 9200
                 ialloci=ndimtemp
               else
                 if(ialloci.lt.nlist)then
                   deallocate(iarray,stat=ierr)
                   if(ierr.ne.0) go to 9200
                   allocate(iarray(ndimtemp),stat=ierr)
                   if(ierr.ne.0) go to 9200
                   ialloci=ndimtemp
                 end if
               end if
               if(iprec.eq.1)then
                 read(inunit,err=9100,end=9100) (iarray(ilist),rarray(ilist),ilist=1,nlist)
               else
                 read(inunit,err=9100,end=9100) (iarray(ilist),darray(ilist),ilist=1,nlist)
               end if
               do ilist=1,nlist
                 icell=iarray(ilist)
                 if((icell.le.0).or.(icell.gt.ncell)) go to 9300
                 iz=cell2zone(icell)
                 if(iz.ne.0)then
                   if(iprec.eq.1)then
                     simflow(nproctime,iz)=simflow(nproctime,iz)+rarray(ilist)
                   else
                     simflow(nproctime,iz)=simflow(nproctime,iz)+darray(ilist)
                   end if
                 end if
               end do
             end if
           else if(imeth.eq.3)then   ! There may be problems with this if cell numbers
                                     ! are different in different layers for an unstructured
                                     ! mfusg grid.
             numread=ndim1*ndim2
             if(iflag.eq.0)then
               read(inunit,err=9100,end=9100) (itemp,icell=1,numread)
               if(iprec.eq.1)then
                 read(inunit,err=9100,end=9100) (rtemp,icell=1,numread)
               else
                 read(inunit,err=9100,end=9100) (dtemp,icell=1,numread)
               end if
             else
               ndimtemp=max(ncell,numread)
               if(iallocr.eq.0)then
                 if(iprec.eq.1)then
                   allocate(rarray(ndimtemp),stat=ierr)
                 else
                   allocate(darray(ndimtemp),stat=ierr)
                 end if
                 if(ierr.ne.0) go to 9200
                 iallocr=ndimtemp
               else
                 if(iallocr.lt.numread)then
                   if(iprec.eq.1)then
                     deallocate(rarray,stat=ierr)
                     if(ierr.ne.0) go to 9200
                     allocate(rarray(ndimtemp),stat=ierr)
                   else
                     deallocate(darray,stat=ierr)
                     if(ierr.ne.0) go to 9200
                     allocate(darray(ndimtemp),stat=ierr)
                   end if
                   if(ierr.ne.0) go to 9200
                   iallocr=ndimtemp
                 end if
               end if
               if(ialloci.eq.0)then
                 allocate(iarray(ndimtemp),stat=ierr)
                 if(ierr.ne.0) go to 9200
                 ialloci=ndimtemp
               else
                 if(ialloci.lt.numread)then
                   deallocate(iarray,stat=ierr)
                   if(ierr.ne.0) go to 9200
                   allocate(iarray(ndimtemp),stat=ierr)
                   if(ierr.ne.0) go to 9200
                   ialloci=ndimtemp
                 end if
               end if
               read(inunit,err=9100,end=9100) (iarray,icell=1,numread)
               if(iprec.eq.1)then
                 read(inunit,err=9100,end=9100) (rarray,icell=1,numread)
               else
                 read(inunit,err=9000,end=9000) (darray,icell=1,numread)
               end if
               if(iprec.eq.1)then
                 do icell=1,numread
                   if(rarray(icell).ne.0.0d0)then
                     if(isim.eq.22)then
                       jcell=iarray(icell)
                     else
                       ilay=iarray(icell)
                       jcell=icell+(ilay-1)*numread
                     end if
                     if((jcell.lt.0).or.(jcell.gt.ncell))then
                       call utl_num2char(jcell,atemp20)
                       write(amessage,250) trim(atemp20),trim(afile1)
                       go to 9890
                     end if
                     iz=cell2zone(jcell)
                     if(iz.ne.0)simflow(nproctime,iz)=simflow(nproctime,iz)+rarray(icell)
                   end if
                 end do
               else
                 do icell=1,numread
                   if(darray(icell).ne.0.0d0)then
                     if(isim.eq.22)then
                       jcell=iarray(icell)
                     else
                       ilay=iarray(icell)
                       jcell=icell+(ilay-1)*numread
                     end if
                     if((jcell.lt.0).or.(jcell.gt.ncell))then
                       call utl_num2char(jcell,atemp20)
                       write(amessage,250) trim(atemp20),trim(afile1)
250                    format('Out of range cell number ',a,' enountered when reading flow ', &
                       'terms from file ',a,' using IMETH=3 method.')
                       go to 9890
                     end if
                     iz=cell2zone(jcell)
                     if(iz.ne.0)simflow(nproctime,iz)=simflow(nproctime,iz)+darray(icell)
                   end if
                 end do
               end if
             end if
           else if(imeth.eq.4)then
             numread=ndim1*ndim2
             if(iflag.eq.0)then
               if(iprec.eq.1)then
                 read(inunit,err=9000,end=9000) (rtemp,icell=1,numread)
               else
                 read(inunit,err=9000,end=9000) (dtemp,icell=1,numread)
               end if
             else
               ndimtemp=max(numread,ncell)
               if(iallocr.eq.0)then
                 if(iprec.eq.1)then
                   allocate(rarray(ndimtemp),stat=ierr)
                 else
                   allocate(darray(ndimtemp),stat=ierr)
                 end if
                 if(ierr.ne.0) go to 9200
                 iallocr=ndimtemp
               else
                 if(iallocr.lt.numread)then
                   if(iprec.eq.1)then
                     deallocate(rarray,stat=ierr)
                     if(ierr.ne.0) go to 9200
                     allocate(rarray(ndimtemp),stat=ierr)
                   else
                     deallocate(darray,stat=ierr)
                     if(ierr.ne.0) go to 9200
                     allocate(darray(ndimtemp),stat=ierr)
                   end if
                   if(ierr.ne.0) go to 9200
                   iallocr=ndimtemp
                 end if
               end if
               if(iprec.eq.1)then
                 read(inunit,err=9100,end=9100) (rarray,icell=1,numread)
               else
                 read(inunit,err=9000,end=9000) (darray,icell=1,numread)
               end if
               if(iprec.eq.1)then
                 do icell=1,numread
                   if(rarray(icell).ne.0.0d0)then
                     iz=cell2zone(icell)
                     if(iz.ne.0)simflow(nproctime,iz)=simflow(nproctime,iz)+rarray(icell)
                   end if
                 end do
               else
                 do icell=1,numread
                   if(darray(icell).ne.0.0d0)then
                     iz=cell2zone(icell)
                     if(iz.ne.0)simflow(nproctime,iz)=simflow(nproctime,iz)+darray(icell)
                   end if
                 end do
               end if
             end if
           else if(imeth.eq.5)then
             read(inunit,err=9100,end=9100) ndat
             if(ndat.lt.-1) go to 9000
             if(ndat.gt.ibig) go to 9000
             if(ndat.gt.1)then
               read(inunit,err=9100,end=9100) (atemp16,idat=1,ndat-1)
             end if
             read(inunit,err=9100,end=9100) nlist
             if(nlist.lt.0) go to 9000
             if(nlist.gt.ibig) go to 9000
             if(iflag.eq.0)then
               if((nlist.gt.0).and.(ndat.gt.0))then
                 if(iprec.eq.1)then
                   read(inunit,err=9400,end=9400)(itemp,(rtemp,idat=1,ndat),ilist=1,nlist)
                 else
                   read(inunit,err=9400,end=9400)(itemp,(dtemp,idat=1,ndat),ilist=1,nlist)
                 end if
               endif
             else
               ndimtemp=max(nlist,ncell)
               if(iallocr.eq.0)then
                 if(iprec.eq.1)then
                   allocate(rarray(ndimtemp),stat=ierr)
                 else
                   allocate(darray(ndimtemp),stat=ierr)
                 end if
                 if(ierr.ne.0) go to 9200
                 iallocr=ndimtemp
               else
                 if(iallocr.lt.nlist)then
                   if(iprec.eq.1)then
                     deallocate(rarray,stat=ierr)
                     if(ierr.ne.0) go to 9200
                     allocate(rarray(ndimtemp),stat=ierr)
                   else
                     deallocate(darray,stat=ierr)
                     if(ierr.ne.0) go to 9200
                     allocate(darray(ndimtemp),stat=ierr)
                   end if
                   if(ierr.ne.0) go to 9200
                   iallocr=ndimtemp
                 end if
               end if
               if(ialloci.eq.0)then
                 allocate(iarray(ndimtemp),stat=ierr)
                 if(ierr.ne.0) go to 9200
                 ialloci=ndimtemp
               else
                 if(ialloci.lt.nlist)then
                   deallocate(iarray,stat=ierr)
                   if(ierr.ne.0) go to 9200
                   allocate(iarray(ndimtemp),stat=ierr)
                   if(ierr.ne.0) go to 9200
                   ialloci=ndimtemp
                 end if
               end if
               if(iprec.eq.1)then
                 read(inunit,err=9400,end=9400)    &
                 (iarray(ilist),rarray(ilist),(rtemp,idat=1,ndat-1),ilist=1,nlist)
               else
                 read(inunit,err=9400,end=9400)    &
                 (iarray(ilist),darray(ilist),(dtemp,idat=1,ndat-1),ilist=1,nlist)
               end if
             end if
             if(iprec.eq.1)then
               do ilist=1,nlist
                 if(rarray(ilist).ne.0.0d0)then
                   icell=iarray(ilist)
                   if((icell.lt.0).or.(icell.gt.ncell)) go to 9450
                   iz=cell2zone(icell)
                   if(iz.ne.0)simflow(nproctime,iz)=simflow(nproctime,iz)+rarray(ilist)
                 end if
               end do
             else
               do ilist=1,nlist
                 if(darray(ilist).ne.0.0d0)then
                   icell=iarray(ilist)
                   if((icell.lt.0).or.(icell.gt.ncell)) go to 9450
                   iz=cell2zone(icell)
                   if(iz.ne.0)simflow(nproctime,iz)=simflow(nproctime,iz)+darray(ilist)
                 end if
               end do
             end if
           else if(imeth.eq.6)then
             if(iprec.eq.1)then
               write(amessage,270) trim(afile1),trim(function_name)
270            format('Reading of data from file ',a,' requires use of the IMETH=6 protocol. This ',   &
               'means that it is a MODFLOW 6 file. MODFLOW 6 budget files are always double ',         &
               'precision. However the IPREC argument in function ',a,' has been set to 1.')
               go to 9890
             end if
             read(inunit,err=9100,end=9100) ndat
             if(ndat.gt.ibig) go to 9000
             if(ndat.lt.0) go to 9000
             if(ndat-1.ge.1)then
               read(inunit,err=9100,end=9100) (atemp16,idat=1,ndat-1)
             end if
             read(inunit,err=9100,end=9100) nlist
             if(nlist.lt.0) go to 9000
             if(nlist.gt.ibig) go to 9000
             if(nlist.gt.0)then
               if(iflag.eq.0)then
                 if(iprec.eq.1)then
                   read(inunit,err=9100,end=9100) (itemp,itemp,(rtemp,idat=1,ndat),ilist=1,nlist)
                 else
                   read(inunit,err=9100,end=9100) (itemp,itemp,(dtemp,idat=1,ndat),ilist=1,nlist)
                 end if
               else
                 ndimtemp=max(nlist,ncell)
                 if(iallocr.eq.0)then
                   if(iprec.eq.1)then
                     allocate(rarray(ndimtemp),stat=ierr)
                   else
                     allocate(darray(ndimtemp),stat=ierr)
                   end if
                   if(ierr.ne.0) go to 9200
                   iallocr=ndimtemp
                 else
                   if(iallocr.lt.nlist)then
                     if(iprec.eq.1)then
                       deallocate(rarray,stat=ierr)
                       if(ierr.ne.0) go to 9200
                       allocate(rarray(ndimtemp),stat=ierr)
                     else
                       deallocate(darray,stat=ierr)
                       if(ierr.ne.0) go to 9200
                       allocate(darray(ndimtemp),stat=ierr)
                     end if
                     if(ierr.ne.0) go to 9200
                     iallocr=ndimtemp
                   end if
                 end if
                 if(ialloci.eq.0)then
                   allocate(iarray(ndimtemp),stat=ierr)
                   if(ierr.ne.0) go to 9200
                   ialloci=ndimtemp
                 else
                   if(ialloci.lt.nlist)then
                     deallocate(iarray,stat=ierr)
                     if(ierr.ne.0) go to 9200
                     allocate(iarray(ndimtemp),stat=ierr)
                     if(ierr.ne.0) go to 9200
                     ialloci=ndimtemp
                   end if
                 end if
                 if(iprec.eq.1)then
                   read(inunit,err=9500,end=9500)    &
                   (iarray(ilist),itemp,rarray(ilist),(rtemp,idat=1,ndat-1),ilist=1,nlist)
                 else
                   read(inunit,err=9500,end=9500)    &
                   (iarray(ilist),itemp,darray(ilist),(dtemp,idat=1,ndat-1),ilist=1,nlist)
                 end if
                 if(iprec.eq.1)then
                   do ilist=1,nlist
                     if(rarray(ilist).ne.0.0d0)then
                       icell=iarray(ilist)
                       if((icell.lt.1).or.(icell.gt.ncell)) go to 9550
                       iz=cell2zone(icell)
                       if(iz.ne.0)simflow(nproctime,iz)=simflow(nproctime,iz)+rarray(ilist)
                     end if
                   end do
                 else
                   do ilist=1,nlist
                     if(darray(ilist).ne.0.0d0)then
                       icell=iarray(ilist)
                       if((icell.lt.1).or.(icell.gt.ncell)) go to 9550
                       iz=cell2zone(icell)
                       if(iz.ne.0)simflow(nproctime,iz)=simflow(nproctime,iz)+darray(ilist)
                     end if
                   end do
                 end if
               end if
             end if
           end if
         end if
       end do

1000   continue

       go to 9900

9000   continue
       write(amessage,9010) trim(afile1)
9010   format('Some of the numbers/text read from file ',a,' do not make sense. ',   &
       'Has the precision-type of this file been supplied correctly?')
       go to 9890

9050   write(amessage,9060) trim(function_name)
9060   format('Function ',a,' has been asked to read an array whose dimensions ', &
       'differ from input argument NCELL. This can mean that the model does not ', &
       'possess NCELL cells, or that inter-cell flows (e.g. FLOW-JA-FACE) terms ', &
       'are being sought. The latter is not allowed. The former comprises ',     &
       'an error condition.')
       go to 9890

9100   write(amessage,9110) trim(afile1)
9110   format('An error or premature end-of-file was encountered when reading ',  &
       'file ',a,'. Has the precision type of this file been supplied correctly?')
       go to 9890

9200   write(amessage,9210) trim(function_name)
9210   format('Memory allocation/deallocate error condition endountered in function ',a,'.')
       go to 9890

9300   continue
       call utl_num2char(icell,atemp20)
       write(amessage,9310) trim(atemp20),trim(afile1)
9310   format('A cell index number of ',a,' was encountered in reading a ',     &
       'flow dataset from file ',a,' with an IMETH value of 2. This could be ', &
       'a model error. Alternatively it may indicate that you ',                &
       'need to call this function again with an altered IPREC precision setting.')
       go to 9890

9400   write(amessage,9410) trim(afile1)
9410   format('Error reading data from file ',a,' for IMETH=5 array reading option.')
       go to 9890

9450   call utl_num2char(icell,atemp20)
       write(amessage,9460) trim(atemp20)
9460   format('Illegal cell number ',a,' encountered when reading an array ',  &
       'with IMETH=5 array reading option.')
       go to 9890

9500   write(amessage,9510) trim(afile1)
9510   format('Error reading data from file ',a,' for IMETH=6 array reading option.')
       go to 9890

9550   call utl_num2char(icell,atemp20)
       write(amessage,9560) trim(atemp20)
9560   format('Illegal cell number ',a,' encountered when reading an array ',  &
       'with IMETH=6 array reading option.')
       go to 9890

9890   continue
       extract_flows_from_cbc_file=1
       nproctime=0
       timestep=0           ! an array
       stressperiod=0       ! an array
       simtime=0.0d0        ! an array
       simflow=0.0d0        ! an array
       numzone=0
       zonenumber=0         ! an array

9900   continue
       if(inunit.ne.0) close(unit=inunit,iostat=ierr)
       if(allocated(cell2zone)) deallocate(cell2zone,stat=ierr)
       if(allocated(iarray)) deallocate(iarray,stat=ierr)
       if(allocated(rarray)) deallocate(rarray,stat=ierr)
       if(allocated(darray)) deallocate(darray,stat=ierr)

end function extract_flows_from_cbc_file



integer (kind=c_int) function get_cell_centres_mf6(gridname,                &
                              ncells,                                       &
                              cellx,celly,cellz)                            &
                 bind(c,name="get_cell_centres_mf6")

! -- This function obtains the centres of model cells of an installed MF6 grid.

       use iso_c_binding, only: c_int,c_double,c_char
       use dimvar
       use deftypes
       use utilities
       implicit none

       character (kind=c_char,len=1), intent(in)  :: gridname(LENGRIDNAME)   ! Name of installed grid
       integer(kind=c_int), intent(in)            :: ncells                  ! Dimensions of grid
       real(kind=c_double), intent(out)           :: cellx(ncells)           ! x coordinates of cell centres
       real(kind=c_double), intent(out)           :: celly(ncells)           ! y coordinates of cell centres
       real(kind=c_double), intent(out)           :: cellz(ncells)           ! z coordinates of cell centres

       integer                                     :: igrid,distype
       integer                                     :: nlay,ncpl
       integer                                     :: ncol,nrow,icol,irow,ilay,icpl,icpl1
       integer                                     :: icell,lasticell,icell1
       double precision                            :: xorigin,yorigin,cosang,sinang,angrot
       double precision                            :: sum,xx,yy
       double precision, pointer, dimension(:)     :: delr,delc
       double precision, pointer, dimension(:,:,:) :: botm
       double precision, pointer, dimension(:,:)   :: botmv
       character (len=LENGRIDNAME)    :: aname

! -- Initialisation

       function_name='get_cell_centres_mf6()'
       get_cell_centres_mf6=0

! -- Text strings are converted to character variables.

       call utl_string2char(LENGRIDNAME,gridname,aname)
       aname=adjustl(aname)
       call utl_casetrans(aname,'lo')
       if(aname.eq.' ')then
         write(amessage,50) 'GRIDNAME', trim(function_name)
50       format('The ',a,' argument of function ',a,' is supplied as blank.')
         go to 9890
       end if
       if(ncells.le.0)then
         write(amessage,110) 'NCELLS',trim(function_name)
110      format('The ',a,' argument of function ',a,' must be greater than zero.')
         go to 9890
       end if

! -- We see if the grid has been installed and that dimensions as are expected.

       do igrid=1,MAXMF6MODGRID
         if(mf6modgrid(igrid)%name.eq.aname) go to 150
       end do
       write(amessage,140) trim(aname)
140    format('"',a,'" is not an installed grid.')
       go to 9890
150    continue
       distype=mf6modgrid(igrid)%distype
       if(ncells.ne.mf6modgrid(igrid)%ncells)then
         write(amessage,160) 'NCELLS',trim(function_name)
160      format('The ',a,' argument of function ',a,' does not match the ', &
         'dimensions of the installed MF6 grid.')
         go to 9890
       end if

! -- We now obtain dimensions and check with function input arguments.

       if(distype.eq.1)then
         nrow=mf6modgrid(igrid)%nrow
         ncol=mf6modgrid(igrid)%ncol
         ncpl=nrow*ncol
       else if(distype.eq.2)then
         ncpl=mf6modgrid(igrid)%ncpl
       end if
       nlay=mf6modgrid(igrid)%nlay

! -- We calculate horizontal coordinates.

       xorigin=mf6modgrid(igrid)%xorigin
       yorigin=mf6modgrid(igrid)%yorigin
       angrot=mf6modgrid(igrid)%angrot
       cosang=cos(angrot*pi/180.0d0)
       sinang=sin(angrot*pi/180.0d0)

       if(distype.eq.1)then
         delr=>mf6modgrid(igrid)%delr
         delc=>mf6modgrid(igrid)%delc
         cellx(1)=delr(1)*0.5
         if(ncol.gt.1)then
           do icol=2,ncol
             cellx(icol)=cellx(icol-1)+(delr(icol)+delr(icol-1))*0.5
           end do
         end if
         sum=0.0d0
         do irow=1,nrow
           sum=sum+delc(irow)
         end do
         celly(1)=sum-delc(1)*0.5
         lasticell=1
         if(nrow.gt.1)then
           do irow=2,nrow
             icell=(irow-1)*ncol+1
             celly(icell)=celly(lasticell)-(delc(irow)+delc(irow-1))*0.5
             lasticell=icell
           end do
         end if
         if(nrow.gt.1)then
           do irow=2,nrow
             do icol=1,ncol
               icell=(irow-1)*ncol+icol
               cellx(icell)=cellx(icol)
             end do
           end do
         end if
         if(ncol.gt.1)then
           do irow=1,nrow
             icell1=(irow-1)*ncol+1
             do icol=2,ncol
               icell=(irow-1)*ncol+icol
               celly(icell)=celly(icell1)
             end do
           end do
         end if
       else
         do icell=1,ncpl
           cellx(icell)=mf6modgrid(igrid)%cellx(icell)
           celly(icell)=mf6modgrid(igrid)%celly(icell)
         end do
       end if
       if(angrot.ne.0.0d0)then
         do icell=1,ncpl
           xx=cellx(icell)
           yy=celly(icell)
           cellx(icell)=xx*cosang-yy*sinang
           celly(icell)=xx*sinang+yy*cosang
         end do
       end if
       cellx=cellx+xorigin    ! an array
       celly=celly+yorigin    ! an array
       if(nlay.gt.1)then
         icpl1=ncpl
         do ilay=2,nlay
           do icpl=1,ncpl
             icpl1=icpl1+1
             cellx(icpl1)=cellx(icpl)
             celly(icpl1)=celly(icpl)
           end do
         end do
       end if

! -- Vertical coordinates are now calculated.

       if(distype.eq.1)then
         botm=>mf6modgrid(igrid)%botm
         icell=0
         do ilay=1,nlay
           do irow=1,nrow
             do icol=1,ncol
               icell=icell+1
               cellz(icell)=(botm(icol,irow,ilay)+botm(icol,irow,ilay-1))*0.5
             end do
           end do
         end do
       else if(distype.eq.2)then
         botmv=>mf6modgrid(igrid)%botmv
         icell=0
         do ilay=1,nlay
           do icpl=1,ncpl
             icell=icell+1
             cellz(icell)=(botmv(icpl,ilay)+botmv(icpl,ilay-1))*0.5
           end do
         end do
       end if

       go to 9900

9890   continue
       get_cell_centres_mf6=1

9900   continue

end function get_cell_centres_mf6



integer (kind=c_int) function get_cell_centres_structured(gridname,         &
                              ncpl,                                         &
                              cellx,celly)                                  &
                 bind(c,name="get_cell_centres_structured")

! -- This function obtains the centres of model cells of a single layer of an installed structured grid.

       use iso_c_binding, only: c_int,c_double,c_char
       use dimvar
       use deftypes
       use utilities
       implicit none

       character (kind=c_char,len=1), intent(in)  :: gridname(LENGRIDNAME)   ! Name of installed grid
       integer(kind=c_int), intent(in)            :: ncpl                    ! Dimensions of grid
       real(kind=c_double), intent(out)           :: cellx(ncpl)             ! x coordinates of cell centres
       real(kind=c_double), intent(out)           :: celly(ncpl)             ! y coordinates of cell centres

       integer                                     :: igrid
       integer                                     :: ncol,nrow,icol,irow
       integer                                     :: icell,lasticell,icell1
       double precision                            :: e0,n0,cosang,sinang,rotation
       double precision                            :: xx,yy
       double precision, pointer, dimension(:)     :: delr,delc
       character (len=LENGRIDNAME)    :: aname

! -- Initialisation

       function_name='get_cell_centres_structured()'
       get_cell_centres_structured=0

! -- Text strings are converted to character variables.

       call utl_string2char(LENGRIDNAME,gridname,aname)
       aname=adjustl(aname)
       call utl_casetrans(aname,'lo')
       if(aname.eq.' ')then
         write(amessage,50) 'GRIDNAME', trim(function_name)
50       format('The ',a,' argument of function ',a,' is supplied as blank.')
         go to 9890
       end if
       if(ncpl.le.0)then
         write(amessage,110) 'NCPL',trim(function_name)
110      format('The value of the ',a,' argument of function ',a,' must be greater than zero.')
         go to 9890
       end if

! -- We see if the grid has been installed and that dimensions as are expected.

       do igrid=1,MAXSTRUCMODGRID
         if(strucmodgrid(igrid)%name.eq.aname) go to 150
       end do
       write(amessage,140) trim(aname)
140    format('"',a,'" is not an installed structured grid.')
       go to 9890
150    continue
       nrow=strucmodgrid(igrid)%nrow
       ncol=strucmodgrid(igrid)%ncol
       if(ncpl.ne.ncol*nrow)then
         write(amessage,160) 'NCPL',trim(function_name)
160      format('The value of the ',a,' argument of function ',a,' does not match the ', &
         'dimensions of the installed structured grid.')
         go to 9890
       end if

! -- We calculate horizontal coordinates.

       rotation=strucmodgrid(igrid)%rotation
       cosang=strucmodgrid(igrid)%cosang
       sinang=strucmodgrid(igrid)%sinang
       delr=>strucmodgrid(igrid)%delr
       delc=>strucmodgrid(igrid)%delc
       cellx(1)=delr(1)*0.5
       if(ncol.gt.1)then
         do icol=2,ncol
           cellx(icol)=cellx(icol-1)+(delr(icol)+delr(icol-1))*0.5
         end do
       end if
       celly(1)=-delc(1)*0.5
       lasticell=1
       if(nrow.gt.1)then
         do irow=2,nrow
           icell=(irow-1)*ncol+1
           celly(icell)=celly(lasticell)-(delc(irow)+delc(irow-1))*0.5
           lasticell=icell
         end do
       end if
       if(nrow.gt.1)then
         do irow=2,nrow
           do icol=1,ncol
             icell=(irow-1)*ncol+icol
             cellx(icell)=cellx(icol)
           end do
         end do
       end if
       if(ncol.gt.1)then
         do irow=1,nrow
           icell1=(irow-1)*ncol+1
           do icol=2,ncol
             icell=(irow-1)*ncol+icol
             celly(icell)=celly(icell1)
           end do
         end do
       end if
       if(rotation.ne.0.0d0)then
         do icell=1,ncpl
           xx=cellx(icell)
           yy=celly(icell)
           cellx(icell)=xx*cosang-yy*sinang
           celly(icell)=xx*sinang+yy*cosang
         end do
       end if
       cellx=cellx+strucmodgrid(igrid)%e0    ! an array
       celly=celly+strucmodgrid(igrid)%n0    ! an array

       go to 9900

9890   continue
       get_cell_centres_structured=1

9900   continue

end function get_cell_centres_structured

#!/usr/bin/env bash
set -e

# always run from top of repo
cd $(dirname $0)/..

# this needs bash
case "$OSTYPE" in
  darwin*)  libname=lib/libpestutils.dylib ;;
  linux*)   libname=lib/libpestutils.so ;;
  msys* )   libname=bin/pestutils.dll ;;
  *) echo "unknown \$OSTYPE: $OSTYPE" && exit 1 ;;
esac

# clean previous attempts
rm -rf builddir
rm -rf inst
rm -rf pypestutils/lib

# setup, compile and install
meson setup builddir --prefix=$(pwd)/inst --libdir=lib
meson compile -C builddir
meson install -C builddir

# copy lib file to Python module
mkdir pypestutils/lib
echo "Copying $libname to pypestutils/lib/"
cp inst/$libname pypestutils/lib/

#!/usr/bin/env bash
set -e

# always run from top of repo
cd $(dirname $0)/..

# clean previous attempts
rm -rf builddir
rm -rf inst
rm -rf pypestutils/lib

# setup, compile and install
meson setup builddir --prefix=$(pwd)/inst --cross-file etc/linux-mingw-w64-64bit.txt
meson compile -C builddir
meson install -C builddir

# copy lib files to Python module
mkdir pypestutils/lib
cp inst/bin/pestutils.dll pypestutils/lib/

:: always run from top of repo
cd %~dp0\..

:: clean previous attempts
RD /S /Q builddir 2> NUL
RD /S /Q inst 2> NUL
RD /S /Q pypestutils\lib 2> NUL

:: setup, compile and install
meson setup builddir --prefix=%cd%\inst
meson compile -C builddir
meson install -C builddir

::copy lib files to Python module
MD pypestutils\lib
COPY /B inst\bin\pestutils.dll pypestutils\lib
